! "0hwtraps.asm", Version 2.01 vom 18.7.1999, (C) Volker Ernst 1999
!  Simple asm source-file to fill the first 2K with trap-handlers.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.

!******************************************************************************!
!                  H  A  R  D  W  A  R  E   -   T  R  A  P  S                  !
!******************************************************************************!

!-------------
! RESET-ENTRY
!-------------

X0:             mov.l BOOT_K0001,r0      ! CPU-RESET-EINSPRUNG:           [0000]
                jmp @r0                  ! Hw-Reset,Man-Reset,Double-Exception
                nop                      ! weiter mit Reset-Handler/Sys-Startup

!--------------
! RESET-BUTTON
!--------------

BOOT_XKILLME:   ldc.l @r15+,r7_bank      ! [CPU-FAULT_RUNNING_PROGRAM:]   [0006]
                ldc.l @r15+,r6_bank      ! Der Code bekam Cpu-Fault-Exception
                ldc.l @r15+,r5_bank      ! ein Debugger war nicht installiert
                ldc.l @r15+,r4_bank      ! lade R4=SR,R5=PC,R6=ExpEvt,R7=Data
                bra BOOT_X0011           ! in 2.Reg-Bank als SoftRes-Erklrung
                add #0x08,r15            ! weiter mit Prozess-Beendigung


_cpu_killme:    sts pr,r0                ! 02 - FINISH_RUNNING_PROGRAM:   [0012]
                bsr BOOT_XRESWR          ! void cpu_killme (unsigned long Data)
                ldc r0,r5_bank           ! Lade RB1: R4=SR,R5=PC,R6=-1,R7=Data
    BOOT_X0011: bsr _send_signal         ! sende Signal#30/SigRes an Sheduler
                mov #0x1E,r4             ! damit werden Tasks wieder resettet
                bra BOOT_X0013           ! wenn das nicht hilft echter Reset
                mov #0x45,r14            ! weiter mit Auslsung PowerOn-Reset


_cpu_rescold:   bra BOOT_X0012           ! 03 - MACHE_POWERON-RESET:      [0020]
                mov #0x45,r14            ! void cpu_rescold (unsigned long Data)


_cpu_reswarm:   mov #0x65,r14            ! 04 - MACHE_MANUAL-RESET:       [0024]
    BOOT_X0012: sts pr,r0                ! void cpu_reswarm (unsigned long Data)
                bsr BOOT_XRESWR          ! Lade RB1: R4=SR,R5=PC,R6=-1,R7=Data
                ldc r0,r5_bank           ! lade R14=0x65 als WTCSR fr Man-Reset
                                         !-
    BOOT_X0013: mova BOOT_K0012,r0       ! Reset-Signal_generieren:       [002C]
                ldc.l @r0+,sr            ! setze BL=T=1,Intm=15 in SR
                mov.w BOOT_K0011,r0      ! schreibe 0xA5nn --> WtCsr
                mov #A_WTCNT,r2          ! damit der Watchdog anhlt
                not r0,r1                ! schreibe 0x5AFF --> WtCnt
                or r14,r0                ! damit Count vor Overflow
                mov.w r0,@(2,r2)         ! schreibe 0xA5mm --> WtCsr
                or #0x80,r0              ! damit Watchdog weiterluft
                mov.w r1,@r2             ! der Overflow/Reset erfolgt
                mov.w r0,@(2,r2)         ! nach 256_PClks/1024_IClks
             1:   bt 1b                  ! entsprechend 8.5uS/120MHz


BOOT_XRESWR:    stc sr,r0                ! [SAVE_USER-REGS_FR_RESET:]    [0042]
                ldc r0,r4_bank           ! Wir merken uns Reset-Grund in R4-R7
                mov #0xFF,r0             ! lade RB1: R4=SR,[R5=PR],R6=-1,R7=Data
                ldc r0,r6_bank           ! die Daten bleiben bei Reset erhalten
                rts                      ! als Startup-Info warum resettet wurde
                ldc r4,r7_bank           ! mit Shutdown-Event und Shutdown-PC/SR
                                         !-
BOOT_K0011:     .short 0xA500            ! WtCsr-Maske                    [004E]
BOOT_K0012:     .long  0x500000F1        ! SR fr Reset

!----------------
! STANDBY-MODE/1
!----------------

_cpu_standby:   sts pr,r0                ! 05 - GOTO_STANDBY-MODE:        [0054]
                bsr BOOT_XRESWR          ! u_long cpu_standby (u_long Data,
                ldc r0,r5_bank           ! u_char PIntMask, u_long MaxTicks,
                mov #A_PTEH,r0           !_const struct rtctime *Alarm)
                mov.l BOOT_K0021,r2      ! Save_System-Zustand:
                mov.l @r0,r1             ! damit cpu_standby als 'C'-Funkion
                mov.l @(8,r0),r0         ! nach Cpu-Wakeup normal returnen kann
                ldc r2,sr                ! zuerst in der 2.Register-Bank (RB=1)
                mov.l r8,@-r15           ! R4=SR,R5=PR,R6=-1,R7=Data abspeichern
                mov.l r9,@-r15           ! lese in 1.Bank R0=VarBase,R1=TaskNr
                mov.l r10,@-r15          ! setze BL=1,Intm=14, lasse MD=1,RB=0
                mov.l r11,@-r15          ! push R8..R14,GBR,VBR,TaskNr,VarBase
                mov.l r12,@-r15          ! denn R0..R7 darf 'C'-Funktion trashen
                mov.l r13,@-r15          ! da der Ram-Inhalt Standby berlebt
                mov.l r14,@-r15          ! knnen wir System-Zustand restoren
                stc.l gbr,@-r15          ! save jetzigen Stack-Pointer in B1/R2
                stc.l vbr,@-r15          ! in B1/R3 steht bereits die Stack-Nr
                mov.l r1,@-r15           ! so steht System-Zustand vor Standby
                mov.l r0,@-r15           ! in den Cpu-Registern R2-R7 der 2.Bank
                ldc r15,r2_bank          !_wird dort dann von Wakeup ausgewertet
                mov.l BOOT_K0022,r2      ! Module-Enable:
                mov #A_STBCR,r3          ! wir brauchen aktiven Rtc und Timer
                mov.b @r3,r0             ! um Standby-Mode per Timer zu beenden
                mov.w BOOT_K0025,r8      ! clr Bit#1/Mstp1/Rtc,Bit#2/Mstp2/Tmu
                mov.w BOOT_K0024,r1      ! in Stbcr fr aktivierteRtc/Tmu-Module
                and #0xF9,r0             ! der Zustand der anderen Module bleibt
                mov.b r0,@r3             !_setup R1=*Scscr,R2=*Dmaor,R8=0x0300
                mov.w @r2,r0             ! Dma-Disable:
                mov.w r8,@r2             !_dummy-read Dmaor, write 0x0300->Dmaor
                add #0x44,r2             ! Sio-Disable:
                mov.l BOOT_K0023,r3      ! setup R2=*Dacr,R3=*Scscr1
                mov #0x01,r0             ! write 0x01 --> Scscr,  Sio#0=Off/Clk
                mov.b r0,@r1             ! write 0x01 --> Scscr1, Sio#1=Off/Clk
                mov.b r0,@r3             ! write 0x00 --> Scscr2, Sio#2=Off
                xor r0,r0                ! damit sind alle Sios deaktiviert
                add #0x10,r3             ! die TxD-Outputs liefern kurz Hi-Pegel
                mov.b r0,@r3             !_bevor die Sio-Outputs tristate werden
                mov #0x1F,r0             ! D/A-Disable:
                mov.b r0,@r2             !_write 0x1F --> Dacr, D/A=Disabled
                mov #0x13,r0             ! A/D-Disable:
                add #0x4C,r1             ! setup R1=*RSecAr,R2=*Adcsr
                add #0xEC,r2             ! write 0x13 --> Adcsr, AdIe=AdSt=0
                mov.b r0,@r2             ! dummy-read Adcsr fr Adf-Flag-Clear
                mov.b @r2,r3             ! write 0x13 --> Adcsr, Adf=0,(Sl.0-3)
                mov.b r0,@r2             !_damit ist der A/D-Wandler disabled
                mov #0x06,r3             ! RTC-Setup:
             1:   tst r7,r7              ! lade gewnschte Wakeup-Zeit in Rtc
                  bt/s 2f                ! fr 6 Alarm-Zeit-Bytes jeweils:
                  xor r0,r0              ! teste ob Rtc-Argument-Ptr Null ist
                    mov.b @r7+,r0        ! wenn ja Null-Byte, sonst Daten lesen
             2:   dt r3                  ! decrement Byte-Count, teste ob Null
                  mov.b r0,@r1           ! schreibe Alarm-Byte in Rtc-Register
                  bf/s 1b                ! update Rtc-Register-Pointer um +=2
                  add #0x02,r1           ! repeat bis alle 6 Rtc-Bytes geladen
                tst r7,r7                ! teste ob Rtc-Argument-Ptr Null ist
                bt/s 3f                  ! wenn ja dann Null-Byte fr Rcr1
                tst r6,r6                ! bei Rtc-Alarm 0x08 als Wert fr Rcr1
                  mov #0x08,r3           ! und ebenfalls R7 mit -=6 zurcksetzen
                  add #0xFA,r7           ! teste ob 32kHz-Count-Argument Null
             3: mov.b r3,@r1             ! schreibe 0x00/0x08 --> Rcr1, Aie=0/1
                mov #0x09,r0             ! schreibe 0x09 --> Rcr2,Start=RtcEn=1
                mov.b r0,@(2,r1)         !_damit ist der Rtc-Wecker gestellt
                xor r0,r0                ! TMR-Setup:
                add #0xB4,r1             ! setup R1=*Tocr,(R2=*Adcsr)
                mov.b r0,@(2,r1)         ! write 0x00 --> TStr, Tmr#0-2=Stop
                add #0x80,r2             ! write 16-kHz-Arg --> Tcnt1
                mov.l r6,@(20,r1)        ! write 0xFFFFFFFF --> Tcor1
                mov #0xFF,r0             ! der 32-Bit-Zhler Tcnt zhlt abwrts
                mov.l r0,@(16,r1)        ! und er luft nach max 73 Stunden ber
                bt/s 4f                  ! weil mit 16384 Hz aus RtcClk getaktet
                mov #0x04,r0             ! somit Einschalt-Auflsung von 61uSec
                  mov #0x24,r0           ! if CntArg=0 dann 0x0004, else 0x0024
             4: mov.w r0,@(24,r1)        ! wr 0x0004/0x0024 --> Tcr1, Unie=0/1
                mov #0x02,r0             ! starte konfigurierten 16kHz-Timer#1
                bra BOOT_XSTANDBY        ! write 0x02 --> Tstr, Tmr#1=Run
                mov.b r0,@(2,r1)         ! weiter mit Interrupt-Konfiguration

!...............

BOOT_K0021:     .long  0x500000E1        ! SR mit BL=1,Intm=14            [00EC]
BOOT_K0022:     .long  A_DMAOR           ! Adresse Dma#0-3 Operation-Register
BOOT_K0023:     .long  A_SCSCR1          ! Adresse Sio#1/2 Control-Register
BOOT_K0024:     .short A_SCSCR           ! Adresse Sio#0 Control-Register
BOOT_K0025:     .short 0x0300            ! Konstante 0x0300 als Dmaor-Val

BOOT_K0001:     .long BOOT_RESET +0xA0000000 ! Cpu-Reset-Handler          [00FC]

!--------------------
! GENERAL_EXCEPTIONS
!--------------------

                mov.w BOOT_K0031,r0      ! **** GENERAL_EXCEPTIONS ****   [0100]
                mov #A_EXPEVT,r1         ! Cpu springt fr Exceptions hierher
                mov.l @r1,r2             ! dabei ist MD=RB=BL=1,PC->SPC,SR->SSR
                tst r3,r3                ! Kopiere 0x0FE0 ---> Expevt ---> R2
                mov.l r0,@r1             ! save StackNr in R0, StackPtr in R1
                mov r3,r0                ! teste ob Stack-Pointer im User-Stack
                bf/s 1f                  ! wenn nein dann kann Stack so bleiben
                mov r15,r1               !_dann weiter mit Cpu-State Stack-Save
                  mov #A_PTEH,r1         ! Wechsele_auf_Task/Kernel-Stack:
                  mov.l @r1,r0           ! lese Task-Nummer aus Pteh nach R0
                  mov.l @(8,r1),r1       ! lese Sys-Data-Ptr aus Ttb nach R1
                  extu.b r0,r0           ! baue Pointer auf Task-private Daten
                  add #0x40,r0           ! Basisadr(R1)+0x4000+TaskNr(R0)*0x0100
                  shll8 r0               ! denn zuerst 2K feste Daten,dann Tasks
                  add r1,r0              ! save alten Stack-Ptr(R15) in R1
                  mov r15,r1             ! lese Kernel-Stack-Ptr aus Task-Daten
                  mov.l @(12,r0),r15     ! setze alte Stack-Nr in R0 auf 0x00
                  xor r0,r0              ! setze neue Stack-Nr in R3 auf 0x01
                  mov #0x01,r3           !_der Expevt-Value in R2 blieb erhalten
             1: mov.l r1,@-r15           ! Save_Cpu-State_auf_neuem_Stack:
                mov.l r0,@-r15           ! push OldStkPtr,OldStkNr,UsrSr,UsrPc
                stc.l ssr,@-r15          ! push Expevt,gleich noch Detail-Grund
                stc.l spc,@-r15          ! dieser Stack-Inhalt auf jeden Fall
                mov.w BOOT_K0032,r0      ! teste Expevt=0x0160 fr Trap-Opcode
                mov.l r2,@-r15           ! denn Traps sind hufigste Exception
                cmp/eq r2,r0             ! setup R1=*Tra,R2=Expevt,R3=StkNr
                bf/s 9f                  ! jump wenn Event kein Trap gewesen
                mov #A_TRA,r1            !_ansonsten weiter den Trap bearbeiten
                  mov.l @r1,r2           ! Bearbeite_Trap-Opcode-Event:
                  mov.l BOOT_K0057,r1    ! lese TrapNr*4 in R2-Register
                  stc sr,r0              ! save TrapNr*4 als Event-Detail
                  and r1,r0              ! modifiziere Cpu-Status-Register
                  mov.l r2,@-r15         ! setze BL=RB=0,lasse Md=1,Dsp,Intm
                  ldc r0,sr              !_ab jetzt drfen Ints wieder kommen
                  mov.l r0,@-r15         ! Save_RB0-Regs_und_verwurste_Traps:
                  mov.l r1,@-r15         ! push R0 und R1 der ersten Reg-Bank
                  mov.l @(8,r15),r0      ! lese TrapNr*4 vom Stack nach R0
                  mov #0x02,r1           ! lese DebugTrap-Limit 0x02 in R1
                  shlr2 r0               ! baue signed 8-Bit-Trap-Nr in R0
                  exts.b r0,r0           ! teste ob ber Debug-Traps 0x00,0x01
                  cmp/hs r1,r0           ! als default R1/MustHaveHandler=0x00
                  bf/s 4f                ! die Traps#0x00/0x01 sind informell
                  xor r1,r1              !_es muss dafr keinen Handler geben
                    cmp/pz r0            ! Bediene_Trap-Nr_0x02..0xFF:
                    mov.l @(20,r15),r1   ! teste ob High-Trap 0x80..0xFF
                    bf 2f                ! lese Usr-Cpu-Sr mit Md-Bit vom Stack
                      shll r1            ! fr High-Traps jump zu deren Handler
                      shll r1            ! sonst testen on User privileged war
                      bf BOOT_X0032      !_if not dann Debugger fr Low-Traps
                        mov.l r2,@-r15   ! Bediene_Trap-Nr_0x02..0x7F:
                        mov.l r3,@-r15   ! das sind Low-Level-IO-Funktionen
                        mov.l r4,@-r15   ! nur fr privileged Caller ausfhrbar
                        mov.l r5,@-r15   ! save User-Register auf Kernel-Stack
                        mov.l r6,@-r15   ! die Regs R0,R1 sind schon gepushed
                        mov.l r7,@-r15   ! jetzt R2,R3,R4,R5,R6,R7,PR,GBR saven
                        sts.l pr,@-r15   ! nun knnen wir 'C'-Funktionen callen
                        stc.l gbr,@-r15  ! wir brauchen 64 Byte an Kernel-Stack
                        mov #A_TTB,r1    ! setup Gbr auf System-Variablen-Ptr
                        ldc.l @r1+,gbr   ! baue Trap-Table-Short-Index in R1
                        extu.b r0,r1     ! aus unsigned TrapNr{0x02..0x7F}*2
                        shll r1          ! plus Tabellen-Basisadresse 0x0300
                        mova BOOT_TRAPTBL-4,r0! ergibt Adresse Offset-Short
                        mov.w @(r0,r1),r0! lese Trap-Handler-Offset aus Table
                        mov.l @(32,r15),r1! restore User-Regs R0,R1 vom Stack
                        bsrf r0          ! call den Trap-Handler als Subroutine
                        mov.l @(36,r15),r0!_das Pr-Register ist Ret-Adr hierher
BOOT_X0031:             mov.l r0,@(36,r15)! Fertig_mit_Trap-Service:      [0184]
                        ldc.l @r15+,gbr  ! save Return-Value in User-R0
                        lds.l @r15+,pr   ! alle anderen Register bleiben gleich
                        mov.l @r15+,r7   ! restore GBR,PR,R7,R6 hier vom Stack
                        bra BOOT_XRET2   ! die anderen Register gleich gemeinsam
                        mov.l @r15+,r6   !_goto Exception-Return im Int-Handler
             2:     cmp/eq #0xFF,r0      ! Bediene_Trap-Nr_0x80..0xFF:
                    bt 3f                ! teste ob Trap#0xFF/Breakpoint-Trap
                      mov.w BOOT_K0033,r0! wenn ja goto Breakpoint-Trap-Handler
                      mov #A_TTB,r1      ! sonst die Traps 0x80..0xFE bedienen
                      mov.l @r1,r1       ! dazu Handler-Adr aus Sys-Data lesen
                      mov.l @(r0,r1),r0  ! steht im Long-Word (VarBase+0x0090)
                      tst r0,r0          ! teste ob Null-Daten und kein Handler
                      bt BOOT_X0032      ! ohne High-Traps-Handler dann Debugger
                        mov.l @r15+,r1   ! sonst bernimmt High-Traps-Handler
                        jmp @r0          ! dazu R0,R1 vom Stack, der Rest bleibt
                        mov.l @r15+,r0   !_jump zum High-Traps-Handler aus Data
             3:     mov.l @(16,r15),r0   ! Bediene_Trap-Nr_0xFF:
                    add #0xFE,r0         ! fr Breakpoint-Trap User-Pc zurck
                    mov.l r0,@(16,r15)   !_denn da wird Opcode wieder eingesetzt
BOOT_X0032:       mov #0x01,r1           ! Call_zustndigen_Debugger:     [01AC]
             4:   stc r3_bank,r0         ! push R1=MustHaveHandler {0x00/0x01}
                  mov.l r1,@-r15         ! lese unsere Stack-Nr aus RB1/R3 in R0
                  mov #0x02,r1           ! teste ob im Int-Stack / Realtime-Part
                  cmp/hs r1,r0           ! lade default System-Data-Ptr in R0
                  mov #A_PTEH,r1         ! dazu kurzzeitig setup R1=*Pteh
                  mov.l @(8,r1),r0       ! baue jetzt Debug-Ptr-Offset in R1
                  bt 5f                  ! fr Realtime-Part goto festem Offset
                    mov.l @r1,r1         ! fr User-Task Debug-Ptr-Offset bauen
                    extu.b r1,r1         ! lese unsere Task-Nr aus Pteh nach R1
                    add #0x40,r1         ! der Offset ist 0x4000+(TaskNr*0x0100)
                    bra 6f               ! bei maximal 256 Tasks (d.h. Asid's)
                    shll8 r1             ! somit beim Maximum 256 Tasks 80K Ram
             5:   mov.w BOOT_K0034,r1    ! fr Realtime-Exception Offset=0x0080
             6:   add r0,r1              ! baue Debug-Var-Ptr aus Base + Offset
                  mov.l @r1,r0           ! lese Consolen-Handle des Debuggers
                  tst r0,r0              ! teste ob Debug-Console installiert
                  bt 7f                  ! wenn Null kein Debugger aufrufbar
                  mov.l @(4,r1),r1       ! lese Variablen-Base des Debuggers
                  tst r1,r1              ! teste ob Ram-Debugger installiert
                  bt 7f                  ! wenn Null kein Debugger aufrufbar
                  tas.b @r1              ! set Bit#7 im ersten Debug-Ram-Byte
                  bf 7f                  !_wenn schon gesetzt Debugger belegt
                    mov.l r0,@r15        ! Jump_zum_verfgbaren_Debugger:
                    mov.w BOOT_K0038,r0  ! setup R0=*Console,R1=*DebugRam
                    braf r0              ! Stack=OldStkPtr,OldStkNr,UsrSr,UsrPc
             7:    mov.l @r15+,r0        !_sowie Expevt,EventDetail,R0,R1
BOOT_X0033:       tst r0,r0              ! Debugger_ist_nicht_verfgbar:
                  bt 8f                  ! restore MustHaveHandler vom Stack
                    bra BOOT_XKILLME     ! wenn Handler ntig dann Selbstmord
                    add #0x08,r15        ! ohne Debugger geht's nicht weiter
             8:   bra BOOT_XRET3         ! wenn kein Handler ntig so zurck
                  nop                    !_kann nur Trap 0x00/0x01 passieren
             9: mov.w BOOT_K0035,r0      ! Bediene_Nicht-Trap-Exceptions:
                cmp/hi r2,r0             ! teste ob Expevt unter 0x0120 ist
                bf 1f                    ! wenn nein weiter, kein Mmu-Event
                  mov.l @(44,r1),r2      ! fr Mmu-Events R2/EventDetail=Tea
             0:   stc sr,r0              ! Gemeinsame_Bedienung_Nicht-Traps:
                  mov.l BOOT_K0057,r1    ! wir haben Event-Detail im R2-Reg
                  mov.l r2,@-r15         ! modifiziere Cpu-Status-Register
                  and r1,r0              ! setze BL=RB=0,lasse Md=1,Dsp,Intm
                  ldc r0,sr              !_ab jetzt drfen Ints wieder kommen
                  mov.l r0,@-r15         ! Save_RB0-Regs_und_verwurste_Event:
                  bra BOOT_X0032         ! push R0 und R1 der ersten Reg-Bank
                  mov.l r1,@-r15         ! weiter mit zwingendem Debug-Aufruf
             1: mov.w BOOT_K0036,r0      ! Bediene_Nicht-Trap/Nicht-Mmu-Events:
                cmp/eq r2,r0             ! teste ob Expevt gleich 0x01E0 fr
                bf/s 0b                  ! die "User-Break-Controller"-Exception
                xor r2,r2                !_ansonsten Std-Service mit R2/Detail=0
                  mov #A_BBRA,r1         ! Bediene_User-Break-Controller-Event:
                  mov.w @r1,r0           ! um weitere Break-Events zu vermeiden
                  and #0x0F,r0           ! disablen wir zuerst Break-Erzeugung
                  mov.w r0,@r1           ! bei Exception schtzt uns kein Intm
                  mov #A_BRCR,r1         ! lese Bbra-Reg, clear Cda/Ida-Enable
                  mov.w BOOT_K0037,r2    ! nun erzeugt Channel#A keine Breaks
                  mov.w @(0x10,r1),r0    ! lese Bbrb-Reg, clear Cdb/Idb-Enable
                  and r2,r0              ! nun erzeugt Channel#B keine Breaks
                  mov.w r0,@(0x10,r1)    ! lese globales Brcr-Register nach R2
                  .if NEWUBC             ! dessen Bus-Breite ist unterschiedlich
                  mov.l @r1,r2           ! clr ScmfcA,Scmfcb,Scmfda,Scmfdb-Flg
                  .else                  ! bei Sh7709=16Bit,Sh7709a/Sh7729=32Bit
                  mov.w @r1,r2           ! bei Sh7709 sind viele Bits auch Null
                  .endif                 ! clr Scmfldt,Scmfiob,Ldte,Iobe
                  mov.l BOOT_K0039,r0    ! clr BieA,BieB,Nprot,Rtbmk
                  and r2,r0              ! sind im Main-Chip-Mode irrelevant
                  bra 0b                 ! lasse die anderen Bits, write Brcr
                  .if NEWUBC             ! so hat Sh7709a/Sh7729 nutzbarem Mehr
                  mov.l r0,@r1           ! Brcr-Bits (Basma,Basmb),Scmfda,Scmfdb
                  .else                  ! und Pcte,Toea,Toeb,Etbe sowie die
                  mov.w r0,@r1           ! BbrX-Bits Cda1,Cda0,Xye,Xys,Cdb1,Cdb0
                  .endif                 ! goto Std-Events mit R2/Detail=Brcr

!...............

BOOT_K0031:     .short 0x0FE0            ! Expevt: Default (double-Excpt) [022A]
BOOT_K0032:     .short 0x0160            ! Expevt: Trap-Opcode
BOOT_K0033:     .short 0x0090            ! SysData: High-Traps-Handler
BOOT_K0034:     .short 0x0080            ! SysData: Realtime-Debugger
BOOT_K0036:     .short 0x01E0            ! Expevt: User-Break-Controller
BOOT_K0037:     .short 0x030F            ! Bbrb-Maske fr Trigger-Clear
BOOT_K0038:     .short MONITOR-BOOT_X0033! Monitor-Entry-Adresse/rel
BOOT_K0039:     .long  0x00300EE9        ! Brcr-Maske fr Match-Clear

!----------------
! STANDBY-MODE/2
!----------------

BOOT_XSTANDBY:  mov.w BOOT_K0040,r3      ! [GOTO_STANDBY-MODE:]           [023C]
                mov.w BOOT_K0041,r0      ! INT-Setup:
                mov.w r3,@r2             ! mit Register-Val R1=*Tocr, R2=*Icr1
                add #0x50,r1             ! setze R1=*Icr0 fr Int-Konfiguration
                mov.w r0,@(2,r2)         ! setze R2=*Icr1 fr Int-Konfiguration
                mov r5,r0                ! write 0x0AA8 --> Icr1, Mai=IrL=BlMs=0
                shll8 r0                 ! write 0x30C0 --> Icr2,  P#F/C-Aktiv
                mov.w r0,@(4,r2)         ! write 0xNN00 --> PInter,P#F/C-Maske
                mov.w BOOT_K0042,r0      ! write 0x0F0F --> IprA, Tmr#1/Rtc=15
                mov.w r0,@(2,r1)         ! write 0x0000 --> IprB,  <disabled>
                xor r0,r0                ! write 0x0000 --> IprC,  <disabled>
                mov.w r0,@(4,r1)         ! write 0x0000 --> IprE,  <disabled>
                mov.w r0,@(6,r2)         ! write 0x0F00 --> IprD, PInt#8-15=15
                mov.w r0,@(10,r2)        ! write 0x0100 --> Icr0, Nmi bei L->H
                mov.w BOOT_K0043,r0      ! damit ist klar was uns aufwecken kann
                mov.w BOOT_K0044,r3      ! nur PInt#8-15, Tmr#1 und Rtc mglich
                mov.w r0,@(8,r2)         ! wenn diese Module Interrupt erzeugen
                mova BOOT_K0050,r0       !_es geht immer Erwecken mit Nmi L->H
                mov.w r3,@r1             ! PIN-Setup:
                bsr BOOT_XSETPORTS       ! bringe Cpu-Port-Pins in Standby-State
                mov #0x06,r1             ! viele Pins mssen z.B. hochohmig sein
                mov.b @r3,r2             ! setup Port#C,D,E,H,J,S fr Standby
                mov #0x06,r1             ! die Ports#A,B,F,G,K,L bleiben gleich
                shlr2 r2                 ! Setze Port#H Config-Switch-Pullups:
                shlr2 r2                 ! dort wo Masse-Jumper Pullup ausmachen
                and r2,r1                ! um unntigen Standby-Strom zu sparen
                mov.l BOOT_K0051,r2      ! isoliere Bit#5/6 aus Port#H-Input
                add #0xE0,r3             ! baue Word-Index 0..3, lese Table-Word
                mov.w @(r0,r1),r0        ! setup R2=*RomBootX0041, R3=*Phcr
                jmp @r2                  ! write Table-Word --> Phcr,CfgPullups
                mov.w r0,@r3             ! weiter mit BUS-Setup-Handler aus Rom
                                         !-
BOOT_X0041:     shlr16 r2                ! BUS-Setup:                     [027A]
                mov.w BOOT_K0045,r1      ! sind im Rom, knnen SDRAM umschalten
                shll16 r2                ! unsere Adresse hier im Rom ist in R2
                mov.w BOOT_K0046,r3      ! setup R1=*Bcr1,R2=*RomBase,R3=0x07FF
                ldc r2,vbr               ! reset Vector-Base-Reg auf Rom-Start
                mov.w @r1,r8             ! setze Bcr1, Pula=Puld=HizM=HizC=End=0
                mov #A_FRQCR,r2          ! damit Adr,Data,Ctrl,Ras/Cas Hi-Z sind
                mov.w @(8,r1),r0         ! setze Mcr, Rfsh=RMode=1/Self-Refresh
                and r3,r8                ! jetzt geht das SDram in Self-Refresh
                mov.w r8,@r1             ! und kann nicht mehr benutzt werden
                or #0x06,r0              ! wir haben jetzt nur noch unser Rom
                mov.w r0,@(8,r1)         !_setup R2=*Frqcr fr Watchdog-Config
                mov.w BOOT_K0048,r0      ! WDT-Setup:
                mov.w r0,@(6,r2)         ! setup Watchdog fr Xtal-Statup-Zeit
                mov.w BOOT_K0049,r0      ! write 0xA547 --> Wtcsr PClk/4096
                mov.w r0,@(4,r2)         ! write 0x5A9D --> Wtcnt fr 20mSec
                mov.b @(2,r2),r0         ! so lange haben Quarz + Netzteil Zeit
                or #0x80,r0              ! setze Bit#7/Stby in Stbcr fr Standby
                mov.b r0,@(2,r2)         !_jetzt sind wir bereit fr Cpu-Standby
                sleep                    !_CPU-Standby: Standby-schalten der SH3
                bra _cpu_rescold         ! Hier sollten wir niemals ankommen
                mov #0xFF,r4             ! denn Standby-Wakeup returned nicht


BOOT_XSETPORTS:   mov.b @r0+,r2          ! [PORT-GRUPPE_EINSTELLEN:]      [02A6]
                  mov.l BOOT_K0047,r3    ! R0 = Adresse Port-Setup-Liste
                  dt r1                  ! R1 = Anzahl einzustellender Ports
                  add r2,r3              ! ---> Ports eingestellt (Data/Ctrl)
                  mov.b @r0+,r2          !      R0,R1,R2,R3 werden verndert
                  mov.b r2,@r3           ! Fr jeden der einzustellenden Ports:
                  add #0xE0,r3           ! lese Byte-Offset des Ports aus Table
                  mov.w @r0+,r2          ! baue Pointer auf Daten-Register in R3
                  bf/s BOOT_XSETPORTS    ! lese Port-Daten-Byte aus List in Port
                  mov.w r2,@r3           ! lese Port-Ctrl-Short aus List in Port
                rts                      ! repeat bis alle Ports eingestellt
                add #0x18,r3             ! update Port-Pointer typ auf PHDR

!...............

BOOT_K0040:     .short 0x0AA8            ! Icr1-Data: Mai=IrqLvl=BlMsk=0  [02BE]
BOOT_K0041:     .short 0x30C0            ! Icr2-Data: Port#F/C Aktiv-Lvl
BOOT_K0042:     .short 0x0F0F            ! IprA-Data: Tmr#1/Rtc Intm=15
BOOT_K0043:     .short 0x0F00            ! IprD-Data: PInt#8-15 Intm=15
BOOT_K0044:     .short 0x0100            ! Icr0-Data: Nmi bei Low->High
BOOT_K0045:     .short A_BCR1            ! Bcr1-Adresse, Bus-Controller-Basis
BOOT_K0046:     .short 0x07FF            ! Bcr1-Clear: Pula,Puld,HizM,HizC,End
BOOT_K0047:     .short 0xA400            ! XSetPorts: Port#A-Daten-Register
BOOT_K0035:     .short 0x0120            ! Expevt: Limit TEA-Exceptions
BOOT_K0048:     .short 0xA547            ! Wtcsr-Data: Xtal-Startup 20mSec
BOOT_K0049:     .short 0x5A9D            ! Wtcnt-Data: Xtal-Startup 20mSec
                                         !-
BOOT_K0050:     .byte  0x04,0x30         ! PORT-STANDBY-TABLE:            [02D4]
                .short 0x5F55            ! Port#C: Data=0x30, Ctrl=0x5F55
                .byte  0x06,0xF8         ! Port#D: Data=0xF8
                .short 0xFF35            ! Port#D: Ctrl=0xFF35
                .byte  0x08,0x20         ! Port#E: Data=0x20
                .short 0x5155            ! Port#E: Ctrl=0x5155
                .byte  0x0E,0x7F         ! Port#H: Data=0x7F
                .short 0xEBFF            ! Port#H: Ctrl=0xEBFF
                .byte  0x10,0x07         ! Port#J: Data=0x07
                .short 0x0540            ! Port#J: Ctrl=0x0540
                .byte  0x16,0xF4         ! Port#S: Data=0xF4
                .short 0xFF75            ! Port#S: Ctrl=0xFF75
                                         !-
                .short 0xFFFF            ! Port#H: Ctrl (Bit#6=L,Bit#5=L) [02EC]
                .short 0xFBFF            ! Port#H: Ctrl (Bit#6=L,Bit#5=H)
                .short 0xEFFF            ! Port#H: Ctrl (Bit#6=H,Bit#5=L)
                .short 0xEBFF            ! Port#H: Ctrl (Bit#6=H,Bit#5=H)
                                         !=
BOOT_ROMINFO1:  .byte 0x84               ! 02F4 (1) Magic-Byte "0x84"     [02F4]
                .byte VER_MAJ            ! 02F5 (1) Versions-Nr/Major
                .byte VER_MIN            ! 02F6 (1) Versions-Nr/Minor
                .byte VER_SPC            ! 02F7 (1) Versions-Nr/Flags
                                         !-
                .long SERIALNR           ! 02F8 (4) Device_Serial-Nr      [02F8]
                                         !=
BOOT_K0051:     .long BOOT_X0041+0xA0000000! Standby-Rom-Shutdown-Code    [02FC]

!------------
! TRAP-TABLE
!------------

BOOT_XNIX:      rts                      ! UNUSED_FUNCTIONS:              [0300]
                mov #0xFE,r0             ! return -2/BadFktn


BOOT_TRAPTBL:   .short _cpu_killme    - BOOT_X0031 ! 02 - Programm-Ende   [0304]
                .short _cpu_rescold   - BOOT_X0031 ! 03 - Power-On-Reset
                .short _cpu_reswarm   - BOOT_X0031 ! 04 - Manual-Reset
                .short _cpu_standby   - BOOT_X0031 ! 05 - Standby-Mode
                .short _cpu_getspeed  - BOOT_X0031 ! 06 - Cpu-Speed_lesen
                .short _cpu_setspeed  - BOOT_X0031 ! 07 - Cpu-Speed_setzen
                .short _cpu_wdtclr    - BOOT_X0031 ! 08 - Watchdog_beruhigen
                .short _mmu_translate - BOOT_X0031 ! 09 - Virt-Adr_bersetzen
                .short _send_signal   - BOOT_X0031 ! 0A - Sende_Sheduler-Signal
                .short BOOT_XNIX      - BOOT_X0031 ! 0B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 0C - <unused>
                .short BOOT_XNIX      - BOOT_X0031 !_0D - <unused>
                .short _sys_crcblock  - BOOT_X0031 ! 0E - Crc-Summe-Update/Block
                .short _sys_crcbyte   - BOOT_X0031 ! 0F - Crc-Summe-Update/Byte
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 10 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 11 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 12 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 13 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 14 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 15 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 16 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 17 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 18 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 19 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 1A - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 1B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 1C - <unused>
                .short BOOT_XNIX      - BOOT_X0031 !_1D - <unused>
                .short _sys_setled    - BOOT_X0031 ! 1E - Setze_Led-Output
                .short _sys_getled    - BOOT_X0031 ! 1F - Lese_Led-Output
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 20 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 21 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 22 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 23 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 24 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 25 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 26 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 27 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 28 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 29 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 2A - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 2B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 2C - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 2D - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 2E - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 2F - <unused>
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 30 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 31 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 32 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 33 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 34 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 35 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 36 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 37 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 38 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 39 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 3A - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 3B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 3C - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 3D - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 3E - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 3F - <unused>
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 40 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 41 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 42 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 43 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 44 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 45 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 46 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 47 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 48 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 49 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 4A - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 4B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 4C - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 4D - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 4E - <unused>
                .short _padda_xchg    - BOOT_X0031 ! 4F - <unused>
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 50 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 51 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 52 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 53 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 54 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 55 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 56 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 57 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 58 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 59 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 5A - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 5B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 !_5C - <unused>
                .short _temic_init    - BOOT_X0031 ! 5D - Temic-Chip_einstellen
                .short _temic_byteout - BOOT_X0031 !_5E - Temic-Byte_ausgeben
                .short BOOT_XNIX      - BOOT_X0031 ! 5F - <unused>
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 60 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 61 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 62 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 63 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 64 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 65 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 66 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 67 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 68 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 69 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 6A - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 6B - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 6C - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 6D - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 6E - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 6F - <unused>
                                                   !-
                .short BOOT_XNIX      - BOOT_X0031 ! 70 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 71 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 72 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 73 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 74 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 75 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 ! 76 - <unused>
                .short BOOT_XNIX      - BOOT_X0031 !_77 - <unused>
                .short _flash_erase_chip-BOOT_X0031! 78 - Flash-Chip_lschen
                .short _flash_erase_sectors-BOOT_X0031!79-Flash-Sektor_lschen
                .short _flash_program_byte-BOOT_X0031!7A- Flash-Byte_schreiben
                .short _flash_read_lock-BOOT_X0031 ! 7B - Lese_Flash-Sektor-Lock
                .short _flash_read_chipid-BOOT_X0031!7C - Lese_Flash-Chip-Id
                .short _flash_read_idmem-BOOT_X0031! 7D - Lese_Flash-Id-Memory
                .short _flash_read_data-BOOT_X0031 !_7E - Lese_Flash-Daten-Mem
                .short BOOT_XNIX      - BOOT_X0031 ! 7F - <unused>

!----------------
! MMU-EXCEPTIONS
!----------------

                mov.w BOOT_K0052,r0      ! ***** MMU-EXCEPTIONS *****     [0400]
                mov #A_EXPEVT,r2         ! Beantworte MMU-Page-Anfragen
                mov.l r0,@r2             ! Cpu springt bei Anfragen hierher
                mov #0x02,r0             ! dabei ist MD=RB=BL=1,PC->SPC,SR->SSR
                cmp/hs r0,r3             ! ignore Expevt-Inhalt 0x0040/0x0060
                mov r3,r0                ! wir wissen schon TLB-Miss-Exception
                bt/s 1f                  ! write 0x0FE0 --> Expevt als default
                mov r15,r1               !_teste ob schon auf Interrupt-Stack
                  mov.w BOOT_K0054,r1    ! Wechsele_auf_Interrupt-Stack:
                  mov.l @(36,r2),r2      ! lese Offset Interrupt-Stacktop in R1
                  add r1,r2              ! lese System-Data-Ptr aus Ttb nach R2
                  mov r15,r1             ! baue Interrupt-Stacktop-VarPtr in R2
                  mov.l @r2,r15          ! put OldStkPtr in R1, (OldStkNr in R0)
                  mov #0x02,r3           !_lade IntStackPtr, setze StkNr = 0x02
             1: mov.l r1,@-r15           ! Save_Cpu-State_und_setze_Intm-Level:
                mov #0x20,r2             ! bevor wir Interrupts erlauben knnen
                mov.l r0,@-r15           ! mssen wir Cpu-Intm>=2 sicherstellen
                stc sr,r0                ! gegen Task-Switch, Sheduler, Signals
                stc.l ssr,@-r15          ! denn Mmu-Bedienung nicht reentrant
                extu.b r0,r1             ! push OldStkPtr,OldStkNr,UsrSr,UsrPc
                stc.l spc,@-r15          ! isoliere Intm-Level aus Sr in R1
                cmp/hs r2,r1             ! teste ob schon mindestens Intm=2
                mov.w BOOT_K0058,r1      ! wenn ja ist Intm so ok, weiter
                bt 2f                    ! Neuen Intm-Level ins Cpu-Sr laden:
                  and r1,r0              ! setze Intm-Feld auf Null mit And-Mask
                  or r2,r0               ! bringe neuen Intm-Wert in den Sr-Wert
             2: mov.l BOOT_K0057,r1      ! setze BL=RB=0,lasse Md=1,Dsp und Intm
                and r1,r0                ! baue und lade den neuen Cpu-Sr-Wert
                ldc r0,sr                ! ab jetzt drfen Ints wieder kommen
                                         !-
                mov.l r0,@-r15           ! Mache_Adress-Translation:
                mov.l r1,@-r15           ! save die
                mov.l r2,@-r15           ! benutzten
                mov.l r3,@-r15           ! Register
                mov.l r4,@-r15           ! auf dem
                mov.l r5,@-r15           ! Int-Stack
                mov.l r6,@-r15           ! wo wir
                mov.l r7,@-r15           ! gesamt
                mov #A_PTEH,r0           ! 52 Byte
                sts.l pr,@-r15           ! brauchen
                mov.l @r0,r4             ! read virtual Page-Nr / Asid aus Pteh
                bsr _mmu_translate       ! ist Virtual-Adr und Task-Nr zugleich
                mov r4,r5                ! call die Adress-bersetzungs-Funktion
                lds.l @r15+,pr           ! schreibe Ergebnis ins Ptel-Register
                mov #A_PTEL,r1           ! darin physikalische Adresse und Flags
                mov.l r0,@r1             ! lade Ptel in Mmu-Hardware mit "ldtlb"
                ldtlb                    ! dann wieder benutzte Register zurck
                mov.l @r15+,r7           ! pop die
                mov.l @r15+,r6           ! benutzten
                mov.l @r15+,r5           ! Register
                mov.l @r15+,r4           ! vom Stack
                mov.l @r15+,r3           ! hier erstmal
                mov.l @r15+,r2           ! nur Pr,R7-R2
                                         !-
BOOT_XRET1:     mov.l BOOT_K0088,r0      ! TRAP-ENDE_OHNE_EVENTCODE:      [0468]
                stc sr,r1                ! restauriert R1,R0, dann ohne Event-Nr
                or r1,r0                 ! im Stack pop UsrPc,UsrSr,StkNr,StkPtr
                mov.l @r15+,r1           ! pop R1 danach RB=BL=1 fr 2.Reg-Bank
                ldc r0,sr                ! pop R0 wieder in die 1.Register-Bank
                bra BOOT_XRET4           ! weiter mit restore der Rest-Register
                ldc.l @r15+,r0_bank      ! dazu jump zum Handler aus Int-Return
                                         !-
BOOT_K0052:     .short 0x0FE0            ! default ExpEvt-Value double-Exception


_mmu_translate: mov #A_TTB,r0            ! 09 - RESOLVE_VIRTUAL_ADRESS:   [0478]
                extu.b r5,r5             ! unsigned long mmu_translate
                add #0x40,r5             ! (const void *Ptr, unsigned char Asid)
                shll8 r5                 ! Baue Task-Data-Offset aus Asid in R5
                mov.l @r0,r6             ! lese Variablen-Base-Adresse nach R6
                sts pr,r7                ! save Return-Adresse zum Caller in R7
                add r6,r5                ! baue Task-Daten-Startadresse in R5
                bsr MMU_XSEARCH          ! lese Pointer Task-MMU-Table in R3
                mov.l @(8,r5),r3         ! suche die virtuelle Adresse aus R4
                bt 1f                    ! fertig wenn Adresse aufgelst wurde
                  mov.w BOOT_K0053,r0    ! lese Offset der globalen Mem-Table
                  bsr MMU_XSEARCH        ! lese Pointer auf globale MMU-Table
                  mov.l @(r0,r6),r3      ! suche die virtuelle Adresse aus R4
                  bt 1f                  ! fertig wenn Adresse gefunden wurde
                    xor r0,r0            ! sonst als default RetVal=0/NoPage
             1: jmp @r7                  ! lade T=R1=0/NoPage,T=R1=1/PageFound
                movt r1                  ! return zum Caller via R7-Return-Adr
                                         !-
BOOT_K0053:     .short 0x0088            ! Offset Globale Mem-Table       [049A]


             1:   add #0x10,r3           ! [SEARCH_MEMMAP-LIST:]          [049C]
MMU_XSEARCH:      mov.b @r3,r0           ! R3 = Pointer Memmap-Liste
                  cmp/pz r0              ! R4 = gesuchte virtuelle Adresse
                  bf 2f                  ! ---> T=0 - Adresse nicht in Liste
                  mov.l @(4,r3),r0       !      T=1 - Adresse wurde aufgelst
                  mov r4,r1              !            R0 = MMU/physical-Adr
                  cmp/hs r0,r1           !      R1 und R2 werden getrashed
                  bf 1b                  !      R3 steht auf aktuellem Eintrag
                  mov.l @(8,r3),r2       ! Vergleiche_nchsten_Tabellen-Eintrag:
                  sub r0,r1              ! teste Bit#7="1"/Ende im ersten Byte
                  cmp/hi r1,r2           ! wenn ja fertig, zurck mit t=0/nix
                  bf 1b                  ! lese virtuelle StartAdr des Eintrags
                mov.l @(12,r3),r0        ! wenn wir kleiner sind nchster Entry
                mov.w BOOT_K0056,r2      ! sonst Position im Bereich bestimmen
                add r1,r0                ! wenn ber Bereichsende nchster Entry
                and r2,r0                ! sonst wurde Adresse in Liste gefunden
                mov.b @r3,r1             ! physikalische Adr aus Offset und Base
                mov.w BOOT_K0055,r2      ! isoliere phys Page-Nr in Bit#10..31
                or r1,r0                 ! set Valid/Bit#8,Dirty/Bit#2,Flags#0-6
             2: rts                      ! das T-Flag ist wenn gefunden gesetzt
                or r2,r0                 ! zurck mit Ptel-Wert/0x0000 fr R4

!...............

BOOT_K0054:     .short 0x008C            ! Offset Kernel-Stacktop         [04C6]
BOOT_K0055:     .short 0x0104            ! Or-Mask fr PTEL-Value
BOOT_K0056:     .short 0xFC00            ! And-Mask fr PPN-Value
BOOT_K0057:     .long  0x400010F0        ! SR-Mask fr BL-Clear
BOOT_K0058:     .short 0xFF0F            ! And-Mask fr Intm-Clr

!-----------------
! CLOCK-GENERATOR
!-----------------

_cpu_wdtclr:    mov #A_WTCNT,r1          ! 08 - WATCHDOG_BERUHIGEN:       [04D2]
                mov.w BOOT_K0061,r0      ! void cpu_wdtclr (void)
                rts                      ! Lese WtCnt-Control-Word
                mov.w r0,@r1             ! schreibe 0x5A00-->WtCnt


_cpu_setspeed:  tst r4,r4                ! 07 - SETZE_CPU-SPEED:          [04DA]
                mov.w BOOT_K0062,r0      ! unsigned long cpu_setspeed
                bt/s 1f                  ! (unsigned long NewSpeed)
                mov #A_FRQCR,r1          ! Lese default-Value fr FrqCr
                  or #0x04,r0            ! wenn Fast/NewSpeed=0 dann ok
             1: mov.w r0,@r1             ! sonst Slow,setze Ifc#0/Bit#2
                                         !-
_cpu_getspeed:  mov #A_FRQCR,r1          ! 06 - LESE_CPU-SPEED:           [04E6]
                mov.w @r1,r0             ! unsigned long cpu_getspeed (void)
BOOT_X0061:     shlr2 r0                 ! Lese FrqCr-Word-Inhalt aus Hardware
                rts                      ! shifte und isoliere Ifc#0 nach Bit#0
                and #0x01,r0             ! zurck mit Speed 0x00=Fast/0x01=Slow

!...............

BOOT_K0061:     .short 0x5A00            ! WtCnt-Clear-Word               [04F0]
BOOT_K0062:     .short K_FRQCR           ! FrqCr fr Cpu=Fast

!------------------
! INTERRUPT-SYSTEM
!------------------

_send_signal:   mov #0x01,r0             ! 0A - SENDE_SHEDULER-SIGNAL:    [04F4]
                add #0xFF,r4             ! void send_signal (unsigned char Sig)
                shld r4,r0               ! R4 = Signal-Nr fr Sheduler {1..32}
                mov r0,r4                ! ---> Signal ist gesendet worden
                mov.l BOOT_K0086,r0      !      R0..R4 werden getrashed
                stc sr,r1                ! Setup Register fr Zugriff mit BL=1
                mov.w BOOT_K0071,r2      ! lade R0=ZugriffSr/BL=1,R1=OrginalSr
                mov #A_TTB,r3            ! lade R2=*Rtcsr,R3=SysVarBase+0x0050
                mov.l @r3,r3             ! lade R4=2^(SigNr-1) oder Null fr 0
                or r1,r0                 ! damit sind wir ready fr BL=1-Phase
                add #0x50,r3             ! in der wir globale Flags verndern
                ldc r0,sr                !_setze BL=1 im Cpu-Status-Register
                mov.l @r3,r0             ! Generiere_Cpu-Signal:
                or r4,r0                 ! lese Signal-Flags in SysData+0x0050
                mov.l r0,@r3             ! setze darin gewnschtes Signal-Flag
                mov.w @r2,r0             ! alle anderen Bits bleiben unverndert
                mov.w BOOT_K0073,r3      ! lese Rtcsr des Refresh-Controllers
                extu.b r0,r0             ! setze darin Bit#1/Ovie fr Ref-Int
                or r3,r0                 ! alle anderen Bits bleiben unverndert
                ldc r1,sr                ! der Int-Request kommt nach 6.5 IClks
                bra BOOT_X0061           ! kann nach 2.5 IClks User-Code kommen
                mov.w r0,@r2             ! wenn dieser Interrupts nicht disabled


BOOT_XSIGNAL:   tst r3,r3                ! [EMPFANGE_SHEDULER-SIGNAL:]    [0520]
                mov r3,r0                ! Durch Refresh-Controller-Overflow-Int
                bf/s 1f                  ! save StackNr in R0, StackPtr in R1
                mov r15,r1               ! teste ob Stack-Pointer im User-Stack
                  mov #A_PTEH,r1         ! wenn nein dann kann Stack so bleiben
                  mov.l @r1,r0           ! Wechsele_auf_Kernel/Task-Stack:
                  mov.l @(8,r1),r1       ! lese Task-Nummer aus Pteh nach R0
                  extu.b r0,r0           ! lese Sys-Data-Ptr aus Ttb nach R1
                  add #0x40,r0           ! baue Pointer auf Task-private Daten
                  shll8 r0               ! Basisadr(R1)+0x4000+TaskNr(R0)*0x0100
                  add r1,r0              ! denn zuerst 2K feste Daten,dann Tasks
                  mov r15,r1             ! save alten Stack-Ptr(R15) in R1
                  mov.l @(12,r0),r15     ! lese Kernel-Stack-Ptr aus Task-Daten
                  xor r0,r0              ! setze alte Stack-Nr in R0 auf 0x00
                  mov #0x01,r3           !_setze neue Stack-Nr in R3 auf 0x01
             1: mov.l r1,@-r15           ! Save_Cpu-State_und_setze_Intm-Level:
                mov.l r0,@-r15           ! bevor wir Interrupts erlauben knnen
                mov #0x20,r0             ! muss Intm-Level mindestens auf 2 sein
                stc.l ssr,@-r15          ! damit keine weiteren Hardware-Ints
                stc sr,r1                ! push OldStkPtr,OldStkNr,UsrSr,UsrPc
                stc.l spc,@-r15          ! einen Eventcode pushen wir hier nicht
                extu.b r1,r2             ! isoliere Intm der Cpu aus SR nach R2
                cmp/hs r0,r2             ! vergleiche ob schon Intm-Level min 2
                bt 2f                    ! wenn ja dann kann Intm so bleiben
                  mov.w BOOT_K0089,r2    ! Neuen Intm-Level ins Cpu-SR laden:
                  and r2,r1              ! clear Intm-Feld durch 0xFFFFFF0F-And
                  or r0,r1               ! setze Intm-Feld durch 0x00000020-Or
             2: mov.l BOOT_K0087,r0      ! setze BL=RB=DSP=0,lasse Md=1 und Intm
                and r1,r0                ! baue und lade den neuen Cpu-Sr-Wert
                ldc r0,sr                !_ab jetzt drfen Ints wieder kommen
                sts.l pr,@-r15           ! Save_Zustand_der_virtuellen_SH3:
                stc.l gbr,@-r15          ! alle User-nutzbaren Register pushen
                stc.l r7_bank,@-r15      ! um den Kontext komplett zu wechseln
                stc.l r6_bank,@-r15      ! bestehend aus genau 104 Bytes Daten
                stc.l r5_bank,@-r15      ! save Regs als Standard-Stack-Frame:
                stc.l r4_bank,@-r15      ! +0x64 /+100 / R15 / Stack-Pointer
                mov.l r14,@-r15          ! +0x60 / +96 / R3" / Stack-Nummer
                mov.l r13,@-r15          ! +0x5C / +92 / SR  / Status-Register
                mov.l r12,@-r15          ! +0x58 / +88 / PC  / Program-Counter
                mov.l r11,@-r15          ! +0x54 / +84 / PR  / Procedure-Reg.
                mov.l r10,@-r15          ! +0x50 / +80 / GBR / Global-Base-Reg.
                mov.l r9,@-r15           ! +0x4C / +76 / R7" / R7_BANK1
                mov.l r8,@-r15           ! +0x48 / +72 / R6" / R6_BANK1
                mov.l r7,@-r15           ! +0x44 / +68 / R5" / R5_BANK1
                mov.l r6,@-r15           ! +0x40 / +64 / R4" / R4_BANK1
                mov.l r5,@-r15           ! +0x3C / +60 / R14 / R14
                mov.l r4,@-r15           ! +0x38 / +56 / R13 / R13
                mov.l r3,@-r15           ! +0x34 / +52 / R12 / R12
                mov.l r2,@-r15           ! +0x30 / +48 / R11 / R11
                mov #A_PTEH,r2           ! +0x2C / +44 / R10 / R10
                mov.l r1,@-r15           ! +0x28 / +40 / R9  / R9
                mov.l @r2,r1             ! +0x24 / +36 / R8  / R8
                mov.l r0,@-r15           ! +0x20 / +32 / R7  / R7_BANK0
                mov.l r1,@-r15           ! +0x1C / +28 / R6  / R6_BANK0
                mov.l @(8,r2),r8         ! +0x18 / +24 / R5  / R5_BANK0
                mov r15,r4               ! +0x14 / +20 / R4  / R4_BANK0
                ldc r8,gbr               ! +0x10 / +16 / R3  / R3_BANK0
                stc sr,r10               ! +0x0C / +12 / R2  / R2_BANK0
                mov.l @(0x94,gbr),r0     ! +0x08 / +8  / R1  / R1_BANK0
                add #0x50,r8             ! +0x04 / +4  / R0  / R0_BANK0
                mov.l BOOT_K0086,r11     ! +0x00 / +0  / PTEH: ASID
                mov r0,r9                ! Setup Register fr Sheduler-Call:
                mov.w BOOT_K0071,r12     ! R0=R9=*Sheduler,R1=Pteh,R2=*Pteh
                mov.w BOOT_K0072,r13     ! R4=*StackPtr,R8=*SignalFlags
                bra BOOT_YSIGNAL         ! R10=Bl0Sr,R11=Bl1Sr,R12=*Rtcsr
                or r10,r11               ! R13=0x5A00,GBR=*SystemDataBase
                                         !-
BOOT_K0071:     .short A_RTCSR           ! Adr Refresh-Ctrl               [05A4]


BOOT_XNMI:      mov.w BOOT_K0074,r1      ! [NON-MASKABLE-INTERRUPT:]      [05A6]
             1:   mov.w @r1,r0           ! Eine Flanke am NMI-Input/Power-Switch
                  mov #0x05,r2           !_setup R1=*Icr0 zur Steuerung des NMI
                  cmp/pz r0              ! Setze neue NMI-Flanken-Auswahl:
                  movt r0                ! uns interessiert nun andere Flanke
                  shll8 r0               ! set in Icr0 Bit#15 invers nach Bit#8
                  mov.w r0,@r1           !_damit uns nchste Flanke interrupted
             2:     mov.w @r1,r0         ! Verify neue NMI-Flanken-Auswahl:
                    cmp/pz r0            ! beobachte min 44 IClks die Stabilitt
                    shlr8 r0             ! erst nach 20 Clks macht Hw neue NMIs
                    addc r1,r0           ! lese Icr0 mit Nmi-Level, Int-Flanke
                    shlr r0              ! teste ob Flanke invers zu Nmi-Pegel
                    bt 1b                ! wenn nein neu setzen und neu warten
                    dt r2                ! ansonsten Verify-Timeout decrementen
                    bf 2b                !_und NMI-Watch wiederholen bis genug
                mov.l BOOT_K0075,r1      ! Clear_Nmif_und_lade_Entprell-Timer:
                mov #0xC9,r0             ! setup Pointer R1=*Pbdr und R2=*Dmaor
                mov.l BOOT_K0076,r2      ! setze Pbdr/EntprellCount=0xC9=50mSec
                mov.b r0,@r1             ! wird durch HiClk zum Signal entprellt
                mov.w @r2,r0             ! lsche Bit#1/Nmif im Dmaor-Register
                mov #0xFD,r1             ! damit Dma-Transfer wieder weitergeht
                and r1,r0                ! dazu Word aus Dmaor lesen und modify
                mov.w r0,@r2             ! write Dmaor-Word an die Dma-Hardware
                rte                      ! damit ist NMI-Flanke bedient worden
                nop                      ! unterbrochenes Programm fortsetzen


BOOT_XWAKEUP:   mov #A_FRQCR,r1          ! [WAKEUP_AUS_CPU-STANDBY:]      [05D8]
                mov.b @(2,r1),r0         ! Interrupt mit Usr-SR/BL-Bit gesetzt
                cmp/pz r0                ! teste Wakeup aus Sleep oder Standby
                bt BOOT_X0081            ! dazu Bit#7 aus Stbcr lesen und testen
                  mov.l BOOT_K0077,r0    ! if Sleep-Wakeup normales Int-Handling
                  jmp @r0                ! ansonsten Standby-Wakeup, in dem Fall
                  nop                    ! jump zum Cpu-Wakeup-Code im Boot-Prom

!...............

BOOT_K0072:     .short 0xA500            ! Rtcsr-Data: Sheduler-Int=Off   [05E6]
BOOT_K0073:     .short 0xA502            ! Rtcsr-Data: Sheduler-Int=On
BOOT_K0074:     .short A_ICR0            ! Adr Icr0 fr Nmi-Control
BOOT_K0075:     .long  A_PBDR            ! Adr Pbdr fr Nmi-Entprellung
BOOT_K0076:     .long  A_DMAOR           ! Adr Dmaor fr Nmif-Lschung
                                         !=
BOOT_ROMINFO2:  .byte 0x7B               ! 05F4 (1) ~Magic-Byte "0x84"    [05F4]
                .byte 0xFF - VER_MAJ     ! 05F5 (1) ~Versions-Nr/Major
                .byte 0xFF - VER_MIN     ! 05F6 (1) ~Versions-Nr/Minor
                .byte 0xFF - VER_SPC     ! 05F7 (1) ~Versions-Nr/Flags
                                         !-
                .long ~SERIALNR          ! 05F8 (4) ~Device_Serial-Nr     [05F8]

BOOT_K0077:     .long BOOT_WAKEUP+0xA0000000! Cpu-Wakeup-Handler          [05FC]

!---------------

                mov.l BOOT_K0086,r1      ! **** HARDWARE-INTERRUPTS ****  [0600]
                stc ssr,r0               ! Cpu springt fr Interrupts hierher
                tst r0,r1                ! dabei ist MD=RB=BL=1,PC->SPC,SR->SSR
                bf BOOT_XWAKEUP          ! wenn User-BL=1 war, dann Cpu-Wakeup
                                         !-
BOOT_X0081:     mov.l BOOT_K0085,r2      ! Verteile_Nmi/Sheduler/Interrupt:
                mov.w BOOT_K0081,r1      ! brauchen alle eigenes Stack-Handling
                mov.l @r2,r2             ! lese Int-Event-Nr aus Intevt2 in R2
                cmp/eq r1,r2             ! teste ob es Nmi/0x01C0 gewesen ist
                mov.w BOOT_K0082,r1      ! wenn ja weiter mit dem Nmi-Handler
                bt BOOT_XNMI             ! teste ob es Sheduler/0x05A0-Int war
                cmp/eq r1,r2             ! wenn ja weiter mit Signal-Handling
                bt BOOT_XSIGNAL          ! ansonsten war es normaler Interrupt
                                         !-
                mov #0x02,r0             ! Bediene_Standard-Interrupts:
                cmp/hs r0,r3             ! hier werden alle IO-Ints verteilt
                mov r3,r0                ! teste ob schon auf Interrupt-Stack
                bt/s 1f                  ! setup R0=OldStkNr und R1=OldStkPtr
                mov r15,r1               !_wenn mindestens Int-Stack dann ok
                  mov #A_TTB,r0          ! Wechsele_auf_Interrupt-Stack:
                  mov.w BOOT_K0083,r1    ! lese Offset Interrupt-Stacktop in R1
                  mov.l @r0,r0           ! lese System-Data-Ptr aus Ttb nach R0
                  add r1,r0              ! baue Interrupt-Stacktop-VarPtr in R0
                  mov r15,r1             ! save den bisherigen Stack-Ptr in R1
                  mov.l @r0,r15          ! lade neuen InterruptStack-Ptr in R15
                  mov r3,r0              ! save bisherige Stack-Nummer in R0
                  mov #0x02,r3           !_lade neue Stack-Nummer 0x02 in R3
             1: mov.l r1,@-r15           ! Handler_suchen_und_Intm_setzen:
                mov.l r0,@-r15           ! bevor wir Interrupts erlauben knnen
                mov r2,r1                ! muss min passender Intm gesetzt sein
                stc.l ssr,@-r15          ! push OldStkPtr,OldStkNr,UsrSr,UsrPc
                shlr2 r1                 ! push Intevt2, gleich Handler/Intm
                stc.l spc,@-r15          ! baue Interrupt-Nummer aus Intevt2-Nr
                shlr2 r1                 ! shifte 5 rechts, Division durch 0x20
                mov.l r2,@-r15           ! jetzt 1er-Schritte zwischen Intcodes
                shlr r1                  ! begrenze Intcodes auf legalen Bereich
                mov #0x20,r0             ! unser Minimum ist 0x0400/Tmr#0-Int
                cmp/hs r0,r1             ! unser Maximum ist 0x0980/Adc-Int
                bt/s 2f                  ! dazwischen liegen alle internen Ints
                mov #0x4D,r0             ! teste ob Intcode minimal 0x0400 ist
                  mov #0x20,r1           ! wenn kleiner lade das Minimum 0x0400
             2: cmp/hi r1,r0             ! denn 0x0400 ist immer ungltiger Int
                bt/s 3f                  ! teste ob Intcode maximal 0x0980 ist
                add #0xE0,r1             ! wenn grsser lade das Minimum 0x0400
                  xor r1,r1              ! denn 0x0400 ist immer ungltiger Int
             3: shll r1                  ! Baue Shortword-Table-Index aus IntNr
                mova BOOT_INTTBL,r0      ! aus BasePtr + ((Intevt2>>5)-0x20)<<1
                mov.w @(r0,r1),r0        ! dabei ist Intevt2=0x0400 fr ungltig
                mov.l r0,@-r15           ! lese Shortword fr Handler aus Table
                shlr8 r0                 ! push Handler-Shortword auf den Stack
                and #0xF0,r0             ! bringe Intm aus Bit#12-15 in Bit#4-7
                stc sr,r1                ! teste ob schon min dieser Intm-Level
                extu.b r1,r2             ! dabei bleiben hhere Level erhalten
                cmp/hs r0,r2             ! isoliere Intm der Cpu aus SR nach R2
                mov.w BOOT_K0089,r2      ! vergleiche mit Wunsch-Intm aus Table
                bt 4f                    ! lade schon mal Intm-Clear-Mask in R2
                  and r2,r1              ! Neuen Intm-Level ins Cpu-SR laden:
                  or r0,r1               ! clr Intm-Feld mit And, Or Table-Intm
             4: mov.l BOOT_K0087,r0      ! setze BL=RB=DSP=0,lasse Md=1 und Intm
                and r1,r0                ! baue und lade den neuen Cpu-Sr-Wert
                ldc r0,sr                !_ab jetzt drfen Ints wieder kommen
                mov.l r0,@-r15           ! Call_Interrupt-Service-Routine:
                mov.l r1,@-r15           ! save benutzte Register auf dem Stack
                mov.l r2,@-r15           ! wir retten gemeinsam R0-R5,PR,GBR
                mov.l r3,@-r15           ! denn das reicht fr fast alle Flle
                mov.l r4,@-r15           ! wenn Aufruf von 'C'-Funktionen dann
                mov.l r5,@-r15           ! muss zustzlich R6,R7 gerettet werden
                sts.l pr,@-r15           ! wir brauchen 56 Byte Interrupt-Stack
                stc.l gbr,@-r15          ! baue Handler-Adress-Offset fr Call
                mov.w BOOT_K0084,r0      ! setup R0=BitMask=0x0FFF, R1=TblWord
                mov.l @(32,r15),r1       ! setup GBR auf System-Variablen-Base
                mov #A_TTB,r2            ! isoliere Bit#0-11 aus Table-Shortword
                ldc.l @r2+,gbr           ! multiply mit 2 fr Short-Opcodeoffset
                and r1,r0                ! damit liegen Int-Handler max 8K weg
                shll r0                  ! wir haben R0=Intevt2 und GBR=SysData
                bsrf r0                  ! call Int-Handler, trashed R0-R5,GBR
                mov.l @(36,r15),r0       !_sollte die Int-Anforderung entfernen
BOOT_X0082:     ldc.l @r15+,gbr          ! Zurck_vom_Interrupt-Service-Handler:
                lds.l @r15+,pr           ! restore benutzte Register vom Stack
BOOT_XRET2:     mov.l @r15+,r5           ! Restauriere_ab_R5:
                mov.l @r15+,r4           ! gemeinsamer Code
                mov.l @r15+,r3           ! fr Ints/Exceptions
                mov.l @r15+,r2           ! hier hufig benutzt
BOOT_XRET3:     mov.l BOOT_K0088,r0      ! Restauriere_ab_R1:
                stc sr,r1                ! gemeinsamer Code
                or r1,r0                 ! fr Ints/Exceptions
                mov.l @r15+,r1           ! hier hufig benutzt
                ldc r0,sr                !_zuerst R1,R0 restore
                ldc.l @r15+,r0_bank      ! Lade_Cpu-Sr/Block:
                add #0x08,r15            ! fr restore BL=RB=1
BOOT_XRET4:     ldc.l @r15+,spc          ! Restauriere_2.Bank:
                ldc.l @r15+,ssr          ! gemeinsamer Code
                mov.l @r15+,r3           ! fr Ints/Mmu-Event
                mov.l @r15,r15           ! hier hufig benutzt
                rte                      ! restore Pc,Sr,StkNr,StkPtr
                nop                      ! unterbrochenen Code fortsetzen

!...............

BOOT_K0081:     .short 0x01C0            ! IntEvt: NMI-Code               [06BC]
BOOT_K0082:     .short 0x05A0            ! IntEvt: REF-Code
BOOT_K0083:     .short 0x008C            ! Offset Int-StackPtr
BOOT_K0084:     .short 0x0FFF            ! Adr-Mask Int-Offset
BOOT_K0085:     .long  A_INTEVT2         ! Adr Interrupt-Event
BOOT_K0086:     .long  0x10000000        ! BL-Mask fr SSR-Test
BOOT_K0087:     .long  0x400000F0        ! SR-Mask fr BL-Clear
BOOT_K0088:     .long  0x70000001        ! SR-Mask fr BL-Set
BOOT_K0089:     .short 0xFF0F            ! And-Mask fr Intm-Clear

!---------------

BOOT_YSIGNAL:     ldc r11,sr             ! [VERWERTE_SHEDULER-SIGNAL:]    [06D6]
             1:   mov.l @r8,r2           ! Bearbeite Signals nach Prioritt
                  xor r5,r5              ! Nchstes Signal abarbeiten:
                  mov r2,r1              ! setze BL=1 im Status-Register
                  mov r1,r0              ! damit keine Ints mit neuen Signals
                  shlr16 r0              ! whrend wir hier Signale auswerten
                  tst r0,r0              ! setup R1=R2 mit Signal-Flags aus Ram
                  bt 2f                  ! setup R5=0x00 fr wichtigstes Signal
                    shlr16 r1            ! teste ob gesetztes Bit in Bit#16-31
                    mov #0x10,r5         ! wenn nein dann sind R1/R5 soweit ok
             2:   mov r1,r0              ! ansonsten R1=R1>>0x10, R5=R5+0x10
                  shlr8 r0               ! nun ist wichtigstes Bit in Bit#0-15
                  tst r0,r0              ! teste ob gesetztes Bit in Bit#8-15
                  bt 3f                  ! wenn nein dann sind R1/R5 soweit ok
                    shlr8 r1             ! ansonsten R1=R1>>0x08, R5=R5+0x08
                    add #0x08,r5         ! nun ist wichtigstes Bit in Bit#0-7
             3:   mov r1,r0              ! teste ob gesetztes Bit in Bit#4-7
                  tst #0xF0,r0           ! wenn nein dann sind R1/R5 soweit ok
                  bt 4f                  ! ansonsten R1=R1>>0x04, R5=R5+0x04
                    shlr2 r0             ! nun ist wichtigstes Bit in Bit#0-3
                    shlr2 r0             ! teste ob gesetztes Bit in Bit#2-3
                    add #0x04,r5         ! wenn nein dann sind R1/R5 soweit ok
             4:   tst #0x0C,r0           ! ansonsten R1=R1>>0x02, R5=R5+0x02
                  bt 5f                  ! nun ist wichtigstes Bit in Bit#0-1
                    shlr2 r0             ! teste ob gesetztes Bit in Bit#1
                    add #0x02,r5         ! wenn nein dann sind R1/R5 soweit ok
             5:   tst #0x02,r0           ! ansonsten R1=R1>>0x01, R5=R5+0x01
                  bt 6f                  ! nun ist wichtigstes Bit in Bit#0
                    shlr r0              ! addiere letztes Bit#0 zur BitNr/R5
                    add #0x01,r5         ! ergibt Bit-Nummer {0x00/0x01..0x20}
             6:   add r0,r5              !_fr das wichtigste Signal in R5
                  mov #0x01,r0           ! Lsche_ausgewhltes_Signal-Bit:
                  mov r5,r1              ! baue Bit-Maske aus der Signal-Nummer
                  add #0xFF,r1           ! zum Lschen des entsprechenden Flags
                  shld r1,r0             ! ist (u_long)(0x01<<(SignalNr-0x01))
                  xor r0,r2              ! invertiere/clear Flag im Ram-Longword
                  tst r2,r2              ! teste ob weitere Signals angefordert
                  mov.l r2,@r8           ! write neues Signal-Flag-Long ins Ram
                  bf 7f                  !_jump wenn noch andere Signal-Requests
                    mov.w @r12,r0        ! Abschalten_Refresh-Interrupt:
                    tst r5,r5            ! denn es liegen keine Signals mehr an
                    and #0xFD,r0         ! lsche Bit#1/Ovie im Rtcsr-Register
                    or r13,r0            ! damit keine weiteren Ints mehr kommen
                    mov.w r0,@r12        ! teste ob wir ein letztes Signal haben
                    bt 8f                ! wenn nein fertig, restauriere Kontext
             7:   ldc r10,sr             !_ansonsten drfen Ints wieder kommen
                  tst r9,r9              ! Call_Signal-Handler_fr_Signal:
                  bt BOOT_YSIGNAL        ! wenn kein Signal-Handler installiert
                    jsr @r9              ! dann weiter mit dem nchstem Signal
                    mov r4,r0            ! call "stack *handler (*stack,signum)"
                    bra BOOT_YSIGNAL     ! save neuen Stack/Kontext-Ptr in R4
                    mov r0,r4            !_wieder Signal-Bearbeitung wiederholen
             8: tst r4,r4                ! Restauriere_neuen_Kontext:
                bf 9f                    ! teste ob Kontext-Ptr Null ist
                  mov #A_STBCR,r1        ! wenn nein dann Kontext vom Stack
                  mov.b @r1,r0           ! ansonsten haben wir nichts zu tun
                  and #0x7F,r0           ! daher Sleep-Mode bis nchster Int
                  mov.b r0,@r1           ! spart Strom ohne lauffhige Tasks
                  sleep                  ! lsche Bit#7/Stby im Stbcr-Register
                  bt 1b                  ! nach Sleep weiter mit nchstem Signal
             9: ldc r10,sr               !_Restauriere_Kontext_vom_Stack:
                mov.l @r4+,r0            ! zuerst Interrupts wieder freigeben
                mov #A_PTEH,r1           ! alle User-nutzbaren Register zurck
                mov.l r0,@r1             ! um den Kontext komplett zu wechseln
                mov r4,r15               ! bestehend aus genau 104 Bytes Daten
                mov.l @r15+,r0           ! pop Regs aus Standard-Stack-Frame
                mov.l @r15+,r1           ! zuerst Pteh-Inhalt
                mov.l @r15+,r2           ! damit ist die
                mov.l @r15+,r3           ! Task-Nummer wieder
                mov.l @r15+,r4           ! aktuell und richtig
                mov.l @r15+,r5           ! danach aus der
                mov.l @r15+,r6           ! 1.Register-Bank
                mov.l @r15+,r7           ! die Regs R0-R7
                mov.l @r15+,r8           ! danach die nur
                mov.l @r15+,r9           ! einmal vorhandenen
                mov.l @r15+,r10          ! Register R8-R14
                mov.l @r15+,r11          ! der Stack-Pointer
                mov.l @r15+,r12          ! aus R15 geht extra
                mov.l @r15+,r13          ! danach aus der
                mov.l @r15+,r14          ! 2.Register-Bank
                ldc.l @r15+,r4_bank      ! die Regs R4-R7
                ldc.l @r15+,r5_bank      ! welche ebenfalls
                ldc.l @r15+,r6_bank      ! privat fr Tasks
                ldc.l @r15+,r7_bank      ! abschliessend die
                ldc.l @r15+,gbr          ! letzten Control-Regs
                lds.l @r15+,pr           ! restauriere GBR,PR
                mov.l r0,@-r15           ! gemeinsam weiter mit
                bra BOOT_XRET1           ! restauriere PC,SR,R3",R15
                mov.l r1,@-r15           ! sowie Ende des Interrupts

!...............

BOOT_INTTBL:    .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0400,15  [0788]
                .short ((INT_HICLK    -BOOT_X0082)/2)-0x4000 ! 0x0420,12 Tmr#1
                .short ((INT_LOCLK    -BOOT_X0082)/2)+0x4000 ! 0x0440,4  Tmr#2/P
                .short (( BOOT_XBADINT-BOOT_X0082)/2)+0x4000 ! 0x0460,4  Tmr#2/C
                .short ((INT_RTCA     -BOOT_X0082)/2)+0x4000 ! 0x0480,4  Rtc/A
                .short (( BOOT_XBADINT-BOOT_X0082)/2)+0x4000 ! 0x04A0,4  Rtc/P
                .short (( BOOT_XBADINT-BOOT_X0082)/2)+0x4000 ! 0x04C0,4  Rtc/C
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x04E0,15 Sio#0/E
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0500,15 Sio#0/R
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0520,15 Sio#0/T
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0540,15 Sio#0/D
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0560,15 Wdt/Tmr
                .short (( BOOT_XBADINT-BOOT_X0082)/2)+0x2000 ! 0x0580,2  Ref/Cmi
                .short (( BOOT_XBADINT-BOOT_X0082)/2)+0x2000 ! 0x05A0,2 !Ref/Ovi
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x05C0,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x05E0,15 H-Udi
                .short ((INT_ADDA     -BOOT_X0082)/2)-0x2000 ! 0x0600,14 Irq#0
                .short ((INT_LAN      -BOOT_X0082)/2)-0x8000 ! 0x0620,8  Irq#1
                .short ((INT_PCSDTR   -BOOT_X0082)/2)-0x6000 ! 0x0640,10 Irq#2
                .short ((INT_MOSDCD   -BOOT_X0082)/2)-0x6000 ! 0x0660,10 Irq#3
                .short ((INT_PCSCTS   -BOOT_X0082)/2)-0x6000 ! 0x0680,10 Irq#4
                .short ((INT_MOSCTS   -BOOT_X0082)/2)-0x6000 ! 0x06A0,10 Irq#5
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x06C0,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x06E0,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0700,15 PInt/L
                .short ((INT_PINTF    -BOOT_X0082)/2)+0x6000 ! 0x0720,6  PInt/H
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0740,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0760,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0780,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x07A0,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x07C0,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x07E0,15 <nouse>
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x2000 ! 0x0800,14 Dei#0
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x2000 ! 0x0820,14 Dei#1
                .short ((INT_DAOUT    -BOOT_X0082)/2)-0x2000 ! 0x0840,14 Dei#2
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x2000 ! 0x0860,14 Dei#3
                .short ((INT_PCSERR   -BOOT_X0082)/2)-0x6000 ! 0x0880,10 Sio#1/E
                .short ((INT_PCSRX    -BOOT_X0082)/2)-0x6000 ! 0x08A0,10 Sio#1/R
                .short ((INT_PCSRXT   -BOOT_X0082)/2)-0x6000 ! 0x08C0,10 Sio#1/B
                .short ((INT_PCSTX    -BOOT_X0082)/2)-0x6000 ! 0x08E0,10 Sio#1/T
                .short ((INT_MOSERR   -BOOT_X0082)/2)-0x6000 ! 0x0900,10 Sio#2/E
                .short ((INT_MOSRX    -BOOT_X0082)/2)-0x6000 ! 0x0920,10 Sio#2/R
                .short ((INT_MOSRXT   -BOOT_X0082)/2)-0x6000 ! 0x0940,10 Sio#2/B
                .short ((INT_MOSTX    -BOOT_X0082)/2)-0x6000 ! 0x0960,10 Sio#2/T
                .short (( BOOT_XBADINT-BOOT_X0082)/2)-0x1000 ! 0x0980,15 Adc

!...............

BOOT_XBADINT:   ldc.l @r15+,gbr          ! [UNEXPECTED_INTERRUPTS:]       [07E2]
                lds.l @r15+,pr           ! Unerwartete Interrupts landen hier:
                mov.l @r15+,r5           ! restauriere alles bis auf R0,R1
                mov.l @r15+,r4           ! dann knnen wir Debugger jumpen
                mov.l @r15+,r3           ! dazu GBR,PR,R5-R2 vom Stack
                bra BOOT_X0032           ! so ist Stack fr Interrupts
                mov.l @r15+,r2           ! weiter mit Debugger-Aufruf


!*** EOF ***
