! "1bioslib.asm", Version 2.01 vom 29.6.1999, (C) Volker Ernst 1999
!  Simple asm source-file with a library of basic i/o-functions.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.

!******************************************************************************!
!            B  A  S  I  C   -   I  N  P  U  T  /  O  U  T  P  U  T            !
!******************************************************************************!


INT_HICLK:      nop
INT_LOCLK:      nop
INT_RTCA:       nop
INT_ADDA:       nop
INT_DAOUT:      nop
INT_PINTF:      nop
INT_LAN:        nop

INT_PCSDTR:     nop
INT_PCSCTS:     nop
INT_PCSERR:     nop
INT_PCSRX:      nop
INT_PCSRXT:     nop
INT_PCSTX:      nop

INT_MOSDCD:     nop
INT_MOSCTS:     nop
INT_MOSERR:     nop
INT_MOSRX:      nop
INT_MOSRXT:     nop
INT_MOSTX:      nop

                .align 2,0xFF
                .short 0xFFFF

!---------
! GENERAL
!---------

_sys_crcblock:  mov.w BOOT_K1051,r1      ! 0E - CRC-SUMME_BLOCK-UPDATE:   [0000]
                mova BOOT_K1051,r0       ! unsigned long sys_crcblock (...)
                add r1,r0                !
             1:   tst r6,r6              !
                  bt BOOT_X1051          !
                  mov.b @r5+,r1          !
                  add #0xFF,r6           !
                  xor r4,r1              !
                  shlr8 r4               !
                  extu.b r1,r1           !
                  shll2 r1               !
                  mov.l @(r0,r1),r1      !
                  bra 1b                 !
                  xor r1,r4              !


_sys_crcbyte:   mova BOOT_K1051,r0       ! 0F - CRC-SUMME_BYTE-UPDATE:    [0000]
                mov.w BOOT_K1051,r1      ! unsigned long sys_crcbyte (...)
                xor r4,r5                !
                add r1,r0                !
                shlr8 r4                 !
                extu.b r5,r5             !
                shll2 r5                 !
                mov.l @(r0,r5),r5        !
                xor r5,r4                !
BOOT_X1051:     rts                      !
                mov r4,r0                !

!...............

BOOT_K1051:     .short -0x0400-(BOOT_K1051-X0)!




!----------
! KEYBOARD
!----------

!-----------
! CHIP-CARD
!-----------








!-------------
! ONBOARD-LED
!-------------

_sys_setled:    sts pr,r5                ! 1E - SETZE_LED-OUTPUT:         [0000]
                tst r4,r4                ! u_char sys_setled (unsigned char Val)
                subc r0,r0               ! R4 = Led-Wunsch-Zustand 0=Off,1..=On
                mov.l BOOT_K1192,r1      ! ---> R0 = Realer Led-Status 0x00/0x01
                and #0x08,r0             !      R4 = Wunsch Led-Status (bleibt)
                mov.w BOOT_K1191,r2      !      R1..R3 und R5 werden getrashed
                bsr BOOT_MODPORT         ! Baue R1=*Pddr,R2=ModifyMask/0x03F0
                or r2,r0                 ! setze Dma=H,Wake=~N,Res=L,leave Temic
                lds r5,pr                ! nach Port-Setzen weiter mit Rcklesen
                                         !-
_sys_getled:    mov.l BOOT_K1192,r1      ! 1F - LESE_LED-OUTPUT:          [0000]
                mov.b @r1,r0             ! unsigned char sys_getled (void)
                tst #0x08,r0             ! ---> R0 = 0x00/Led=Off,0x01/Led=On
                rts                      !      R1 wird dabei getrashed
                movt r0                  ! Lese Led-Zustand invers aus Port#D3

!...............

BOOT_K1191:     .short 0x03F0            ! Mod Dma=H,Wake=N,Res=L,(Temic) [0000]
BOOT_K1192:     .long  A_PDDR            ! Adresse Port#D-Datenregister

!------------
! LC-DISPLAY
!------------


                .short 0xFFFF







!---------------

LCD_BYTEOUT:    sts pr,r7                ! WRITE_ONE_LCD-BYTE:            [0000]
                rotcl r0                 ! R0 = Byte zum Ausgeben an LCD-Modul
                mov r0,r6                !      T=0/Command-Byte,T=1/Data-Byte
                shlr r0                  ! ---> R0..R7 werden getrashed, T=1
                shlr2 r0                 ! Lcd-Byte-Ausgabe dauert knapp 10uSec
                bsr LCD_NIBBLEOUT        ! save Daten und T-Bit in R6,RetAdr->R7
                shlr2 r0                 ! dann High-Nibble nach Bit#0-3 shiften
                mov r6,r0                ! die ersten vier Daten-Bis ausgeben
                shlr r0                  ! dann Daten und T-Bit aus R6 zurck
                lds r7,pr                ! save RetAdr->Pr,weiter mit Low-Nibble
                                         !-
LCD_NIBBLEOUT:  sts pr,r5                ! WRITE_ONE_LCD-NIBBLE:          [0000]
                and #0x0F,r0             ! R0 = Nibble zum Ausgeben an LCD-Modul
                mov r0,r1                !      T=0/Command-Nib,T=1/Daten-Nibble
movt r4
shlr r0
movt r5
sett
rotcl r0
shlr r5
rotcl r0
sett
rotcl r0
sts pr,r5
shlr r4
mov r0,r4
nop
!                shll2 r0                 ! ---> R0..R5 werden getrashed, T=1
!                or #0x07,r0              ! Lcd-Nibble-Ausgabe dauert knapp 5uSec
!                mov r0,r4                ! Schreibe Datenbus D4-D7,Control/Data
                movt r0                  ! save Return-Adresse in R5
                shll r0                  ! baue Pjdr-Output-Byte in R4
                shlr r1                  ! mit Bit#7-6=L,Bit#5-3=D7-5,Bit#2-0=H
                rotcl r0                 ! baue Pedr-Modify-Word in R0,R1=*Pedr
                shll2 r0                 ! aus 0x0E20|(Bit#6=T,Bit#4=D4) basteln
                mov.l BOOT_K1202,r1      ! Bit#7/E=L,Bit#6/C=T,Bit#5=H,Bit#4=D4
                shll2 r0                 ! (Bit#3-1/ChipCard),Bit#0/ChipCardD=L
                mov.w BOOT_K1204,r2      ! update Port#E mit Lcd-Control und D4
                bsr BOOT_MODPORT         ! update Port#J mit Lcd-Datenbus D5-D7
                or r2,r0                 ! whrend Port#E-Modify sind Ints aus
                mov r4,r0                ! damit keine Probleme mit anderen Ints
                mov.b r0,@(8,r1)         ! die auch Port#E verndern (ChipCard)
                bsr BOOT_UDELAY1         ! jetzt min 140nSec Setup-Zeit warten
                mov r1,r4                ! wir brauchen min 800nSec,typ 1600nSec
                mov.w BOOT_K1205,r0      ! dann den Enable-Pin auf High setzen
                bsr BOOT_MODPORT         ! mittels Port#E-Modify/Mask=0x5EA0
                mov r4,r1                ! fr Bit#7/LcdE=H,Bit#5=H,Bit#0/CarD=L
                bsr BOOT_UDELAY          ! lasse Bit#6/LcdC,Bit#4/LcdD4,Bit#3-1
                mov #0xFE,r0             ! jetzt min 450nSec Enable=High warten
                mov.w BOOT_K1206,r0      ! wir brauchen min 800nSec,typ 1600nSec
                bsr BOOT_MODPORT         ! dann Enable-Pin auf Low zurcksetzen
                mov r4,r1                ! jetzt min 10nSec an Hold-Zeit warten
                lds r5,pr                ! wir brauchen min 800nSec,typ 1600nSec

!. . . . . . . .

BOOT_UDELAY1:   mov #0xFE,r0             ! WARTE_EIN_BISCHEN:             [0000]
BOOT_UDELAY:    mov.w BOOT_K1203,r1      ! R0 = Wartezeit (-Ticks) in 800nSec
                mov.l @r1,r2             ! ---> R0 = Anzahl vergangener Ticks
                not r2,r2                !      R1..R3 werden getrashed
             1:   mov.l @r1,r3           ! 0xFF ergibt Warten auf nchsten Count
                  add r2,r3              ! ist aber wenn nicht synchron unsicher
                  cmp/hi r3,r0           ! 0xFE fr 1 Tick Delay wenn Int=Enable
                  bf 1b                  ! damit Sync und dann Warten auf 1 Tick
                rts                      ! Baue in R1=*Tcnt0,R2=(0-1-StartCount)
                not r3,r0                ! warte bis (Count+R2)<Delay, ret Delay


BOOT_MODPORT:   mov.l BOOT_K1201,r3      ! MODIFY_PORT-DATEN:             [0000]
                stc sr,r2                ! R0 = Modify-Maske (0-7=Or,8-15=And)
                or r2,r3                 ! R1 = *PortDatenRegister
                ldc r3,sr                ! ---> R0..R1 bleiben erhalten
                mov.b @r1,r3             !      R2..R3 werden getrashed
                swap.b r0,r0             ! Interrupts whrend Port-Modify aus
                and r0,r3                ! fr Port zwischen Int-Levels sharebar
                swap.b r0,r0             ! Baue R2=OrginalSr, R3=Sr mit BL=1
                or r0,r3                 ! dann alle Ints disablen, Port lesen
                ldc r2,sr                ! errechne Port=(Port&(Mask>>8))|Mask
                rts                      ! schreibe Port und Ints wieder enablen
                mov.b r3,@r1             ! das war Update von Teilen eines Ports

!...............

BOOT_K1201:     .long  0x10000000        ! Sr-Mask fr Setzen von BL=1    [0000]
BOOT_K1202:     .long  A_PEDR            ! Adr Pedr (und Pjdr) fr Lcd-Output
BOOT_K1203:     .short A_TCNT0           ! Adr Tcnt#0/1.25MHz-Counter fr Timing
BOOT_K1204:     .short 0x0E20            ! Mod Bit#7=L,Bit#5=H,(Bit#3-1),Bit#0=L
BOOT_K1205:     .short 0x5EA0            ! Mod Bit#7=Bit#5=H,(Bit#6,4-1),Bit#0=L
BOOT_K1206:     .short 0x5E20            ! Mod Bit#7=Bit#0=L,Bit#5=H,(Bit#6,4-1)

!--------------
! SOUND-OUTPUT
!--------------





!-------------
! AUDIO-AD/DA
!-------------








!---------------

ADDA_FSYNC:     mov.w BOOT_K1401,r4      ! WARTE_AUF_ADDA-FRAMESYNC:      [0000]
                mov.w BOOT_K1405,r2      ! ---> R0 = Zeit wie lange gewartet
                mov.l BOOT_K1402,r1      !      positiv in 800nSec-Schritten
                mov.l @(24,r2),r3        !      F(T=0) - Timeout, kein Sync kam
             1:   mov.b @r1,r0           !      T(T=1) - Sync-Fallend-Flanke kam
                  shlr r0                !      R1..R4 werden getrashed
                  mov.l @(24,r2),r0      !      Es wird maximal 200uSec gewartet
                  neg r0,r0              ! Setup R1=*Irr0,R2=*Scsmr fr Reg-IO
                  bt/s 2f                ! setze R3=Tmr#0-Startwert,R4=Timeout
                  add r3,r0              ! Dann bis Timeout oder Frame-Sync do
                  cmp/hs r0,r4           ! lese Irr0 mit Irq0/Framesync-Flanke
                  bt 1b                  ! setze T-Flag wenn fallende Flanke war
                rts                      ! errechne vergangene Zeit mittels Tmr0
                xor r3,r3                ! wenn Flanke dann goto Flanken-Return
             2: mov #0x3E,r3             ! sonst repeat bis Timeout abgelaufen
                rts                      ! bei Timeout return mit R0>Timeout,T=0
                mov.b r3,@r1             ! bei Flanke 0x3E-->Irr0(Irq0-Clr), T=1


ADDA_SYNCIO:    mova BOOT_K1404,r0       ! EXCHANGE_ONE_AD/DA-WORD:       [0002]
                mov.w BOOT_K1404,r2      ! R4 = Short zum Ausgeben an D/A-Out
                mov.w BOOT_K1405,r1      ! ---> R5 = Short gelesen vom A/D-In
                mov.l BOOT_K1403,r3      !      R0..R3 werden getrashed
                add r0,r2                !_Adda-Word-Exchange dauert knapp 4uSec
                mov.b @(8,r1),r0         ! Lese_Rx-Daten/Low:
                mov.b @(10,r1),r0        ! set R1=*Scsmr,R2=*BitSwapTbl,R3=*Padr
                mov.b @r3,r5             ! dummy-read Scssr fr Flag-Lschung
                extu.b r0,r0             ! read empfangenes Byte aus Scrdr
                mov.b @(r0,r2),r0        ! lese old High-Byte geswapped aus Padr
                shll8 r5                 ! swappe empfangenes Low-Byte aus Scrdr
                extu.b r0,r0             ! kombiniere beide zu empfangenem Word
                or r0,r5                 ! save A/D-Word als ReturnData in R5
                mov #0x84,r0             ! write 0x84 --> Scssr fr Rx-Flags-Clr
                mov.b r0,@(8,r1)         !_zur Lschung Rdrf,Orer,Fer,Per,Mpbt
                swap.b r4,r0             ! Sende_Tx-Daten/High:
                extu.b r0,r0             ! lese High-Byte des D/A-Words nach R0
                mov.b @(r0,r2),r0        ! swappe zu sendendes Sio-Daten-Byte
                mov.b r0,@(6,r1)         ! write 0xNN --> Sctdr fr Tx-Daten
                xor r0,r0                ! write 0x00 --> Scssr Rx/Tx-Flags-Clr
                mov.b r0,@(8,r1)         !_fr Clr Tdre,(Rdrf,Orer,Fer,Per),Mpbt
             1:   mov.b @(8,r1),r0       ! Lese_Rx-Daten/High:
                  tst #0x40,r0           ! warte 3.2uSec (8 Bits zu 400nSec)
                  bt 1b                  ! bis das Rx- und Tx-Byte transferiert
                mov.b @(10,r1),r0        ! dazu loopen bis Rdrf in Scssr gesetzt
                extu.b r0,r0             ! read empfangenes Byte aus Scrdr
                mov.b @(r0,r2),r0        ! swappe empfangenes High-Byte aus Sio
                mov.b r0,@r3             ! save new High-Byte geswapped in Padr
                mov #0x84,r0             ! write 0x84 --> Scssr fr Rx-Flags-Clr
                mov.b r0,@(8,r1)         !_zur Lschung Rdrf,Orer,Fer,Per,Mbpt
                extu.b r4,r0             ! Schreibe_Tx-Daten/Low:
                mov.b @(r0,r2),r0        ! lese Low-Byte des D/A-Words nach R0
                mov.b r0,@(6,r1)         ! swappe zu sendendes Sio-Daten-Byte
                xor r0,r0                ! write 0xNN --> Sctdr fr Tx-Daten
                rts                      ! write 0x00 --> Scssr Rx/Tx-Flags-Clr
                mov.b r0,@(8,r1)         ! fr Clr Tdre,(Rdrf,Orer,Fer,Per),Mpbt

!...............

BOOT_K1401:     .short 0x00FA            ! Frame-Sync-Timeout 200uSec     [0000]
BOOT_K1402:     .long  A_IRR0            ! Adr Intreq-Reg fr Frame-Sync-Flanke
BOOT_K1403:     .long  A_PADR            ! Adr Port#A-Daten als AD-Highbyte-Buf
BOOT_K1404:     .short -0x0900-(BOOT_K1404-X0)! Offset Bitswap-Table 0x8C007700
BOOT_K1405:     .short A_SCSMR           ! Adr Sio#0-Basis auch fr Timer#0-Cnt

!----------------
! LINE-INTERFACE
!----------------






!---------------

_line_sethook:



_line_gethook:


!. . . . . . . .

_line_getring:
_line_getpower:
_line_getreset:








!. . . . . . . .

_temic_init:    sts pr,r7                ! 5D - TEMIC_INITIALISIEREN:     [0000]
                mova BOOT_K1506,r0       ! signed long temic_init (void)
                mov r0,r6                ! ---> Alle Register auf default-Wert
             1:   bsr _temic_byteout     !      R0..R7 werden dabei getrashed
                  mov.b @r6,r4           ! Temic-Setup dauert knapp 500uSec
                  mov.b @r6+,r0          ! Baue R6=TablePtr,R7=ReturnAdress
                  cmp/eq #0xC0,r0        ! Dann fr jedes der 8 Temic-Register
                  bf 1b                  ! lese Byte aus Table, setze Register
                jmp @r7                  ! repeat solange Daten-Val nicht 0xC0
                xor r0,r0                ! alle Register eingestellt, return 0


_temic_byteout: sts pr,r5                ! 5E - CONTROL-BYTE_AN_TEMIC:    [0000]
                extu.b r4,r4             ! void temic_byteout (unsigned char N)
                mov.w BOOT_K1505,r0      ! R4 = Byte-Wert fr Temic-Chip
                bra 2f                   ! ---> Daten werden seriell ausgegeben
                or r0,r4                 !      R0..R5 werden dabei getrashed
             1:   bsr BOOT_UDELAY        ! Temic-Byte-Output dauert knapp 60uSec
                  mov #0xFC,r0           ! bei 139 KBit/Sec gehen 16.5 KByte/Sec
                  mov.w BOOT_K1504,r0    ! Baue R4=Data/Marker,R5=ReturnAdress
                  mov.l BOOT_K1501,r1    ! dann jump zur Ausgabe erstes Datenbit
                  bsr BOOT_MODPORT       ! Daten-Bit-bernahme nach/fr Bit#0-6:
                  shlr r4                ! der Clock-Pin gerade auf High gesetzt
                  bsr BOOT_UDELAY        ! jetzt min 2uSec mit Clock=H abwarten
                  mov #0xFE,r0           ! wir brauchen min 2.4uSec,typ 3.2uSec
             2:   mov r4,r0              ! dann den Clock-Pin auf Low rcksetzen
                  mov.l BOOT_K1501,r1    ! jetzt min 0uSec an Hold-Zeit warten
                  and #0x01,r0           ! wir warten damit Data nicht vor Clock
shll r0
nop
                  mov.w BOOT_K1502,r2    ! wir brauchen min 0.8uSec,typ 1.6uSec
                  bsr BOOT_MODPORT       ! Daten-Bit-Ausgabe fr Bit#0-7:
                  or r2,r0               ! next Lsb aus Daten an Port-Data-Pin
                  bsr BOOT_UDELAY        ! dabei bleibt Clock-Line zunchst Low
                  mov #0xFD,r0           ! jetzt min 0.1uSec Setup-Zeit warten
                  mov.w BOOT_K1503,r0    ! wir brauchen min 1.6uSec,typ 2.4uSec
                  mov.l BOOT_K1501,r1    ! erfllen damit 2uSec Clock-Low-Zeit
                  bsr BOOT_MODPORT       ! zusammen mit der 0.8uSec Hold-Zeit
                  nop                    ! dann den Clock-Pin auf High setzen
                  swap.b r4,r0           ! damit beginnt Bit-bernahme in Temic
                  tst #0xFF,r0           ! fr Bit#0..6 weiter mit Bit-bernahme
                  bf 1b                  ! nach 7 Shifts sind R4/Bit#8-15 alle 0
                mov #0x03,r4             ! Byte-Strobe-Sequenz nach Daten-Bit#7:
             3:   bsr BOOT_UDELAY        ! nun wird geshiftetes Byte bernommen
                  mov #0xFE,r0           ! der Clock-Pin gerade auf High gesetzt
                  add #0xFF,r4           ! jetzt min 0.1uSec mit Clock=H warten
                  mov.l BOOT_K1501,r1    ! wir brauchen min 0.8uSec,typ 1.6uSec
                  neg r4,r0              ! dann Data=L setzen und Clock=H lassen
shlr r0
rotcl r2
shlr r0
rotcl r2
mov r2,r0
nop
                  mov.w BOOT_K1502,r2    ! jetzt min 0.2uSec mit Data=L abwarten
                  and #0x03,r0           ! wir brauchen min 0.8uSec,typ 1.6uSec
                  bsr BOOT_MODPORT       ! dann Data=H setzen und Clock=H lassen
                  or r2,r0               ! jetzt min 0.2uSec mit Data=H abwarten
                  tst r4,r4              ! wir brauchen min 0.8uSec,typ 1.6uSec
                  bf 3b                  ! dann Data=L und Clock=L zurcksetzen
                bra BOOT_UDELAY1         ! wir warten so min 0.8uSec,typ 1.6uSec
                lds r5,pr                ! erfllen damit 2uSec Clock-Low-Zeit

!...............

BOOT_K1501:     .long  A_PDDR            ! Adr Port#D-Datenregister       [0000]
BOOT_K1502:     .short 0x08F0            ! Modify Dma=H,Res=L,(leave Wakeup)
BOOT_K1503: .short 0x0AF1
BOOT_K1504: .short 0x0AF0
!BOOT_K1503:     .short 0x09F2            ! Modify Dma=H,Res=L,Clk=H,(Wake+Data)
!BOOT_K1504:     .short 0x09F0            ! Modify Dma=H,Res=L,Clk=L,(Wake+Data)
BOOT_K1505:     .short 0x4000            ! Bit-Marker als Count fr 8 Data-Bits
                                         !-
BOOT_K1506:     .byte 0xE8               ! R#7: Sin1=Sin2=Sd=Amf=0,Isq=1  [0000]
                .byte 0xB7               ! R#5: Ec=0,Ie1=Im=It=Ir=1
                .byte 0x98               ! R#4: Bal0=Bal1=Bal2=0,Ibal=Ie2=1
                .byte 0x50               ! R#2: Nea0=Nea1=Nea2=Ea=0,Ial=1
                .byte 0x70               ! R#3: At0=At1=Ar0=Ar1=0,Iagc=1
                .byte 0x00               ! R#0: Tx0=Tx1=Tx2=Tx6=Mis=0
                .byte 0x20               ! R#1: Rx0=Rx1=Rx2=Rx6=Lis=0
                .byte 0xC0               ! R#6: M0=M1=M2=M3=M4=0 (Loop-Ende!)

!---------------
! PC-LINK/SIO#1
!---------------




!-------------
! MODEM/SIO#2
!-------------



!--------------
! FLASH-MEMORY
!--------------

FLASH_XFIRST:   mov r5,r0                ! FLASH-ZUGRIFF_STARTUP:         [0000]
                mov #A_TTB,r1            ! Startup aller Flash-Access-Funktionen
                mov.l @r1,r1             ! R3 = Kennung fr Flash-Reservierung
                shll2 r0                 ! Reserviere Flash-Baustein fr uns:
                shll r0                  ! bringe Bit#28 der Adresse nach R0
                rotl r0                  ! damit entscheidet sich Area#0/4
                and #0x01,r0             ! lese Basis-Adr System-Variablen
                add #0x46,r1             ! baue Pointer auf Flash-Lockbyte
                add r0,r1                ! aus Systemvariablen+0x46+Area01
                tas.b @r1                ! versuche ob wir Byte mit 0 kriegen
                bt 1f                    ! wenn ja dann gut, wir haben Flash
                  lds.l @r15+,pr         ! Flash ist schon belegt:
                  bra FLASH_XWDTCLR      ! als Return-Adr eine Ebene hher
                  mov #0xFF,r0           ! clear Watchdog, Error "Busy"/-1
             1: mov r1,r2                ! Wir haben das Flash erhalten:
                add #0x02,r2             ! notiere Flash-Arbeits-Adresse
                add r0,r2                ! ins Ram fr Power-Down-Hander
                add r0,r2                ! der resettet Flash vor Standby
                mov.l r5,@(r0,r2)        ! schreibe Flash-Adr +0x48/+0x4C
                mov.b r3,@r1             ! schreibe Flash-Use +0x46/+0x47
                mov.l r1,@-r15           ! save Ptr Flash-Lock-Byte auf Stack
                mov.w BOOT_K1807,r0      ! baue Pointer auf Flash-Command-Adr
                mov.w BOOT_K1801,r1      ! clear A0..A14 in der Flash-Adresse
                and r5,r0                ! als Basis-Adresse des Flash-Chips
                mov.w BOOT_K1808,r2      ! setze R0 = BasisAdr Flash-Segment
                or r0,r1                 ! setze R1 = BasisAdr+0x2AAA (Low)
                or r0,r2                 ! setze R2 = BasisAdr+0x5555 (High)
                                         !-
FLASH_XWDTCLR:  mov.l r7,@-r15           ! USER-WATCHDOG_BERUHIGEN:       [0000]
                mov.l r6,@-r15           ! R4 = *Watchdog-Clear-Funktion
                mov.l r5,@-r15           ! ---> Watchdog wird beruhiged
                mov.l r4,@-r15           !      R3 wird getrashed
                mov.l r2,@-r15           ! Save fast alle getrashten Register
                mov.l r1,@-r15           ! R0 fr Return-Value etc.
                sts.l pr,@-r15           ! R1,R2 mit Flash-Command-Adressen
                jsr @r4                  ! R4,R5,R6,R7 mit Funktions-Argumenten
                mov.l r0,@-r15           ! kostet 32 Byte Stack fr 8 Long-Words
                mov.l @r15+,r0           ! save Register als Stack-Frame
                lds.l @r15+,pr           ! +0x1C - R7   +0x0C - R2
                mov.l @r15+,r1           ! +0x18 - R6   +0x08 - R1
                mov.l @r15+,r2           ! +0x14 - R5   +0x04 - PR
                mov.l @r15+,r4           ! +0x10 - R4   +0x00 - R0
                mov.l @r15+,r5           ! dann Watchdog-Funktion callen
                mov.l @r15+,r6           ! restauriere Register aus Stack
                rts                      ! nur R3 und Flags sind verndert
                mov.l @r15+,r7           ! mit beruhigtem Watchdog zurck


FLASH_XCMD:     mov.b r1,@r2             ! COMMAND_ANS_FLASH-CHIP:        [0000]
                mov.b r2,@r1             ! R1 = Command-Adresse/Low  (..0x2AAA)
                rts                      ! R2 = Command-Adresse/High (..0x5555)
                mov.b r3,@r2             ! R3 = auszugebender Flash-Command

!. . . . . . . .

_flash_erase_chip:
                sts.l pr,@-r15           ! 78 - LSCHE_GESAMTES_FLASH:    [0000]
                bsr FLASH_XFIRST         ! signed long flash_erase_chip
                mov #0x01,r3             ! (const void *WdtClr, void *Flash)
                bsr FLASH_XCMD           ! Flash mit Grund=0x01 reservieren
                mov #0x80,r3             ! schreibe Command "EraseSetup"/0x80
                bsr FLASH_XCMD           ! schreibe Command "Chip-Erase"/0x10
                mov #0x10,r3             !_damit wird gesamtes Flash gelscht
BOOT_X1801:     mov.l BOOT_K1803,r7      ! Warte auf Erase-Beendigung:
                bra FLASH_XSYNC          ! lade R6/Data=0xFF,R7=Timeout=100Sec
                mov #0xFF,r6             ! weiter mit Warten auf Flash-Ready

_flash_erase_sectors:
                tst r5,r5                ! 79 - LSCHE_FLASH-SEKTOREN:    [0000]
                bt/s FLASH_XWDTCLR       ! signed long flash_erase_sectors
                xor r0,r0                ! (const void *WdtClr, u_char SektAnz,
                  mov #0x40,r7           !  const void *SektListe)
                  cmp/hi r7,r5           ! Teste ob die Sektor-Anzahl Null ist
                  bt 1f                  ! dann Watchdog-Reset und Ende mit R0=0
                    mov r5,r7            ! teste ob die Sektor-Anzahl ber 64
             1:   sts.l pr,@-r15         ! wenn ja Count auf 64 Sekts limiten
                  mov.l @r6,r5           ! lese Adresse erster Sektor nach R5
                  bsr FLASH_XFIRST       ! zum Ermitteln der Cmd-Reg-Adressen
                  mov #0x02,r3           ! Flash mit Grund=0x02 reservieren
                  bsr FLASH_XCMD         ! schreibe Command "EraseSetup"/0x80
                  mov #0x80,r3           ! von jetzt ab wird es zeitkritisch
                  mov.l BOOT_K1804,r0    ! denn zwischen Sektoren max 50uSec
                  stc sr,r3              ! daher solange alle Interrupts aus
                  or r3,r0               ! save SR in R3, Mask Intm=15 in R0
                  ldc r0,sr              ! lade SR mit Intm=15 fr Ints=Off
                  mov.b r1,@r2           ! schreibe 0xAA-->+0x5555 1.Unlock
                  mov #0x30,r0           ! schreibe 0x55-->+0x2AAA 2.Unlock
                  mov.b r2,@r1           ! ab jetzt kommen die Sektor-Angaben
             2:     dt r7                ! Repeat fr jeden Sektor der Liste:
                    mov.l @r6+,r5        ! lese Sektor-Adresse aus der Liste
                    bf/s 2b              ! schreibe 0x30-->+Sektor EraseCmd
                    mov.b r0,@r5         ! decrement Count, repeat bis done
                  bra BOOT_X1801         ! restauriere SR/Orginal-Intm-Level
                  ldc r3,sr              ! weiter mit Warten auf Erase-Ready

_flash_program_byte:
                sts.l pr,@-r15           ! 7A - PROGRAM_FLASH-BYTE:       [0000]
                bsr FLASH_XFIRST         ! signed long flash_program_byte
                mov #0x03,r3             ! (const void *WdtClr, u_char *Flash,
                mov.b @r5,r7             !  unsigned char DataByte)
                exts.b r6,r6             ! Flash mit Grund=0x03 reservieren
                cmp/eq r6,r7             ! Teste_ob_Programmeriung_notwendig:
                bt/s BOOT_X1804          ! lese bisherigen Wert aus Flash
                xor r0,r0                !_wenn Wert wie gewnscht ok-Ende
                mov.w BOOT_K1806,r0      ! Teste_ob_Programmeriung_mglich:
                bsr FLASH_XCMD           ! schreibe Command "Id-Memory"/0x90
                mov #0x90,r3             ! lese Bit-Maske fr Sektor-Start
                and r5,r0                ! lese Sektor-Lock-Byte aus Id-Mem
                mov.b @(2,r0),r0         ! mit 00=Unlock/01=Locked als Daten
                tst r0,r0                ! teste ob Sektor auch nicht gelocked
                bf/s BOOT_X1803          ! bei Protection Flash=Data,Error=-02
                mov #0xFE,r0             ! teste das keine 0->1 Programmierung
                xor r6,r7                ! denn dazu ist ne Lschung notwendig
                and r6,r7                ! teste ob Bits die verndert werden
                tst r7,r7                ! nun auf High gesetzt werden sollen
                bf/s BOOT_X1803          ! wenn ja Fehler-Ende mit Error=-03
                mov #0xFD,r0             !_wegen "Byte must be erased first"
                bsr FLASH_XCMD           ! Mache_Programming-Sequence:
                mov #0xA0,r3             ! schreibe Command "Program"/0xA0
                mov.b r6,@r5             ! schreibe Daten-Wert ins Ziel-Byte
                mov.w BOOT_K1802,r7      ! lade Timeout 10mSec max BusyTime
                                         !-
FLASH_XSYNC:    mov.l r8,@-r15           ! WARTE_BIS_FLASH_BEREIT:        [0000]
                mov.l r9,@-r15           ! R1 = *Flash-Cmd-Adr / Low  (..0x2AAA)
                mov.l r10,@-r15          ! R2 = *Flash-Cmd-Adr / High (..0x5555)
                mov.b @r5,r8             ! R4 = *Watchdog-Clear (Clear-Funktion)
                mov.w BOOT_K1805,r0      ! R5 = *Flash-Mem-Adresse (Status-Reg)
BOOT_K1801:     xor r10,r10              ! R6 =  Wunsch-Daten-Wert (Flash-Byte)
                mov.l @r0,r9             ! R7 =  Maximum Busy-Time (in 800nSecs)
             1:   mov.l BOOT_K1804,r0    ! Mache weitere Register R8-R10 frei
                  stc sr,r3              ! setup R8 = letzter Flash-Status-Input
                  or r3,r0               ! setup R9 = letzter Timer#0-Count-Read
                  ldc r0,sr              ! setup R10 = Gesamte Ready-Wartezeit
                  mov.b @r5,r0           ! Dann solange bis Flash bereit ist:
                  xor r8,r0              ! save SR in R3, setze Intm=15/Ints=Off
                  tst #0x40,r0           ! fr Flash-Status und Zeit konsistent
                  bt 4f                  ! lese neuen Flash-Status nach R0
                  xor r0,r8              ! wenn D6 nicht toggelt dann ready
                  xor r8,r0              ! sonst testen ob letztemal D5=On
                  tst #0x20,r0           ! dann Fehler-Ende mit Flash-Reset
                  bf 2f                  ! ansonsten ist Flash normal busy
                  mov.w BOOT_K1805,r0    ! dann neuen Timer#0-Count lesen
                  mov.l @r0,r0           ! enable Interrupts jetzt wieder
                  bsr FLASH_XWDTCLR      ! call User-Watchdog whrend Wartens
                  ldc r3,sr              ! errechne vergangene Timer-Counts
                  sub r0,r9              ! der Timer#0 decrements alle 800nS
                  add r9,r10             ! addiere Counts zu Gesamt-Wartezeit
                  cmp/hi r7,r10          ! teste ob schon ber Timeout gewartet
                  bf/s 1b                ! save Timer-Count in last-Timer-Count
                  mov r0,r9              ! repeat Warterei bis Timeout erreicht
                bra 3f                   ! dann Fehler-Ende "Prog-Timeout"/-05
                mov #0xFB,r0             ! restore Register und resette Flash
             2: ldc r3,sr                ! Flash-Programmier-Fehler gesetzt:
                mov #0xFC,r0             ! dann Fehler-Ende "Prog-Error"/-04
             3: mov.l @r15+,r10          ! restauriere R8-R10 wieder von Stack
                mov.l @r15+,r9           ! schreibe Command "Reset"/0xF0
                bra BOOT_X1803           ! damit Flash wieder auf Daten-Bereich
                mov.l @r15+,r8           ! remove Flash-Lock und zurck
             4: ldc r3,sr                ! Gutes Programmier-Ende:
                mov r10,r0               ! enable Interrupts jetzt wieder
                mov.b @r5,r3             ! lade R0/RetVal mit Flash-Busy-Zeit
                mov.l @r15+,r10          ! restauriere R8-R10 wieder vom Stack
                mov.l @r15+,r9           ! lese geschriebenes Flash-Byte zurck
                cmp/eq r3,r6             ! vergleiche mit dem was wir erwarten
                mov.l @r15+,r8           ! wenn gleich dann ist alles in Ordnung
                bt BOOT_X1804            ! dann Lock removen und ret zum Caller
                  bra BOOT_X1804         ! wenn ungleich dann Final-Verify-Error
                  mov #0xFA,r0           ! dann Fehler-Ende "Prog-Verify"/-06

_flash_read_lock:
                sts.l pr,@-r15           ! 7B - LESE_SEKTOR-LOCK:         [0000]
                bsr FLASH_XFIRST         ! signed long flash_read_lock
                mov #0x04,r3             ! (const void *WdtClr, void *Flash)
                mov.w BOOT_K1806,r0      ! Flash mit Grund=0x04 reservieren
                bsr FLASH_XCMD           ! schreibe Command "Id-Memory"/0x90
                mov #0x90,r3             ! lade Bit-Maske SektorStart 256Byte
                and r5,r0                ! lese Locks aus Byte SektorStart+2
                mov.b @(2,r0),r0         ! mit 00=Unlock/01=Locked als Daten
BOOT_X1802:     extu.b r0,r0             ! Sign-Extende Byte-Return-Value
BOOT_X1803:     bsr FLASH_XCMD           ! Resette Flash wieder auf Daten
                mov #0xF0,r3             ! schreibe Command "Reset"/0xF0
BOOT_X1804:     mov.l @r15+,r1           ! Remove Flash-Lock und Return
                lds.l @r15+,pr           ! lese Adresse des Lock-Bytes
                xor r2,r2                ! restauriere PR mit Ret-Adr
                rts                      ! schreibe 0x00->Lock-Byte
                mov.b r2,@r1             ! zurck zum Caller mit R0

_flash_read_chipid:
                sts.l pr,@-r15           ! 7C - LESE_FLASH-CHIP-ID:       [0000]
                bsr FLASH_XFIRST         ! signed long flash_read_chipid
                mov #0x05,r3             ! (const void *WdtClr, void *Flash)
                bsr FLASH_XCMD           ! Flash mit Grund=0x05 reservieren
                mov #0x90,r3             ! schreibe Command "Id-Memory"/0x90
                mov.w @r0,r0             ! lese Hersteller und Device nach R0
                bra BOOT_X1803           ! aus +0x00/Hersteller, +0x01/Device
                extu.w r0,r0             ! sel Flash=Data, unlock Flash, ret

_flash_read_idmem:
                sts.l pr,@-r15           ! 7D - LESE_FLASH_ID-MEM:        [0000]
                bsr FLASH_XFIRST         ! signed long flash_read_idmem
                mov #0x06,r3             ! (const void *WdtClr, u_char *Flash)
                bsr FLASH_XCMD           ! Flash mit Grund=0x06 reservieren
                mov #0x90,r3             ! schreibe Command "Id-Memory"/0x90
                bra BOOT_X1802           ! lese gesuchtes Id-Mem-Byte nach R0
                mov.b @r5,r0             ! sel Flash=Data, unlock Flash, ret

_flash_read_data:
                sts.l pr,@-r15           ! 7E - LESE_FLASH-DATEN:         [0000]
                bsr FLASH_XFIRST         ! signed long flash_read_data
                mov #0x07,r3             ! (const void *WdtClr, u_char *Flash)
                mov.b @r5,r0             ! Flash mit Grund=0x07 reservieren
                bra BOOT_X1804           ! lese gesuchtes Daten-Byte nach R0
                extu.b r0,r0             ! unlock Flash und zurck zum Caller

!...............

BOOT_K1802:     .short 0x30D4            ! Timeout/Prog  10mSec (1.25MHz) [0000]
BOOT_K1803:     .long  0x07735940        ! Timeout/Erase 100Sec (1.25MHz)
BOOT_K1804:     .long  0x10000000        ! SR-Mask mit BL=1 fr alle Ints aus
BOOT_K1805:     .short A_TCNT0           ! Adresse Timer#0 Count-Register
BOOT_K1806:     .short 0xFF00            ! Maske fr Flash Sektor-Start (Locks)
BOOT_K1807:     .short 0x8000            ! Maske fr Flash Chip-Start (Cmds,Id)
BOOT_K1808:     .short 0x5555            ! Offset der oberen Flash-Command-Adr


!*** EOF ***
