! "2monitor.asm", Version 2.01 vom 13.6.1999, (C) Volker Ernst 1999
!  Simple asm source-file for the "mcm3" machine-code-monitor.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.

.org 0x2000,0xFF

!******************************************************************************!
!        M  A  C  H  I  N  E   -   C  O  D  E   -   M  O  N  I  T  O  R        !
!******************************************************************************!

!---------------
! MONITOR-ENTRY
!---------------

MONITOR:        rts
                nop

                .short 0xFFFF



!---------------

BOOT_AUXSTART:  mov.w BOOT_K2991,r0      ! PROVISORISCHER_BOOT-LOADER:
                mov #A_WTCSR,r1          ! Watchdog jetzt disablen
                mov.w r0,@r1             ! write 0xA547 --> Wtcsr
                                         !-
                mov.l BOOT_K2992,r1      ! Starte_SDram-Code:
                jmp @r1                  ! jump --> 0x8C010040
                xor r0,r0                ! ist SDram+64K+64Byte
                                         !-
BOOT_K2991:     .short 0xA547            !
BOOT_K2992:     .long  0x8C010040        !

!---------------




_breakpoint:    mov.l r0,@-r15           ! MONITOR-FUNCTION-CALL:         [0000]
                mov.l r1,@-r15           ! void breakpoint (void)
                bra MON_X0001            ! setze R0/PC=PR, R1/Grund=0x00
                xor r1,r1                ! weiter wie Debug-Text-Ausgabe


_debugtext:     mov.l r0,@-r15           ! PRINT_DEBUG-MESSAGE:           [0000]
                mov.l r1,@-r15           ! void debugtext (const u_char *Text)
                mov #0xFF,r1             ! setze R0/PC=PR, R1/Grund=0xFF
     MON_X0001: bra MON_XENTRY           ! dann zur Text-Ausgabe Monitor callen
                sts pr,r0                ! damit Mcm/Gdb Message ausgeben kann


MON_SWBRK:      add #0xFE,r0             ! SOFTWARE-BREAKPOINT:           [0000]
                mov.l r1,@-r15           ! setze R1/Grund auf 0x10
                bra MON_XENTRY           ! decrement R0/PC 1 Word
                mov #0x10,r1             ! zurck auf Trap-Opcode


MON_HWBRK:      add #0x20,r1             ! HARDWARE-BREAKPOINT:           [0000]

!. . . . . . . .

MON_XENTRY:     add #0xE4,r15            ! ***** MONITOR-ENTRY *****
                mov.l r14,@-r15          ! R0 = User-PC
                mov.l r13,@-r15          ! R1 = Entry-Grund {0x00..0x2F,0xFF}
                mov.l r12,@-r15          ! Auf dem Stack liegen Orginal-R0/R1
                mov.l r11,@-r15          ! mache Platz fr System-Register
                mov.l r10,@-r15          ! save R14..R8 auf dem Stack
                mov.l r9,@-r15           ! schreibe Stack-Top in R15 auf Stack
                mov r15,r14              ! schreibe R0/User-PC in PC auf Stack
                mov.l r8,@-r15           ! schreibe R1/Grund unter Stack-Top
                add #0x3C,r14            ! save R1 mit Monitor-Grund in R12
                mov.l r14,@(0x1C,r15)    ! save R4 mit Text-Message-Ptr in R8
                add #0xFC,r14            ! restauriere User-R0/R1 back vom Stack
                mov.l r0,@(0x20,r15)     ! save SR,MACH,MACL,VBR,GBR,PR im Stack
                mov r4,r8                ! baue R9=SR/Org,R10=SR/RB0,R11=SR/RB1
                mov.l @(0x3C,r15),r0     ! select RB1 und save R7..R0 auf Stack
                mov r1,r12               ! select RB0 und save R7..R0 auf Stack
                mov.l r1,@(0x3C,r15)     ! Aufbau des Stack-Frames im Ram:
                mov.l @(0x38,r15),r1     ! +0x7C  Monitor Start-Grund
                stc.l sr,@-r14           ! +0x78  SR
                sts.l macl,@-r14         ! +0x74  MACL
                sts.l mach,@-r14         ! +0x70  MACH
                stc.l vbr,@-r14          ! +0x6C  VBR
                mov.l MON_K0001,r10      ! +0x68  GBR
                stc sr,r9                ! +0x64  PR
                mov.l MON_K0002,r11      ! +0x60  PC
                and r9,r10               ! +0x5C  R15
                stc.l gbr,@-r14          ! +0x58  R14
                or r10,r11               ! +0x54  R13
                mov.l MON_K0003,r10      ! +0x50  R12
                ldc r11,sr               ! +0x4C  R11
                sts.l pr,@-r14           ! +0x48  R10
                and r11,r10              ! +0x44  R9
                mov.l r7,@-r15           ! +0x40  R8
                mov.l r6,@-r15           ! +0x3C  R7/Bank1
                mov.l r5,@-r15           ! +0x38  R6/Bank1
                mov.l r4,@-r15           ! +0x34  R5/Bank1
                mov.l r3,@-r15           ! +0x30  R4/Bank1
                mov.l r2,@-r15           ! +0x2C  R3/Bank1
                mov.l r1,@-r15           ! +0x28  R2/Bank1
                mov.l r0,@-r15           ! +0x24  R1/Bank1
                ldc r10,sr               ! +0x20  R0/Bank1
                mov.l r7,@-r15           ! +0x1C  R7/Bank0
                mov.l r6,@-r15           ! +0x18  R6/Bank0
                mov.l r5,@-r15           ! +0x14  R5/Bank0
                mov.l r4,@-r15           ! +0x10  R4/Bank0
                mov.l r3,@-r15           ! +0x0C  R3/Bank0
                mov.l r2,@-r15           ! +0x08  R2/Bank0
                mov.l r1,@-r15           ! +0x04  R1/Bank0
                mov.l r0,@-r15           ! +0x00  R0/Bank0
                                         !-
                mov #A_PTEH,r2           ! Call_Monitor-Programm:
                mov.l @r2,r1             ! R8=*Msg,R9=SR/Org,R10=SR/B0,R11=SR/B1
                mov.l @(8,r2),r0         ! R12=Grund, Register-Bank#0 ausgewhlt
                add #0x08,r1             ! Teste und reserviere Task-Debugger:
                extu.b r1,r1             ! lade R0=SystemDataBaseadr,R1=TaskNr
                shll8 r1                 ! baue Offset fr Task-private-Daten
                mov.l @(r0,r1),r13       ! ergibt sich aus TaskNr*256+2048
                add r0,r1                ! lese Debugger/DriverPtr aus +0x00
                tst r13,r13              ! wenn Null-Pointer kein Debugging
                bt 8f                    ! lese Debugger/RamBase aus +0x04
                mov.l @(4,r1),r14        ! wenn Null-Pointer kein Debugging
                tst r14,r14              ! R13=Debug/DriverPtr,R14=Debug/RamBase
                bt 8f                    ! versuche Debug-Ram/Byte#0 zu setzen
                tas.b @r14               ! wenn dort keine Null kein Debugging
                bf 8f                    ! ansonsten haben wir Debugger bekommen
                  mov.l r11,@-r15        ! Run_Debugger-Functions:
                  ldc r0,gbr             ! save R10=SR/B0,R11=SR/B1 auf Stack
                  mov.l r10,@-r15        ! setze GBR=System-Data-Baseadress
                  cmp/pz r12             ! lese R0=Debug-Flags aus Debugger-Ram
                  mov.b @(1,r14),r0      ! teste ob Breakpoint/String-Ausgabe
                  bf 3f                  ! bei String-Ausgabe Breakpoints lassen
                    tst #0x40,r0         ! Entferne_alle_Breakpoints:
                    bt 1f                ! teste ob wir Hardware-Breaks nutzen
                      mov #A_BBRB,r1     ! wenn nein weiter mit Software-Breaks
                      mov.w @(0x10,r1),r0! Entferne_Hardware-Breakpoints:
                      and #0x3F,r0       ! lsche Bits#6-15 im BBRA-Register
                      mov.w r0,@(0x10,r1)! lsche Bits#6-15 im BBRB-Register
                      mov.w @r1,r0       ! damit werden keine Breaks erzeugt
                      and #0x3F,r0       ! denn weder Cpu noch Dma triggert
                      mov.w r0,@r1       ! die eigentliche Bedingung bleibt
                      xor r0,r0          ! schreibe 0x00000000-->BRCR-Reg
                      mov #A_BRCR,r1     ! fr default-Break-Optionen
                      mov.l r0,@r1       ! damit ist Break-Hardware ruhig
                      mov.b @(1,r14),r0  ! und bereit zu neuer Verwendung
             1:     tst #0x0F,r0         ! teste ob Software-Breakpoints aktiv
                    bt 3f                ! wenn nein weiter mit Debugger-Start
                      and #0x0F,r0       ! Entferne_Software-Breakpoints:
                      mov #0x0A,r11      !
                      cmp/hi r11,r0      !
                      bt/s 2f            !
                      xor r10,r10        !
                        mov r0,r11       !
             2:         mov r10,r0       !
                        shll2 r0         !
                        add #0x40,r0     !
                        mov.l @(r0,r14),r4!
                        shlr r0          !
                        add #0x48,r0     !
                        bsr MON_MEMWRW   !
                        mov.w @(r0,r14),r5!
                        add #0x01,r10    !
                        cmp/hs r11,r10   !
                        bf 2b            !
                      mov.b @(1,r14),r0  !
                      and #0xF0,r0       !
                      mov.b r0,@(1,r14)  !
             3:   tst #0x80,r0           !
                  bf/s 5f                !
                  rotl r12               !
                    bt 4f                !
                      bsr MCM_MAIN       !
                      mov #0x07,r12      !
                      bra 7f             !
                      xor r0,r0          !
             4:     bsr MON_PUTS         !
                    mov r8,r4            !
                    bt 6f                !
             5:   bsr GDB_MAIN           !
                  mov #0x27,r12          !
             6:   xor r0,r0              !
             7:   mov.b r0,@r14          !
                  ldc.l @r15+,sr         !
                  mov.l @r15+,r11        !
                                         !-
             8: mov.l @r15+,r0           !
                mov.l @r15+,r1           !
                mov.l @r15+,r2           !
                mov.l @r15+,r3           !
                mov.l @r15+,r4           !
                mov.l @r15+,r5           !
                mov.l @r15+,r6           !
                mov.l @r15+,r7           !
                ldc r11,sr               !
                mov.l @r15+,r0           !
                mov.l @r15+,r1           !
                mov.l @r15+,r2           !
                mov.l @r15+,r3           !
                mov.l @r15+,r4           !
                mov.l @r15+,r5           !
                mov.l @r15+,r6           !
                mov.l @r15+,r7           !
                mov.l @r15+,r8           !
                mov.l @r15+,r9           !
                mov.l @r15+,r10          !
                mov.l @r15+,r11          !
                mov.l @r15+,r12          !
                mov r15,r14              !
                add #0x10,r14            !
                lds.l @r14+,pr           !
                ldc.l @r14+,gbr          !
                ldc.l @r14+,vbr          !
                lds.l @r14+,mach         !
                lds.l @r14+,macl         !
                ldc.l @r14+,sr           !
                mov.l @(8,r15),r14       !
                mov.l @r15+,r13          !
                mov.l r13,@-r14          !
                mov.l @r15+,r13          !
                mov.l r13,@-r14          !
                mov.l @(4,r15),r13       !
                mov r14,r15              !
                mov.l @r15+,r14          !
                jmp @r13                 !
                mov.l @r15+,r13          !
                                         !=
MON_K0001:      .long  0x100010F0        ! SR-Maske was erhalten bleibt
MON_K0002:      .long  0x60000001        ! SR: Md=Rb=1,M=Q=S=0,T=1
MON_K0003:      .long  0xDFFFFFFF        ! SR: And-Mask fr Rb-Clear

!*******************************************************************************

!----------------
! TEXT-COMMANDER
!----------------

MCM_MAIN:       sts.l pr,@-r15           ! MCM3_MAIN-ENTRY:               [0000]
                mova MCM_SIGNON,r0       ! R12  = 0x07 fr Hex-Grossschreibung
                bsr MON_PUTS0            ! R10 = SR/Bank#0  R11 = SR/Bank#1
                xor r8,r8                ! R12 = Adresse Task-Variablen
                bsr MCMC_REGPRINT        ! R13 = Adresse Driver-Table
                mov #0x01,r0             ! R14 = Adresse Monitor-Ram
                                         !-
MCM_CMDLOOP:    mov.l @(20,r14),r0       ! Flash-Statistik:               [0000]
                tst r0,r0                !
               !bt ?f                    !



                .align 2,0xFF

!...............

MCM_SIGNON:     .byte 0x0D,0x0A,0x0D,0x0A            ! SIGNON-MESSAGE     [0000]
                .ascii "*****  M C M - 3  *****"
                .byte 0x0D,0x0A,0x0D,0x0A,0x00




!------------------
! COMMAND-ROUTINES
!------------------

MCMC_REGPRINT:  sts.l pr,@-r15           ! "R" - PRINT_REGISTER-DATA:     [0000]
                mova MCM_TXTREGS,r0      ! Anzeige aller Cpu-Register in Hex
                mov r15,r1               !
                add #0x08,r1             !
                mov #0x04,r2             !
             1:   mov.l r1,@-r15         !
                  bsr MON_PUTS0          !
                  mov.l r2,@-r15         !
                  mov.l r0,@-r15         !
                  mov #0x08,r2           !
             2:     mov #0x20,r4         !
                    bsr MON_PUTCH4       !
                    mov.l r2,@-r15       !
                    mov.l @(12,r15),r1   !
                    mov.l @r1+,r0        !
                    bsr MON_PUTXL        !
                    mov.l r1,@(12,r15)   !
                    mov.l @r15+,r2       !
                    dt r2                !
                    bf 2b                !
                  mov.l @r15+,r0         !
                  mov.l @r15+,r2         !
                  mov.l @r15+,r1         !
                  dt r2                  !
                  bf 1b                  !



                .align 2,0xFF

!...............

MCM_TXTREGS:    .ascii "Cpu-Register:"               ! REGISTER-DISPLAY   [0000]
                .byte 0x0D,0x0A
                .ascii "B1/R0-R7"
                .byte 0x00,0x0D,0x0A
                .ascii "B0/R0-R7"
                .byte 0x00,0x0D,0x0A
                .ascii "  R8-R15"
                .byte 0x00,0x0D,0x0A
                .ascii " CONTROL"
                .byte 0x00
                .ascii "PC  "
                .ascii "PR  "
                .ascii "GBR "
                .ascii "VBR "
                .ascii "MACH"
                .ascii "MACL"
                .ascii "SR  "
                .ascii "Call"





                .align 2,0xFF

!*******************************************************************************

!----------
! WATCHDOG
!----------

MON_WDTCLR:     mov.l @(4,r13),r0        ! WATCHDOG_BERUHIGEN:            [0000]
     MON_X0201: jmp @r0                  ! void mcm_wdtclr (void)
                mov #0x42,r0             ! R0-R7 werden getrashed

!-------------
! CONSOLE-I/O
!-------------

MON_BRKCHK:     sts.l pr,@-r15           ! TESTE_OB_USER-BREAK:           [0000]
                bsr MON_X0201            ! unsigned char mon_brkchk (void)
                mov.l @(8,r13),r0        ! ---> F/T=0: kein User-Break
                mov r0,r1                !      T/T=1: User wnscht Abbruch
                rotr r1                  !      R0: Bit0=Break, Bit1=Pause
     MON_X0202: lds.l @r15+,pr           !      R1-R7 werden getrashed
                rts                      ! Call Break-Check-Handler via R13
                extu.b r0,r0             ! clear Bit8-31,copy Bit0 in T-Flag

!. . . . . . . .

MON_BUFEATSPC:  sts.l pr,@-r15           ! BERGEHE_BUFFER-WHITE-SPACES:  [0000]
             1:   bsr MON_BUFGETCH       ! unsigned char mon_bufeatspc (void)
                  mov #0x20,r2           ! ---> F/T=0: Echten Char gefunden
                  bt MON_X0202           !      T/T=1: Nichts mehr im Buffer
                  cmp/hi r2,r0           !      R0 = Nchster Char aus Buffer
                  bf 1b                  !      R1-R2 werden getrashed
                add #0x7E,r14            ! Save Callers PR, dann immer wieder:
                mov.w @r14,r1            ! lese nchsten Character aus Buffer
                add #0xFF,r1             ! wenn Null dann Ende mit T=1,R0=0
                mov.w r1,@r14            ! wenn Whitespace dann read next Char
                bra MON_X0203            ! sonst guten Char in Buffer zurcktun
                add #0x82,r14            ! zurck zum Caller mit T=1,R0=NextChar


MON_BUFGETNUML: mov #0x08,r3             ! LESE_ZAHLENWERT_AUS_BUFFER:    [0000]
MON_BUFGETNUM:  sts.l pr,@-r15           ! unsigned long mon_bufgetnum (void)
                xor r4,r4                ! ---> F/T=0: Nicht alle Digits gelesen
             1:   bsr MON_BUFGETCHX      !             Abbruch durch Nicht-Digit
                  add #0x7C,r14          !             R0 = Ascii-Chr Non-Digit
                  bsr MON_HEX2BIN        !      T/T=1: Alle Digits eingelesen
                  mov r0,r2              !             R0 = Zahlen-Wert binr
                  bf 2f                  !      R1 = <wird getrashed>
                  shll2 r4               !      R2 = letzter gelesener Ascii-Chr
                  shll2 r4               !      R3 = Anz. nicht gelesener Digits
                  dt r3                  !      R4 = Zahlenwert gelesener Digits
                  bf/s 1b                ! Save PR, init R3/Count und R4/Value
                  or r0,r4               ! lese Char aus Buf, wandle Hex->Bin
                bt MON_X0204             ! wenn kein Hex-Chr Ende mit T=0,R0=Chr
             2: bra MON_X0202            ! sonst Value<<4 und Hex-Digit-Val dazu
                mov r2,r0                ! wenn alle Digits done Ende T=1,R0=Val


MON_BUFGETCH:   add #0x7C,r14            ! LESE_CHARACTER_AUS_BUFFER:     [0000]
MON_BUFGETCHX:  mov.w @r14+,r0           ! unsigned char mon_bufgetch (void)
                mov.w @r14+,r1           ! ---> F/T=0: Character gelesen
                cmp/hs r0,r1             !             R0 = Character (unsigned)
                bt/s 1f                  !             R1 = Character (signed)
                xor r0,r0                !      T/T=1: Nichts mehr im Buffer
                  extu.w r1,r0           !             R0 = Character (Null)
                  mov.b @(r0,r14),r1     !             R1 = BufferLen (signed)
                  add #0x01,r0           ! Setze R14/MonVarPtr auf Buf-Variablen
                  mov.w r0,@-r14         ! lese R0=Gesamt-Len, R1=Lese-Position
                  add #0x02,r14          ! wenn Pos>=Len dann Ende mit T=1,R0=0
                  extu.b r1,r0           ! sonst Char aus Buffer lesen, Pos++
             1: rts                      ! setze R14/MonVarPtr wieder zurck
                add #0x80,r14            ! return mit R0=Character aus Buf (>=0)

!. . . . . . . .

MON_SIOGETXB:   mov #0x02,r3             ! LESE_ZAHLENWERT_AUS_SIO-RX:    [0000]
MON_SIOGETXN:   sts.l pr,@-r15           ! unsigned long mon_siogetxn (void)
                xor r4,r4                ! ---> F/T=0: Eingabe-Fehler
             1:   mov.l r3,@-r15         !             R0 = 0x01 - Syntax-Error
                  bsr MON_SIOGETCH       !             R0 = 0x1B - User-Break
                  mov.l r4,@-r15         !      T/T=1: Eingabe gut abgeschlossen
                  mov.l @r15+,r4         !             R0 = Zahlen-Wert
                  mov.l @r15+,r3         !      R1-R7 werden getrashed
                  bt MON_X0203           ! Save PR, init R3/Count und R4/Value
                  bsr MON_HEX2BIN        ! Dann fr jede einzulesende Digit:
                  shll2 r4               ! save Count und Value, lese Character
                  bf 2f                  ! restore Count/Value, bei Break Ende
                  shll2 r4               ! sonst Char von Hex nach Bin wandeln
                  dt r3                  ! bei Fehlern Ende mit "Syntax-Error"
                  bf/s 1b                ! sonst Bin-Value zu Gesamtwert dazu
                  or r0,r4               ! repeat bis alle Digits eingelesen
                bt MON_X0204             ! restauriere PR, return mit R0=R4
             2: mov #0x01,r0             ! Syntax-Error: lade R0=0x01/Syntax
     MON_X0203: lds.l @r15+,pr           ! Fehler-Ende: restauriere PR vom Stack
                rts                      ! lsche T-Flag als Signal fr Fehler
                clrt                     ! return mit positiver Error-Nr in R0


MON_HEX2BIN:    mov #0x30,r1             ! WANDLUNG_HEX->BIN:             [0000]
                cmp/hs r1,r0             ! unsigned char mon_hex2bin (u_char)
                bf 1f                    ! ---> F/T=0: schlechter Ascii-Char
                  add #0xD0,r0           !             R0 = <getrashed>
                  mov #0x0A,r1           !             R1 = 0x00
                  cmp/hi r0,r1           !      T/T=1: guter Ascii-Hex-Char
                  bt 1f                  !             R0 = binrer Wert
                    and #0xDF,r0         !             R1 = 0x01
                    add #0xF9,r0         ! Fr a-f ist Gross-/Kleinschreibung ok
                    cmp/hs r1,r0         ! wenn <0x30 Error, sonst 0x30 abziehen
                    bf 1f                ! wenn <0x0A ok, sonst Bit5=Clr, -=0x07
                      tst #0xF0,r0       ! wenn <0x0A Error, sonst wenn <0x10 ok
             1: rts                      ! wir haben Binr-Wert jetzt in R0
                movt r1                  ! setze T und R1 auf 0=Error, 1=Ok


MON_SIOGETCH:   sts.l pr,@-r15           ! LESE_CHARACTER_AUS_SIO-RX:     [0000]
                bsr MON_X0201            ! unsigned char mon_siogetch (void)
                mov.l @(12,r13),r0       ! ---> F/T=0: Ok, normaler Character
                extu.b r0,r0             !             R0 = Sio-Rx Daten-Byte
                tst r0,r0                !      T/T=1: Break-Signal empfangen
                bt/s 1f                  !             R0 = 0x1B / Escape
                lds.l @r15+,pr           !      R1-R7 werden getrashed
                cmp/eq #0x03,r0          ! Call Sio-Getch-Handler via R13
                bf 2f                    ! teste ob Byte Null oder Ctrl-C
             1:   mov #0x1B,r0           ! wenn ja dann 0x1B/Escape laden
             2: rts                      ! setze T-Flag wenn Daten=Escape
                cmp/eq #0x1B,r0          ! zurck zum Caller mit R0=Daten

!. . . . . . . .

MON_PUTARREL:     tst r5,r5              ! STRING_AUS_ARRAY_AUSGEBEN:     [0000]
                  bt MON_PUTS            ! const unsigned char *mon_putarrel
             1:     mov.b @r4+,r0        ! (const unsigned char *,unsigned long)
                    tst r0,r0            ! R4 = Start-Adresse des Text-Arrays
                    bf 1b                ! R5 = gewnschte Text-Nummer {00...}
                  bra MON_PUTARREL       ! Wenn Text gefunden dann ausgeben
                  add #0xFF,r5           ! sonst nchsten Text berspringen


MON_PUTS0:      mov r0,r4                ! TEXT-STRING_AUSGEBEN:          [0000]
MON_PUTS:       sts.l pr,@-r15           ! const unsigned char *mon_puts
             1:   mov.b @r4+,r0          ! (const unsigned char *Text)
                  tst r0,r0              ! R4 = Start-Adresse des Textes
                  bt MON_X0204           ! Save Return-Adresse auf dem Stack
                  bsr MON_PUTCH          ! Dann fr jeden Character des Strings:
                  mov.l r4,@-r15         ! lese nchstes Zeichen, Ende wenn Null
                  bra 1b                 ! sonst Char ausgeben, dabei Ptr saven
                  mov.l @r15+,r4         ! repeat Character-Ausgabe bis Null
     MON_X0204: lds.l @r15+,pr           ! Fertig mit String-Ausgabe:
                rts                      ! restauriere Return-Adresse vom Stack
                mov r4,r0                ! return den geupdateten Text-Pointer


MON_PUTXL:      sts.l pr,@-r15           ! HEX-LONG_AUSGEBEN:             [0000]
                bsr MON_PUTXW            ! void mon_putxl (unsigned long Data)
                swap.w r0,r0             ! R0  = Daten-Long zum Ausgeben
                lds.l @r15+,pr           ! R12 = Hex-"a-f" 0x07=Gross,0x27=Klein
                swap.w r0,r0             ! High-Word ausgeben, weiter Low-Word
                                         !-
MON_PUTXW:      sts.l pr,@-r15           ! HEX-WORD_AUSGEBEN:             [0000]
                bsr MON_PUTXB            ! void mon_putxw (unsigned short Data)
                swap.b r0,r0             ! R0  = Daten-Short zum Ausgeben
                swap.b r0,r0             ! R12 = Hex-"a-f" 0x07=Gross,0x27=Klein
                lds.l @r15+,pr           ! High-Byte ausgeben, weiter Low-Byte
                                         !-
MON_PUTXB:      mov.l r0,@-r15           ! HEX-BYTE_AUSGEBEN:             [0000]
                sts.l pr,@-r15           ! void mon_putxb (unsigned char Data)
                shlr2 r0                 ! R0  = Daten-Byte zum Ausgeben
                bsr MON_PUTDIGIT         ! R12 = Hex-"a-f" 0x07=Gross,0x27=Klein
                shlr2 r0                 ! Save Number und Return-Adresse
                bsr MON_PUTDIGIT         ! zuerst High-Nibble Digit ausgeben
                mov.l @(4,r15),r0        ! dann Number wieder aus Stack lesen
                lds.l @r15+,pr           ! danach Low-Nibble Digit ausgeben
                rts                      ! restauriere Ret-Adresse und Number
                mov.l @r15+,r0           ! zurck zum Caller mit R0=Argument


MON_PUTDIGIT:   and #0x0F,r0             ! HEX-ZIFFER_AUSGEBEN:           [0000]
                mov #0x09,r1             ! void mon_putdigit (unsigned char Dig)
                cmp/hi r1,r0             ! R0  = Hex-Digit zum Ausgeben
                bf/s MON_PUTCH           ! R12 = Hex-"a-f" 0x07=Gross,0x27=Klein
                add #0x30,r0             ! isoliere R0/Bit#0..3 mit Digit-Value
                  add r12,r0             ! add 0x30 dazu, wenn >9 dann add R12
                                         !-
MON_PUTCH:      mov r0,r4                ! SCHREIBE_CHARACTER_IN_SIO-TX:  [0000]
MON_PUTCH4:     bra MON_X0201            ! void mon_putch (unsigned char Data)
                mov.l @(16,r13),r0       ! bringe Data nach R4, jump Sio-Device

!----------------
! VIRTUAL-MEMORY
!----------------

MON_MEMRDL:     sts.l pr,@-r15           ! READ_VIRTUELLES_LONG:          [0000]
                bsr MON_MEMRDW           ! unsigned long mon_memrdl (u_long *)
                nop                      ! R4 = Pointer in virtuellen Memory
                lds.l @r15+,pr           ! bei Fehlern wird Fehlercode eingebaut
                                         !-
MON_MEMRDW:     sts.l pr,@-r15           ! READ_VIRTUELLES_SHORT:         [0000]
                bsr MON_MEMRDB           ! unsigned short mon_memrdw (u_short *)
                nop                      ! R0 = Wert fr Ergebnis-High-Word
                lds.l @r15+,pr           ! R4 = Pointer in virtuellen Memory
                                         !-
MON_MEMRDB:     sts.l pr,@-r15           ! READ_VIRTUELLES_BYTE:          [0000]
                mov.l r4,@-r15           ! unsigned char mon_memrdb (u_char *)
                mov.l r0,@-r15           ! R0 = Wert fr Ergebnis Bit#8..31
                bsr MON_X0201            ! R4 = Pointer in virtuellen Memory
                mov.l @(20,r13),r0       ! ---> R0 = Ergebnis in Bit#0..7
                mov.l @(12,r14),r1       !           Old-R0 in Bits#8..31
                mov.l @r15+,r2           !      R4 = Pointer auf nchstes Byte
                add #0x01,r1             ! Save Ret-Adresse, Pointer und Daten
                mov.l r1,@(12,r14)       ! lese Byte aus virtuellem Mem-Device
                extu.b r0,r0             ! increment Ges-Read-Count Mem-Device
                mov.l @r15+,r4           ! restauriere Daten und Pointer
                shll8 r2                 ! kombiniere alte Daten und Mem-Byte
                or r2,r0                 ! zum Ergebnis und Return-Value in R0
     MON_X0205: lds.l @r15+,pr           ! Fertig mit virtuellem Memory-Zugriff:
                rts                      ! restauriere Return-Adresse vom Stack
                add #0x01,r4             ! increment Memory-Pointer und zurck

!. . . . . . . .

MON_MEMWRL:     sts.l pr,@-r15           ! WRITE_VIRTUELLES_LONG:         [0000]
                bsr MON_MEMWRW           ! signed long mon_memwrl
                swap.w r5,r5             ! (unsigned long *, unsigned long)
                swap.w r5,r5             ! R4 = Pointer in virtuellen Memory
                lds.l @r15+,pr           ! R5 = Long-Word-Daten fr Memory
                                         !-
MON_MEMWRW:     sts.l pr,@-r15           ! WRITE_VIRTUELLES_SHORT:        [0000]
                bsr MON_MEMWRB           ! signed long mon_memwrw
                swap.b r5,r5             ! (unsigned short *, unsigned short)
                lds.l @r15+,pr           ! R4 = Pointer in virtuellen Memory
                swap.b r5,r5             ! R5 = Short-Word-Daten fr Memory
                                         !-
MON_MEMWRB:     sts.l pr,@-r15           ! WRITE_VIRTUELLES_BYTE:         [0000]
                mov.l r4,@-r15           ! signed long mon_memwrb
                mov.l r5,@-r15           ! (unsigned char *, unsigned char)
                bsr MON_X0201            ! R4 = Pointer in virtuellen Memory
                mov.l @(24,r13),r0       ! R5 = Byte-Daten fr Memory
                mov.l @r15+,r5           ! ---> R0 =0: Ok, Byte geschrieben
                mov.l @(16,r14),r1       !         >0: Ok, Byte programmiert
                tst r0,r0                !             R0 = Programmier-Zeit
                mov.l @r15+,r4           !         <0: Fehler, ErrorNr=-R0
                add #0x01,r1             !             R0=-1: Flash ist busy
                mov.l r1,@(16,r14)       !             R0=-2: Sektor-Protect
                bt MON_X0205             !             R0=-3: Must_erase_first
                cmp/pz r0                !             R0=-4: Flash-Prog-Error
                bf 3f                    !             R0=-5: Prog-Timeout
                  mov.l @(24,r14),r1     !             R0=-6: Verify-Error
                  add #0x01,r1           ! Save Ret-Adresse, Pointer und Daten
                  mov.l r1,@(24,r14)     ! schreibe Byte in virtuellen Memory
                  mov.l @(28,r14),r1     ! increment Ges-Write-Count Mem-Device
                  add r0,r1              ! teste ob Write-Return-Value Null war
                  mov.l r1,@(28,r14)     ! restauriere Daten und Pointer
                  mov.l @(32,r14),r1     ! wenn Null/Ok dann zurck mit Ptr++
                  tst r1,r1              ! wenn <0, Write-Fehler, dann jump
                  bt 1f                  ! Update Programmier-Timing-Statistik:
                  cmp/hs r0,r1           ! increment Anzahl programmierter Byte
                  bf 2f                  ! addiere Progammier-Zeit zur Summe
             1:     mov.l r0,@(32,r14)   ! update Minimum-Programmierzeit
             2:   mov.l @(36,r14),r1     ! wenn Null darin dann immer schreiben
                  cmp/hi r1,r0           ! update Maximum-Programmierzeit
                  bf MON_X0205           ! wenn Zeit nicht grsser dann fertig
                    bra MON_X0205        ! sonst aktuelle Zeit als Max schreiben
                    mov.l r0,@(36,r14)   ! fertig mit Statistik, ret mit Ptr++
             3: neg r0,r1                ! Update Programmier-Fehler-Liste:
                mov.l @(20,r14),r0       ! save Fehler-Nummer invers in R1
                mov #0x04,r2             ! lese die Anzahl der Prog-Fehler
                add #0x01,r0             ! increment Progamming-Error-Count
                cmp/hi r2,r0             ! teste ob Liste mit 4 Pltzen voll
                mov.l r0,@(20,r14)       ! schreibe neuen Error-Count in Mem
                bt 4f                    ! wenn Liste schon voll dann jumpen
                  add #0x27,r0           ! baue Pointer auf ErrNo-Array-Pos
                  mov.b r1,@(r0,r14)     ! schreibe ErrNo nach +0x28..0x2B
                  add #0x04,r0           ! baue Pointer auf DataByte-Array-Pos
                  mov.b r5,@(r0,r14)     ! schreibe DataByte nach +0x2C..0x2F
                  add #0xE0,r0           ! baue Pointer auf Mem-Adress-Array-Pos
                  shll2 r0               ! bestehend auf 4 Long-Word-Eintrgen
                  mov.l r4,@(r0,r14)     ! schreibe MemAdr nach +0x30..0x3F
             4: bra MON_X0205            ! Fertig mit Fehler-Behandlung:
                neg r1,r0                ! restauriere ErrNr, ret mit Ptr++

!*******************************************************************************

GDB_MAIN:


                .align 2,0xFF

!*******************************************************************************

!================
! STARTUP-HANDLE
!================

BOOT_CONHANDLE: .long 0x00000000               ! +00 (4) Command-Extention
                .long _sys_wdtclr +0x8C008000  ! +04 (4) Watchdog-Beruhigung
                .long _pcon_break +0x8C008000  ! +08 (4) Console Break-Test
                .long _pcon_getch +0x8C008000  ! +0C (4) Console Char-Input
                .long _pcon_putch +0x8C008000  ! +10 (4) Console Char-Output
                .long _sys_memrd  +0x8C008000  ! +14 (4) Memory-Emu Byte-Read
                .long _sys_memwr  +0x8C008000  ! +18 (4) Memory-Emu Byte-Write
                .long _padda_xchg +0x8C008000  ! +1C (4) Adda Audio-Data-I/O

!--------------
! AUDIO-DEVICE
!--------------

_padda_xchg:    mov.w DEV_K0004,r2       ! ADDA_AUDIO-DATEN-EXCHANGE:     [0000]
nop !           mov #0x61,r0             ! signed long adda_xchg
nop !           mov.b r0,@(4,r2)         !  signed short *MemoryPtr,
             1:   mov.w DEV_K0006,r0     !  unsigned long SampleAnzahl{0=2^32},
                  mov #A_WTCNT,r7        !  unsigned char OperatingMode)
                  mov.w r0,@r7           ! Im Operating-Mode erlauben die Bits
                  mov.l DEV_K0002,r7     ! Bit#0 - enable MemRd/Output DA-Values
                  mov.l @(24,r2),r1      ! Bit#1 - enable MemWr/Input  AD-Values
                  mov.b @r7,r0           ! Sind beide Bits auf 1 gesetzt, werden
                  mov.w DEV_K0005,r3     ! die Daten "auf der Stelle" getauscht
                  and #0xFE,r0           ! Enable Sio#0 Sync-Daten Rx und Tx
                  mov.b r0,@r7           ! Dann fr jedes auszugebende Sample:
             2:     mov.b @r7,r0         ! schreibe 0x5A00->Wtcnt fr Wdt-Clear
                    tst #0x01,r0         ! lese Tcnt0 Startwert nach R1
                    bf 3f                ! lese und lsche Irr0/Bit#0 Int0-Req
                    mov.l @(24,r2),r0    ! setze 1mSec-Timeout-Value in R3
                    sub r0,r1            ! Warte auf Adda Fs-Flanke:
                    sub r1,r3            ! lese Irr0, teste Int0-Request-Bit
                    cmp/pz r3            ! wenn Request/Flanke dann Ausgabe
                    bt/s 2b              ! sonst Tcnt0 mit aktueller Zeit lesen
                    mov r0,r1            ! teste ob Timeout schon abgelaufen
                  bra 8f                 ! wenn nein weiter auf Flanke warten
                  mov #0xFF,r1           ! Adda-Fs-Timeout: Error=-1, Sio=Off
             3:   and #0xFE,r0           ! Fs-Flanke ist nun gekommen:
                  mov.b r0,@r7           ! lsche Int0-Request in Irr0 wieder
                  mov #0x02,r3           ! initialisiere Byte-Count in R3
                  mov.l DEV_K0001,r7     ! initialisiere Bit-Swap-Table in R7
                  mov r6,r0              ! lade Option-Flags von R6 nach R0
             4:     tst #0x01,r0         ! Fr jedes auszugebende Sample-Byte:
                    bt/s 5f              ! teste ob wir DA-Daten aus Mem lesen
                    xor r1,r1            ! wenn nicht dann Null-Byte ausgeben
                      mov.b @r4,r0       ! sonst Daten-Byte aus Memory lesen
                      extu.b r0,r0       ! daraus unsigned Table-Index bauen
                      mov.b @(r0,r7),r1  ! swap Bits im Byte durch Table-Read
             5:       mov.b @(8,r2),r0   ! Warte bis Sio#0 Tx-Ready:
                      tst #0x80,r0       ! teste Tdre-Bit in Scssr
                      bt 5b              ! warte solange bis Tx bereit
                    mov r1,r0            ! lese DA-Byte aus R1 nach R0
                    mov.b r0,@(6,r2)     ! schreibe DA-Byte in Sctdr
                    mov #0x78,r0         ! schreibe Byte 0x78-->Scssr
                    mov.b r0,@(8,r2)     ! zum Lschen von Tdre und Tend
             6:       mov.b @(8,r2),r0   ! Warte bis Sio#0 Rx-Ready:
                      tst #0x40,r0       ! teste Rdrf-Bit in Scssr
                      bt 6b              ! warte solange bis Rx voll
                    mov.b @(10,r2),r0    ! lese Daten-Byte aus Scrdr
                    extu.b r0,r0         ! daraus unsigned Table-Index bauen
                    mov.b @(r0,r7),r1    ! swap Bits im Byte durch Table-Read
                    mov #0x84,r0         ! schreibe Byte 0x84-->Scssr
                    mov.b r0,@(8,r2)     ! zum Lschen Rdrf und Error-Flags
                    mov r6,r0            ! lade Option-Flags von R6 nach R0
                    tst #0x02,r0         ! teste ob AD-Daten in Mem schreiben
                    bt 7f                ! wenn nein dann AD-Byte ignorieren
                      mov.b r1,@r4       ! sonst AD-Byte in Memory schreiben
             7:     dt r3                ! decrement Byte/Sample-Count in R3
                    bf/s 4b              ! increment Byte-Pointer in R4
                    add #0x01,r4         ! repeat nchstes Adda-Byte
                  dt r5                  ! decrement Sample-Count in R5
                  bf 1b                  ! repeat nchstes Adda-Sample
                xor r1,r1                ! lade R1/RetVal=0 fr ok
8: nop !     8: mov #0x01,r0             ! Fertig mit Adda-Exchange:
   nop !        mov.b r0,@(4,r2)         ! schreibe 0x01-->Scscr
                rts                      ! fr Re=Te=0,Rx/Tx=Off
                mov r1,r0                ! return mit 00/Error

!----------------
! CONSOLE-DEVICE
!----------------

_pcon_putch:    mov.w DEV_K0006,r1       ! SENDE_SIO#1-CHARACTER:         [0000]
                mov.l DEV_K0003,r3       ! void pcon_putch (unsigned char Data)
                mov #A_WTCNT,r2          ! setup R1=WdtCnt,R2=*Wdt,R3=*Scsmr1
             1:     mov.w r1,@r2         ! Warte solange bis Sio-Tx bereit:
                    add #0xEE,r3         ! schreibe 0x5A00->Wtcnt fr Wdt-Clear
                    mov.b @r3,r0         ! lese PHDR mit PcSio-Cts in Bit#4
                    add #0x12,r3         ! restauriere R1 auf Scsmr1 zurck
                    tst #0x10,r0         ! teste ob PcSio-Cts nun aktiv ist
                    bf 1b                ! wenn nein weiter auf Cts warten
                  mov.w @(14,r3),r0      ! Teste ob Platz im Sio-Tx-Fifo:
                  shlr8 r0               ! lese Scfdr1 mit Fifo-Fllstand
                  tst #0xF0,r0           ! teste ob schon 16 Byte im Tx-Fifo
                  bf 1b                  ! wenn ja weiter auf Cts+Fifo warten
                mov.w @(8,r3),r0         ! lese Scssr1 fr lschbare Flags
                mov r4,r0                ! lese User-Daten-Byte nach R0
                mov.b r0,@(6,r3)         ! schreibe die Daten in Scftdr1
                mov.w DEV_K0009,r0       ! schreibe 0x0093-->Scssr1
                rts                      ! zum Lschen von Tdfe und Tend
                mov.w r0,@(8,r3)         ! fertig mit Character-Ausgabe


_pcon_break:    mov.w DEV_K0006,r1       ! TESTE_SIO#1-BREAK:             [0000]
                mov #A_WTCNT,r2          ! unsigned char pcon_break (void)
                mov.l DEV_K0003,r3       ! setup R1=WdtCnt,R2=*Wdt,R3=*Scsmr1
                xor r5,r5                ! setup R5=BreakFlags:0=Break,1=Halt
                sts pr,r6                ! save Caller-Return-Adresse in R6
             1:   mov.w @(8,r3),r0       ! Solange bis Sio#1 abgearbeitet:
                  mov.w r1,@r2           ! lese Scssr1 mit Sio#1-Status-Flags
                  tst #0x10,r0           ! teste ob Rx-Break-Error empfangen
                  bf 2f                  ! wenn ja ist Sio-Rx nicht leer
                    mov.w @(14,r3),r0    ! sonst lese Scfdr mit Fifo-Fllstand
                    tst #0xFF,r0         ! teste ob Rx-Daten im Fifo drin sind
                    bt 6f                ! wenn nein dann fertig mit Break-Check
             2:   bsr DEV_X01            ! lese empfangene Daten aus Sio#1-Rx
                  mov.w @(8,r3),r0       ! wir wissen ja das etwas vorhanden ist
                  cmp/eq #0x20,r0        ! teste ob Space-Byte empfangen wurde
                  bf 3f                  ! wenn nein weiter mit Break-Tests
                    mov #0x02,r0         ! sonst fr Space Halt-Flag toggeln
                    xor r0,r5            ! dazu Bit#1 im Ret-Value invertieren
             3:   tst r0,r0              ! teste ob Null-Byte empfangen wurde
                  bt 4f                  ! wenn ja dann dafr Escape setzen
                  cmp/eq #0x03,r0        ! teste ob Ctrl-C empfangen wurde
                  bf 5f                  ! wenn nein weiter mit Escape-Test
             4:     mov #0x1B,r0         ! sonst fr Null/Ctrl-C Escape setzen
             5:   cmp/eq #0x1B,r0        ! teste ob Escape-Byte fr Breaks
                  movt r0                ! wenn ja Break-Flag in Bit#0 setzen
                  bra 1b                 ! sammle Break-Flags im Ret-Value
                  or r0,r5               ! weiter mit Sio#1 Rx-Verwertung
             6: jmp @r6                  ! Fertig mit Sio#1 Rx-Verwertung:
                mov r5,r0                ! return Break/Halt-Flags in R0


_pcon_getch:    mov.w DEV_K0006,r1       ! EMPFANGE_SIO#1-CHARACTER:      [0000]
                mov.l DEV_K0003,r3       ! unsigned char pcon_getch (void)
                mov #A_WTCNT,r2          ! setup R1=WdtCnt,R2=*Wdt,R3=*Scsmr1
             1:     mov.w @(8,r3),r0     ! lese Scssr1 mit Sio#1-Status-Flags
                    mov.w r1,@r2         ! schreibe 0x5A00-->Wtcnt fr Wdt-Clear
       DEV_X01:     tst #0x10,r0         ! teste ob Sio#1-Rx Break-Error hatte
                    mov.w @(14,r3),r0    ! lese Scfdr1 mit Fifo-Fllstnden
                    bf 2f                ! bei Break-Error goto Break-Handler
                    tst #0xFF,r0         ! sonst testen ob Daten im Sio-Rx-Fifo
                    bt 1b                ! wenn nein weiter auf Rx-Daten warten
                  mov.w @(8,r3),r0       ! lese Scssr1 fr lschbare Flags
                  tst #0x0C,r0           ! teste ob Daten mit Empfangs-Fehler
                  mov.b @(10,r3),r0      ! lese Daten-Byte aus Scfrdr1 nach R0
                  mov r0,r4              ! save Daten-Byte falls Return-Value
                  mov.w DEV_K0007,r0     ! schreibe Word 0x00F0-->Scssr1
                  bf/s 1b                ! zum Lschen des Rdf- und Dr-Bits
                  mov.w r0,@(8,r3)       ! wenn Empfangs-Fehler nchstes Byte
                rts                      ! Return gutes Daten-Byte empfangen:
                extu.b r4,r0             ! zurck mit unsigned Data in R0
             2: extu.b r0,r1             ! Break-Signal im Sio-Rx empfangen:
                mov.w DEV_K0008,r0       ! save Rx-Fifo-Fllstand in R1
                tst r1,r1                ! schreibe Word 0x00E3-->Scssr1
                mov.w r0,@(8,r3)         ! zum Lschen des Break-Flags
             3:   bt 4f                  ! Dann gesamten Rx-Fifo lschen:
                  mov.w @(8,r3),r0       ! wenn alle Bytes gelesen done
                  dt r1                  ! sonst lese Scssr1 fr Flag-Clear
                  mov.b @(10,r3),r0      ! lese Daten-Byte aus Scfrdr1
                  mov.w DEV_K0007,r0     ! schreibe Word 0x00F0-->Scssr1
                  bra 3b                 ! zum Lschen des Rdf- und Dr-Bits
                  mov.w r0,@(8,r3)       ! repeat Fifo-Clear-Loop nochmal
             4: rts                      ! Return Break-Signal empfangen:
                mov #0x1B,r0             ! zurck mit unsigned Data 0x1B/Esc

!---------------
! MEMORY-DEVICE
!---------------

_sys_memwr:     mov.l DEV_K0010,r0       ! SCHREIBE_EMULIERTEN_SPEICHER:  [0000]
                mov.l DEV_K0011,r1       ! signed long sys_memwr
                and r4,r0                ! (unsigned char *, unsigned char Data)
                cmp/eq r1,r0             ! isoliere relevante Adress-Bits
                bt 1f                    ! teste ob Pointer in Flash-Area
                  mov.b r5,@r4           ! Schreibe normalen Memory:
                  mov.b @r4,r0           ! das Daten-Byte in Speicher schreiben
                  exts.b r5,r5           ! das Daten-Byte aus Speicher lesen
                  cmp/eq r5,r0           ! vergleiche ob richtiger Wert drin
                  bt/s _sys_wdtclr       ! wenn ja gutes Ende mit R0=0
                  xor r0,r0              ! vorher noch Watchdog beruhigen
                    bra _sys_wdtclr      ! wenn nein Fehler-Ende mit R0=-6
                    mov #0xFA,r0         ! fr Verify-Error, Watchdog-clear
             1: mov r5,r6                ! Schreibe in Flash-Memory:
                mov r4,r5                ! setup Register fr Prog-Funktion
                mova _sys_wdtclr,r0      ! in R4=*WdtClr,R5=*Flash,R6=Data
nop !           bra _flash_program_byte  ! weiter mit Byte-Prog-Funktion
                mov r0,r4                ! die macht auch den Verify


_sys_memrd:     mov.l DEV_K0010,r0       ! LESE_EMULIERTEN_SPEICHER:      [0000]
                mov.l DEV_K0011,r1       ! signed long sys_memrd
                and r4,r0                ! (unsigned char *MemByte)
                cmp/eq r1,r0             ! isoliere relevante Adress-Bits
                bf 1f                    ! teste ob Pointer in Flash-Area
                  mov.w DEV_K0007,r0     ! Lese aus Flash-Memory:
                  stc sr,r1              ! save Cpu-Statusregister in R1
                  or r1,r0               ! setze Intm=15 fr keine Ints
                  ldc r0,sr              ! lese zweimal Flash-Mem-Byte
                  mov.b @r4,r0           ! damit wir Toggle-Bit lassen
                  mov.b @r4,r0           ! falls Flash gerade busy ist
                  bra 2f                 ! restore SR mit Intm-Level
                  ldc r1,sr              ! clear Watchdog, ret unsigned Byte
             1: mov.b @r4,r0             ! Lese normalen (nicht Flash) Memory:
             2: extu.b r0,r0             ! lese Byte, Wdt-Clear, return u_Byte
                                         !-
_sys_wdtclr:    mov.w DEV_K0006,r1       ! BERUHIGE_CPU-WATCHDOG:         [0000]
                mov #A_WTCNT,r2          ! void sys_wdtclr (void)
                rts                      ! schreibe 0x5A00-->Wtcnt
                mov.w r1,@r2             ! fr 52mSec Watchdog-Ruhe

!...............

DEV_K0001:      .long  0x8C007700        ! Adresse Bit-Swap-Table         [0000]
DEV_K0002:      .long  A_IRR0            ! Adresse Irq0-Req-Flag
DEV_K0003:      .long  A_SCSMR1          ! Adresse Sio#1-Basis
DEV_K0004:      .short A_SCSMR           ! Adresse Sio#0-Basis
DEV_K0005:      .short 0x04E2            ! Adda-Timeout 1mSec
DEV_K0006:      .short 0x5A00            ! Wtcnt-Value Wdt-Clr
DEV_K0007:      .short 0x00F0            ! SR-Mask fr Intm=15
DEV_K0008:      .short 0x00E3            ! Scssr1 fr Break-Clr
DEV_K0009:      .short 0x0093            ! Scssr1 fr Tx-Daten
DEV_K0010:      .long  0xEC000000        ! Area#0/4 Bit-Maske
DEV_K0011:      .long  0xA0000000        ! Area#0/4 Adr-Value
                                                                         ![0000]

!*** EOF ***
