! "3startup.asm", Version 2.01 vom 18.7.1999, (C) Volker Ernst 1999
!  Simple asm source-file to setup everything and start the system.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.

!******************************************************************************!
!                  H  A  R  D  W  A  R  E   -   S  E  T  U  P                  !
!******************************************************************************!

.org 0x2B24,0xFF

!---------------
! RESET-HANDLER
!---------------

BOOT_RESET:     mov.l BOOT_K3002,r0      ! CPU-RESET-HANDLER:             [2B24]
                ldc r0,sr                !_auf RB=0, (MD=BL=1), Intm=15
                mov.w BOOT_K3009,r0      ! Baue_Startup-Grund_R13/R14:
                mov #A_EXPEVT,r1         ! move 0x0FE0 ---> Expevt ---> R14
                mov.l @r1,r14            ! baue Startcode {0x10..0x25} in R13
                mov #0x13,r13            ! 0x10 = Power-On-Reset, <unknown>
                mov.l r0,@r1             ! 0x11 = Power-On-Reset, Reset-Pin
                cmp/eq r0,r14            ! 0x12 = Power-On-Reset, Watchdog-Ovf
                bt BOOT_X3001            ! 0x13 = <Pwr-On-Res>, double-Exception
                  tst r14,r14            ! 0x14 = Power-On-Reset, Exception-Req
                  bt/s 1f                ! 0x15 = Power-On-Reset, Software-Req
                  mov #0x10,r13          ! 0x20 = Manual-Reset, <unknown_Source>
                    mov #0x20,r13        ! 0x21 = Manual-Reset, Reset-Pin
                    cmp/eq r13,r14       ! 0x22 = Manual-Reset, Watchdog-Ovf
                    bt 1f                ! 0x23 =[<Man-Res>, double-Exception]
                      bra BOOT_X3001     ! 0x24 = Manual-Reset, Exception-Req
                      mov #0x10,r13      ! 0x25 = Manual-Reset, Software-Request
                                         !-
             1: mov #A_WTCSR,r0          ! Verwerte_Watchdog-Overflow:
                mov.b @r0,r0             ! bei Expevt 0x00/0x20 Watchdog lesen
                add #0x01,r13            ! woher das Reset-Signal gekommen ist
                not r0,r0                ! lese Wtcsr mit Watchdog-Status-Reg
                tst #0xD0,r0             ! invertiere alle Bits fr die Tests
                bf BOOT_X3001            ! teste ob Watchdog enabled oder reset
                  tst #0x07,r0           ! wenn Watchdog=Off dann externer Reset
                  bt/s BOOT_X3001        ! teste ob Watchdog Software-Watchdog
                  add #0x01,r13          ! wenn ja dann gefunden, Watchdog-Ovf
                    stc r6_bank,r0       ! Watchdog wurde vorstzlich ausgelst
                    cmp/eq #0xFF,r0      ! teste ob als Exception-Reaktion oder
                    mov #0x02,r0         ! war es auf Software-Anforderung hin
                    bra BOOT_X3001       ! lese dazu Shutdown-Eventcode in B2/R6
                    addc r0,r13          ! wenn Eventcode<>SwReq dann Exception

!----------------
! WAKEUP-HANDLER
!----------------

BOOT_WAKEUP:    mov.l BOOT_K3002,r0      ! CPU-WAKEUP-HANDLER:            [2B62]
                ldc r0,sr                !_auf RB=0, (MD=BL=1), Intm=15
                mov.w BOOT_K3005,r0      ! Baue_Startup-Grund_R13/R14:
                mov.l BOOT_K3003,r1      ! lese Intevt2-Eventcode nach R14
                mov #0x31,r13            ! baue Startcode {0x30..0x39} in R13
                mov.l @r1,r14            ! 0x30        - Wakeup, <unknown>
                cmp/eq r0,r14            ! 0x31/0x01C0 - Wakeup, Nmi-Flanke
                mov.w BOOT_K3006,r0      ! 0x32/0x0420 - Wakeup, Timer#1-Ovf
                bt BOOT_X3002            ! 0x33/0x0480 - Wakeup, Rtc-Alarm
                  mov #0x32,r13          ! 0x34/0x0720 - Wakeup, PInt/<unknown>
                  cmp/eq r0,r14          ! 0x35/0x0720 - Wakeup, PInt/Keyboard
                  mov.w BOOT_K3007,r0    ! 0x36/0x0720 - Wakeup, PInt/Card-In
                  bt BOOT_X3002          ! 0x37/0x0720 - Wakeup, PInt/Tem-Res
                    mov #0x33,r13        ! 0x38/0x0720 - Wakeup, PInt/Tem-Line
                    cmp/eq r0,r14        ! 0x39/0x0720 - Wakeup, PInt/Tem-Ring
                    mov.w BOOT_K3008,r0  ! Teste einzeln welcher Int-Eventcode
                    bt BOOT_X3002        ! vergleiche fr Nmi,Timer,Rtc,PInts
                      mov #0x30,r13      ! wenn nichts von allem dann unknown
                      cmp/eq r0,r14      ! fr Nmi,Timer,Rtc ist Startcode ok
                      bf BOOT_X3002      ! bei PInts aktiven Int-Pin rausfinden
                                         !-
                mov.w @(0x14,r1),r0      ! Verwerte_PInt-Portstate:
                mov.l BOOT_K3004,r2      ! bei Intevt2 0x0720/PInt Port#F lesen
                swap.b r0,r3             ! und Startcode den PInt-Pins anpassen
                mov.b @r2,r0             ! lese PInter mit Enable-Mask nach R0
                mov #0x35,r13            ! lade default-Startcode 0x35 nach R13
                xor #0xCF,r0             ! swap Port#F-Mask-Byte im PInter-Word
                and r3,r0                ! lese Port#F-Pegel, aktive Bits auf 1
                tst #0x0F,r0             ! aktiv-Bits and Port#F-Mask zu Request
                bf BOOT_X3002            ! wenn Keyboard-Request Startcode=0x35
                  tst #0x80,r0           ! teste ob aktives Signal Card-Detect
                  bf/s BOOT_X3002        ! fr eingeschobene Chip-Card im Reader
                  mov #0x36,r13          ! wenn Card-Detect dann Startcode=0x36
                    tst #0x40,r0         ! teste ob aktives Signal Temic-Reset
                    bf/s BOOT_X3002      ! fr eigenstndigen Reset des Line-If
                    mov #0x37,r13        ! wenn Temic-Reset dann Startcode=0x37
                      tst #0x20,r0       ! teste ob aktives Signal Temic-Line
                      bf/s BOOT_X3002    ! fr aktivierte Phone-Line-Speisung
                      mov #0x38,r13      ! wenn Temic-Line dann Startcode=0x38
                        tst #0x10,r0     ! teste ob aktives Signal Temic-Ring
                        bf/s BOOT_X3002  ! fr Klingel-Signal auf der Phone-Line
                        mov #0x39,r13    ! wenn Temic-Ring dann Startcode=0x39
                          mov #0x34,r13  ! Signal schon weg, so PInt/<unknown>

!-----------
! CPU-SETUP
!-----------

BOOT_X3001:     mov.l BOOT_K3003,r1      ! SYSTEM-STARTUP/1.RUNDE:        [2BB6]
BOOT_X3002:     mov.w BOOT_K3009,r0      ! R13 = Startup-Code {0x10..0x39}
                mov #A_TRA,r2            !_R14 = Startup-Event (Expevt/Intevt2)
                mov.w BOOT_K3010,r3      ! Setup_Event-Register:
                mov.l r0,@(4,r2)         ! werden durch Hardware nicht resettet
                mov.l r3,@(8,r2)         ! write 0x0FE0 --> Expevt  (dbl-Excpt)
                mov.w BOOT_K3011,r0      ! write 0x0FFF --> Intevt  (No-Int)
                mov.l r0,@r2             ! write 0x01FC --> Tra     (Trap#0x7F)
                                         !-
                add #0x60,r1             ! Disable_Dma-Transfer:
                mov.w BOOT_K3012,r0      ! kann bei Manual-Reset noch laufen
                mov.w @r1,r2             ! lese Dmaor um auch Nmif zu lschen
                mov.w r0,@r1             ! write 0x0300 --> Dmaor (Dme=Nmif=Off)
                                         !-
                mov #A_FRQCR,r1          ! Setup_Taktfrequenz:
                mov.w BOOT_K3013,r0      ! die Clocks IClk und PClk einstellen
                mov.w r0,@(6,r1)         ! dabei ist IClk=2*BClk und PClk=20_MHz
                mov.w BOOT_K3014,r0      ! per Hardware ist BClk=4*XTal gesetzt
                mov.w r0,@(4,r1)         ! die Pll#1 wechselt von *1 auf typ *2
                mov.w BOOT_K3015,r2      ! write 0xA542 --> Wtcsr, Clk=PClk/16
                mova BOOT_K3017,r0       ! write 0x5A82 --> Wtcnt, Time=100uSec
                mov.w r2,@r1             ! write K_FRQCR -> Frqcr, set IClk/PClk
                                         !--------------------------------------
                mov r0,r8                ! Setup_Cpu-Baseregs:
                mov.l @r8+,r15           ! R15/Stack-Top   = 0x8C008000/SysStack
                ldc r15,vbr              ! VBR/Vector-Base = 0x8C008000/SysCode
                ldc.l @r8+,gbr           ! GBR/Global-Base = 0x8C000000/SysData
                                         !-
                mov.w @r8+,r0            ! Setup_Cpu-Watchdog:
                mov.w r0,@(6,r1)         ! jetzt Nutzung als Software-Watchdog
                mov.w @r8+,r0            ! macht Power-On-Reset nach 52mSec
                mov.w r0,@(4,r1)         ! write 0xA547 --> Wtcsr, Clk=PClk/4096
                mov.w @r8+,r0            ! write 0x5A00 --> Wtcnt, Count=Clr
                mov.w r0,@(6,r1)         ! write 0xA5C7 --> Wtcsr, PwrOn-Res,Run
                                         !-
                mov #0x0C,r1             ! Setup_Port-Pinout:
                mov.w BOOT_K3016,r0      ! konfiguriere stabiles Pio-Cpu-Pinout
                bsrf r0                  ! damit bald stabiler Hardware-Zustand
                mov r8,r0                ! init alle 12 8-Bit-Ports am Cpu-Chip
                                         !-
BOOT_X3003:     mov r0,r8                ! Setup_Bus-Parameter:
                mov.w @r8+,r1            ! zuerst Refresh-Timer abschalten
                mov #0x07,r2             ! damit zunchst kein CBR-Refresh
                mov.w @r8+,r0            ! write 0xA500 --> Rtcsr, Clock=Off
                bsr BOOT_BLOCKOUT        ! lade Bcr1,Bcr2,Wcr1,Wcr2,Mcr,Dcr,Pcr
                mov.w r0,@(14,r1)        ! jetzt SDram wieder auf CBR-Refresh
                xor r0,r0                ! aber kein Refresh weil Timer aus ist
                mov.w r0,@(16,r1)        ! write 0x0000 --> Bcr3 StdDRam=unused
                                         !-
                mov #A_STBCR,r1          ! Disable_Module-Standby:
                mov.b r0,@r1             ! write 0x00 --> Stbcr  alle_Module=On
                mov.b r0,@(6,r1)         ! write 0x00 --> Stbcr2 alle_Module=On
                                         !--------------------------------------
                mov.w @r8+,r1            ! Setup_Timer-Module:
                mov #0x03,r2             ! init R1=*TimerRegs, R2=TimerLoopCount
                mov.b r0,@(8,r1)         ! write 0x00 --> Tocr, TClk=Clock-Input
                mov.b r0,@(10,r1)        ! write 0x00 --> Tstr, alle Timer=Stop
             1:   mov.w @r8+,r4          ! dann fr jeden der 3 Timer-Channels:
                  mov.w @r8+,r0          ! lese Short mit Tcor-Value aus Table
                  mov.l r4,@(12,r1)      ! lese Short mit Tcnt-Value aus Table
                  add #0x0C,r1           ! write 0xNNNNNNNN --> TcorX Periode-1
                  mov.l r0,@(4,r1)       ! write 0xMMMMMMMM --> TcntX StartCount
                  dt r2                  ! lese Short mit Tcsr-Value aus Table
                  mov.w @r8+,r0          ! write 0xPPPP --> TcsrX fr Mode-Set
                  bf/s 1b                ! update Register-Ptr und Loop-Count
                  mov.w r0,@(8,r1)       ! repeat bis alle Timer eingestellt
                mov #0x01,r0             ! Starte Timer#0/Free_running_Counter:
                add #0xE6,r1             ! liefert die Zeitbasis fr Init-Ablauf
                mov #0x80,r2             ! write 0x01 --> Tstr, starte Tmr#0
                mov.b r0,@r1             ! jetzt luft Startup-Zeitmessung
                                         !-
                add #0xEE,r1             ! Setup_Sio-Module:
                mov.b r0,@(4,r1)         ! init R1=*Scsmr,R3=*Scsmr1,R4=0x00
                add #0x14,r3             ! zuerst Sio#0 auf synchron einstellen
                mov.b r2,@r1             ! write 0x01 --> Scscr Rx=Tx=Off,ClkOut
                mov #0x02,r2             ! write 0x80 --> Scsmr SyncMode,PClk/1
                mov.b r0,@(2,r1)         ! write 0x01 --> Scbrr 2.5_MBit/Sec
                xor r0,r0                ! write 0x00 --> Scscmr SmartCard=Off
                mov.b r0,@(12,r1)        ! damit ist Sio#0 im Zustand Reset=On
                xor r4,r4                ! dann fr jede der beiden Async-Sios:
             1:   dt r2                  ! decrement den Loop-Count in R2
                  mov r2,r0              ! lade R0=0x01(Sio#1), R0=0x00(Sio#2)
                  mov.b r0,@(4,r3)       ! das ist Control-Reg-Value fr Sios
                  mov #0x06,r0           ! write 0xNN --> ScscrX Rx=Tx=Off,Clk=N
                  mov.b r0,@(12,r3)      ! write 0x06 --> ScfcrX Rx-/Tx-Fifo=Res
                  mov #0x0A,r0           ! write 0x00 --> ScsmrX Async,8N1-Chars
                  mov.b r4,@r3           ! write 0x0A --> ScbrrX 57600(56818) Bd
                  mov.b r0,@(2,r3)       ! damit ist Sio#1/2 im Zustand Reset=On
                  bf/s 1b                ! jetzt brauchen Sios 17.6uSec Ruhezeit
                  add #0x10,r3           ! update Registerptr,repeat nchste Sio
                                         !-
                mov.l BOOT_K3003,r2      ! Setup_Dma-Module:
                mov #0x04,r4             ! init R2=*Dmaor,R4=0x04
                mov.w BOOT_K3012,r0      ! zuerst Dmaor einstellen
                add #0x60,r2             ! dummy-read Dmaor fr Nmif-Clear
                mov.w @r2,r3             ! write 0x0300 --> Dmaor Nmif=Dme=Off
                mov.w r0,@r2             ! setze R2 auf Baseadr 1.Dma-Channel
                add #0xC0,r2             ! dann fr jeden der 4 Dma-Channels:
             1:   mov.l @r8+,r0          ! lese Long mit Source-Adr aus Table
                  mov.l @r8+,r3          ! lese Long mit Destination-Adr aus Tbl
                  mov.l r0,@r2           ! write 0xNNNNNNNN --> SarX Source-Adr
                  mov.l r3,@(4,r2)       ! write 0xMMMMMMMM --> DarX Destination
                  mov.l @r8+,r0          ! lese Long mit Transfer-Count aus Tbl
                  mov.l @r8+,r3          ! lese Long mit Channel-Control aus Tbl
                  mov.l r0,@(8,r2)       ! write 0xPPPPPPPP --> DmatcrX DmaCount
                  mov.l @(12,r2),r0      ! dummy-read ChcrX fr Te-Flag-Lschung
                  dt r4                  ! write 0xQQQQQQQQ --> ChcrX Dma-OpMode
                  mov.l r3,@(12,r2)      ! decrement Dma-Loop-Counter in R4
                  bf/s 1b                ! update Dma-Register-Pointer in R2
                  add #0x10,r2           !_repeat bis alle 4 Dma-Channel done
                xor r0,r0                ! Setup_Dma-Timer:
                mov.w r0,@(16,r2)        ! erzeugt getimete Transfer-Requests
                mov.w @(18,r2),r0        ! benutzen wir fr D/A-Output-Update
                mov.w @r8+,r3            ! write 0x0000 --> Cmstr, Timer=Halt
                xor r0,r0                ! dummy-read Cmcsr fr Cmf-Flag-Clear
                mov.w r0,@(18,r2)        ! write 0x0000 --> Cmcsr, Cmf=0,PClk/4
                mov #0x01,r0             ! write 0x0000 --> Cmcnt, Count=Reset
                mov.l r3,@(20,r2)        ! write 0x0270 --> Cmcor, 8_kHz-Rate
                mov.w BOOT_K3001,r3      ! write 0x0001 --> Cmstr, Timer=Run
                mov.w r0,@(16,r2)        ! nun erzeugt Cmt 8-kHz-Dma-Requests
                mov.w r3,@r2             ! write 0x0301 --> Dmaor, Dme=On
                                         !-
                add #0x30,r2             ! Setup_A/D-Module:
                mov #0x13,r3             ! init R2=*Adcsr,R3=0x13/AD-Mode
                mov.b r3,@r2             ! write 0x13 --> Adcsr Adst=0,Slow0-3
                mov #0x3F,r0             ! write 0x3F --> Adcr  ExtTrigger=Off
                mov.b r0,@(2,r2)         ! dummy-read Adcsr fr Adf-Flag-Clear
                mov.b @r2,r0             ! write 0x13 --> Adcsr Adf=Aie=Adst=0
                mov.b r3,@r2             ! damit ist A/D resettet und inaktiv
                                         !-
                mov #0x80,r0             ! Setup_D/A-Module:
                add #0x10,r2             ! init R0=Analog-Mitte,R2=*Dadr
                mov.b r0,@r2             ! write 0x80 --> Dadr0 D/A#0=Mitte
                mov.b r0,@(2,r2)         ! write 0x80 --> Dadr1 D/A#1=Mitte
                mov #0xFF,r0             ! write 0xFF --> Dacr  D/A-Outs=On
                mov.b r0,@(4,r2)         ! damit gibt D/A Mittelwerte aus
                                         !-
                add #0x5C,r1             ! Setup_Rtc-Module:
                mov.b r4,@r1             ! init R1=*Rcr1,(R4=0x00)
                mov #0x09,r0             ! write 0x00 --> Rcr1 Af=Cf=Aie=Cie=0
                mov.b r0,@(2,r1)         ! write 0x09 --> Rcr2 Rtcen=Start=1
                                         !-
             1:   mov.w @(4,r1),r0       ! Setup_Int-Control:
                  mov #0x05,r2           ! zuerst passende Nmi-Flanke einstellen
                  cmp/pz r0              ! damit bei folgender Flanke Nmi-IntReq
                  movt r0                ! Solange bis Nmi-Input-Signal stabil:
                  shll8 r0               ! lese in Icr0 aktuellen Nmi-Pin-Input
                  mov.w r0,@(4,r1)       ! setze passende Flanke fr Nmi-IntReq
             2:     mov.w @(4,r1),r0     ! Warte bis Nmi 40 IClks stabil war:
                    cmp/pz r0            ! denn Hardware erzeugt 20 BClks? nach
                    shlr8 r0             ! einem Wechsel der Nmi-Flanke no Ints
                    addc r4,r0           ! daher testen wir 4 Loops zu 11 IClks
                    shlr r0              ! lese in Icr0 Nmi-Level und Nmi-Flanke
                    bt 1b                ! wenn unpassende Flanke neu einstellen
                    dt r2                ! ansonsten Nmi-Delay-Count decrementen
                    bf 2b                ! weiter beobachten bis 20 BClks vorbei
                add #0x06,r1             ! Setze Interrupt-Masken und Priorities
                bsr BOOT_BLOCKOUT        ! setup Ipra und Iprb mit dem Int-Level
                mov #0x02,r2             ! von Tmr0,Tmr1,Tmr2,Rtc,Wdt,Ref,Sci0
                mov.l BOOT_K3003,r1      ! init R1=*Icr1,R2=Reg-Count/0x06
                mov #0x06,r2             ! setup Icr1,Icr2,PInter,Iprc,Iprd,Ipre
                bsr BOOT_BLOCKOUT        ! mit Mai=IrqLvl=BlMsk=0,Irq1=Low-Level
                add #0x10,r1             ! sowie Irq0-5,PInts,Dma,Sci1,Sci2,A/D
                                         !-
                xor r0,r0                ! Setup_Ubc-Module:
                mov #A_BARA,r1           ! fr zwei Ubc-Hardware-Versionen
                mov.w r0,@(8,r1)         ! alt fr Sh7709,neu fr Sh7709a/Sh7729
                mov.l r0,@r1             ! write 0x0000          --> Bbra
                .if NEWUBC               ! write 0x00000000      --> Bara
                mov.l r0,@(4,r1)         ! write 0x00/0x00000000 --> Bamra
                .else                    ! der alte Ubc hat Byte-Mask-Register
                mov.b r0,@(4,r1)         ! der neue Ubc hat Long-Mask-Register
                .endif                   ! mit Mask-Bit fr jedes Adress-Bit
                mov #A_BARB,r1           ! write 0x0000          --> Bbrb
                mov.w r0,@(8,r1)         ! write 0x00000000      --> Barb
                mov.l r0,@r1             ! write 0x00/0x00000000 --> Bamrb
                .if NEWUBC               ! der alte Ubc hat Byte-Mask-Register
                mov.l r0,@(4,r1)         ! der neue Ubc hat Long-Mask-Register
                .else                    ! mit Mask-Bit fr jedes Adress-Bit
                mov.b r0,@(4,r1)         ! damit sind in Channel#A/B jeweils
                .endif                   ! der Match disabled,Adresse=Mask=0
                mov #A_BDRB,r1           ! nun die Daten-Breaks zurcksetzen
                mov.l r0,@r1             ! write 0x00000000 --> Bdrb  Data=0
                mov.l r0,@(4,r1)         ! write 0x00000000 --> Bdmrb Mask=0
                .if NEWUBC               ! der Maskwert=0 bedeutet alle Bits
                mov.l r0,@(8,r1)         ! nun gemeinsames Break-Control-Reg
                .else                    ! write 0x0000/0x00000000 --> Brcr
                mov.w r0,@(8,r1)         ! der alte Ubc hat Word-Control-Reg
                .endif                   ! der neue Ubc hat Long-Control-Reg
                mov #A_MMUCR,r1          ! write 0x00 --> Basra Channel#A/Asid
                mov.b r0,@(4,r1)         ! write 0x00 --> Basrb Channel#B/Asid
                mov.b r0,@(8,r1)         ! nun ist User-Break-Control resettet
                                         !-
                mov.l r0,@(16,r1)        ! Setup_Mmu-Module:
                stc gbr,r2               ! write 0x00000000 --> Pteh  Asid=0x00
                mov.l r0,@(20,r1)        ! write 0x00000000 --> Ptel  Ppn=V=0
                mov #0x06,r0             ! write 0x8C000000 --> Ttb   SysData
                mov.l r2,@(24,r1)        ! write 0x00000006 --> Mmucr At=0,Tf=1
                bra BOOT_X3004           ! dabei schon Sv=0,Ix=1 als Mmu-Mode
                mov.l r0,@r1             ! weiter mit zweiter Startup-Runde

!...............

BOOT_K3001:     .short 0x0301            ! Dmaor fr Dma-Master-Enable    [2D0E]
BOOT_K3002:     .long  0x500000F0        ! SR mit RB=0,MD=BL=1,Intm=15
BOOT_K3003:     .long  A_INTEVT2         ! Adr Int-Event2-Register
BOOT_K3004:     .long  A_PFDR            ! Adr Port#F-Daten-Input
BOOT_K3005:     .short 0x01C0            ! Intevt2-Code fr 31/Nmi
BOOT_K3006:     .short 0x0420            ! Intevt2-Code fr 32/Tmr#1
BOOT_K3007:     .short 0x0480            ! Intevt2-Code fr 33/Rtc-Alarm
BOOT_K3008:     .short 0x0720            !_Intevt2-Code fr 34-39/PInt#8-15
BOOT_K3009:     .short 0x0FE0            ! default Expevt-Value double-Exception
BOOT_K3010:     .short 0x0FFF            ! default Intevt-Value No_Int_Event
BOOT_K3011:     .short 0x01FC            ! default TrapNr#0x7F  No_Trap_Code
BOOT_K3012:     .short 0x0300            ! Dmaor fr Dma-Disable bei Startup
BOOT_K3013:     .short 0xA542            ! Wtcsr fr Frequenz-Wechsel,PClk/16
BOOT_K3014:     .short 0x5A82            ! Wtcnt fr Frequenz-Wechsel,100uSec
BOOT_K3015:     .short K_FRQCR           ! Frqcr-Wert/Default fr Speed=Fast
BOOT_K3016:     .short BOOT_XSETPORTS-BOOT_X3003! Offset fr Setports-Routine
BOOT_K3017:     .long  0x8C008000        ! Vbr-Wert/Stacktop/Startup
                .long  0x8C000000        ! Gbr-Wert/System-Variablen
                .short 0xA547            ! Wtcsr fr Watchdog-Setup,Pwr-Reset
                .short 0x5A00            ! Wtcnt fr Watchdog-Setup,Count=Clr
                .short 0xA5C7            ! Wtcsr fr Watchdog-Betrieb,52mSec
                                         !-
                .byte  0x04,0x30         ! Port#C: Data=0x30   KbdOut=Row#0
                .short 0x55A9            ! Port#C: Ctrl=0x55A9 SioCtl=H,Line=L
                .byte  0x06,0xF8         ! Port#D: Data=0xF8   TemicCtl=IoRes=L
                .short 0x6655            ! Port#D: Ctrl=0x6655 Wup=Dack=H,Drq=Pu
                .byte  0x08,0x20         ! Port#E: Data=0x20   CardIf=L,LcdIf=L
                .short 0x5155            ! Port#E: Ctrl=0x5155 PcmciaCe2B=H
                .byte  0x10,0x07         ! Port#J: Data=0x07   SDramCtl=H,LcdD=L
.short 0x0544  !.short 0x0540            ! Port#J: Ctrl=0x0540 CpuStatus=LL/Run
                .byte  0x16,0xF6         ! Port#S: Data=0xF6   SioC/D=H,IrdaCk=L
                .short 0x1555            !_Port#S: Ctrl=0x1555 AddaCk=H,AddaDa=L
                .byte  0x0A,0xCF         ! Port#F: Data=0xCF   KbdIn=CardIn=Pup
                .short 0xBFAA            ! Port#F: Ctrl=0xBFAA TemicInput=CMosIn
                .byte  0x0E,0x7F         ! Port#H: Data=0x7F   Ints=Cin,Irq1=Pup
                .short 0xE808            ! Port#H: Ctrl=0xE808 CfgSw=Pup,Tck=Cin
                .byte  0x0C,0x7F         ! Port#G: Data=0x7F   Iocs16=Cin/Low
                .short 0x2AAA            !_Port#G: Ctrl=0x2AAA PortG#0-6=Pup/H
                .byte  0x00,0x00         ! Port#A: Data=0x00   Daten-Bus D16-D23
                .short 0x0000            ! Port#A: Ctrl=0x0000 alle als Bus-Pins
                .byte  0x02,0x00         ! Port#B: Data=0x00   Daten-Bus D24-D31
                .short 0x0000            ! Port#B: Ctrl=0x0000 alle Bus-Pins (L)
                .byte  0x12,0xFF         ! Port#K: Data=0xFF   Bus-Ctrl-Signals
                .short 0x0000            ! Port#K: Ctrl=0x0000 alle Bus-Pins (H)
                .byte  0x14,0x00         ! Port#L: Data=0x00   A/D und D/A-Pins
                .short 0x0000            ! Port#L: Ctrl=0x0000 fr Analog-IO (H)
                                         !-
                .short A_BCR1            ! Bus-Controller Basis-Adresse
                .short 0xA500            ! Rtcsr-Value fr kein Refresh
                .short 0x000F            ! Bcr1 Pulls=Burst=Off,HiZ,SDRam,Pcmcia
                .short 0x29F0            ! Bcr2 Buswidth A4=8,A5/6=16,A2/3=32
                .short K_WCR1            ! Wcr1 Idle-Cycles fr Driver-Disable
                .short K_WCR2            ! Wcr2 Wait-Cycles fr Memory-Zugriff
                .short K_MCR             ! Mcr Timing-Parameter fr SDram A2/3
                .short 0x0000            ! Dcr fr Standard-Dram inaktivieren
                .short K_PCR             ! Pcr fr Pcmcia/Netzwerk-Bus-Timing
                                         !-
                .short A_TOCR - 8        ! Timer-Module Basis-Adresse
                .short 0xFFFF            ! Tcor0 fr free-running-Counter
                .short 0x0000            ! Tcnt0 Cnt-Clear, 800nSec/Count
                .short 0x0001            ! Tcr0 Unf=Unie=CkEg=0,PClk/16
                .short 0x04E1            ! Tcor1 fr 1-kHz-HiClock-Counter
                .short 0x04E1            ! Tcnt1 Cnt-Reset,volle 1.Periode
                .short 0x0021            ! Tcr1 Unf=CkEg=0,Unie=1,PClk/16
                .short 0xFFFF            ! Tcor2 fr Temic-Oszillator-Test
                .short 0x0000            ! Tcnt2 Cnt-Clear, 1099nSec/Count
                .short 0x0015            ! Tcr2 Unf=Unie=IcpX=0,CkEg=10,TClk
                                         !-
                .long  0x14000000        ! Sar0:    NetRx, Dma-Rx-Port
                .long  0x0C100000        ! Dar0:    NetRx, Sdram-Buffer 64K
                .long  0x00008000        ! Dmatcr0: NetRx, 32K-Words fr 64K
                .long  0x00044448        ! Chcr0:   NetRx, S/D+,Word,AutoRq
                .long  0x0C110000        ! Sar1:    NetTx, Sdram-Buffer 4K
                .long  0x1A000000        ! Dar1:    NetTx, Tx-Hw-Memory
                .long  0x00000400        ! Dmatcr1: NetTx, 1K-Longs fr 4K
                .long  0x00065450        ! Chcr1:   NetTx, S+/D+,Long,AutoRq
                .long  0x0C000000        ! Sar2:    Sound, Sdram-Buffer 1M
                .long  0x040000A0        ! Dar2:    Sound, D/A#0-Output
                .long  0x00100000        ! Dmatcr2: Sound, 1M-Bytes fr 1M
                .long  0x00001F00        ! Chcr2:   Sound, S+/D,Byte,Cmt
                .long  0x00000000        ! Sar3:    Softw, Boot-Rom-Code
                .long  0x0C008000        ! Dar3:    Softw, Sdram-Boot-Kopie
                .long  0x00001000        ! Dmatcr3: Softw, 4K-Longs fr 16K
                .long  0x00005410        ! Chcr3:   Softw, S+/D+,Long,AutoRq
                .short 0x0270            ! Cmcnt/Cmcor: Cnt=0,Cor=0x0270=8kHz
                                         !-
                .short 0x0C44            ! IprA: Tmr0=0,Tmr1=12,Tmr2=4,Rtc=4
                .short 0x0200            ! IprB: Wdt=0,Ref=2,Sio0=0,<res>=0
                .short 0x0AA8            ! Icr1: Mai=IrqLvl=BlMsk=0,Irq0=Flanke
                .short 0x30C0            ! Icr2: Aktiv-Level fr PInt-Requests
                .short 0xF000            ! PInter: Bit-Maske fr PInt-Requests
                .short 0x0A0E            ! IprC: Irq3=0,Irq2=10,Irq1=0/8,Irq0=14
                .short 0x060A            ! IprD: PIntC=0,PIntF=6,Irq5=0,Irq4=10
                .short 0xEAA0            ! IprE: Dma=14,Sio1=Sio2=10,A/D=0
                                         !=
                .short 0x0139            ! Tmr#0-Count fr 250uSec in 800nSecs
                .short K_SDMR2           ! Adresse/Init-Value SDram/Area#2/Mode
                .short K_SDMR3           ! Adresse/Init-Value SDram/Area#3/Mode
                .short A_RTCNT           ! Adresse Refresh-Count-Register
                .short 0xA500            ! Rtcnt: PrescaleCount=0x00
                .short K_RFSH_H          ! Rtcor: Refresh-Rate=5uSec (HighRate)
                .short 0xA7F0            ! Rfcr:  RefreshCount=0x03F0 (=Ovf-16)
                .short 0xA508            ! Rtcsr: Ckio/4,(Lmts=1024,Flags=Clr)
                .short 0xA500            ! Rtcnt: PrescaleCount=0x00
                .short K_RFSH_M          ! Rtcor: Refresh-Rate=10uSec (Medium)
                .short 0xA400            ! Rfcr:  RefreshCount=0x0000
                                         !-
                .short BOOT_XSETPORTS-BOOT_X3005! Offset fr Setports-Routine
                .byte  0x06,0xF8         ! Port#D: Data=0xF8   TemicCtl=IoRes=L
                .short 0x2255            ! Port#D: Ctrl=0x2255 Wup=Dack=H,Drq=Pu
                .byte  0x16,0xF6         ! Port#S: Data=0xF6   SioDat=IrdaCk=On
                .short 0x1400            !_Port#S: Ctrl=0x1400 AddaCk=AddaDa=On
                .byte  0x0E,0x7F         ! Port#H: Data=0x7F   Ints=Cin,Irq1=Pup
                .short 0x2808            ! Port#H: Ctrl=0x2808 CfgSw=Pup,Tck=Clk

!...............

BOOT_X3004:     bsr BOOT_WAITUNTIL       ! SYSTEM-STARTUP/2.RUNDE:        [2E0E]
                mov.w @r8+,r0            ! Warte_auf_T=250uSec:   <50/150/180uS>
                                         !-
                mov #0x21,r0             ! Splung_Sio#0/TxD:          <T=250uS>
                mov.b r0,@r6             ! auf Sync-Sio Null-Byte ausgeben
                mov.b @(4,r6),r0         ! damit Tx-Dout danach auf Msb=Low
                mov #0x84,r0             ! write 0x21 --> Scscr Tx=On,(Clk=Out)
                mov.b r0,@(4,r6)         ! dummy-read Scssr fr Error-Flag-Clear
                xor r0,r0                ! write 0x84 --> Scssr lsche Err-Flags
                mov.b r0,@(2,r6)         ! write 0x00 --> Sctdr Null-Byte,TxD0=L
                mov.b @(4,r6),r0         ! dummy-read Scssr fr Sio#0-Flag-Clear
                xor r0,r0                ! write 0x00 --> Scssr lsche Tdre,Rdrf
                mov.b r0,@(4,r6)         ! damit senden wir synchrones Null-Byte
                                         !-
                mov.w @r8+,r3            ! Setup_Sdram-Banks:          <T=255uS>
                mov.w @r8+,r4            ! jetzt hatte SDram die 200uS Ruhezeit
                mov.b r0,@r3             ! Zuerst Command "Precharge all Banks"
                mov.b r0,@r4             ! an SDram-Chips in Area#2/3 ausgeben
                mov.w @r8+,r1            ! Jetzt die 16 ersten Refresh-Cycles
                bsr BOOT_BLOCKOUT        ! erforderlich sind typ 2-8 Cbr-Rfsh
                mov #0x03,r2             ! dazu Refresh-Timer auf HighClk/5uSec
                mov.w @r8+,r5            ! schreibe Rtcnt=0,Rtcor=N,Rfcr=0x03F0
                add #0xF8,r1             ! write 0xA508 --> Rtcsr Ckio/4,L=1024
                mov.w r5,@r1             ! jetzt kommt Cbr-Refresh alle 5uSec
             1:   mov.w @r1,r0           ! Warte 80uSec auf 16 Refresh-Cycles
                  tst #0x04,r0           ! lese Rtcsr mit Refresh-Count-Overflow
                  bt 1b                  ! warte bis 16 Refreshs und Ovf gesetzt
                mov.w @r8,r0             ! Nun Cbr-Refreshs wieder abschalten
                mov.w r0,@r1             ! write 0xA500 --> Rtcsr Clock=Off
                add #0x02,r1             ! damit kein Trouble mit Mode-Set-Cmd
                mov #0x03,r2             ! dann Command "Mode-Set" des SDrams
                mov.b r0,@r3             ! an SDram-Chips in Area#2/3 ausgeben
                bsr BOOT_BLOCKOUT        ! Jetzt Cbr-Refresh wieder einschalten
                mov.b r0,@r4             ! schreibe Rtcnt=0,Rtcor=M,Rtcr=0x0000
                add #0xF8,r1             ! write 0xA508 --> Rtcsr Ckio/4,L=1024
                mov.w r5,@r1             ! jetzt kommt Cbr-Refresh alle 10uSec
                                         !-
                mov #0x01,r0             ! Enable_Module-Pins:         <T=367uS>
                mov.w @r8+,r2            ! die Module Tmr,Sio,Dma kriegen Pins
                mov #0x03,r1             ! write 0x01 --> Scscr Tx=Rx=Off,ClkOut
                mov.b r0,@r6             ! enable Port#D Dma-Handshake-Outputs
                bsrf r2                  ! enable Port#S Sio Data+Clock-Output
                mov r8,r0                ! enable Port#H Tmr Temic-Clock-Input

!-----------------
! SDRAM-BOOTIMAGE
!-----------------

BOOT_X3005:     mov.l BOOT_K3027,r0      ! SYSTEM-STARTUP/3.RUNDE: <393uS>[2E5E]
                mov.l BOOT_K3122,r3      ! Teste_SDram/Area#3L:
                bsr BOOT_RAMCHECK        ! init R0=*SDramBase,R3=SDramMaxLen
                mov #0xF0,r2             ! teste wieviel Ram dort verfgbar ist
                mov r1,r12               ! save SDram/Area#3L-Size in R12
                shlr16 r1                ! init R2=0xF0(Port#D-Aktiv),R4=0x5A00
                tst r1,r1                ! baue Ramsize in 64K-Pages durch >>16
                mov.w BOOT_K3021,r4      ! teste ob minimal 64KByte an SDram da
                bt BOOT_XMEMPANIC        ! wenn nein Ram-Err, Blinken und Reset
                                         !-
                bsr BOOT_CACHESYNC       ! Setup_Cache-System:   <643/723/771uS>
                mov #0x0D,r5             ! alten Cache-Inhalt ins Ram schreiben
                mov.l r5,@r1             ! write 0x0D --> Ccr Cache=On, flushen
                                         !-
                mov.l BOOT_K3026,r1      ! Dma-Bootcode-Copy:  <648/1755/2827uS>
                mov.w BOOT_K3023,r2      ! kopiere 16K Rom-Bootcode ins SDram
                mov.l r2,@(12,r1)        ! die Dma wurde bei IO-Init eingestellt
                add #0xFF,r2             ! daher mssen wir nur Transfer enablen
             1:   mov.l @(12,r1),r0      ! write 0x5411 --> Chcr3 Dma#3=Running
                  tst #0x02,r0           ! update Chcr3-Word/Disable auf 0x5410
                  mov.w @(16,r1),r0      ! lese Chcr3 mit Dma#3-Status nach R0
                  mov.w BOOT_K3022,r0    ! teste Ende-Bit/Te/Bit#1 im Status
                  bt/s 1b                ! lese Dmaor fr Nmi-Flag-Lschung
                  mov.w r0,@(16,r1)      ! write 0x0301 --> Dmaor Nmif=Clear
                mov #A_WTCNT,r0          ! write 0x5410 --> Chcr3 Te=De=Clear
                                         !-
                mov.l r2,@(12,r1)        ! Starte_High-Init: <T=3.4/10.0/12.7mS>
                mov.w r4,@r0             ! write 0x5A00 --> Wtcnt Watchdog=Clear
                mov.l BOOT_K3028,r4      ! R0=0x00,R1=*Sar3,R2=0x5410,R4=*HiInit
                jmp @r4                  ! R5=0x0D,R8=*Boot_X3004,R12=RamSize
                xor r0,r0                ! R13=StartGrund,R14=Event,R15=Stacktop

!-------------
! NORAM-PANIC
!-------------

BOOT_XMEMPANIC: mov.l BOOT_K3109,r3      ! KEIN_SDRAM_PANIK:  <410..643uS>[2E96]
                mov.b r2,@r3             ! R2 = 0xF0 (Port#D/Aktiv),R4=0x5A00
                mov.l BOOT_K3025,r2      ! set R1=*Scscr,R2=BlinkDelay,R3=*Pddr
                bsr BOOT_YPANDEL         ! set R5=*Wtcnt fr Watchdog-Clear
                mov #A_WTCNT,r5          ! write 0xF0 --> Pddr (/Wakeup=On)
                mov #0xF8,r0             ! warte bis 500mSec nach Boot, Led=On
                bsr BOOT_ZPANDEL         ! write 0xF8 --> Pddr (/Wakeup=Off)
                mov.b r0,@r3             ! warte bis 1000mSec nach Boot-Beginn
                mov.w BOOT_K3024,r0      ! so lange bleibt die Led wieder aus
                bsrf r0                  ! damit ergibt sich Blinken mit 1_Hz
                mov #0xFF,r4             ! call cpu_rescold(-1) fr Cpu-Reset


BOOT_XPANDEL:   mov.l BOOT_K3109,r3      ! WARTE_EIN_BISCHEN:             [2EAC]
                mov.w BOOT_K3021,r4      ! der Watchdog wird solange versorgt
BOOT_YPANDEL:   mov.w BOOT_K3031,r1      ! wahlweise auch incl Register-Setup
BOOT_ZPANDEL:     mov.l @(20,r1),r0      ! R1=*Scscr,R2=Zeit,R4=0x5A00,R5=*Wtcnt
                  mov.w r4,@r5           ! setup R1 mit Timer-Pointer erstes Mal
                  neg r0,r0              ! Solange bis Wunsch-Zeitpunkt erreicht
                  cmp/hi r2,r0           ! lese aktuellen Count des Timer#0
                  bf BOOT_ZPANDEL        ! negate fr Aufwrts-Count,vergleichen
                rts                      ! zwischendrin den Watchdog beruhigen
                shll r2                  ! repeat bis Zeit erreicht, dann return

!...............

BOOT_K3021:     .short 0x5A00            ! Wtcnt Clear-Value              [2EC0]
BOOT_K3022:     .short 0x0301            ! Dmaor-Value fr Nmif-Clear,(Dme=On)
BOOT_K3023:     .short 0x5411            ! Chcr3-Value fr Dma-Transfer=On
BOOT_K3024:     .short _cpu_rescold-BOOT_XPANDEL! Offset Power-On-Reset-Button
BOOT_K3025:     .long  0x00098968        ! 500mSec in 800nSec-Steps
BOOT_K3026:     .long  A_SAR3            ! Dma#3 Basisadresse
BOOT_K3027:     .long  0xAC000000        ! SDram/3L Startadresse
BOOT_K3028:     .long  BOOT_HIGHINIT+0x8C008000! High-Level-Code

!-------------
! SUBROUTINEN
!-------------

BOOT_RAMCHECK:  mov.l BOOT_K3034,r4      ! TESTE_RAM-MEMORY-SIZE:         [2ED8]
                mov #0x04,r1             ! R0 = Basis-Adresse der Area
                mov.l @r0,r7             ! R3 = Maximal-Grsse der Area
             1:   mov.l @(r0,r1),r6      ! ---> Area-Size wird ermittelt
             2:     mov.l r4,@r0         !      R1 = Area-Grsse in Byte
                    not r4,r4            !      R4-R7 werden getrashed
                    mov.l r4,@(r0,r1)    ! Setup Register fr Memory-Check
                    not r4,r4            ! in R1=4(Size),R4=0x55555555,R7=OrgDat
                    mov.l @r0,r5         ! Dann fr jeden Adress-Line-Test:
                    cmp/eq r4,r5         ! save alte Memory-Daten in R6
                    bf 3f                ! Fr jedes der beiden Test-Muster:
                    mov.l @(r0,r1),r5    ! schreibe  Pattern-->Area+0x00000000
                    not r5,r5            ! schreibe ~Pattern-->Area+(AdrLine)
                    cmp/eq r4,r5         ! verify  Pattern in Area+0x00000000
                    bf 3f                ! verify ~Pattern in Area+(AdrLine)
                    rotl r4              ! bei Fehlern Ende des Pattern-Tests
                    bf 2b                ! repeat mit nchstem der 2 Pattern
             3:   bf/s 4f                ! restauriere Memory-Daten aus R6
                  mov.l r6,@(r0,r1)      ! bei Fehlern Mem-Grsse gefunden
                  shll r1                ! ansonsten nchste Adress-Leitung
                  cmp/hs r3,r1           ! solange nicht Max-Grsse erreicht
                  bf 1b                  ! repeat Mem-Test nchste Adr-Line
             4: mov.l r7,@r0             ! fertig mit Grssen-Ermittlung
                mov #0xF8,r4             ! restauriere Memory-Daten aus R7
                rts                      ! isoliere signifikante Adr-Lines
                and r4,r1                ! zurck mit Memory-Size in R1


BOOT_BLOCKOUT:    mov.w @r8+,r0          ! BLOCK_WORDCOPY:                [2F0C]
                  dt r2                  ! R8++ = ShortWord Read-Pointer
                  mov.w r0,@r1           ! R1++ = ShortWord Write-Pointer
                  bf/s BOOT_BLOCKOUT     ! R2-- = Counter ShortWord-Anzahl
                  add #0x02,r1           ! Lese ShortWord aus Table++,Count--
BOOT_X3006:     rts                      ! schreibe ShortWord in Mem++,repeat
                nop                      ! zurck mit R0,R1,R2,R8 verndert


BOOT_WAITUNTIL: mov.w BOOT_K3031,r6      ! WARTE_AUF_ZEITPUNKT:           [2F1A]
                neg r0,r0                ! R0 = gesuchte Zeit nach Start
             1:   mov.l @(20,r6),r1      !      positiv in 800nSec-Schritten
                  cmp/hs r0,r1           ! ---> Zeitpunkt ist erreicht
                  bt 1b                  !      R0,R1,R6 werden getrashed,T=0
                bf BOOT_X3006            !      Watchdog wird nicht bedient


BOOT_CACHESYNC: mov #A_CCR,r1            ! SCHREIBE_CACHE_INS_RAM:        [2F26]
                mov.l @r1,r0             ! --> R0 = 0x00/Cache=Off,0x01/Cache=On
                shlr r0                  !     R1 = *Ccr
                bf 2f                    !     R2 und R3 werden getrashed
                  xor r0,r0              ! Gesamten Cache-Inhalt zurckschreiben
                  mov.l BOOT_K3033,r2    ! lese Cache-Control, teste ob Cache an
                  mov.w BOOT_K3032,r3    ! wenn Cache=Off dann done, return 0x00
             1:     mov.l r0,@r2         ! init R0=0L,R2=*CacheAdrArray,R3=Lines
                    dt r3                ! jetzt je nach Cpu viele Lines lschen
                    bf/s 1b              ! fr jede Cache-Line U- und V-Bits clr
                    add #0x10,r2         ! wir schreiben Writeback-Daten zurck
             2: rts                      ! gecachte Read-Daten werden ungltig
                movt r0                  ! fertig mit Cache-Sync,ret 0x00/0x01

!...............

BOOT_K3031:     .short A_SCSCR           ! Adresse Sio#0/Sync Control-Reg [2F40]
BOOT_K3032:     .short CACHELEN          ! Cache Line-Anzahl
BOOT_K3033:     .long  A_CACHEA          ! Adr Cache-Adress-Array
BOOT_K3034:     .long  0x55555555        ! SDram-Memcheck Testmuster

!##############################################################################!
!            I  N  I  T   -   C  O  D  E     I  M     S  D  R  A  M            !
!##############################################################################!

!-----------------
! ROM-TABLE-SETUP
!-----------------

BOOT_HIGHINIT:  mov.w BOOT_K3101,r1      ! HIGH-LEVEL_STARTUP-CODE:       [2F4C]
                mov.l BOOT_K3102,r0      ! Baue_CRC-Table:   <T=3.4/10.0/12.7mS>
             1:   add #0xFF,r1           ! fest von 0x8C007C00..0x8C007FFF
                  mov r1,r2              ! als 256 Long-Word-Eintrge fr Crc
                  xor r3,r3              ! damit knnen bei der Crc-Berechnung
                  mov #0x08,r4           ! immer 8-Bit-Stcke verarbeitet werden
             2:     shlr r3              ! Ergebnisse kommen via Stack in Table
                    shlr r2              ! setup R0=CrcMagic, R1=Longword-Count
                    bf/s 3f              ! Dann fr jedes der 256 Crc-Long-Words
                    xor r3,r2            ! dec Long-Count, als InputData nach R2
                      xor r0,r3          ! init OutputData in R3=0, R4=LoopCount
             3:     dt r4                ! Dann fr jedes Long-Word 8 Bit-Loops
                    bf/s 2b              ! aus InputData, OutputData und Magic
                    xor r3,r2            ! den neuen OutputData-Wert errechnen
                  tst r1,r1              ! repeat fr 8 Bit-Loops, save Longword
                  bf/s 1b                ! teste ob schon alle 256 Longs erzeugt
                  mov.l r3,@-r15         ! repeat bis die 1K/256-Long-Table done
                                         !-
                mova BOOT_K3103,r0       ! Baue_D/A-Table:   <T=3.7/10.3/13.0mS>
                mov r0,r1                ! fest von 0x8C007800..0x8C007BFF
                mov #0x08,r2             ! als 4*256 Byte-Eintrge fr 8-Bit-D/A
             1:   mov.w BOOT_K3101,r3    ! damit haben wir Sinus-Tabellen fr
                  neg r2,r0              ! die Basis-Tne 250,500,1000,2000_Hz
             2:     dt r3                ! fr variablen Sinus von 250-4000_Hz
                    and #0x1F,r0         ! bei variabler Sample-Rate 8-16_kHz
                    mov.b @(r0,r1),r4    ! Init R1=*SinusBasisTable (32 Bytes)
                    sub r2,r0            ! init R2=GapSize/Freq, dann pro Table:
                    mov.b r4,@-r15       ! init R0=SinusIndex,R3=TableEntryCount
                    bf 2b                ! dann fr jeden der 256 Table-Eintrge
                  shlr r2                ! dec Count,lese SinusVal,schreibe Data
                  bf 1b                  ! update SinusIndex, repeat Entry/Table
                                         !-
                mov.w BOOT_K3101,r1      ! Baue_Bitswap-Table: <3.8/10.4/13.1mS>
             1:   mov #0x08,r4           ! fest von 0x8C007700..0x8C0077FF
                  add #0xFF,r1           ! als 256 Byte-Eintrge fr Bit-Swap
                  mov r1,r2              ! zum spiegeln der Bits im Daten-Byte
             2:     shlr r2              ! also Bit#7->0,Bit#6->1,...,Bit#0->7
                    rotcl r3             ! zur Konvertierung MSB-first/LSB-first
                    dt r4                ! Dann fr jeden der 256 Byte-Eintrge
                    bf 2b                ! dec Byte-Count, als InputData nach R3
                  tst r1,r1              ! dann Bits inversrum in R3 einrotieren
                  bf/s 1b                ! mittels 8 Bit-Rotate-Loops, save Byte
                  mov.b r3,@-r15         ! repeat bis 256 Byte-Eintrge erzeugt

!----------------
! HARDWARE-SETUP
!----------------

                mov.w BOOT_K3104,r0      ! EXTERNE_HARDWARE_EINSTELLEN:   [2F9E]
                bsr BOOT_WAITUNTIL       ! Warte_auf_T=20mSec: <4.0/10.6/13.3mS>
                mov #0x31,r2             ! init T=0,R2=0x31/Scscr,R6=*Scscr
                                         !-
                mov.b r2,@r6             ! Init_mit_IoReset=On:         <T=20mS>
                bsr BOOT_FLASHCMDS       !_write 0x31 --> Scscr Sio#0/Rx+Tx=On
                mov #0x90,r0             ! Flash-Command 0x90/"Id-Mem" an Area#0
                mov.w BOOT_K3105,r0      !_Flash-Command 0x90/"Id-Mem" an Area#4
                bsrf r0                  ! Lcd-Command-Nibble "3" fr DisplayRes
                mov #0x03,r0             !_als 1.ResWr 20mSec (>15mSec) nach Pwr
BOOT_X3101:     mov.w BOOT_K3106,r0      ! Clear Adda-Shift-Register auf 0x0000:
                bsrf r0                  ! 16 externe Flipflops im 4006 resetten
                xor r4,r4                !_so Adda beim Start keinen Mll kriegt
BOOT_X3102:     mov.w BOOT_K3107,r0      ! Setup Temic-Register auf Defaults:
                bsrf r0                  ! vor Adda-Setup fr festen Zeitpunkt
                xor r4,r4                !_damit beginnt auch Temic-Oszillator
BOOT_X3103:     mova BOOT_K3108,r0       ! SDram auf Std/Slow-Refresh <T=20.5mS>
                mov r0,r8                ! wir hatten 20mSec um 30% hhere Rate
                mov.w @r8+,r1            ! haben somit 7mSec ohne Rfsh aufgeholt
                bsr BOOT_BLOCKOUT        ! das ist genug, jetzt normale Rfshrate
                mov #0x04,r2             ! write 0xA500 --> Rtcsr Clk=Off,FlgClr
                mov.w @r8+,r0            ! write 0xA500 --> Rtcnt PreCount=0x00
                mov.l @r8+,r2            ! write 0xA5NN --> Rtcor RefRate=<NN>
                add #0xF8,r1             ! write 0xA400 --> Rfcr  RefCount=0x000
                mov.w r0,@r1             !_write 0xA508 --> Rtcsr Clk=Ckio/4,Clr
                swap.w r2,r3             ! Lese Keyboard-Boot-Auswahl:
                mov.b @(4,r2),r0         ! lese Boot-Auswahl-Tasten "1","2","3"
                not r0,r0                ! oberste Reihe ist mit Outputs gewhlt
                and #0x0F,r0             ! lese Spalten-Input aus Port#F/Bit#0-3
                mov r0,r11               ! save gedrckte Tasten als in R11/#0-3
                mov.b @(8,r2),r0         ! darin steht High-Bit fr Tastendruck
                shlr r0                  ! lese Config-Switches Port#H/Bit#5-6
                and #0x30,r0             ! bringe mit H=Enabled nach R11/Bit#4-5
                or r0,r11                !_nun steht Boot-Auswahl in R11/Bit#0-5
                mov.w @r8+,r0            ! Watchdog-Beruhigung:
                shll16 r3                ! write 0x5A00 --> Wtcnt Count=0x00
                mov.w r0,@(22,r1)        ! nun ist Watchdog fr 52mSec ruhig
                                         !===
                mov.w @r8+,r0            ! Setze_IoReset=Off:         <T=20.5mS>
                add #0xE0,r2             ! write 0x2245 --> Pdcr IoRes=ResOut/H
                mov.w r0,@r2             ! damit startet die externe Hardware
                                         !===
                mov.b @(4,r3),r0         ! Adda-Setup:                <T=20.5mS>
                xor r0,r0                ! lsche Irq0-Irq5 Flanken-Flipflops
                mov.b r0,@(4,r3)         ! denn History vor Reset zhlt nicht
                mov #0x14,r6             ! erste Fs-Flanke kommt nach 70uSec
             1:   mov.w BOOT_K3112,r0    ! setup R6=WordCounter,R8=*InitData
                  bsrf r0                ! Dann fr jedes auszugebende Word:
                  add #0xFF,r6           ! decrement Word-Counter in R6
BOOT_X3104:       bf/s 2f                ! call ADDA_FSYNC zum Warten auf FSync
                  mov r0,r7              ! save Warte-Zeit in R7, jmp if Timeout
                  mov.w BOOT_K3113,r0    ! sonst nchstes Ausgabe-Word aus Table
                  bsrf r0                ! call ADDA_SYNCIO zur Adda-Wordausgabe
                  mov.w @r8+,r4          ! dort erfolgt bereits das Bit-Swappen
BOOT_X3105:       tst r6,r6              ! teste ob schon alle 20 Words gesendet
                  bf 1b                  ! wenn nein weiter warten und ausgeben
                bt 3f                    ! fertig mit gutem Ende, goto push_Time
             2: mov.w BOOT_K3122,r0      ! wir hatten Timeout Framesync-Warten
                or r0,r11                ! setze R11/Bit#9 fr "Adda-Fs-Timeout"
             3: mov.l r7,@-r15           ! push Framesync-Wartezeit fr Fs-Rate
                                         !-
                mova BOOT_K3114,r0       ! Warte_auf_T=25mSec:<20.7/21.8/24.5mS>
                mov r0,r8                ! dann hat Lcd ersten Res-Wr verkraftet
                bsr BOOT_WAITUNTIL       ! warte bis Tcnt#0 ber 0x7A12 geworden
                mov.w @r8+,r0            ! dann starten wir nchste Init-Runde
                                         !-
                mov.w @r8+,r9            ! Setup_LCD-Module:            <T=25mS>
                mov #0x03,r0             ! in R9=*LCD_NIBBLEOUT,R10=*BOOT_UDELAY
                mov.w @r8+,r10           ! die callen/brauchen wir jetzt dauernd
                add r8,r9                ! setup R0=CmdNibble/"3",R1=Delay/150uS
                mov.w @r8+,r1            ! dann einzelnes Nibble an Lcd senden
                bsr BOOT_LCDCMDN         ! wieder obere Hlfte Function-Set-Cmd
                add r8,r10               ! hier schalten wir zunchst 8-Bit-Mode
                bsr BOOT_LCDCMD          ! nachdem dann 150uSec Wartezeit vorbei
                mov #0x03,r0             ! einzelnes Cmd-Nibble "3" an Lcd geben
                bsr BOOT_LCDCMD          ! nachdem dann 60uSec Wartezeit vorbei
                mov #0x02,r0             ! einzelnes Cmd-Nibble "2" an Lcd geben
                add #LCD_BYTEOUT-LCD_NIBBLEOUT,r9! ab jetzt Bytes statt Nibbles
                bsr BOOT_LCDCMD          ! nach 60uS Lcd-Cmd 0x28/"Function-Set"
                mov #0x28,r0             ! fr DL=0/4Bit,N=1/2Line,F=0/5*7,<xx>
                bsr BOOT_LCDCMD          ! nach 60uS Lcd-Cmd 0x08/"DisplayOnOff"
                mov #0x08,r0             ! fr Display/D=0,Csr/C=0,Blink/B=0
                mov.w @r8+,r1            ! nach 60uS Lcd-Cmd 0x01/"ClearScreen"
                bsr BOOT_LCDCMDN         ! fr Display-Ram-Lschung,NoShift,Home
                mov #0x01,r0             ! nach 2500uS Lcd-Cmd 0x06/"EntryMode"
                bsr BOOT_LCDCMD          ! fr ID=1/Increment,S=0/NoDisplayShift
                mov #0x06,r0             ! nun sind Lcd-Control-Regs eingestellt
                mov #0x40,r1             ! Upload Lcd-Character-Generator:
                bsr BOOT_LCDLOAD         ! fr 8 User-definierbare 5*7-Character
                mov #0x40,r0             ! laden wir default-Pattern aus Rom-Tbl
                mov #0x10,r1             ! lade Lcd-Mem 0x40..0x7F mit Char-Gen
                bsr BOOT_LCDLOAD         ! nach jedem Byte 60uSec Busy-Delay
                mov #0x80,r0             ! Upload Startup/Signon-Screen:
                mov #0x10,r1             ! ges 32 Char in 16 Spalten bei 2 Lines
                bsr BOOT_LCDLOAD         ! lade Lcd-Mem 0x80..0x8F mit 1.Txtline
                mov #0xC0,r0             ! lade Lcd-Mem 0xC0..0xCF mit 2.Txtline
                bsr BOOT_LCDCMD          ! nach 60uS Lcd-Cmd 0x80/"DdAdr=0"/Home
                mov #0x80,r0             ! unsichtbarer Cursor steht links oben
                bsr BOOT_LCDCMD          ! nach 60uS Lcd-Cmd 0x0C/"DisplayOnOff"
                mov #0x0C,r0             ! fr Display/D=1,Csr/C=0,Blink/B=0
                mov #0x07,r0             ! die Lcd-Leitungen auf Inaktiv/Low
                mov.b r0,@(8,r4)         ! write 0x07 --> Pjdr fr D5-D7=Low
                                         !-
                mov.l BOOT_K3117,r0      ! Warte_auf_T=40mSec:        <T=33.8mS>
                bsr BOOT_WAITUNTIL       ! setup (R4=*Pedr),R5=*Wtcnt,R6=*Scscr
                mov #A_WTCNT,r5          ! dann starten wir nchste Init-Runde
                                         !-
                mov #0x05,r0             ! Starte_Temic-Oscmessung:     <T=40mS>
                mov.b r0,@(14,r6)        !_write 0x05 --> Tstr Tmr#2(=Tmr#0)=Run
                mov.w BOOT_K3110,r0      ! Watchdog-Beruhigung:
                mov.l BOOT_K3124,r1      ! write 0x5A00 --> Wtcnt Count=0x00
                mov #0x33,r2             !_nun ist Watchdog fr 52mSec ruhig
                mov.w r0,@r5             ! Starte_A/D-Wandlung:
                mov.b r2,@r1             ! interner A/D wandelt Ch#0..3 in 52uS
                mov.l BOOT_K3126,r2      !_write 0x33 --> Adcsr Start=On,Ch#0-3
                mov.l BOOT_K3125,r1      ! Lese_Flash-Chipids:
                mov.w @r2,r2             ! die Chip-Id (Manufacture/Device)
                mov.w @r1,r1             ! aus ersten Id-Memory-Bytes lesen
                mov.w r2,@-r15           ! lese Area#4-Id-Word aus 0xB0000000
                mov.w r1,@-r15           ! lese Area#0-Id-Word aus 0xA0000000
                bsr BOOT_FLASHCMDS       ! save beide Words im Stack fr Long
                mov #0xF0,r0             !_an beide Areas Flash-Cmd 0xF0/Reset
                mov #0x02,r1             ! Setup_Async-Sios:
                add #0x08,r4             ! die hatten jetzt 1 Bitzeit Init-Ruhe
             1:   add #0x10,r4           ! setup R1=SioCount,R4=*Scsmr1 fr Loop
                  mov #0x80,r0           ! Dann fr jede der beiden Async-Sios:
                  mov.b r0,@(12,r4)      ! write 0x80 --> ScfcrN Rx/Tx=8,Res=Off
                  dt r1                  ! dummy-read ScssrN fr Flag-Lschung
                  mov.w @(8,r4),r0       ! write 0x0060 --> ScssrN fr Flag-Clr
                  mov #0x60,r0           ! lscht Er,Brk sowie Rx-Data Rdf,Dr
                  mov.w r0,@(8,r4)       ! die Sio bleibt aus ScscrN/Re=Te=0
                  bf 1b                  ! update SioPtr und repeat next Sio
                                         !-
                shlr16 r4                ! Adda-Readback:               <T=40mS>
                shll16 r4                ! lsche Irq#0-Flanken-Flipflop
                mov.b @(4,r4),r0         ! denn wir warten auf neue Flanke
                mov #0x3E,r0             ! damit wir im richtigen Moment
                mov.b r0,@(4,r4)         ! die Daten seriell rausschieben
                swap.b r11,r0            ! read Hardware-Error-Flags in R11
                tst #0x02,r0             ! teste ob Adda-Timeout bei Upload
                bf 6f                    ! wenn ja kein Readback, done/Error
                  mov r15,r7             ! sonst 19 Frames mit Adda tauschen
                  mov #0x13,r6           ! init R6=FrameCount,R7=OldStackptr
             1:     mov.w BOOT_K3118,r0  ! fr jeden auszutauschenden Frame:
                    bsrf r0              ! decrement Frame-Count in R6
                    add #0xFF,r6         ! call ADDA_FSYNC zum Warten auf FSync
BOOT_X3106:         bf 3f                ! bei Timeout Readback-Ende mit Error
                    mov.w BOOT_K3119,r0  ! sonst nchsten Word aus Table lesen
                    bsrf r0              ! call ADDA_SYNCIO zum Adda-Wordtausch
                    mov.w @r8+,r4        ! wir bekommen Read-Daten in R5 zurck
BOOT_X3107:         tst r6,r6            ! teste ob noch weitere Readback-Frames
                    mov.w r5,@-r15       ! save zurckgelesenes Word auf'm Stack
                    bf 1b                !_repeat bis alle 19 Frames getauscht
                  mov.w BOOT_K3120,r1    ! Vergleiche_zurckgelesene_Daten:
                  mov #0x08,r3           ! init R0=0x0400,R3=RegCnt,R8=*OrgData
                  mov.w BOOT_K3121,r0    ! dann vergleichen wir Rcklese-Werte
                  add r1,r8              ! fr die Register 1-8 des TMS320AC01
             2:     mov.b @r8,r1         ! lese nchstes Orginal-Byte aus Rom
                    mov.w @r15,r2        ! lese nchstes Readback-Word aus Stack
                    extu.b r1,r1         ! erweitere Rom-Byte zu unsigned Word
                    cmp/eq r1,r2         ! vergleiche ob Adda-Readback 0x00NN
                    bf 4f                ! wenn nein Ende mit Readback-Error
                    dt r3                ! sonst Vergleichs-Count decrement
                    add #0xFC,r8         ! update Rom-Daten-Pointer mit -=4
                    bf/s 2b              ! update Stack-Daten-Pointer mit +=4
                    add #0x04,r15        ! repeat bis 8 Adda-Register compared
                  bt 5f                  ! gutes Ende, weiter mit Stack-Restore
             3:   mov.w BOOT_K3122,r0    ! Framesync-Timeout-Error: R11/Bit#9=1
             4:   or r0,r11              ! fr Readback-Errors ist R11/Bit#10=1
             5:   mov r7,r15             ! restauriere Stackptr auf Orginal-Wert
             6: mova BOOT_K3122,r0       ! Setup Rom-Table-Ptr fr nchste Tests
                mov.l @r0+,r3            ! nach Table Hardware-Setup-Fortsetzung
                bra BOOT_X3108           ! init R3=0x02000000/MaxSDramAreasize
                mov r0,r8                ! init R8=*SDram-Testparameter-Table

!...............

BOOT_K3101:     .short 0x0100            ! Count fr 256 Loops            [30EA]
BOOT_K3102:     .long  0xEDB88320        ! Crc-Konstante Table-Erzeugung
BOOT_K3103:     .byte  128,153,177,199   ! Sinus-Basiswert-Tabelle:
                .byte  218,234,245,253   ! 32 unsigned 8-Bit D/A-Werte
                .byte  255,253,245,234   ! mit Mittelwert=128
                .byte  218,199,177,153   ! und Amplitude=+/-127
                .byte  128,103, 79, 57   ! und Periode von 32
                .byte   38, 22, 11,  3   ! daraus werden die
                .byte    1,  3, 11, 22   ! Tabellen im Ram
                .byte   38, 57, 79,103   ! zusammengebaut
                                         !-
BOOT_K3104:     .short 0x61A8            ! 20mSec-Zeitpunkt in 800nSec-Steps
BOOT_K3105:     .short LCD_NIBBLEOUT-BOOT_X3101! Offset fr Lcd-Nibble-Output
BOOT_K3106:     .short ADDA_SYNCIO-BOOT_X3102! Offset fr Adda-Daten-Exchange
BOOT_K3107:     .short _temic_init-BOOT_X3103! Offset fr Temic-Register-Init
BOOT_K3108:     .short A_RTCSR           ! Adresse Refresh-Control-Register
                .short 0xA500            ! Rtcsr: Clk=Off,(Lmts=1024,Flags=Clr)
                .short 0xA500            ! Rtcnt: PrescaleCount=0x00
                .short K_RFSH_L          ! Rtcor: Refresh-Rate=15uSec (Low)
                .short 0xA400            ! Rfcr:  RefreshCount=0x0000
                .short 0xA508            ! Rtcsr: Ckio/4,(Lmts=1024,Flags=Clr)
BOOT_K3109:     .long  A_PDDR            ! Adresse Port#D,F,H Daten-Register
BOOT_K3110:     .short 0x5A00            ! Wtcnt: Clear-Value fr Wtcnt=0x00
                .short 0x2245            !_Pdcr: Io-Reset als Cpu-Resetout/H
                .short 0x0000            ! 0000 - Dummy/Nop
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x0123            ! 0123 - A-Reg=35->FClk=142.857kHz
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x0212            ! 0212 - B-Reg=18->FSamp=7936.51Hz
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x03FF            ! 03FF - A'-Reg=-1->FSamp-Adjust
                .short 0x0003            ! 0003 - DA=0,SecReq
 		.short 0x0419            ! 0419 - Mon=0dB,In=+6dB,Out=0dB
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x0501            ! 0501 - AnCfg: In+/In-,HighPass=On
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x0610            ! 0610 - DiCfg: Fsd=Off,normal
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x074F            ! 074F - FsdDelay=79 (1/4Frame)
                .short 0x0003            ! 0003 - DA=0,SecReq
BOOT_K3111:     .short 0x0801            ! 0801 - FsAnz=1 (keine Slaves)
                .short 0x0000            ! 0000 - DA=0,normal
                .short 0x0000            ! 0000 - DA=0,normal
                .short 0x0000            ! 0000 - DA=0,normal
BOOT_K3112:     .short ADDA_FSYNC-BOOT_X3104! Offset fr Adda-Framesync-Warten
BOOT_K3113:     .short ADDA_SYNCIO-BOOT_X3105! Offset fr Adda-Daten-Exchange
                                         !-
BOOT_K3114:     .short 0x7A12            ! 25mSec-Zeitpunkt in 800nSec-Steps
                .short LCD_NIBBLEOUT-BOOT_K3115! Offset fr Lcd-Nibble-Output
                .short BOOT_UDELAY-BOOT_K3116! Offset fr Lcd-Busy-Delay-Fktn
BOOT_K3115:     .short 0xFF43            ! uDelay von  150uSec bei Lcd-Setup
BOOT_K3116:     .short 0xF3CA            !_uDelay von 2500uSec bei Lcd-Clear
                .byte 0x00,0x0A,0x00,0x04! Character_0x00:
                .byte 0x15,0x11,0x0E,0x00!   Smiley
                .byte 0x0F,0x0F,0x0F,0x06! Character_0x01:
                .byte 0x06,0x00,0x06,0x06!   Warnungs-"!"
                .byte 0x02,0x04,0x08,0x1E! Character_#x02:
                .byte 0x02,0x14,0x18,0x1C!   Blitz
                .byte 0x04,0x04,0x04,0x15! Character_0x03:
                .byte 0x0E,0x04,0x0A,0x11!   Antenne
                .byte 0x07,0x08,0x13,0x14! Character_0x04:
                .byte 0x14,0x13,0x08,0x07!   Copyright/links
                .byte 0x00,0x10,0x08,0x08! Character_0x05:
                .byte 0x08,0x08,0x10,0x00!   Copyright/rechts
                .byte 0x17,0x15,0x15,0x17! Character_0x06:
                .byte 0x11,0x15,0x17,0x00!   KombiChar "19"
                .byte 0x07,0x08,0x10,0x1F! Character_0x07:
                .byte 0x10,0x08,0x07,0x00!___Euro-Symbol
                .byte 0x20,0x43,0x72,0x79! Lcd-Signon-Text:
                .byte 0x70,0x74,0x2D,0x4F! " Crypt-O-Phone s"
                .byte 0x2D,0x50,0x68,0x6F! "Rom-Version X.YY"
                .byte 0x6E,0x65,0x20,0x00! hier explizit
                .byte 0x52,0x6F,0x6D,0x2D! als Hex-Byte im
                .byte 0x56,0x65,0x72,0x73! Lcd-Zeichensatz
                .byte 0x69,0x6F,0x6E,0x20! falls mal anders
                .byte 0x30+VER_MAJ       ! als Host-Charset
                .byte 0x2E               ! oder Special-Chars
                .byte 0x30+(VER_MIN>>4)  ! baue Versions-Nummer
                .byte 0x30+(VER_MIN&0x0F)! als Ascii-Nr in Text
                                         !-
                .short 0x0000            ! 0000 - Dummy/Nop
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2100            ! 2100 - read_Reg#1
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2200            ! 2200 - read_Reg#2
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2300            ! 2300 - read_Reg#3
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2400            ! 2400 - read_Reg#4
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2500            ! 2500 - read_Reg#5
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2600            ! 2600 - read_Reg#6
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2700            ! 2700 - read_Reg#7
                .short 0x0003            ! 0003 - DA=0,SecReq
                .short 0x2800            ! 2800 - read_Reg#8
                .short 0x0000            ! 0000 - DA=0/Dummy
                .short 0x0000            ! 0000 - DA=0/Dummy
BOOT_K3117:     .long  0x0000C350        ! 40mSec-Zeitpunkt in 800nSec-Steps
BOOT_K3118:     .short ADDA_FSYNC-BOOT_X3106! Offset Adda-Framesync-Funktion
BOOT_K3119:     .short ADDA_SYNCIO-BOOT_X3107! Offset Adda-Wordexchange-Routine
BOOT_K3120:     .short BOOT_K3111+1-BOOT_K3117! Offset der Ausgabe-Werte in Tbl
BOOT_K3121:     .short 0x0400            !_Adda-Readback-Error fr R11/Bit#10
BOOT_K3122:     .long  0x02000000        ! Adda-Timeout-Error und SDram-Areasize
                .long  0xA8000000        ! SDram-Area#2L/Bank#3 NoCache/StartAdr
                .long  0xAA000000        ! SDram-Area#2H/Bank#4 NoCache/StartAdr
                .long  0xAE000000        ! SDram-Area#3H/Bank#2 NoCache/StartAdr
                .short -(BOOT_K3123-X0)  ! Offset Bootcode-Start von Table-Adr
                .short _sys_crcblock-BOOT_X3109! Offset der Crc-Block-Berechnung
BOOT_K3123:     .short 0x4000            ! Byte-Anzahl fr Bootcode-Crc-Check
                .short 0x1000            ! Long-Anzahl fr High-Bios-Lschung
BOOT_K3124:     .long  A_ADCSR           ! Adresse A/D-Control/Status-Reg
                                         !-
                .long  0x000124F8        ! 60mSec-Zeitpunkt in 800nSec-Steps
                .short 0x3E80            ! Temic Max-Clock 500kHz/20mSec
                .short 0x4E20            ! Temic Min-Clock 400kHz/20mSec
                .short 0x0800            ! Error-Flag R11/Bit#11 Temic-Osc
                .short 0x30D3            ! Tcor#2 fr 10mSec Low-Clock-Rate
BOOT_K3125:     .long  0xA0000000        ! Basis-Adresse Flash/Area#0
BOOT_K3126:     .long  0xB0000000        ! Basis-Adresse Flash/Area#4

!...............

BOOT_X3108:     add #0xE8,r15            ! SDram-Memchk:<40.2/41.4/43.8mS>[3224]
                bsr BOOT_RAMCHECK        ! teste die brigen drei Ram-Banks
                mov.l @r8+,r0            ! teste Area#2L/Bank#3 an 0x08000000
                mov.l r1,@(8,r15)        ! merke Bank#3-Memsize in 0x8C0076E8
                mov.l r12,@r15           ! merke Bank#1-Memsize in 0x8C0076E0
                bsr BOOT_RAMCHECK        ! teste Area#2H/Bank#4 in 0x0A000000
                mov.l @r8+,r0            ! merke Bank#4-Memsize in 0x8C0076EC
                mov.l r1,@(12,r15)       ! die Variablen liegen wie Bank-Nummer
                bsr BOOT_RAMCHECK        ! teste Area#3H/Bank#2 in 0x0E000000
                mov.l @r8+,r0            ! merke Bank#2-Memsize in 0x8C0076E4
                mov.l r1,@(4,r15)        ! daraus wird spter Boot-Info-Block
                                         !-
                mov.w @r8+,r5            ! Bootcode-Check:      <41/42.2/44.9mS>
                mov.w @r8+,r0            ! teste Crc-Prfsumme ber 16K Bootcode
                mov #0xFF,r4             ! setup Register fr Call _sys_crcblock
                add r8,r5                ! in R4=0xFF/StartCrc,R5=*Code,R6=Lnge
                bsrf r0                  ! baue CodePtr aus Table-Ptr und Offset
                mov.w @r8+,r6            ! call _sys_crcblock fr Crc-Prfsumme
BOOT_X3109:     tst r0,r0                ! teste ob gutes Rom mit Prfsumme=Null
                mov.w @r8+,r1            ! wenn ja soweit ok und kein Fehler
                bt 1f                    ! fr schlechten Bootcode Error-Flag
                  mov.w BOOT_K3132,r0    !_setze in R11/Bit#8 fr Rom-Prfsumme
                  or r0,r11              ! Clear_High-Bios:     <42.8/44/46.7mS>
             1: bsr BOOT_MEMSET          ! fill 0x8C00C000..0x8C00FFFF mit 0xFF
                mov #0xFF,r2             ! als default solange kein HighBios da
                mov.l @r8+,r4            ! setup R4=*Adcsr fr A/D-Wandler-Ctrl
                                         !-
                bsr BOOT_WAITUNTIL       ! Warte_auf_T=60mSec:  <43.1/44.3/47mS>
                mov.l @r8+,r0            ! dann ist Clockmessung und Flash ready
                                         !-
                mov #0x01,r0             ! Beende_Temic-Oscmessung:     <T=60mS>
                mov.b r0,@(14,r6)        ! write 0x01 --> Tstr fr Tmr#2=Stop
                mov.l @(44,r6),r0        !_lese Tcnt2 mit Anz Temic-Clk-Flanken
                mov.w BOOT_K3131,r1      ! Watchdog-Beruhigung:
                mov #A_WTCNT,r2          ! write 0x5A00 --> Wtcnt Count=0x00
                mov.w r1,@r2             !_damit ist der Watchdog 52mSec ruhig
                neg r0,r0                ! Beende_A/D-Wandlung:
                mov.b @r4,r1             ! lese Adcsr fr Adf-Flag-Lschung
                mov #0x13,r2             ! write 0x13 --> Adcsr A/D=Stop,Adf=Clr
                mov.w @r8+,r1            ! damit ist der A/D wieder im Ruhestate
                mov.b r2,@r4             !_mit Analog-Werten in Daten-Registern
                mov.w @r8+,r2            ! Verwerte_Clock-Messungen:
                cmp/hs r1,r0             ! setup R1=0x3E80,R2=0x4E20,R3=0x0800
                mov.w @r8+,r3            ! negiere Tmr2-Count fr positiven Wert
                bf/s 1f                  ! teste ob Temic-Clock im Bereich liegt
                mov.w @r8+,r4            ! ist Count min 0x3E80, Freq min 400kHz
                cmp/hs r0,r2             ! wenn nein setze Error-Flag R11/Bit#11
                bt 2f                    ! ist Count max 0x4E20, Freq max 500kHz
             1:   or r3,r11              ! wenn nein setze Error-Flag R11/Bit#11
             2: mov.l @(28,r15),r1       ! lese Long Adda-Framerate vom Stack
                extu.w r0,r0             ! bringe Adda-Clockmessung in High-Word
                shll16 r1                ! unsere Temic-Taktmessung ins Low-Word
                or r0,r1                 ! ergibt im Mem zuerst Adda, dann Temic
                mov.l r1,@(28,r15)       !_save neues Longword mit Taktmessungen
                add #0x28,r6             ! Re-Config_Timer#2:
                mov.l r4,@r6             ! ab jetzt wird der 10mSec/LowClock-Tmr
                mov #0x21,r0             ! write 0x000030D3 --> Tcor2 10mS-Rate
                mov.l r4,@(4,r6)         ! write 0x000030D3 --> Tcnt2 1.Periode
                mov.w r0,@(8,r6)         ! write 0x0021 ------> Tcr2  Clk,Int=On
                                         !-
                mov.l @r8+,r1            ! Eprom/Flash-Memcheck:        <T=60mS>
                bsr BOOT_ROMCHECK        ! teste physikalische Rom-Grsse und
                mov.w @(24,r15),r0       ! update die gelesenen Chip-Id-Codes
                mov.w r0,@(24,r15)       ! init R0=ChipCode/Area#0 nach IdSel
                mov.l r2,@(16,r15)       ! init R1=*Area#0/NoCache 0xA0000000
                mov.l @r8+,r1            ! teste Bootrom-Size, save Ergebnisse
                bsr BOOT_ROMCHECK        ! init R0=ChipCode/Area#4 nach IdSel
                mov.w @(26,r15),r0       ! init R1=*Area#4/NoCache 0xB0000000
                mov.w r0,@(26,r15)       ! teste AuxRom-Size, save Ergebnisse
                mov #0xFF,r0             ! update Rom-Size und Chip-Id im Ram

!--------------
! MEMORY-SETUP
!--------------

                mov.l r2,@(20,r15)       ! SDRAM-SETUP:  <60/60.1/60.3mS> [32A8]
                shll16 r0                ! Bestimme_Reload-Art:
                add r0,r12               ! entscheide Reload/Restart/Continue
                cmp/pl r12               ! von Ramsize/R12 64K Bios-Ram abziehen
                bf/s BOOT_X3110          ! teste ob noch Platz fr System bleibt
                xor r10,r10              ! wenn nein dann kein Restart/Continue
                  mov r13,r10            ! baue Startup-Art aus Startup-Code
                  shlr2 r10              ! aus 0x10..0x39 wird 0x00/0x01/0x02
                  shlr2 r10              ! teste ob Software-Wunsch, 0x25..0x39
                  mov #0x25,r0           ! wenn ja dann Startup-Art-Limit B2/R7
                  cmp/hs r0,r13          ! vor Shutdown von der Software gesetzt
                  bf/s 1f                ! erlaubt Reload trotz Manual-Res 0x2N
                  add #0xFF,r10          ! sowie Reload/Restart bei Wakeup 0x3N
                    stc r7_bank,r0       ! lese Startup-Art-Limit aus 2.Regbank
                    cmp/hs r0,r10        ! teste ob Restart-Art ber Limit liegt
                    bf 1f                ! wenn nein ist Restart-Art/R10 korrekt
                      mov r0,r10         ! sonst Limit als Restart-Art einsetzen
             1:   tst r10,r10            ! Teste soll Sysimage erhalten bleiben
                  bt BOOT_X3110          ! wenn nein Reload-Bestimmung fertig
                    mov r12,r5           ! ansonsten Gltigkeit des Image prfen
                    mov.l BOOT_K3141,r4  ! setup R4=*Image,R5=MaxLen,R6=*SysName
                    mova BOOT_SYSNAME,r0 ! teste ob "HLBSYSTEM", Typ "S" geladen
                    bsr BOOT_AREACHECK   ! die Lnge muss ins Rest-Ram passen
                    mov r0,r6            ! sowie Long-Aligned sein, Area-Crc gut
                    subc r0,r0           ! bei guter Area ist T-Flag nun gesetzt
                    and r0,r10           ! wenn gut/gltig dann Reload-Art so ok
                    swap.b r10,r0        ! sonst wenn ungltig dann Reload-Art=0
                    shlr2 r0             ! save Reload-Art in R10 to R11/Bit#6-7
                    mov #0x02,r1         ! teste ob wir Continue als Art haben
                    cmp/hs r1,r10        ! nur dann bleiben Variablen erhalten
                    bt/s BOOT_X3111      ! fr Continue weiter mit Minimal-Setup
                    or r0,r11            ! sonste alle Variablen initialisieren
                                         !-
BOOT_X3110:     mov #0x08,r1             ! Setup_System-Data: <T=60/60.1/3695mS>
                mova BOOT_SYVMDATA,r0    ! Komplett-Init/Kaltstart:
                mov r0,r4                ! hier setzen wir bei Reload/Restart
                stc gbr,r5               ! die ansonsten bei Continue erhalten
                mov.w BOOT_K3133,r0      !_gebliebenen System-Variablen zurck
                bsr BOOT_MEMCPY          ! Initialisiere 0x0080..0x00FF-Bereich
                add r0,r5                ! kopiere 32 Bytes initialisierte Daten
                mov #0x18,r1             ! von BOOT_SYVMDATA nach 0x0080..0x009F
                bsr BOOT_MEMSET          ! clear 96 Bytes genullte Sys-Variablen
                xor r2,r2                ! von 0x00A0..0x00FF als 24-Long-Nullen
                mov.w BOOT_K3134,r0      ! das waren die eigentlichen Variablen
                mov #0x04,r1             !_jetzt kommen die Daten der Sys-Task#0
                bsr BOOT_MEMCPY          ! Initialisiere 0x4000..0x75FF-Bereich
                add r0,r5                ! kopiere 16 Bytes initialisierte Daten
                mov.w BOOT_K3135,r1      ! aus der Rom-Table nach 0x4000..0x400F
                bsr BOOT_MEMSETX         ! clear 13808 Bytes Task- und Stack-Ram
                mov.l r2,@r5             ! von 0x4010..0x75FF als 3452 LongNulls
                mov r12,r0               !_darin noch Daten ungleich Null setzen
                mov.w BOOT_K3136,r6      ! Initialisiere 0x4080..0x40C0-Bereich
                mov #0x7C,r3             ! mit privaten Mmu-Eintrgen der Task#0
                bsr BOOT_MMUWRITEL       ! setup R2=*VirtAdr=0,R3=PageMode=0x7C
                add r6,r5                ! sowie R4=*RomTbl,R5=*RamTbl,R7=Loops
                mov r15,r7               ! dann zunchst fr erste SDram-Bank
                add #0x04,r7             ! schreibe Mmu-Entry fr Memory ab 64KB
                mov #0x03,r8             ! denn wir sind virtuell nicht sichtbar
             1:   bsr BOOT_MMUWRITEL     ! dann fr die nchsten drei Ram-Banks
                  mov.l @r7+,r0          ! lese MemLen nach R0, PhysAdr nach R1
                  dt r8                  ! call Mmu_Write fr Tlb-Entry-Write
                  bf 1b                  !_repeat bis alle 4 SDram-Banks done
                stc gbr,r5               ! Initialisiere 0x5FD8..0x5FFF-Bereich
                mov.l BOOT_K3147,r6      ! das ist initial Task#0/User-Stack
                ldc r8,r3_bank           ! baue dort Stack mit R8-R14,GBR,SR,PC
                mov.l r5,@-r6            ! mit Startwerten fr System im Memory
                mov.l BOOT_K3143,r0      ! als R8-R14=0x00000000,GBR=0x8C000000
                mov.l BOOT_K3142,r1      ! und Cpu-SR=0x40000020, PC=0x8C010040
                mov.l r0,@-r6            ! bei uns stimmt VBR/GBR-Wert schon so
                bra 2f                   ! ebenso ist Asid=0x00, TTB=0x8C000000
                mov.l r1,@-r6            !_weiter mit gemeinsamem Memory-Setup
BOOT_X3111:       mov #A_PTEH,r1         ! Minimal-Init/Warmstart:
                  stc r2_bank,r6         ! lese alten Stack-Pointer aus B2/R2
                  mov.l @r6+,r5          ! lese dort Adresse der Sys-Variablen
                  mov.l @r6+,r0          ! lese dort alten Pteh/Asid-Value
                  mov.l r5,@(8,r1)       ! write <SysVarAdr> --> TTB SyVar back
                  mov.l r0,@r1           ! write <OrginAsid> --> PTEH Asid back
                  ldc.l @r6+,vbr         ! schreibe <SysVarAdr> auch in GBR
                  ldc r5,gbr             ! zum initialisieren der Variablen
                  stc.l r4_bank,@-r6     ! echtes User-GBR liegt auf dem Stack
                  stc.l r5_bank,@-r6     !_put old CPU-SR und CPU-PC auf Stack
             2: mov #0x08,r1             ! Gemeinsames_Setup:
                bsr BOOT_MEMCPY          ! mit R5=GBR=*SystemData,R6=*UserStack
                mov r15,r4               ! wir geben unseren Startup-Stack auf
                mov #0x02,r1             ! und wechseln auf den Interrupt-Stack
                stc r3_bank,r2           !_fr Traps,Exceptions,Debugger ntig
                cmp/hs r1,r2             ! Initialisiere 0x0000..0x001F-Bereich
                bt/s 3f                  ! kopiere 32 Bytes Startup-Memory-Infos
                mov r6,r15               !_aus unserem Stack nach 0x0000..0x001F
                  mov.l @(0x8C,gbr),r0   ! Wechsel auf Interrupt-Stack
                  ldc r1,r3_bank         ! teste ob B2R3/Stack-Nummer min 2/Int
                  mov r0,r15             ! wenn ja ist kein Wechsel notwendig
             3: mov.l r6,@-r15           ! sonst Int-Stacktop aus SysData lesen
                mov.l r2,@-r15           ! und als neuen Stack-Pointer setzen
                add #0x20,r5             ! save alten Stack-Pointer auf Stack
                stc.l r7_bank,@-r5       !_save alte Stack-Nummer auf Stack
                stc.l r6_bank,@-r5       ! Initialisiere 0x0030..0x003F-Bereich
                stc.l r5_bank,@-r5       ! dort steht Cpu-Zustand bei Shutdown
                stc.l r4_bank,@-r5       ! blieb in R4-R7 whrend Reset/Standby
                mov.l r14,@-r5           ! write Shutdown/UserData --> 0x003C(4)
                mov #0x10,r1             ! write Shutdown/EventCode -> 0x0038(4)
                mov.w r13,@-r5           ! write Shutdown/Cpu-PC ----> 0x0034(4)
                xor r2,r2                !_write Shutdown/Cpu-SR ----> 0x0030(4)
                mov.w r11,@-r5           ! Initialisiere 0x0020..0x002F-Bereich
                mov.l r2,@-r5            ! dort stehen Startup/Hardware-Infos
                mov.l r2,@-r5            ! write Startup/EventCode --> 0x002C(4)
                bsr BOOT_MEMSET          ! write Startup/StartGrund -> 0x002A(2)
                add #0x20,r5             ! write Startup/HardwareFlgs> 0x0028(2)
                mov.w BOOT_K3133,r0      ! clear Startup/SysLoadAdr -> 0x0024(4)
                mov.w BOOT_K3137,r1      ! clear Startup/HiBiosAdr --> 0x0020(4)
                bsr BOOT_MEMSET          !_die 0x0020..0x0027 wird noch gesetzt
                add r0,r5                ! Clear 0x0040..0x007F-Bereich
                mov.w BOOT_K3138,r0      !_dort liegen Null-initialisierte Daten
                mov #0xFF,r1             ! Clear 0x0100..0x3FFF-Bereich
                mov.b r1,@(r0,r5)        ! dort liegen Null-initialisierte Daten
                mov.l BOOT_K3149,r5      ! write 0xFF ---> 0x0200 global Mmu-Tbl
nop !           bsr BOOT_MEMSET          !_damit ist diese Table gltig und leer
                mov #0x40,r1             ! Clear 0x8C007600..0x8C0076FF-Bereich
                tst r10,r10              ! unabhngig von SysData-Basisadresse
                bf 4f                    !_als Data-Workspace fr High-Bios-Code
                  cmp/pl r12             ! teste ob kein System aber >64K Memory
                  mov.l BOOT_K3141,r0    ! dann write Null-Long an Sys-Baseadr
                  bf 4f                  ! damit kein gltiges System im Memory
                    mov.l r1,@r0         !_bei nachfolgenden System-Startups
             4: mov.l BOOT_K3153,r0      ! Cache-Writeback
                mov.w BOOT_K3131,r1      ! write 0x5A00 --> Wtcnt Count=0x00
                mov #A_WTCNT,r2          ! nun ist Watchdog fr 52mSec ruhig
                jsr @r0                  ! call BOOT_CACHESYNC ungecached
                mov.w r1,@r2             ! damit kein rger nach Dma-Memload
                                         !-
                mov.l BOOT_K3144,r4      ! Setup_Sys-Code:  <T=60.6/60.7/3696mS>
                mova BOOT_HIGHNAME,r0    ! Lade optionales High-Bios
                mov.w BOOT_K3139,r5      ! setup R4=*LoadAdr,R5=MaxLen,R6=*Name
                bsr BOOT_LOADFILE        ! suche Image im Eprom/Flash und lade
                mov r0,r6                ! wenn wir nichts finden macht nichts
                bf 1f                    ! dieses 16K-Laden dauert so max 5mSec
                  mov.l r0,@(0x20,gbr)   !_if loaded save LoadAdr in 0x0020(4)
             1: tst r10,r10              ! Lade wenn ntig System-Image
                bf/s 2f                  ! teste ob gltiges Image schon im Ram
                mov #0xFF,r0             ! wenn ja LoadAdr=-1 und Laden erledigt
                  cmp/pl r12             ! ansonsten testen ob Ram zum Laden da
                  bf BOOT_X3112          ! wenn nein LoadAdr=0, SysLoad erledigt
                    mov.l BOOT_K3141,r4  ! setup R4=*LoadAdr,R5=MaxLen,R6=*Name
                    mov r12,r5           ! suche Image im Eprom/Flash und lade
                    mova BOOT_SYSNAME,r0 ! je nach Eprom/Flash-Typ etwa 3MB/Sec
                    bsr BOOT_LOADFILE    ! der Watchdog wird dabei versorgt
                    mov r0,r6            ! hier sollten wir ein Image finden
                    bf BOOT_X3112        ! sonst luft fast nur der Debugger
             2: mov.l r0,@(0x24,gbr)     ! if loaded save LoadAdr in 0x0024(4)

!----------------
! BOOTLOAD-HOOKS
!----------------

BOOT_X3112:     mov.l BOOT_K3148,r2      ! Mindestens_T=100mSec:          [33CE]
                bsr BOOT_XPANDEL         ! setup R2=100mS,R5=*Wtcnt frs Warten
                mov #A_WTCNT,r5          ! warte auf Zeitpunkt,bediene Watchdog
                                         !-
                mov #0x71,r0             ! BootHooks_Hardware-Setup:
                add #0x1E,r3             ! jetzt die Pc-Sio und Mmu freigeben
                mov.b r0,@r3             ! write 0x71 ---> Scscr1 Rx=Tx=RxInt=On
                mov #0x07,r0             ! das Modem bleibt noch Reset-Zeit aus
                mov.l BOOT_K3146,r1      ! da die Memory-Tables eingestellt sind
                mov #A_MMUCR,r2          ! knnen wir die Mmu jetzt freigeben
                mov.l r0,@r2             ! write 0x00000007 --> Mmucr Tf=Ix=At=1
                ldc r1,sr                ! setze BL=0, Exceptions/Nmi freigeben
                                         !=
                bsr BOOT_SIGNON          ! Signon_Text-Output:
                xor r0,r0                ! call Boot_Signon(0) fr erste Message
                mov r11,r0               ! mit Signon-Msg und Hardware-Testinfos
                tst #0x20,r0             ! teste ob Cfg-Switch#2 Debug erlaubt
                bt BOOT_XMONRET          !_wenn nein weiter mit High-Bios-Init
                  and #0x07,r0           ! Verwerte Keyboard-Boot-Auswahl:
                  cmp/eq #0x03,r0        ! wir reagieren auf 3 Kombinationen
                  bt/s 1f                ! der Keyboard-Tasten "1","2","3"
                  xor r4,r4              ! wenn "1"+"2" dann 0 - Monitor-Prog
                    cmp/eq #0x06,r0      ! wenn "2"+"3" dann 1 - Gnu-Debugger
                    bt/s 1f              ! wenn "1"+"3" dann 2 - Srecord-Upload
                    mov #0x01,r4         ! alle anderen Tasten sind dabei egal
                      cmp/eq #0x05,r0    ! teste einzeln auf die Kombinationen
                      bf BOOT_XMONRET    ! baue Debugger-Wunschmode in R4{0..2}
                        mov #0x02,r4     ! wird vom Debugger nur hier beachtet
             1:         trapa #0x00      !_call optionalen Real-Time-Debugger
BOOT_XMONRET:   mov.l @(0x20,gbr),r0     ! High-Bios_Init-Call:
                tst r0,r0                ! teste ob High-Bios geladen wurde
                bt BOOT_X3113            ! wenn nein kein Init-Call machen
                  mov.l BOOT_K3145,r1    ! sonst High-Bios fr Init callen
                  jsr @r1                ! mit R0=0 und R1-R14=<undefined>
                  xor r0,r0              ! an der Start-Adresse 0x8C00C040

!--------------
! SYSTEM-START
!--------------

BOOT_X3113:     mov.l @(0x24,gbr),r0     ! STARTE_GELADENES_SYSTEM:       [3410]
                tst r0,r0                ! Teste ob System im Speicher
                bt BOOT_XSYSPANIC        ! wenn nicht Panik "No System"
                                         !-
                mova BOOT_K3150,r0       ! Build_global_Mmu-Table:
                mov.l BOOT_K3160,r2      ! abhngig von geladenem System
                mov r0,r4                ! Zuerst Code-Segment ab 0xC0000000
                mov.l BOOT_K3141,r0      ! als system/read-only Memory-Block
                mov #0x1A,r3             ! init R0=MemLen,R2=*VirtAdr,R3=Mode
                mov.l @(12,r0),r0        ! sowie R4=*RomTbl und R5=*MmuListe
                stc gbr,r5               ! die Lnge ist Syslen, maximal Memlen
                mov.w BOOT_K3140,r6      ! die physikalische Mem-Adresse in R1
                cmp/hs r0,r12            ! liesst Subroutine aus Rom-Table R4
                bt 1f                    ! die Table-Writeadr ist GBR+0x0200
                  mov r12,r0             ! dort ist default global-Mmu-Table
             1: bsr BOOT_MMUWRITEL       ! schreibe Eintrag fr System-Code
                add r6,r5                ! merke EndOfSysCode-Adresse in R9
                neg r0,r0                ! Danach Data-Segment ab 0xD0000000
                mov r2,r9                ! als system/read-write Memory-Block
                mov.l BOOT_K3161,r2      ! zuerst den Rest der 1.SDram-Bank
                add r12,r0               ! was nach Sys-Code noch brigbleibt
                bsr BOOT_MMUWRITE        ! init R0=MemLen,R2=*VirtAdr,R3=Mode
                mov #0x3E,r3             ! (R1=PhysAdr,R4=*RomTbl,R5=*MmuList)
                bra BOOT_X3114           ! schreibe Eintrag fr Sys-Data-Memory
                stc gbr,r7               ! weiter mit nchsten Mmu-SDram-Banks

!...............

BOOT_K3131:     .short 0x5A00            ! Wtcnt-Value fr Count=0x00     [3440]
BOOT_K3132:     .short 0x0100            ! Bootcode-Check-Error-Bit#8
BOOT_K3133:     .short 0x0080            ! Offset Sys-Data ab 0x0080
BOOT_K3134:     .short 0x3F00            ! Offset Sys-Data ab 0x4000 von 0x0100
BOOT_K3135:     .short 0x0D7C            ! Long-Anzahl Bereich 0x4010..0x75FF
BOOT_K3136:     .short 0xCA80            ! Offset Mmu-Table ab 0x4080 von 0x7600
BOOT_K3137:     .short 0x0FC0            ! Long-Anzahl Bereich 0x0100..0x3FFF
BOOT_K3138:     .short 0xC200            ! Offset Mmu-Table ab 0x0200 von 0x4000
BOOT_K3139:     .short 0x4000            ! Byte-Anzahl-Maximum High-Bios-Laden
BOOT_K3140:     .short 0x0200            !_Offset Mmu-Table ab 0x0200 von 0x0000
BOOT_K3141:     .long  0x8C010000        ! Memory-Startadresse System-Image
 BOOT_K3142:     .long  0x8C008000+BOOT_AUXSTART
!BOOT_K3142:     .long  0x8C010040        ! PC fr System-Start (Reload/Restart)
 BOOT_K3143:     .long  0x400000F0
!BOOT_K3143:     .long  0x40000020        !_SR fr System-Start (Reload/Restart)
BOOT_K3144:     .long  0x8C00C000        ! Memory-Startadresse HighBios-Image
BOOT_K3145:     .long  0x8C00C040        ! PC fr Highbios Startup-Init-Call
BOOT_K3146:     .long  0x400000F0        !_SR fr Bootload-Hooks (BL=0,Intm=15)
BOOT_K3147:     .long  0x8C005FE4        ! SP/R15 Stack-Aufbau (Reload/Restart)
BOOT_K3148:     .long  0x0001E848        ! 100mSec in 800nSec-Steps
                                         !-
BOOT_SYVMDATA:  .long  0x8C008000+BOOT_CONHANDLE![0080] Debug: Consolen-Handle
                .long  0x8C000400        ! [0084] Debugger: Ram-Arbeitsbereich
                .long  0x8C000200        ! [0088] Kernel: global Memory-Map
BOOT_K3149:     .long  0x8C007600        ! [008C] Kernel: Interrupt-Stacktop
                .long  0x00000000        ! [0090] Kernel: High-Traps-Handler
                .long  0x00000000        ! [0094] Kernel: User-Sheduler/Signals
                .long  0x00000000        ! [0098] Kernel: User-Sheduler/Idles
                .long  0x00000000        !_[009C] Kernel:   <reserviert>
                .long  0x00000000        ! [4000] Task#0: Debugger-Console
                .long  0x8C000900        ! [4004] Task#0: Debugger-Ramarea
                .long  0x8C004080        ! [4008] Task#0: local Memory-Map
                .long  0x8C007000        ! [400C] Task#0: Kernel-Stacktop
                                         !-
BOOT_K3150:     .short 0x0C01            ! physikalische Startadr Bank#1/Area#3L
                .short 0x0E00            ! physikalische Startadr Bank#2/Area#3H
                .short 0x0800            ! physikalische Startadr Bank#3/Area#2L
                .short 0x0A00            ! physikalische Startadr Bank#4/Area#2H

!...............

BOOT_X3114:     add #0x04,r7             ! [Build_global_Mmu-Table:]      [34AC]
                mov #0x03,r8             ! schreibe restliche Sys-Data-Entries
             1:   bsr BOOT_MMUWRITEL     ! fr die zweite bis vierte SDram-Bank
                  mov.l @r7+,r0          ! lese MemSize aus Var, PhysAdr aus Rom
                  dt r8                  ! die VirtAdr geupdated, Mode/R3 bleibt
                  bf 1b                  ! schreibe max drei Mmu-Table-Entries
                mov r2,r8                ! save die EndOfSysData-Adresse in R8
                                         !-
                bsr BOOT_SIGNON          ! Signon-Message/SysStart:
                mov #0x01,r0             ! informiere User ber System-Start
                                         !-
                mov r9,r6                ! Final_Hardware-Setup:
                mov.l BOOT_K3153,r0      ! Flush_Cache-Inhalt_ins_SDram:
                mov r8,r7                ! call BOOT_CACHESYNC ungecached
                jsr @r0                  ! schreibt den Cache-Inhalt ins Ram
                mov #0x01,r4             ! init R4=1,R6=EndSysCode,R7=EndSysData
                mov.l BOOT_K3152,r1      ! PcSio-Cts_Aktivierung:
                mov #0x10,r0             ! ab jetzt darf der Pc uns Daten senden
                mov.b r0,@r1             ! denn gleich werden Interrupts enabled
                mov #0x07,r0             ! write 0x10 -> Pcdr PcCts=On,PcDcd=Off
                mov.w BOOT_K3158,r1      ! Timer-Int_Aktivierung:
                xor r3,r3                ! starte HiClock/Tmr#1,LoClock/Tmr#2
                mov.b r0,@r1             ! erzeugen ab jetzt zyklische IntReqs
                mov #A_MMUCR,r1          ! write 0x07 --> Tstr fr Tmr#0..2=Run
                mov.l r0,@r1             ! Flush_Mmu-Eintrge:
                xor r2,r2                ! denn Memory-Tables wurden verndert
                mov.w BOOT_K3151,r0      ! write 0x00000007 --> Mmucr Tlb-Clr
                mov #A_WTCNT,r1          ! Watchdog-Beruhigung:
                mov.w r0,@r1             ! write 0x5A00 --> Wtcnt Count=0x00
                                         !-
                xor r1,r1                ! Reg-Restore/Start-Jump:
                mov.l BOOT_K3155,r5      ! restauriere Register und Cpu-Zustand
                ldc r1,r4_bank           ! damit beginnt Ausfhrung System-Code
                mov.l BOOT_K3154,r0      ! setup R1=R2=R3=MACH=PR=Null/unbenutzt
                ldc r1,r5_bank           ! init R4/InterfaceVersion = 0x00000001
                ldc r1,r6_bank           ! init R5/MACL/Rom-Version = 0x00MaMiSp
                ldc r0,sr                ! schon in R6/EndOfSysCode = 0xCxxxxxxx
                ldc.l @r15+,r3_bank      ! schon in R7/EndOfSysData = 0xDxxxxxxx
                ldc r1,r7_bank           ! clear in 2.Bank R4,R5,R6,R7 unbenutzt
                mov.l @r15,r15           ! setup R0=StartupGrund als ReturnValue
                mov r13,r0               ! wenn wir aus Standby-Schlaf aufwachen
                ldc.l @r15+,spc          ! zurck vom Interrupt auf User-Stack
                dmulu.l r4,r5            ! zum restaurieren der User-Register
                ldc.l @r15+,ssr          ! setze BL=1 whrend Register-Restore
                lds r1,pr                ! nebenbei Version*1 nach MAC multiply
                ldc.l @r15+,gbr          ! sowie PR mit Return-Adresse lschen
                mov.l @r15+,r14          ! restauriere Stack-Nummer in R3/B1
                mov.l @r15+,r13          ! restauriere Stack-Pointer in R15
                mov.l @r15+,r12          ! dann vom alten Stack dieses zurck
                mov.l @r15+,r11          ! restauriere User-PC und User-SR
                mov.l @r15+,r10          ! restauriere User-GBR und R14..R8
                mov.l @r15+,r9           ! verndert nur R0-R7 wie 'C'-Fktn
                rte                      ! jetzt werden Interrupts freigegeben
                mov.l @r15+,r8           ! lade Cpu-SR und jump zum System-Code

!-------------
! NOSYS-PANIC
!-------------

BOOT_XSYSPANIC: mova BOOT_K3156,r0       ! KEIN_SYSTEM_PANIK:             [3512]
                mov.l @r0+,r2            ! Fehler ausblinken und an Lcd und Sio
                mov r0,r8                ! zuletzt resetten wir uns dann selbst
                mov.w @r8+,r9            ! setup R2=Delay/1Sec und R5=*Wtcnt
                mov #A_WTCNT,r5          ! und R8=*Lcd_TextData,R9=*Lcd_Byteout
                mov.w @r8+,r10           ! und R10=*Boot_uDelay,R12=Delay/1Sec
                add r8,r9                ! erhalte R11 mit Signon-Cfg#1-Switch
                add r8,r10               ! call Delay-Routine mit Watchdog-Clr
                bsr BOOT_XPANDEL         ! setzt R1=*Scscr,R3=*Pddr,R4=0x5A00
                mov r2,r12               ! returned positiven Tcnt#0-Val in R0
                add r0,r12               !_baue Reset-Zeit in R12 aus R0+1Sec
                mov #0xC0,r0             ! Fehler-Messages_ausgeben:
                mov #0xF0,r1             ! es ist mindestens 1 Sec nach Start
                mov.b r1,@r3             ! erster Lcd-Text lange genug sichtbar
                bsr BOOT_LCDLOAD         ! write 0xF0 --> Pddr Led/Wakeup=On/L
                mov #0x10,r1             ! ab jetzt leuchtet die on-board-Led
                bsr BOOT_SIGNON          ! upload 2.Lcd-Zeile mit Fehler-Text
                mov #0x02,r0             ! dazu 16 Bytes ins Lcd-DD-Ram ab 0x40
                mov.l BOOT_K3153,r0      ! call Boot_Signon(2) fr User-Message
                jsr @r0                  ! call BOOT_CACHESYNC als ungecached
                mov #A_WTCNT,r5          !_damit bei Reset alles im SDram ist
                bsr BOOT_XPANDEL         ! Warte bis Message 1 Sekunde gesehen:
                mov r12,r2               ! dann knnen wir uns selbst resetten
                mov.w BOOT_K3159,r0      ! ergibt Reset-Loop alle 2 Sekunden
                mov #0xF8,r1             ! write 0xF8 --> Pddr Led/Wakeup=Off/H
                mov.b r1,@r3             ! damit keine berschneidung mit Reset
                bsrf r0                  ! jetzt versuchen wir das ganze nochmal
                mov #0xFE,r4             ! call cpu_rescold(-2)/System-Kaltstart

!...............

BOOT_K3151:     .short 0x5A00            ! Wtcnt-Value fr Count=0x00     [354A]
BOOT_K3152:     .long  A_PCDR            ! Adresse Port#C-Data Pc-Sio-Cts
BOOT_K3153:     .long  0xAC008000+BOOT_CACHESYNC! Adresse Cache-Sync-Routine
BOOT_K3154:     .long  0x500000F0        ! SR mit BL=1/Intm=15 fr Reg-Restore
BOOT_K3155:     .byte  0x00,VER_MAJ,VER_MIN,VER_SPC!_Versions-Nr Bootrom
BOOT_K3156:     .long  0x001312D0        ! 1000mSec in 800nSec-Steps
                .short LCD_BYTEOUT-BOOT_K3157! Offset Lcd-Byteout-Routine
                .short BOOT_UDELAY-BOOT_K3157! Offset uDelay-Routine Lcd-Out
BOOT_K3157:     .ascii "Nothing to boot!"! Lcd-Text wenn kein System gefunden
                                         !-
BOOT_SYSNAME:   .ascii "HLSYSTEM","S","!"! Name/Type System-File
BOOT_K3158:     .short A_TSTR            ! Adr Tmr-Start-Register
BOOT_HIGHNAME:  .ascii "HIGHBIOS","B","!"! Name/Type High-Bios-File
BOOT_K3159:     .short _cpu_rescold-BOOT_K3151! Offset DoReset-Routine
                                         !=
BOOT_K3160:     .long  0xC0000000        ! virtuelle Startadresse System-Code
BOOT_K3161:     .long  0xD0000000        ! virtuelle Startadresse System-Data

!-------------
! SUBROUTINEN
!-------------

BOOT_ROMCHECK:  mov.w @r1,r2             ! TESTE_ROM-MEMORY-SIZE:         [3594]
                cmp/eq r0,r2             ! R0 = Flash-Chip-Id
                bt 3f                    ! R1 = *Rom-Startadresse
                  swap.b r0,r2           ! ---> R0 = Flash-Chip-Id (geupdated)
                  xor r2,r0              !      R1 = *Rom-Startadresse (bleibt)
                  tst #0xFF,r0           !      R2 = Rom-Gesamtlnge (in Bytes)
                  bt 3f                  !      Register R3-R7 werden getrashed
                    xor r2,r0            ! Update_Flash-Id-Word:
                    xor r3,r3            ! lese (Daten-) Word aus Flash-Adr 0
                    xor r4,r4            ! wenn Daten=Id dann Rom gefunden,Id=0
                    mov #0x02,r5         ! teste High-/Low-Byte unterschiedlich
             1:       mov #0x08,r6       ! wenn gleich dann leerer Bus,Id=0x0000
                      mov #0x01,r7       ! teste ob beide Bytes Odd-Parity haben
             2:         shlr r2          ! setup R2=Data,R3=Gesamt-Error,R4=0000
                        addc r4,r7       ! in R5=Byte-Cnt,R6=Bit-Cnt,R7=Bit-Err
                        dt r6            ! dann fr jedes der beiden Id-Bytes:
                        bf 2b            ! init Bit-Count=8 und Bit-Parity/Err=1
                      dt r5              ! dann fr jedes der acht Bits im Byte:
                      bf/s 1b            ! shifte next Datenbit, add zur Parity
                      or r7,r3           ! repeat bis alle acht Bits erledigt
                    shlr r3              ! or Byte-Parity zu Gesamt-Error-Bit
                    bf 4f                ! repeat bis alle beide Bytes erledigt
             3: xor r0,r0                !_bei ungltiger Id lade 0x0000=NoFlash
             4: mov.w BOOT_K3175,r2      ! Bestimmt physikalische Memory-Size:
             5:   mov.w BOOT_K3173,r3    ! init R2=TestAdrLine/0x1000,R3=0x0804
                  mov #0x08,r4           ! baue daraus R1=TestAdr1=Base+0x0804
                  or r3,r1               ! R3=TestAdr2=Base+0x0804+TestAdrLine
                  mov r1,r3              ! dann fr jede AdrLine 32 Byte compare
                  or r2,r3               ! wenn gleich dann AdrLine unwichtig
             6:     mov.l @r1+,r5        ! fr jedes der 8 zu testenden Longs
                    mov.l @r3+,r6        ! lese Daten aus Adr TestAdrLine=Low
                    cmp/eq r5,r6         ! lese Daten aus Adr TestAdrLine=High
                    bf 7f                ! wenn ungleich dann ist Line wichtig
                    dt r4                ! sonst LongCount-- fr gesamt 32 Byte
                    bf 6b                ! wenn gleich repeat bis alles compared
             7:   mov.l BOOT_K3182,r3    ! bei allen Test-Longs war AdrLine egal
                  bt 8f                  ! zurck, wir haben Rom-Size gefunden
                  shll r2                ! bei ungleichen Daten war Line wichtig
                  tst r2,r3              ! dann jetzt nchsthhere Line testen
                  bt/s 5b                ! solange wir noch in Mem-Area bleiben
             8:  and r3,r1               ! setze Rom-Baseadress auf Start zurck
                mov.w BOOT_K3178,r3      ! melde Rom erst bei RomSize minimal 8K
                rts                      ! erst dann haben wir wichtige AdrLines
                and r3,r2                ! zurck mit R0=RomId,R1=*Rom,R2=Size


BOOT_MMUWRITEL: mov.w @r4+,r1            ! SCHREIBE_MMU-EINTRAG:          [35EC]
                shll16 r1                ! lese physical-Adr aus Liste nach R1
BOOT_MMUWRITE:  tst r0,r0                ! baue aus High-Word Adresse via Shift
                bt 1f                    ! R0 = Block-Size (aufgerundet auf 4K)
                  mov.w BOOT_K3174,r6    ! R1 = *physical_Ram-Adresse
                  mov.b r3,@r5           ! R2 = *virtual_Ram-Adresse
                  add r6,r0              ! R3 = Flags fr Mmu-Eintrag
                  mov.w BOOT_K3179,r6    ! R5 = *Mmu-Tabelle/Output
                  mov.l r1,@(12,r5)      ! ---> Mmu-Eintrag wurde geschrieben
                  and r6,r0              !      R0 = real zugewiesene Block-Size
                  mov.l r2,@(4,r5)       !      R1+= Block-Size, R2+= Block-Size
                  add r0,r1              !      R3 bleibt, R5+= 16, R6 getrashed
                  mov.l r0,@(8,r5)       ! Teste mehr als Null Bytes zu mappen
                  add r0,r2              ! wenn nein fertig, schreibe End-Marker
                  add #0x10,r5           ! sonst Lnge auf nchste 4K aufrunden
             1: mov #0xFF,r6             ! schreibe ModeByte,VirtAdr,Len,BusAdr
                rts                      ! schreibe 0xFF --> ModeByte next Entry
                mov.b r6,@r5             ! fertig, return R0,R1,R2,R5 geupdated


BOOT_LOADFILE:  mov.l @(0x10,gbr),r0     ! LADE_SYSTEM-FILE:              [3610]
                mov.w BOOT_K3176,r3      ! R4 = *Ram-Ziel-Adresse
                sts.l pr,@-r15           ! R5 = Maximal-Lnge (in Bytes)
                cmp/hi r3,r0             ! R6 = *File-Name/Typ (9 Bytes)
                bf 3f                    ! GBR = *System-Variablen-Start
                  mov r0,r2              ! ---> File wird gesucht und geladen
                  mov.l BOOT_K3184,r1    !      T=0/F - nicht gefunden
                  bsr BOOT_FILECHECK     !              Register R0-R3,R7=Trash
                  mov.l r1,@-r15         !      T=1/T - gefunden/geladen
                  bt 5f                  !              R0 = physical Read-Adr
                  mov r0,r3              !              R7 = gelesene Byte-Anz
             1:     mov.w BOOT_K3176,r7  !              Register R1-R6 getrashed
                    cmp/hi r7,r3         !      32 Bytes Stack werden genutzt
                    bf 2f                !      Der Watchdog wird dabei versorgt
                      bsr BOOT_FILECHECK ! Versuche_Laden_aus_Area#0:
                      mov.l r1,@-r15     ! lese Memory-Lnge des Roms in Area#0
                      bt 5f              ! wenn nicht ber 16K dann nur Bootcode
             2:     add r0,r3            ! dann weiter mit Laden aus der Area#4
                    cmp/hi r3,r2         ! wenn ber 16K teste Eintrag an 16K
                    bt 1b                ! wenn gefunden dann jump zum Laden
             3: mov.l @(0x14,gbr),r0     ! teste Eintrag fr die Sektoren#2-8
                tst r0,r0                ! aber nur wenn Adr oberhalb von 16K
                bt BOOT_X3115            ! wenn gefunden dann jump zum Laden
                  mov r0,r2              ! sonst repeat fr nchsten Sektor
                  mov.l BOOT_K3187,r1    ! Versuche_Laden_aus_Area#4:
                  xor r3,r3              ! lese Memory-Lnge des Roms in Area#4
             4:     bsr BOOT_FILECHECK   ! wenn Null Ende mit "nicht gefunden"
                    mov.l r1,@-r15       ! teste Eintrag fr die Sektoren#1-8
                    bt 5f                ! wenn gefunden dann jump zum Laden
                    add r0,r3            ! sonst Test-Offset in R3 updaten
                    cmp/hi r3,r2         ! teste ob Adresse noch in ChipSize
                    bt 4b                ! repeat solange gltige Test-Adresse
BOOT_X3115:     lds.l @r15+,pr           ! Eintrag_nicht_gefunden:
                rts                      ! restore Return-Adresse vom Stack
                clrt                     !_zurck zum Caller mit F/T=0/NotFound
             5: shlr2 r7                 ! Lade_guten_gefundenen_Eintrag:
                mov.l BOOT_K3181,r0      ! init R0=PhysMask/0x1FFFFFFC,R1=*Sar3
                add r1,r3                ! in R2=0x5411,R3=RdBusAdr,R4=WrBusAdr
                mov.l BOOT_K3183,r1      ! sowie R5=0x5A00,R6=*Wtcnt,R7=LongLen
                and r0,r3                ! write <RdBusAdr> --> Sar3 Read-Adr
                mov.l r3,@r1             ! write <WrBusAdr> --> Dar3 Write-Adr
                and r0,r4                ! write <LongLen> ---> Dmatcr3 Long-Anz
                mov.l r4,@(4,r1)         ! damit ist Dma#3 fr Transfer bereit
                mov.w BOOT_K3177,r2      ! sie teilt sich den Bus mit der Cpu
                mov.l r7,@(8,r1)         ! write <0x00005411> --> Chcr3 Dma=Run
                mov.w BOOT_K3171,r5      ! jetzt werden die Daten in Long-Happen
                mov.l r2,@(12,r1)        ! vom 8-Bit-Rom in 32-Bit-SDram kopiert
                mov #A_WTCNT,r6          ! im SDram ist der Zugriff 10*schneller
             6:   mov.l @(12,r1),r0      ! Warte bis Dma#3-Transfer beendet:
                  mov.w r5,@r6           ! lese Chcr3 mit Dma#3-Status nach R0
                  tst #0x02,r0           ! teste Ende-Bit/Te/Bit#1 im Status
                  mov.w @(16,r1),r0      ! write 0x5A00 --> Wtcnt Count=0x00
                  mov.w BOOT_K3172,r0    ! lese Dmaor fr Nmi-Flag-Lschung
                  bt/s 6b                ! write 0x0301 --> Dmaor Nmif=Clear
                  mov.w r0,@(16,r1)      ! repeat solange bis Dma#3/Te-Bit=1
                add #0xFF,r2             ! update Chcr3-Word/Disable auf 0x5410
                mov.l r2,@(12,r1)        ! restore PR-Register mit ReturnAdr
                mov r3,r0                ! write 0x00005410 --> Chcr3 Te=Clr
                lds.l @r15+,pr           ! damit hat Dma#3 wieder Ruhezustand
                shll2 r7                 ! init R0 auf physical Read-Adresse
                rts                      ! init R7 mit Anzahl gelesener Bytes
                sett                     ! zurck zum Caller mit T/T=1/Loaded


BOOT_FILECHECK: mov.l r4,@-r15           ! TESTE_ROM-RECORD:              [368C]
                mov r1,r4                ! R1 = *Chip-Basisadresse
                mov.l r3,@-r15           ! R2 = Chip-Gesamt-Lnge
                add r3,r4                ! R3 = Test-Offset im Chip
                mov.l r2,@-r15           ! R4 = *Ram-Ziel-Adresse
                sub r3,r2                ! R5 = Maximal-Lnge (in Bytes)
                mov.l r5,@-r15           ! R6 = *File-Name/Typ (9 Bytes)
                cmp/hi r5,r2             ! ---> Eintrag wird getestet
                sts.l pr,@-r15           !      T=0/F - ungltiger Eintrag
                bt 1f                    !      T=1/T - gltiger Eintrag,R7=Len
                  mov r2,r5              !      R0 = Sektor-Lnge des Chips
             1: bsr BOOT_AREACHECK       !      Register R0,R7 werden getrashed
                mov.l r6,@-r15           !      28 Bytes Stack werden genutzt
                mov.l @r15+,r6           !      Der Watchdog wird dabei versorgt
                lds.l @r15+,pr           ! Save R1,R2,R3,R4,R5,R6,PR im Stack
                mov.l @r15+,r5           ! init R4=*FileStart,R5=FileMaxLen
                mov.l @r15+,r2           ! sowie R6=*FileName fr Area-Check
                movt r1                  ! dazu FileStart aus ChipBase+TestOfs
                mov.l @r15+,r3           ! sowie MaxLen aus Min (MaxLen,RestLen)
                mov r2,r0                ! mit RestLen aus ChipGesamtLen-TestOfs
                mov.l @r15+,r4           ! nach Area-Test Register restaurieren
                shlr2 r0                 ! save T-Bit kurzfristig in R1/Bit#0
                shlr r0                  ! baue R0/SektorSize aus GesamtLen/8
                shlr r1                  ! restore T-Bit wieder aus R1/Bit#0
                rts                      ! restore zuletzt R1 noch vom Stack
                mov.l @r15+,r1           ! return T=Ok/Bad,R0=SektLen,R7=FileLen


BOOT_AREACHECK: mov.l @(12,r4),r0        ! TESTE_AREA_IM_SPEICHER:        [36C0]
                tst #0x03,r0             ! R4 = *Area-Startadresse
                bf 3f                    ! R5 = Maximal-Lnge (in Bytes)
                mov #0x50,r1             ! R6 = *Area-Name/Typ (9 Bytes)
                cmp/hs r1,r0             ! ---> Area wird auf gltig geprft
                bf 3f                    !      T=0/F - Area ungltig
                cmp/hs r0,r5             !      T=1/T - Area ist gltig
                bf 3f                    !              R7 = Area-Lnge
                mov.l @r6+,r1            !      Register R0-R7 werden getrashed
                mov r0,r7                !      Der Watchdog wird dabei versorgt
                mov.l @r4,r0             ! Teste_formale_Parameter:
                cmp/eq r0,r1             ! lese Area-Lnge als deren Header
                mov.l @r6+,r1            ! teste ob Lnge Long-Aligned ist
                bf 3f                    ! wenn nein zurck mit T=0/Invalid
                mov.l @(4,r4),r0         ! teste ob Lnge min 80 Bytes ist
                cmp/eq r0,r1             ! wenn nein zurck mit T=0/Invalid
                mov.b @r6,r1             ! teste ob Lnge max Maximal-Lnge
                bf 3f                    ! wenn nein zurck mit T=0/Invalid
                mov.b @(11,r4),r0        ! vergleiche Name und Typ aus Header
                cmp/eq r0,r1             ! gesamt 9 Bytes mssen gleich sein
                bf 3f                    !_wenn nicht zurck mit T=0/Invalid
                  sts pr,r2              ! Teste_CRC-Prfsumme:
                  mov r7,r3              ! init R2=RetAdr,R3=R7=AreaLen
                  mov r4,r5              ! sowie R4=0xFF,R5=*AreaAdr
                  mov #0xFF,r4           ! dann fr jeden Daten-Happen:
             1:     mov.w BOOT_K3175,r6  ! setze R6/ChunkLen default 0x1000
                    mov.w BOOT_K3171,r0  ! nebenbei den Watchdog beruhigen
                    mov #A_WTCNT,r1      ! write 0x5A00 --> Wtcnt Count=0x00
                    cmp/hi r6,r3         ! teste ob Rest-Lnge noch ber 4K
                    bt/s 2f              ! wenn ja dann sind 4K ChunkLen ok
                    mov.w r0,@r1         ! ansonsten Chunk gesamte Rest-Lnge
                      mov r3,r6          ! damit dann gesamtes Stck bearbeitet
             2:     mov.w BOOT_K3180,r0  ! update R3/RestLen -= R6/ChunkSize
                    bsrf r0              ! call _sys_crcblock fr Chunk-Crc
                    sub r6,r3            ! die Routine updated den Crc in R4
BOOT_X3116:         tst r3,r3            ! teste ob noch weitere Bytes zu tun
                    bf 1b                ! wenn ja repeat mit nchstem Chunk
                  tst r4,r4              ! fertig mit Crc-Berechnung,teste Crc
                  lds r2,pr              ! gute Daten ergeben R4=0/T=1,PR back
             3: mov #A_WTCNT,r1          ! fertig mit Area-Gltigkeits-Check
                mov.w BOOT_K3171,r0      ! write 0x5A00 --> Wtcnt Count=0x00
                rts                      ! fr 52mSec an Watchdog-Ruhezeit
                mov.w r0,@r1             ! zurck mit F/T=0/Bad,T/T=1/Good


BOOT_FLASHCMDS: mov.l BOOT_K3185,r1      ! COMMAND_AN_ALLE_FLASH-CHIPS:   [3716]
                mov.l BOOT_K3186,r2      ! R0 = auszugebendes Command-Byte
                mov.b r1,@r2             ! ---> Command an Areas#0+4 ausgegeben
                mov.b r2,@r1             !      R1..R2 werden dabei getrashed
                mov.b r0,@r2             ! Dazu zweimal Unlock und Cmd-Ausgabe
                mov.l BOOT_K3188,r1      ! write 0xAA --> 0xA0005555 Area#0/Ul#1
                mov.l BOOT_K3189,r2      ! write 0x55 --> 0xA0002AAA Area#0/Ul#2
                mov.b r1,@r2             ! write <Cmd>--> 0xA0005555 Area#0/FCmd
                mov.b r2,@r1             ! write 0xAA --> 0xB0005555 Area#4/Ul#1
                rts                      ! write 0x55 --> 0xB0002AAA Area#4/Ul#2
                mov.b r0,@r2             ! write <Cmd>--> 0xB0005555 Area#4/FCmd


BOOT_LCDLOAD:   sts.l pr,@-r15           ! UPLOAD_LCD-MEMORY-BLOCK:       [372C]
                bsr BOOT_LCDCMD          ! R0 = Command-Byte fr Startadr-Setzen
                mov.l r1,@-r15           ! R1 = Anzahl der zu uploadenden Bytes
                mov.l @r15+,r1           ! R8 = Pointer auf zu uploadende Daten
             1:   mov.b @r8+,r0          ! R9 = Pointer Lcd-Byte-Ausgabe-Routine
                  bsr BOOT_LCDDAT        ! R10= Pointer auf uDelay-Warte-Routine
                  mov.l r1,@-r15         ! ---> Daten sind in LCD-Memory kopiert
                  mov.l @r15+,r1         !      R0..R7 getrashed, 16 Bytes Stack
                  dt r1                  !      R8 wird hinter Daten incremented
                  bf 1b                  ! Save RetAdr und ByteCount auf Stack
                bt BOOT_X3115            ! Fr jedes Byte PutByte *p++,Count--


BOOT_LCDCMD:    mov #0xB4,r1             ! COMMAND/DATEN_ANS_LCD-MODUL:   [3742]
BOOT_LCDCMDN:   bra 1f                   ! R0 = auszugebender Lcd-Command 4/8Bit
                clrt                     ! R1 = uDelay-Count fr Cmd-Busy-Zeit
BOOT_LCDDAT:    mov #0xB4,r1             ! R9 = Pointer Command-Ausgabe-Funktion
                sett                     ! R10= Pointer auf uDelay-Warte-Routine
             1: sts.l pr,@-r15           ! ---> Command ausgegeben,Zeit gewartet
                jsr @r9                  !      R0..R7 getrashed, 8 Bytes Stack
                mov.l r1,@-r15           ! Setup R0=Data,T=Cmd/Dat,R1=BusyDelay
                mov.l @r15+,r0           ! call LCD_NIBBLEOUT/LCD_BYTEOUT-Fktn
                jmp @r10                 ! restore PR, BusyDelay vom Stack-->R0
                lds.l @r15+,pr           ! weiter und Abschluss mit BOOT_UDELAY


BOOT_MEMCPY:      mov.l @r4+,r0          ! KOPIERE_SPEICHER-BLOCK:        [3758]
                  dt r1                  ! R1 = Anzahl zu kopierender Long-Words
                  mov.l r0,@r5           ! R4 = *Lese-Adresse der Daten
                  bf/s BOOT_MEMCPY       ! R5 = *Schreib-Adresse der Daten
                  add #0x04,r5           ! ---> Daten sind kopiert worden
                bt BOOT_X3117            !      Register R0,R1,R4,R5 getrashed


BOOT_MEMSET:      mov.l r2,@r5           ! FLLE_SPEICHER-BLOCK:          [3764]
BOOT_MEMSETX:     dt r1                  ! R1 = Anzahl zu schreibender Longs
                  bf/s BOOT_MEMSET       ! R2 = Fll-Wert fr Memory-Block
                  add #0x04,r5           ! R5 = *Schreib-Adresse der Daten
BOOT_X3117:     rts                      ! ---> Bereich ist gefllt worden
                nop                      !      Register R1,R5 getrashed

!...............

BOOT_K3171:     .short 0x5A00            ! Wtcnt-Value fr Count=0x00     [3770]
BOOT_K3172:     .short 0x0301            ! Dmaor-Value fr Nmif-Clear
BOOT_K3173:     .short 0x0804            ! Test-Offset fr Romsize-Tests
BOOT_K3174:     .short 0x0FFF            ! Aufrundung Pagesize Mmu-Write
BOOT_K3175:     .short 0x1000            ! Start-AdrLine fr Romsize-Chk
BOOT_K3176:     .short 0x4000            ! Start-Offset Area#0-Filesearch
BOOT_K3177:     .short 0x5411            ! Chcr3-Value fr Dma-Transfer=On
BOOT_K3178:     .short 0xE000            ! And-Maske gefundene Rom-Size
BOOT_K3179:     .short 0xF000            ! And-Maske Mmu-Page-Aufrundung
BOOT_K3180:     .short _sys_crcblock-BOOT_X3116! Offset Block-Crc-Routine
BOOT_K3181:     .long  0x1FFFFFFC        ! And-Maske physical Dma#3-Adr
BOOT_K3182:     .long  0xFC000000        ! And-Maske Areasize Rom-Check
BOOT_K3183:     .long  A_SAR3            ! Dma#3-Basisadresse File-Load
BOOT_K3184:     .long  0x80000000        ! Rom#1/Area#0: Basis-Adr/Cache
BOOT_K3185:     .long  0xA0002AAA        ! Rom#1/Area#0: Flash-Cmd/Low
BOOT_K3186:     .long  0xA0005555        ! Rom#1/Area#0: Flash-Cmd/High
BOOT_K3187:     .long  0x90000000        ! Rom#2/Area#4: Basis-Adr/Cache
BOOT_K3188:     .long  0xB0002AAA        ! Rom#2/Area#4: Flash-Cmd/Low
BOOT_K3189:     .long  0xB0005555        ! Rom#2/Area#4: Flash-Cmd/High

!##############################################################################!
!                S  I  G  N  O  N   -   M  E  S  S  A  G  E  S                 !
!##############################################################################!

!------------------
! USER-INFORMATION
!------------------

BOOT_SIGNON:    mov #0x10,r1             ! TEXT-INFORMATION_AN_USER:      [37A8]
                tst r1,r11               ! R0 = Message-Nummer {0x00/0x01/0x02}
                bt BOOT_X3117            !
                  tst r0,r0              !
                  sts.l pr,@-r15         !
                  bt BOOT_SIGNONSCR      !
                    dt r0                !
                    mova MSG_SIGNON01,r0 !
                    bf 1f                !
                      bsr BOOT_SBIGLIST  !
                      mov #A_PTEH,r0     !
                      mova MSG_SIGNON02,r0!
             1:     bra BOOT_STXEND      !
                    nop                  !

!...............

MSG_SIGNON01:   .ascii "No system to boot, resetting mysel"              ![37C4]
                .byte  'f'+0x80
                .byte  0xFF

MSG_SIGNON02:   .ascii "Running the syste"
                .byte  'm'+0x80

!---------------
! SIGNON-SCREEN
!---------------

BOOT_SIGNONSCR: mova MSG_SIGNON10,r0     ! HAUPT-SIGNON-BLOCK_AUSGEBEN:   [37FA]
                bsr BOOT_SPUTS0          ! Der erste Signon-Text des Startups
                mov r13,r6               ! Zuerst festen Signon-Text ausgeben
                                         !=
                shlr2 r6                 ! 2.Text-Block:
                shlr2 r6                 !
                bsr BOOT_SARREL          !
                add #0xFF,r6             !
                mova MSG_SIGNON11,r0     !
                bsr BOOT_SPUTS0          !
                mov #0x30,r3             !
                cmp/hs r3,r13            !
                bf/s 1f                  !
                mov r13,r6               !
                  add #MSG_SIGNON13-MSG_SIGNON12,r5!
             1: bsr BOOT_SARRELA         !
                mov #0x0F,r0             !
                mova MSG_SIGNON14,r0     !
                bsr BOOT_SPUTS0          !
                mov #0x04,r9             !
                                         !-
                cmp/hs r3,r13            !
                bt 1f                    !
                  mov r13,r0             !
                  and #0x0F,r0           !
                  cmp/hs r9,r0           !
                  bt 1f                  !
                    bsr BOOT_SPUTS       !
                    add #MSG_SIGNON16-MSG_SIGNON15,r5!
                    bf 2f                !
             1: bsr BOOT_SHEXLSTR        !
                mov.l @(0x34,gbr),r0     !
                bsr BOOT_SHEXLSTR        !
                mov.l @(0x30,gbr),r0     !
                bsr BOOT_SHEXLSTR        !
                mov.l @(0x38,gbr),r0     !
                bsr BOOT_SHEXLSTR        !
                mov.l @(0x3C,gbr),r0     !
                add #MSG_SIGNON17-MSG_SIGNON16,r5!
             2: bsr BOOT_SPUTS           !
                stc gbr,r8               !
                                         !-
                bsr BOOT_SARREL          !
                mov r10,r6               !
                mova MSG_SIGNON18,r0     !
                bsr BOOT_SPUTS0          !
                swap.b r11,r6            !
                                         !=
                bsr BOOT_SARRELA         !
                mov #0x01,r0             !
                mova MSG_SIGNON19,r0     !
                bsr BOOT_SPUTS0          !
                swap.b r11,r6            !
                                         !-
                shlr r6                  !
                bsr BOOT_SARRELA         !
                mov #0x03,r0             !
                div0u                    !
                mov.w @(0x1C,gbr),r0     !
                mov #0x15,r2             !
                mov.l BOOT_K3201,r1      !
                add #0x07,r0             !
                shld r2,r0               !
             1:   div1 r0,r1             !
                  rotcr r0               !
                  dt r2                  !
                  bf/s 1b                !
                  shll r0                !
                mov.l BOOT_K3202,r6      !
                rotcl r1                 !
                bsr BOOT_SDEZLONG        !
                and r1,r6                !
                mova MSG_SIGNON20,r0     !
                bsr BOOT_SPUTS0          !
                mov #0x19,r3             !
                                         !-
                swap.b r11,r0            !
                tst #0x08,r0             !
                mov.w @(0x1E,gbr),r0     !
                bt/s 1f                  !
                extu.w r0,r0             !
                  add #MSG_SIGNON22-MSG_SIGNON21,r5!
             1: bsr BOOT_SPUTS           !
                mul.l r0,r3              !
                bsr BOOT_SDEZLONG        !
                sts macl,r6              !
                mova MSG_SIGNON23,r0     !
                bsr BOOT_SPUTS0          !
                mov.l @(0x10,r8),r6      !
                                         !=
                bsr BOOT_SMEMLINE        !
                mov.w @(0x18,gbr),r0     !
                mov.l @(0x14,r8),r6      !
                bsr BOOT_SMEMLINE        !
                mov.w @(0x1A,gbr),r0     !
                mov #0xFF,r0             !
             1:   bsr BOOT_SMEMLINE      !
                  mov.l @r8+,r6          !
                  dt r9                  !
                  bf 1b                  !
                bsr BOOT_SPUTS           !
                xor r8,r8                !
                                         !=
                bsr BOOT_SBIGLIST        !
                mov #A_PTEH,r0           !
                                         !=
                mova MSG_SIGNON24,r0     !
                bsr BOOT_SPUTS0          !
                mov r11,r6               !
                mov #0x0F,r0             !
                tst r0,r11               !
                bf 1f                    !
                  bsr BOOT_SPUTS         !
                  add #MSG_SIGNON26-MSG_SIGNON25,r5!
                  bf BOOT_X3201          !
             1: mov #0x04,r2             !
             2:   shlr r6                !
                  bf 4f                  !
                    tst r8,r8            !
                    bt 3f                !
                      bsr BOOT_SPUTCH    !
                      mov #0x2B,r4       !
             3:     bsr BOOT_SPUTCH      !
                    mov.b @r5,r4         !
                    mov #0x01,r8         !
             4:   dt r2                  !
                  bf/s 2b                !
                  add #0x01,r5           !
                add #MSG_SIGNON27-MSG_SIGNON26,r5!
                                         !-
BOOT_X3201:     bsr BOOT_SPUTS           !
                mov r11,r6               !
                mov #0xFB,r0             !
                shld r0,r6               !
                bsr BOOT_SARRELA         !
                mov #0x01,r0             !
                                         !=
                mova MSG_SIGNON28,r0     !
                bra BOOT_STXEND          !
                xor r8,r8                !

!...............

BOOT_K3201:     .long  0x001312D0        ! Timer#0-Clockfreq 1250000 Hz   [38FC]
BOOT_K3202:     .long  0x001FFFFF        ! Bit-Maske fr Adda-Frequenz

MSG_SIGNON10:   .byte  0x0D,0x0A,0x0D,0x0A                               ![3904]
                .ascii "*****  HARMLESS LITTLE BOARD  *****"
                .byte  0x0D,0x0A,0x0D,0x0A,0x0D,0x0A
                .ascii "Rom-version "
                .byte  '0'+VER_MAJ,'.','0'+(VER_MIN>>4),'0'+(VER_MIN&0x0F)
                .ascii ", (C) Copyright Volker Ernst 1999."
                .byte  0x0D,0x0A
                .ascii "See \"http://www.ccc.de/hlb/\" for further information."
                .byte  0x0D,0x0A,0x0D,0x0A
                .ascii "Starting with"
                .byte  ' '+0x80

                .ascii "power-on rese"
                .byte  't'+0x80
                .ascii "manual rese"
                .byte  't'+0x80
                .ascii "standby-wakeu"
                .byte  'p'+0x80

MSG_SIGNON11:   .ascii " because of"
                .byte  ' '+0x80

MSG_SIGNON12:   .ascii "unknown reaso"
                .byte  'n'+0x80
                .ascii "reset-pin input-signa"
                .byte  'l'+0x80
                .ascii "watchdog-overflo"
                .byte  'w'+0x80
                .ascii "double exceptio"
                .byte  'n'+0x80
                .ascii "bad exceptio"
                .byte  'n'+0x80
                .ascii "software-reques"
                .byte  't'+0x80

MSG_SIGNON13:   .ascii "unknown reaso"
                .byte  'n'+0x80
                .ascii "nmi-pin input-signa"
                .byte  'l'+0x80
                .ascii "timer#1-overflo"
                .byte  'w'+0x80
                .ascii "rtc-alar"
                .byte  'm'+0x80
                .ascii "unknown pint-signa"
                .byte  'l'+0x80
                .ascii "keyboard activit"
                .byte  'y'+0x80
                .ascii "chipcard presenc"
                .byte  'e'+0x80
                .ascii "line-interface rese"
                .byte  't'+0x80
                .ascii "line-voltage presenc"
                .byte  'e'+0x80
                .ascii "line ring-signa"
                .byte  'l'+0x80
                .byte  0xFF

MSG_SIGNON14:   .byte  '.',0x0D,0x0A
                .ascii "Shutdown"
                .byte  ' '+0x80
MSG_SIGNON15:   .ascii "with pc"
                .byte  '='+0x80
                .ascii ", sr"
                .byte  '='+0x80
                .ascii ", event"
                .byte  '='+0x80
                .ascii ", data"
                .byte  '='+0x80
MSG_SIGNON16:   .ascii "happened under unknown circumstance"
                .byte  's'+0x80

MSG_SIGNON17:   .byte  '.',0x0D,0x0A
                .ascii "Boot-method is to r"
                .byte  'e'+0x80
                .ascii "loa"
                .byte  'd'+0x80
                .ascii "star"
                .byte  't'+0x80
                .ascii "sum"
                .byte  'e'+0x80

MSG_SIGNON18:   .ascii " the system."
                .byte  0x0D,0x0A,0x0D,0x0A
                .ascii "Bootcode  :"
                .byte  ' '+0x80
                .ascii "O"
                .byte  'k'+0x80
                .ascii "Crc faile"
                .byte  'd'+0x80

MSG_SIGNON19:   .byte  0x0D,0x0A
                .ascii "Adda-test :"
                .byte  ' '+0x80
                .ascii "Ok (fsamp"
                .byte  '='+0x80
                .ascii "Framesync-timeout (fsamp"
                .byte  '<'+0x80
                .ascii "Reg-readback failed (fsamp"
                .byte  '='+0x80

MSG_SIGNON20:   .ascii " Hz)"
                .byte  0x0D,0x0A
                .ascii "Temic-test:"
                .byte  ' '+0x80
MSG_SIGNON21:   .ascii "Ok (fosc"
                .byte  '='+0x80
MSG_SIGNON22:   .ascii "Osc-freq out of range (fosc"
                .byte  '='+0x80
                .byte  0xFF

MSG_SIGNON23:   .ascii " Hz)"
                .byte  0x0D,0x0A,0x0D,0x8A
                .ascii "Rom#"
                .byte  '1'+0x80
                .ascii "0) "
                .byte  '-'+0x80
                .ascii "Rom#"
                .byte  '2'+0x80
                .ascii "4) "
                .byte  '-'+0x80
                .ascii "Ram#"
                .byte  '1'+0x80
                .ascii "3L)"
                .byte  ' '+0x80
                .ascii "Ram#"
                .byte  '2'+0x80
                .ascii "3H)"
                .byte  ' '+0x80
                .ascii "Ram#"
                .byte  '3'+0x80
                .ascii "2L)"
                .byte  ' '+0x80
                .ascii "Ram#"
                .byte  '4'+0x80
                .ascii "2H)"
                .byte  ' '+0x80
                .byte  0x0D,0x8A

MSG_SIGNON24:   .ascii "Boot-keys:"
                .byte  ' '+0x80
MSG_SIGNON25:   .ascii "123A"
MSG_SIGNON26:   .ascii " <none"
                .byte  '>'+0x80

MSG_SIGNON27:   .byte 0x0D,0x0A
                .ascii "Kbd-debug:"
                .byte  ' '+0x80
                .ascii "Di"
                .byte  's'+0x80
                .ascii "E"
                .byte  'n'+0x80

MSG_SIGNON28:   .ascii "abled"
                .byte  0x0D,0x0A,0x0D,0x0A
                .ascii "Running the boot-hook"
                .byte  's'+0x80
                .byte  0xFF

!----------------
! OUTPUT-SUPPORT
!----------------

BOOT_SBIGLIST:  mov.l @r0,r0             ! MMU+IMAGE-LIST-OUTPUT:         [3C90]
                stc gbr,r1               ! R0 = Pointer auf Pteh-Register
                sts.l pr,@-r15           ! ---> Mmu-Listen,Image-Lines angezeigt
                extu.b r0,r0             !      R0..R7 werden dabei getrashed
                add #0x40,r0             ! Lese aktuellen Asid aus Pteh-Register
                shll8 r0                 ! save Variablen-Basisadresse in R1
                add #0x08,r0             ! save Return-Adresse auf dem Stack
                xor r6,r6                ! baue Pointer auf private Mmu-Tabelle
                bsr BOOT_SMMULIST        ! beginnt bei VarBase+0x4000+Asid*8+8
                mov.l @(r0,r1),r7        ! im Task/Asid-privaten Daten-Bereich
                mov.l @(0x88,gbr),r0     ! clear Mmu-Line-Ausgegeben-Flag in R6
                bsr BOOT_SMMULIST        ! die erste Mmu-Tabelle an Sio ausgeben
                mov r0,r7                ! baue Pointer auf globale Mmu-Tabelle
                tst r6,r6                ! zweite Mmu-Tabelle via Sio ausgeben
                bt 1f                    ! teste ob ein Table Eintrge hatte
                  mova BOOT_K3214,r0     ! wenn ja dann abschliessende Leerzeile
                  bsr BOOT_SPUTS         ! dazu festen String mit Cr,Lf ausgeben
                  mov r0,r5              !_ohne Mmu-Zeilen auch keine Leerzeile
             1: mova BOOT_K3229,r0       ! Image-Lade-Zustnde ausgeben:
                mov r0,r5                ! setup R5=Pointer auf Image-Namen
                mov.l BOOT_K3212,r1      ! dann Zustand High-Bios-Image zeigen
                bsr BOOT_SIMGLINE        ! setup R0=HiBiosSource,R1=*HiBiosLen
                mov.l @(0x20,gbr),r0     ! wie gross und woher es geladen wurde
                mov.l BOOT_K3213,r1      ! dann Zustand System-Image anzeigen
                bsr BOOT_SIMGLINE        ! setup R0=SysLoadSource,R1=SystemLen
                mov.l @(0x24,gbr),r0     ! wie gross und woher es geladen wurde
                bsr BOOT_SHEXLSTR        ! abschliessend die Basis-Pointer
                stc vbr,r0               ! fr Code/vbr,Data/gbr,Task/asid
                bsr BOOT_SHEXLSTR        ! nochmal als Hex-Zahlen ausgeben
                stc gbr,r0               ! zuerst Code-Basis aus vbr-Reg
                bsr BOOT_SPUTS           ! danach festen Text ", data="
                mov #A_PTEH,r3           ! jetzt Data-Basis aus gbr-Reg
                mov.l @r3,r6             ! dann fester Text ", asid="
                mov #0x02,r3             ! nun Task-Nr aus asid/pteh
                shll16 r6                ! als 2-stellige Hex-Zahl
                bsr BOOT_SHEXNUM         ! und letzter Wert ausgeben
                shll8 r6                 ! abschliessend Zeilenende
                bra BOOT_SPUTS           ! mit nachfolgend Leerzeile
                lds.l @r15+,pr           ! return zur Adr aus Stack


BOOT_SMMULIST:  sts.l pr,@-r15           ! MMU-LIST-OUTPUT:               [3CDE]
             1:   mov.b @r7,r1           ! R7 = Pointer Mmu-Listenanfang
                  cmp/pz r1              ! ---> Ganze Mmu-Liste wird ausgegeben
                  bf BOOT_X3203          !      R0..R5,R7 werden dabei getrashed
                  bsr BOOT_SHEXLONG      !      R6 wird 1 gesetzt wenn Eintrge
                  mov.l @(4,r7),r6       ! Save Return-Adresse auf dem Stack
                  mova BOOT_K3226,r0     ! dann fr jede neue Mmu-Zeile:
                  mov r0,r5              ! lese Byte mit Flags des Mmu-Eintrags
                  bsr BOOT_SHEXLSTRA     ! teste ob Table-End-Marker in Bit#7
                  mov.l @(8,r7),r0       ! wenn ja dann fertig mit Mmu-Tabelle
                  mov.l @(12,r7),r0      ! sonst virtuelle Startadresse lesen
                  bsr BOOT_SHEXLSTR      ! und als erste Hex-Long-Zahl ausgeben
                  add #BOOT_K3225-BOOT_K3227,r5! schreibe nachfolgend 2 Punkte
                  bsr BOOT_SHEXLSTRA     ! und virtuelle Endadresse VStart+Len-1
                  mov.l @(8,r7),r0       ! wieder als Hex-Long-Zahl ausgeben
                  bsr BOOT_SPUTS         ! dann festen String " is ", danach
                  mov #0xFB,r3           ! die physikalische Startadr ausgeben
                  mov.b @r7,r0           ! schreibe nachfolgend zwei Punkte
                  shld r3,r0             ! und physikalische Endadr PStart+Len-1
                  bsr BOOT_SPUTCH0D      ! wieder als Hex-Long-Zahl ausgeben
                  and #0x03,r0           ! jetzt die Mmu-Page-Flags anzeigen
                  bsr BOOT_SMMUFLAG      ! zuerst einzeln Protection {0..3}
                  mov #0xFF,r1           ! denn Mmuflags sind sonst nur 0/1
                  bsr BOOT_SMMUFLAG      ! dann die binren Mmu-Page-Flags
                  mov #0xFD,r1           ! mit Name-String und 0/1 im Call
                  bsr BOOT_SMMUFLAG      ! beginnend mit sh/shared-Flag
                  mov #0xFE,r1           ! danach das c/cachable-Flag
                  bsr BOOT_SMMUFLAG      ! danach das d/dirty-Flag
                  mov #0xFC,r1           ! zuletzt das c/size-Flag
                  bsr BOOT_SPUTS         ! nach der letzten Digit
                  mov #0x01,r6           ! Klammer zu, Zeilenende
                  bra 1b                 ! set R6=1 fr Mmu-Zeile
                  add #0x10,r7           ! inc MmuEntryPtr,repeat


BOOT_SIMGLINE:  sts.l pr,@-r15           ! IMAGE-LINE-OUTPUT:             [3D20]
                tst r0,r0                ! R0 = Image-Ladequelladresse oder Null
                bt/s 1f                  ! R1 = Pointer auf Image-Lngenvariable
                xor r6,r6                ! R5 = Pointer Image-Vorspann-Text
                  mov.l @r1,r6           ! ---> R0..R4,R6,R7 werden getrashed
             1: bsr BOOT_SPUTS           !      R5 wird hinter Text geupdated
                mov.l r0,@-r15           ! Save Return-Adresse und Image-Quelle
                bsr BOOT_SMEMSIZE        ! wenn Image-Quelladresse ungleich Null
                mov.l r5,@-r15           ! dann Len-Variable lesen, sonst NoLen
                tst r6,r6                ! gebe Image-Vorspann aus, save TextPtr
                bt BOOT_X3202            ! gebe Image-Memory-Size dezimal aus
                  mov.l @(4,r15),r6      ! wenn Null-Lnge dann zum Zeilenende
                  mova BOOT_K3228,r0     ! Wenn Lnge>0 dann Quelle ausgeben:
                  cmp/pz r6              ! lese Image-Quelladresse nach R6
                  add #0x02,r6           ! teste ob ber Null, aus Rom geladen
                  bf/s 2f                ! merke Rom-Quelle als Flag in R3
                  movt r3                ! add 2 zur Quelle fr TextTbl-Index
                    mov #0x02,r6         ! fr Rom-Laden Index auf 2 begrenzen
             2:   bsr BOOT_SARREL        ! Gebe Image-Quellbezeichnung aus:
                  mov r0,r5              ! schreibe einen von drei Strings
                  tst r3,r3              ! fr BootHook,vorgefunden,RomLoad
                  bt BOOT_X3202          ! teste ob es vom Rom geladen wurde
                    bsr BOOT_SHEXLONG    ! wenn nein dann jump zum Zeilenende
                    mov.l @(4,r15),r6    ! sonst Quell-Adresse hex ausgeben
                    bt BOOT_X3202        ! und Ende Image-Line mit Zeilenende


BOOT_SMEMLINE:  sts.l pr,@-r15           ! MEMORY-LINE-OUTPUT:            [3D52]
                bsr BOOT_SPUTS           ! R0 = Memory-Typ {-1...0xFEFE}
                mov.l r0,@-r15           ! R5 = Pointer Area-Namens-Text
                mova BOOT_K3222,r0       ! R6 = Memory-Size in Bytes
                bsr BOOT_SPUTS0          ! ---> R1..R4,R6,R7 werden getrashed
                mov.l r5,@-r15           !      R5 wird hinter Text geupdated
                bsr BOOT_SPUTS           ! Save Return-Adresse und Memory-Typ
                mov.l @r15+,r5           ! gebe String mit Area-Namen aus
                mova BOOT_K3223,r0       ! save neuen Text-Pointer im Stack
                bsr BOOT_SPUTS0          ! geben festen Text " (area#" aus
                mov.l r5,@-r15           ! lese neuen Text-Pointer vom Stack
                bsr BOOT_SMEMSIZEX       ! gebe 2.Teil des Area-Namens aus
                tst r6,r6                ! save neuen Text-Pointer im Stack
                tst r6,r6                ! gebe festen Text "--> " nun aus
                bt BOOT_X3202            ! dann Memory-Size dezimal ausgeben
                  mov.l @(4,r15),r6      ! wenn Null-Size dann zum Zeilenende
                  mov #0x02,r3           ! Memory-Size ist grsser als Null:
                  add #0x01,r6           ! dann auch den Memory-Typ ausgeben
                  cmp/hs r3,r6           ! lese Memory-Typ-Wert vom Stack
                  bf/s 1f                ! inc Typ zu 0..., teste ob min 2
                  movt r7                ! wenn ja R7/FlashFlag auf 1 setzen
                    mov #0x02,r6         ! und Mem-Typ auf 2 fr Table-Index
             1:   mova BOOT_K3224,r0     ! Gebe Memory-Typenbezeichnung aus:
                  bsr BOOT_SARREL        ! schreibe einen von drei Strings
                  mov r0,r5              ! fr Sdram,Eprom,Flash aus Table
                  tst r7,r7              ! teste ob es Flash-Memory ist
                  bt BOOT_X3202          ! wenn nein dann zum Zeilenende
                    mov.l @(4,r15),r6    ! Gebe Flash-Typen-Nummer aus:
                    bsr BOOT_SHEXNUM     ! lese Memory-Typ, ist Chip-Id
                    shll16 r6            ! zuerst obere 8 Bits ausgeben
                    bsr BOOT_SPUTS       ! das ist die Hersteller-Nummer
                    nop                  ! danach festen String ", dev="
                    bsr BOOT_SHEXNUM     ! gefolgt von unteren 8 Bits
                    mov #0x02,r3         ! das ist die Device-Nummer
                    bsr BOOT_SPUTCH      ! abschliessend ')'-Character
                    mov #0x29,r4         ! fr Ende der Chip-Id-Angabe
BOOT_X3202:     mova BOOT_K3214,r0       ! Fertig mit Zeilen-Text:
                bsr BOOT_SPUTS           ! sende Cr,Lf via serielle
                mov r0,r5                ! fr Terminal-Zeilenende
                mov.l @r15+,r5           ! dann Areaname-Text-Pointer
                mov.l @r15+,r0           ! und Memory-Typ restaurieren
BOOT_X3203:     bra BOOT_X3117           ! zuletzt Return-Adr vom Stack
                lds.l @r15+,pr           ! und zurck zur Return-Adresse


BOOT_SDEZLONG:  xor r7,r7                ! DEZIMAL-NUMBER-OUTPUT:         [3DA8]
                sts pr,r2                ! R6 = auszugebender Zahlenwert
                mov #0x0A,r3             ! ---> Zahl wird dezimal ausgegeben
             1:   mova BOOT_K3230,r0     !      Fhrende Nullen werden ignoriert
                  add #0xFF,r3           !      R0..R4,R6..R7 werden getrashed
                  shll2 r3               ! Init R2=Retadr,R3=Digitanz,R7=Nullflg
                  mov.l @(r0,r3),r4      ! dann fr jede der 10 Dezimal-Stellen:
                  shlr2 r3               ! dec Stellen-Count, daraus Long-Index
                  xor r0,r0              ! lese Konstante 10^Stelle aus Table
                  mov r6,r1              ! den Long-Index zum Stellen-Count back
                  shlr r1                ! setup Register fr Stellen-Division
                  rotcr r0               ! baue 64-Bit Dividend/Restzahl R1/R0
                  shlr r1                ! shifte 64-Bit Dividend 4 Bit rechts
                  rotcr r0               ! dann durch Divisor in R4 dividieren
                  shlr r1                ! dazu zuerst M,Q,T-Flags lschen
                  rotcr r0               ! dann fr jedes der vier Quotient-Bits
                  shlr r1                ! zuerst Low-Long um eins nach links
                  rotcr r0               ! rotate T-Flag mit Quotient-Bit in Lsb
                  div0u                  ! rotate Msb in T-Flag fr new High-Lsb
                  rotcl r0               ! dann 1-Bit-Division in einem Opcode
                  div1 r4,r1             ! das Ergebnis steht wieder im T-Flag
                  rotcl r0               ! das High-Long wurde 1 links rotiert
                  div1 r4,r1             ! der Dividend darin geupdated
                  rotcl r0               ! ebenso wie auch das Q-Flag
                  div1 r4,r1             ! dabei bleibt M-Flag Null
                  rotcl r0               ! wiederhole diese Prozedur
                  div1 r4,r1             ! fr 4 Quotienten-Bits
                  rotcl r0               ! dieser Dezimal-Stelle
                  tst r0,r0              ! Fhrende Null-Unterdrckung:
                  bf/s 2f                ! multiply Quotient*(10^Stelle)
                  mul.l r0,r4            ! wenn Quotient<>Null Digit ausgeben
                    tst r3,r3            ! bei Null teste ob letzte Stelle
                    bt 2f                ! wenn ja dann die Null ausgeben
                      tst r7,r7          ! teste Digits vorher ausgegeben
                      bt 3f              ! wenn nein dann Null ignorieren
             2:   bsr BOOT_SPUTCH0D      ! Gebe Digit-Character seriell aus
                  mov #0x01,r7           ! set R7/Nullflg=1,Char ausgegeben
                  sts macl,r0            ! lade R0=Quotient*(10^Stelle)
             3:   tst r3,r3              ! Weiter mit nchster Dez-Stelle:
                  bf/s 1b                ! sub letzte Stelle vom Zahlenwert
                  sub r0,r6              ! repeat bis alle 10 Stellen done
                bt BOOT_X3204            ! fertig mit Zahl, return via R2


BOOT_SHEXLSTRA: add #0xFF,r6             ! STRING+HEXNUM-OUTPUT:          [3DFC]
                add r6,r0                ! R0 = auszugebende Zahl (+R6-1)
BOOT_SHEXLSTR:  sts pr,r3                ! R5 = Pointer auf Vorspann-Text
                bsr BOOT_SPUTS           ! ---> Text und Zahl werden ausgegeben
                mov r0,r6                !      R0..R4 und R6 werden getrashed
                lds r3,pr                !      R5 wird hinter Text geupdated
                                         !-
BOOT_SHEXLONG:  mov #0x08,r3             ! HEX-NUMBER-OUTPUT:             [3E08]
BOOT_SHEXNUM:   sts pr,r2                ! R6 = auszugebende Zahl
                bsr BOOT_SPUTCH          ! ---> Zahl wird hexadezimal ausgegeben
                mov #0x30,r4             !      R0..R4 werden dabei getrashed
                bsr BOOT_SPUTCH          ! Init R2=Return-Adr und R3=Digit-Count
                mov #0x78,r4             ! dann den festen String "0x" ausgeben
             1:   rotl r6                ! Nchste Hex-Ziffer ausgeben:
                  rotl r6                ! rotate die nchste Stelle nach 0..3
                  rotl r6                ! beginnend mit den 4 hchsten Bits
                  rotl r6                ! fr die erste auszugebende Digit
                  mov r6,r0              ! lese nchste Digit nach R0
                  and #0x0F,r0           ! isoliere deren 4 Daten-Bits
                  mov #0x0A,r1           ! teste ob Wert ber 9 liegt
                  cmp/hs r1,r0           ! denn dann Buchstabe ntig
                  bf 2f                  ! wenn nein dann soweit ok
                    add #0x07,r0         ! fr Buchstaben 7 addieren
             2:   bsr BOOT_SPUTCH0       ! add 0x30 Ascii-Zahlenbasis
                  add #0x30,r0           ! gebe Zahlen-Character aus
                  dt r3                  ! decrement den Digit-Count
                  bf 1b                  ! repeat bis alle Digits done
                bt BOOT_X3204            ! fertig mit Zahl, ret via R2


BOOT_SARRELA:   and r0,r6                ! ARRAY-ELEMENT-OUTPUT:          [3E32]
BOOT_SARREL:      tst r6,r6              ! R5 = Pointer auf Text-Array-Anfang
                  bt BOOT_SPUTS          ! R6 = gewnschte Message {0..NN}
             1:     mov.b @r5+,r0        ! ---> Message-Text wird ausgegeben
                    cmp/pz r0            !      R0..R2,R4,R6 werden getrashed
                    bt 1b                !      R5 wird hinter Text geupdated
                  bra BOOT_SARREL        ! While Msg-- nicht Null String lesen
                  add #0xFF,r6           ! zuletzt den richtigen String ausgeben


BOOT_SMEMSIZE:  tst r6,r6                ! MEMORY-SIZE-OUTPUT:            [3E42]
BOOT_SMEMSIZEX: mova BOOT_K3219,r0       ! R6 = Speicher-Grsse in Bytes
                bt BOOT_SPUTS0           ! ---> Grssen-String wird ausgegeben
                  mov.w BOOT_K3218,r0    !      R0..R5 und R7 werden getrashed
                  xor r1,r1              !      R6 bleibt Null oder wird eins
                  sts.l pr,@-r15         ! Zuerst testen ob Memory-Size Null ist
             1:     tst r0,r6            ! wenn ja String <none> ausgeben, done
                    bf 2f                ! sonst zunchst die Memsize skalieren
                    add #0x01,r1         ! und daraus Kbyte/Mbyte/Gbyte machen
                    shlr8 r6             ! setup BitMask/R0=0x03FF,Exponent/R1=0
                    bra 1b               ! dann testen ob 10 Low-Bits Null sind
                    shlr2 r6             ! wenn nein dann ist Exponent gefunden
             2:   mova BOOT_K3220,r0     ! sonst mache Daten>>=10 und Exponent++
                  bsr BOOT_SDEZLONG      ! repeat Exponent-Loop fr next BitTest
                  mov.b @(r0,r1),r5      ! Lese Ascii-Char fr unseren Exponent
                  bsr BOOT_SPUTCH        ! aber erstmal Zahl dezimal ausgeben
                  mov #0x20,r4           ! gefolgt von einem einzelnen Space
                  tst r5,r5              ! teste ob Exponent=0 gewesen ist
                  bt 3f                  ! dann reine Byte-Zahl ohne Prefix
                    bsr BOOT_SPUTCH      ! fr Kbyte/Mbyte/Gbyte-Zahlen
                    mov r5,r4            ! den Character K/M/G ausgeben
             3:   mova BOOT_K3221,r0     ! Abschliessend festen String
                  mov #0x01,r6           ! mit dem Text "byte" ausgeben
                  lds.l @r15+,pr         ! vorher Return-Adresse zurck
                                         !-
BOOT_SPUTS0:    mov r0,r5                ! STRING-OUTPUT:                 [3E72]
BOOT_SPUTS:     sts pr,r2                ! R5 = Pointer auf String-Text
             1:   bsr BOOT_SPUTCH        ! ---> R0..R2 und R4 werden getrashed
                  mov.b @r5+,r4          !      R5 wird hinter Text geupdated
                  cmp/pz r4              ! Save Ret-Adr in R2, dann in der Loop
                  bt 1b                  ! lese nchsten String-Char, ausgeben
BOOT_X3204:     jmp @r2                  ! repeat bis der Char Bit#7=1 hatte
                nop                      ! return mittels Return-Adr in R2


BOOT_STXEND:    bsr BOOT_SPUTS           ! WARTE_AUF_SIO-TX-ENDE:         [3E82]
                mov r0,r5                ! R5 = Abschluss-Message
                mova BOOT_K3216,r0       ! ---> Message wird ausgegeben
                bsr BOOT_SPUTS0          !      Es wird gewartet bis Tx-Idle
                mov #A_WTCNT,r3          !      Dann wird Signon-Call returned
                mov.l BOOT_K3211,r1      ! Zuerst Abschluss-String ausgeben
                mov.w BOOT_K3215,r2      ! wir werden angejumped, nicht gecalled
             1:   mov.w @(8,r1),r0       ! brauchen daher PR nicht zu erhalten
                  mov.w r2,@r3           ! setup R1=*Scsmr1,R2=0x5A00,R3=*Wtcnt
                  tst #0x40,r0           ! dann auf Tend in Scssr1/Bit#6 warten
                  bt 1b                  ! dabei write 0x5A00-->Wtcnt Count=0x00
                bf BOOT_X3203            ! wenn Tx-Idle return via PR auf Stack


BOOT_SMMUFLAG:  mov.b @r7,r0             ! MMU-FLAG-AUSGABE:              [3E9A]
                sts pr,r3                ! R1 = Bit-Shift fr Mmu-Flag
                shld r1,r0               ! R5 = Text mit Mmu-Flag-Name
                and #0x01,r0             ! R7 = Pointer auf Mmu-Flag-Byte
                bsr BOOT_SPUTS           ! ---> Flag-Name und -Wert ausgegeben
                mov r0,r6                !      R0..R4 und R6 werden getrashed
                mov r6,r0                !      R5 wird hinter Text geupdated
                lds r3,pr                !      R7 mit Flag-Ptr bleibt erhalten
                                         !-
BOOT_SPUTCH0D:  add #0x30,r0             ! CHARACTER-OUTPUT:              [3EAA]
BOOT_SPUTCH0:   mov r0,r4                ! R0/R4 = auszugebendes Zeichen/Digit
BOOT_SPUTCH:    mov.l BOOT_K3211,r1      ! ---> Zeichen wird seriell ausgegeben
             1:   mov.w @(8,r1),r0       !      Watchdog wird wieder beruhigt
                  tst #0x20,r0           !      R0 und R1 werden getrashed
                  bt 1b                  ! Setup R1=*Scsmr1 und R4=Character
                mov r4,r0                ! dann zunchst warten bis Tx-Ready
                and #0x7F,r0             ! um Pc-Cts kmmern wir uns nicht
                mov.b r0,@(6,r1)         ! lese Scssr1 mit Sio#1-Zustand
                mov.w BOOT_K3217,r0      ! teste das Tdfe-Flag in Bit#5
                mov.w r0,@(8,r1)         ! mit Info ob Platz im Tx-Fifo
                mov.w BOOT_K3215,r0      ! loop bis unter 9 Fifo-Bytes
                mov #A_WTCNT,r1          ! write Char&0x7F --> Scsfdr1
                rts                      ! write 0x5A00 --> Wtcnt
                mov.w r0,@r1             ! fertig mit Char-Output

!...............

BOOT_K3211:     .long  A_SCSMR1          ! Basis-Adresse Sio#1/Pc-Sio     [3EC8]
BOOT_K3212:     .long  0x8C00C00C        ! Variablen-Adr Lnge High-Bios-Image
BOOT_K3213:     .long  0x8C01000C        ! Variablen-Adr Lnge System-Image
BOOT_K3214:     .byte  0x0D,0x8A         ! Zeilenende-Text mit Cr,Lf-Ausgabe
BOOT_K3215:     .short 0x5A00            ! Wtcnt-Value fr Count=0x00
BOOT_K3216:     .ascii "..."             ! Abschluss-Text vor Image-Start
                .byte  0xD,0x0A,0x0D,0x8A! drei Punkte und eine Leerzeile
                .byte  0xFF              ! bevor wir Image dann starten
BOOT_K3217:     .short 0x009F            !_Scssr1-Value fr Txchr-Write
BOOT_K3218:     .short 0x03FF            ! Fr Memsize-Ausgabe:
BOOT_K3219:     .ascii " <none"          ! Bit-Maske fr 1K-Stelle
                .byte  '>'+0x80          ! Text fr Null-Memory-Lnge
                .byte  0xFF              ! dann schreiben wir <none>
BOOT_K3220:     .byte  0x00,'K','M','G'  ! Stellen-Grssenprefix
BOOT_K3221:     .ascii "byt"             ! abschliessender Text
                .byte  'e'+0x80          !_nach Zahl und Stelle
BOOT_K3222:     .ascii " (area"          ! Fr Memline-Ausgabe:
                .byte  '#'+0x80          ! Text-Bausteine fr
                .byte  0xFF              ! festen Text in dem
BOOT_K3223:     .ascii "-->"             ! Memory/Area-Namen
                .byte  ' '+0x80          ! der sonst variabelen
BOOT_K3224:     .ascii " of sdra"        ! Liste der Mem-Namen
                .byte  'm'+0x80          ! nach Memory-Name
                .ascii " of epro"        ! und Grssen-Wert
                .byte  'm'+0x80          ! wenn Grsse ber Null
                .ascii " of flash (man"  ! dann 3 mgliche Typen
                .byte  '='+0x80          ! sind Sdram,Eprom,Flash
                .ascii ", dev"           ! bei Flash weiterer Text
                .byte  '='+0x80          ! zur Ausgabe Chip-Code
                .byte  0xFF              !_mit Hersteller und Typ
BOOT_K3225:     .ascii " is"             ! Fr Mmulist-Ausgabe:
                .byte  ' '+0x80          ! Text-Bausteine fr
BOOT_K3226:     .byte '.','.'+0x80       ! Hex-Bereichs-Angaben
BOOT_K3227:     .ascii " (pr"            ! danach Texte fr die
                .byte  '='+0x80          ! Ausgabe der Page-Flags
                .ascii ", sh"            ! zuerst Protection
                .byte  '='+0x80          ! gefolgt von "0"-"3"
                .ascii ", c"             ! danach Flag-Namen
                .byte  '='+0x80          ! fr shared,cachable
                .ascii ", d"             ! dirty sowie size
                .byte  '='+0x80          ! danach kommt jeweils
                .ascii ", sz"            ! eine einzelne Digit
                .byte  '='+0x80          ! im Bereich "0".."1"
                .byte ')',0x0D,0x8A      !_mit dem Flag-Wert
BOOT_K3228:     .ascii " loaded by boot-hook"! Fr Imgline-Ausgabe:
                .byte  's'+0x80          ! Text-Bausteine fr die
                .ascii " found already loade"! Image-Lade-Quellen
                .byte  'd'+0x80          ! fr Highbios und System
                .ascii " loaded from physical address"! es gibt
                .byte  ' '+0x80          !_drei mgliche Quellen
BOOT_K3229:     .ascii "Highbios-ext:"   ! Fr Biglist-Ausgabe:
                .byte  ' '+0x80          ! nach der Mmu-Liste
                .ascii "System-image:"   ! wird Image-Zustand
                .byte  ' '+0x80          ! mit Pointer angezeigt
                .ascii "Base-pointer: Code"! dazu hier die Texte
                .byte  '='+0x80          ! erst zwei Image-Namen
                .ascii ", data"          ! dann Pointer-Vorspann
                .byte  '='+0x80          ! zuletzt Text fr die
                .ascii ", asid"          ! zwei weiteren Zahlen
                .byte  '='+0x80          ! dieser Pointer-Zeile
                .byte  0xD,0x0A,0x0D,0x8A! am Ende der Biglist
                .byte  0xFF,0xFF,0xFF    ! eine Leerzeile dazu
                                         !-
BOOT_K3230:     .long  0x00000001        ! Dezimal-Konstante 1            [3FD4]
                .long  0x0000000A        ! Dezimal-Konstante 10
                .long  0x00000064        ! Dezimal-Konstante 100
                .long  0x000003E8        ! Dezimal-Konstante 1000
                .long  0x00002710        ! Dezimal-Konstante 10000
                .long  0x000186A0        ! Dezimal-Konstante 100000
                .long  0x000F4240        ! Dezimal-Konstante 1000000
                .long  0x00989680        ! Dezimal-Konstante 10000000
                .long  0x05F5E100        ! Dezimal-Konstante 100000000
                .long  0x3B9ACA00        ! Dezimal-Konstante 1000000000
                                                                         ![3FFC]

!*** EOF ***
