! "bootrom.asm", Version 2.01 vom 6.5.1999, (C) Volker Ernst 1999
!  Simple asm source-file to build the boot-rom with startup-code.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.


!******************************************************************************!
!                                                                              !
!                   B    O    O    T      -      R    O    M                   !
!                                                                              !
!******************************************************************************!

!-------------
! ASM-CONTROL
!-------------

.list
.psize 0,132
.title "Harmless little box"
.sbttl "Boot-Rom"

.set VER_MAJ,  0x02
.set VER_MIN,  0x01
.set VER_SPC,  0x80

!--------------
! USER-DEFINES
!--------------

.set SERIALNR, 0xFFFFFFFF                ! Device Serial-Nr (Rom=0xFFFFFFFF)
                                         !-
.set K_FRQCR,  0x0192                    ! Cpu-Freq-Control
.set K_WCR1,   0x1602                    ! Driver-Off-Cycles
.set K_WCR2,   0xB756                    ! Memory-Wait-Cycles
.set K_MCR,    0x5144                    ! SDRAM-Timing-Parameter
.set K_PCR,    0x0055                    ! PCMCIA-Timing-Parameter
.set K_SDMR2,  0xD880                    ! SDRAM/Area#2-ModeReg-Value
.set K_SDMR3,  0xE880                    ! SDRAM/Area#3-ModeReg-Value
.set K_RFSH_H, 0xA531                    ! Rtcor fr Refresh-Rate 5uSec
.set K_RFSH_M, 0xA563                    ! Rtcor fr Refresh-Rate 10uSec
.set K_RFSH_L, 0xA59B                    ! Rtcor fr Refresh-Rate 15.6uSec
                                         !-
.set NEWUBC,   0                         ! UBC-Typ: 0=Sh7709,1=Sh7709a/Sh7729
.set CACHELEN, 512                       ! LineAnz: 512=Sh7709,1024=Sh7709a/7729

!----------
! INCLUDES
!----------

.include "hlbports.inc"

!---------
! PUBLICS
!---------

.global _cpu_killme, _cpu_rescold, _cpu_reswarm, _cpu_standby
.global _cpu_getspeed, _cpu_setspeed, _cpu_wdtclr
.global _mmu_translate, _send_signal
.global _sys_crcblock, _sys_crcbyte

.global _sys_setled, _sys_getled

.global _temic_init, _temic_byteout

.global _flash_erase_chip, _flash_erase_sectors, _flash_program_byte
.global _flash_read_lock, _flash_read_chipid, _flash_read_idmem
.global _flash_read_data

!*******************************************************************************
!###############################################################################
!*******************************************************************************

.section .text,0

!-------------
! CODE-BLOCKS
!-------------

.include "0hwtraps.asm"
.include "1bioslib.asm"
.include "2monitor.asm"
.include "3startup.asm"

.org 0x4000,0xFF


!*** EOF ***
