/* mpz_invert (inv, x, n).  Find multiplicative inverse of X in Z(N).
   If X has an inverse, return non-zero and store inverse in INVERSE,
   otherwise, return 0 and put garbage in X.

Copyright (C) 1996 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Library General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
License for more details.

You should have received a copy of the GNU Library General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. */

#include "gmp.h"


int
#if __STDC__
mpz_invert (mpz_ptr inverse, mpz_srcptr x, mpz_srcptr n)
#else
mpz_invert (inverse, x, n)
     mpz_ptr inverse;
     mpz_srcptr x, n;
#endif
{
/*
  mpz_t gcd;
  int rv;
  
  malloc(1000);
  mpz_init (gcd);
  malloc(1000);
  mpz_gcdext (gcd, inverse, (mpz_ptr) 0, x, n);
  rv = gcd->_mp_size == 1 && (gcd->_mp_d)[0] == 1;
  mpz_clear (gcd);
  return rv;
*/

  mpz_t u, v, u1, u2, u3, v1, v2, v3, q, t1, t2, t3;

malloc(1000);
  mpz_init(u);
malloc(1000);  
  mpz_init(v);
malloc(1000);  
  mpz_init(u1);
malloc(1000);  
  mpz_init(u2);
malloc(1000);  
  mpz_init(u3);
malloc(1000);  
  mpz_init(v1);
malloc(1000);  
  mpz_init(v2);
malloc(1000);  
  mpz_init(v3);
malloc(1000);  
  mpz_init(q);
malloc(1000);  
  mpz_init(t1);
malloc(1000);  
  mpz_init(t2);
malloc(1000);  
  mpz_init(t3);  
malloc(1000);  
  
  mpz_set(u, x);
  mpz_set(v, n);
  mpz_set_ui(u1, 1);
  mpz_set_ui(u2, 0);
  mpz_set(u3, u);
  mpz_set_ui(v1, 0);
  mpz_set_ui(v2, 1);
  mpz_set(v3, v);
  while( mpz_cmp_ui(v3, 0) ) {
  	mpz_fdiv_q(q, u3, v3);
  	mpz_mul(t1, v1, q);
  	mpz_mul(t2, v2, q);
  	mpz_mul(t3, v3, q);
  	mpz_sub(t1, u1, t1);
  	mpz_sub(t2, u2, t2);
  	mpz_sub(t3, u3, t3);
  	mpz_set(u1, v1);
  	mpz_set(u2, v2);
  	mpz_set(u3, v3);
  	mpz_set(v1, t1);
  	mpz_set(v2, t2);
  	mpz_set(v3, t3);
  }
  mpz_set(inverse, u1);
 
  mpz_clear(u1);
  mpz_clear(u2);	 
  mpz_clear(u3);
  mpz_clear(v1);
  mpz_clear(v2);
  mpz_clear(v3);
  mpz_clear(q);
  mpz_clear(t1);
  mpz_clear(t2);
  mpz_clear(t3);
  mpz_clear(u);
  mpz_clear(v); 

}

