
/* Includes for the MD5 hash */
#include "../hash/md5/global.h"
#include "../hash/md5/md5.h"

#include "../gmp-2.0.2/gmp.h"

#define TRUE 1
#define FALSE 0

#include <stdio.h>
#include <string.h>
#include <malloc.h>

/* static local Variables */
MD5_CTX randomseed;

/* external exported Funtions */
void
HLBCryptRandomStart(
	void
) {		/* start the Randomgenerator with generating a new Seed */
	MD5Init(&randomseed);
	
	MD5Update(&randomseed, "h" , 1);
	
}

void
HLBCryptRandomGet(		/* Erzeuge eine neue Zufallszahl */
	unsigned char randombytes[16]	/* OUT 32-Byte random */
) {
	unsigned char hash[16], hash2[16];
	char string[35];		/* room for 128String represented as hex */
	int i;
	
	/* Finalize old MD5 */
	MD5Final(hash, &randomseed);
	
	/* get old MD5 as HexString */
	sprintf(string, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", \
		hash[0], hash[1], hash[2], hash[3],			\
		hash[4], hash[5], hash[6], hash[7],			\
		hash[8], hash[9], hash[10], hash[11],			\
		hash[12], hash[13], hash[14], hash[15]);
		
	/* reinit MD5 */
	MD5Init(&randomseed);
	
	/* make new MD5 with oldasHexString */
	MD5Update(&randomseed, string, strlen(string));
	
	/* Finalize new MD5 */
	MD5Final(hash2, &randomseed);

	/* get new MD5 as HexString */
	sprintf(string, "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x", \
		hash2[0], hash2[1], hash2[2], hash2[3],			\
		hash2[4], hash2[5], hash2[6], hash2[7],			\
		hash2[8], hash2[9], hash2[10], hash2[11],		\
		hash2[12], hash2[13], hash2[14], hash2[15]);
		
	/* reinit MD5 */
	MD5Init(&randomseed);
	
	/* make next MD5 with newasHexString */
	MD5Update(&randomseed, string, strlen(string));	                                               
	                                               
	/* xor old hash with new hash and give back this as random */
	for (i = 0; i <= 15; i++) {
		randombytes[i] = hash[i] ^ hash2[i];
	}
}

long int 
random(void)	/* reimplementation of unix Systemfunction random for gmp-lib */
{
	long int l;

static	unsigned char hash[16];	
static  int offset = 0;	

	if (offset == 0)	/* schon alle alten Hashwerte aufgebraucht also neue holen */
		HLBCryptRandomGet(hash);
	l = hash[offset] + (hash[offset+1]<<8) + (hash[offset+2]<<16) + (hash[offset+3]<<24);
	offset += 4;
	if (offset >= 16)
		offset = 0;	/* alle hashwerte schon fuer Zufall genutzt */
	return(l);
}

int				/* False=wrong Input nothing computed */
HLBCryptRandomGetLarge(
mpz_t rndzahl, 			/* OUT Randomnumber */
int bits)			/* IN Number of Bits must be modulo 128 */
{
	unsigned char hash[16], hashashex[35];
	char *string;
	int turns, i;
	
	if (bits < 128)		return (FALSE);
	if ((bits%128) != 0)	return (FALSE);
	turns = bits / 128;
	string = (char *)malloc( (bits/4) + 5);	
	if (string == NULL) 	return (FALSE);
	string[0] = '\0';
	mpz_init(rndzahl);
	for (i = 1; i <= turns; i++) {
		HLBCryptRandomGet(hash);
		sprintf(hashashex, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", \
			hash[0], hash[1], hash[2], hash[3],			\
			hash[4], hash[5], hash[6], hash[7],			\
			hash[8], hash[9], hash[10], hash[11],			\
			hash[12], hash[13], hash[14], hash[15]);			
		strcat(string, hashashex); /* add to large Number */
	}
	mpz_set_str(rndzahl, string, 16);
	free(string);
	return(TRUE);
}

/*
int main (){
	unsigned char hash[16];
	int i;

	HLBCryptRandomStart();
	for (i = 0; i <= 15; i++) {
	HLBCryptRandomGet(hash);
	printf("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X\n", \
		hash[0], hash[1], hash[2], hash[3],			\
		hash[4], hash[5], hash[6], hash[7],			\
		hash[8], hash[9], hash[10], hash[11],			\
		hash[12], hash[13], hash[14], hash[15]);
	}
}
*/

