#include <stdio.h>
#include <stdlib.h>

#include "hlbtypes.h"
#include "hlbbuffer.h"


HLBBuffer *		/* Zeiger auf die erzeugte Pufferstruktur */
HLBBufferMalloc (
LONG bufLen, 			/* IN */
LONG bufLowMark, 		/* IN */
VOID (*bufLowCall)		/* IN */
) {
	HLBBuffer *buf;

	buf = (HLBBuffer *)malloc(sizeof(HLBBuffer));
	if (buf == NULL) {
		printf("Kein Speicher fuer Pufferallokation da\n");
		exit(1);
	}

	buf->bufferStart = (CHAR *)malloc(bufLen + 2);
	if (buf->bufferStart == NULL) {
		printf("Kein Speicher2 fuer Pufferallokation da\n");
		exit(1);
	}

	buf->bufferEnd = buf->bufferStart;
	buf->bufferBegin = buf->bufferStart;
	buf->bufferLen = bufLen;
	buf->bufferFill = 0L;
	buf->bufferLow = bufLowMark;
	buf->bufferLowFunction = bufLowCall;
	buf->bufferLastGetHitsMargin = FALSE;
	buf->bufferLastGetHitsMarginPtr = NULL;
	return (buf);
}


VOID
HLBBufferFree(
HLBBuffer *buf		/* IN zeiger auf bufferstrucktur */
) {
	free(buf->bufferStart);							/* hau den ringpuffer weg */
	if (buf->bufferLastGetHitsMargin == TRUE) {		/* hat das letzte get einen ueberlaufpuffer erzeugt? */
		free((VOID *)buf->bufferLastGetHitsMarginPtr);
	}
	free(buf);		/* mach dich selber platt */
}


VOID
HLBBufferPut(
HLBBuffer *buf, 	/* IN zeiger auf bufferstrucktur */
CHAR* ptr, 			/* IN zeiger auf anfang der im puffer zu speicherden Bytes */
LONG len			/* IN anzahl der zu speichernden Bytes */
) {
	LONG l;
	CHAR *cptr;
	
	if ((buf->bufferFill + len) > buf->bufferLen) {
		printf("puffer zu voll um neue zu speichern\n");
		exit(1);
	}

	/* uebertragen des eingabepuffers in den Buffer */
	cptr = (CHAR *)buf->bufferEnd;
	for (l = 1; l <= len; l++) {
		*cptr++ = *ptr++;
		if (cptr >= (buf->bufferStart + buf->bufferLen))	/* pufferueberlauf erreicht ? */
			cptr = buf->bufferStart;
	}
	buf->bufferFill += len;
	buf->bufferEnd = cptr;
	
	/* schauen ob soviele Bytes da sind das man was verarbeiten muss */
	while (buf->bufferLowFunction != NULL  &&  buf->bufferFill >= buf->bufferLow) {	/* es sind genuegend Bytes im Puffer um ihn verarbeiten zu koennen */
		l = buf->bufferFill;
		buf->bufferLowFunction((VOID *)buf);
		if (l == buf->bufferFill)
			break; 		/* dem Puffer wurde nichts entnommen */			
	};
}


LONG				/* anzahl der Bytes die zurueckgegeben wurden (0=keine) */
HLBBufferGet(
HLBBuffer *buf, 	/* IN zeiger auf bufferstrucktur */
LONG anzahl, 		/* IN anzahl der Bytes die maximal ausgelesen werden sollen */
CHAR **bufStored	/* OUT zeiger auf den anfang der zurueckgegebenen Bytes */
) {
	LONG l, i;
	CHAR *cptr;

	if (buf->bufferLastGetHitsMargin == TRUE) {		/* hat das letzte get einen ueberlaufpuffer erzeugt? */
		buf->bufferLastGetHitsMargin = FALSE;		/* ja dann mach weg das Ding */
		free((VOID *)buf->bufferLastGetHitsMarginPtr);
	}

	l = anzahl;
	if (buf->bufferFill < anzahl) {
		l = buf->bufferFill;
	}
	
	if ((buf->bufferBegin + l)  >  (buf->bufferStart + buf->bufferLen)) {	/* uebergabepuffer wuerde ueber ende des Puffers liegen */
		buf->bufferLastGetHitsMargin = TRUE;
		cptr = (CHAR *)malloc(l + 2);
		if (cptr == NULL) {
			printf("wrappuffer kann nicht allociert werden\n");
			exit(1);
		}
		buf->bufferLastGetHitsMarginPtr = cptr;
		*bufStored = cptr;
		for (i = 1; i <= l; i++) {
			*cptr++ = *(buf->bufferBegin)++;
			if (buf->bufferBegin >= (buf->bufferStart + buf->bufferLen))	/* pufferueberlauf erreicht ? */
				buf->bufferBegin = buf->bufferStart;
		}
	} else {
		*bufStored = (CHAR *)buf->bufferBegin;
		buf->bufferBegin += l;
	}
	buf->bufferFill -= l;
	return (l);
}




/* testroutinen */
/*

VOID test1(HLBBuffer *buf) {
	CHAR *cptr;
	LONG l, i;
	
	l = HLBBufferGet(buf, 33, &cptr);
    printf("%d=",l);
	for (i = 1; i <= l; i++) {
		printf("%c", *cptr++);
	}		
	printf("\n");
}


int
main() {
	HLBBuffer *testbuf;

	testbuf = HLBBufferMalloc(80, 33, test1);
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);	
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);	
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);
	HLBBufferPut(testbuf, "1234567890", 10);
	HLBBufferPut(testbuf, "abcdefghijklmnopqrstuvwxyz", 26);	
	HLBBufferFree(testbuf);
	return 0;
}

*/

/* EOF */
