/*
  "hlbios.h", Version 2.01 vom 18.7.1999, (C) Volker Ernst 1999
   Simple c include-file to define basic i/o-functions and data.
   Part of the source-files for HLB, the harmless little box.
   Free for non-commercial usage, written by xorrox@gmx.net.
*/

#ifndef _HLBIOS_H
#define _HLBIOS_H

/*-----------------*/
/* BIOS-STRUCTURES */
/*-----------------*/

struct rtctime
{
  unsigned char sec;
  unsigned char min;
  unsigned char hr;
  unsigned char wk;
  unsigned char day;
  unsigned char mon;
};

/*------------------*/
/*  BIOS-FUNCTIONS  */
/*------------------*/

void breakpoint (void);                                               /* 0x00 */
void debugtext (const unsigned char *Text);                           /* 0x01 */

void cpu_killme (unsigned long Data);                                 /* 0x02 */
void cpu_rescold (unsigned long Data);                                /* 0x03 */
void cpu_reswarm (unsigned long Data);                                /* 0x04 */
unsigned long cpu_standby (unsigned long Data, unsigned char PIntMask, \
                           unsigned long MaxTicks, const struct rtctime *Alarm);

unsigned long cpu_getspeed (void);                                    /* 0x06 */
unsigned long cpu_setspeed (unsigned long NewSpeed);                  /* 0x07 */
void cpu_wdtclr (void);                                               /* 0x08 */

unsigned long mmu_translate (const void *Adr, unsigned char Asid);    /* 0x09 */

void send_signal (unsigned char SigNr);                               /* 0x0A */

unsigned long sys_crcblock (unsigned long OldCrc, const void *Data, \
                            unsigned long ByteAnzahl);                /* 0x0E */
unsigned long sys_crcbyte (unsigned long OldCrc, unsigned char Data); /* 0x0F */

unsigned char sys_setled (unsigned char Data);                        /* 0x1E */
unsigned char sys_getled (void);                                      /* 0x1F */

signed long padda_xchg (signed short *SampleData, unsigned long SampleAnz, \
                        unsigned char OpMode);                        /* 0x4F */

signed long temic_init (void);                                        /* 0x5D */
void temic_byteout (unsigned char Data);                              /* 0x5E */

signed long flash_erase_chip (const void *WdtClr, void *Flash);       /* 0x78 */
signed long flash_erase_sectors (const void *WdtClr, unsigned char SektAnz, \
                                 const void *SektorListe);            /* 0x79 */
signed long flash_program_byte (const void *WdtClr, unsigned char *Flash, \
                                unsigned char DataByte);              /* 0x7A */
signed long flash_read_lock (const void *WdtClr, void *Flash);        /* 0x7B */
signed long flash_read_chipid (const void *WdtClr, void *Flash);      /* 0x7C */
signed long flash_read_idmem (const void *WdtClr, unsigned char *Flash);
                                                                      /* 0x7D */
signed long flash_read_data (const void *WdtClr, unsigned char *Flash);
                                                                      /* 0x7E */
/**/

void pcon_putch (unsigned char Data);
unsigned char pcon_getch (void);
unsigned char pcon_kbhit (void);

#endif


/*** EOF ***/
