/*
  "hlbports.h", Version 2.01 vom 29.4.1999, (C) Volker Ernst 1999
   Simple c include-file to define the adresses of i/o-ports.
   Part of the source-files for HLB, the harmless little box.
   Free for non-commercial usage, written by xorrox@gmx.net.
*/

#ifndef _HLBPORTS_H
#define _HLBPORTS_H

/*------------------*/
/*  LO-INTERNE I/O  */
/*------------------*/

#define INTEVT2 (*((volatile unsigned long *)0xA4000000))	/* INT-CTRL */
#define IRR0	(*((volatile unsigned short *)0xA4000004))
#define IRR1	(*((volatile unsigned short *)0xA4000006))
#define IRR2	(*((volatile unsigned short *)0xA4000008))
#define IRR3	(*((volatile unsigned short *)0xA400000A))
#define IRR4	(*((volatile unsigned short *)0xA400000C))
#define ICR1	(*((volatile unsigned short *)0xA4000010))
#define ICR2	(*((volatile unsigned short *)0xA4000012))
#define PINTER	(*((volatile unsigned short *)0xA4000014))
#define IPRC	(*((volatile unsigned short *)0xA4000016))
#define IPRD	(*((volatile unsigned short *)0xA4000018))
#define IPRE	(*((volatile unsigned short *)0xA400001A))

#define SAR0	(*((volatile unsigned long *)0xA4000020))	/* DMA_#0-3 */
#define DAR0	(*((volatile unsigned long *)0xA4000024))
#define DMATCR0 (*((volatile unsigned long *)0xA4000028))
#define CHCR0	(*((volatile unsigned long *)0xA400002C))
#define SAR1	(*((volatile unsigned long *)0xA4000030))
#define DAR1	(*((volatile unsigned long *)0xA4000034))
#define DMATCR1 (*((volatile unsigned long *)0xA4000038))
#define CHCR1	(*((volatile unsigned long *)0xA400003C))
#define SAR2	(*((volatile unsigned long *)0xA4000040))
#define DAR2	(*((volatile unsigned long *)0xA4000044))
#define DMATCR2 (*((volatile unsigned long *)0xA4000048))
#define CHCR2	(*((volatile unsigned long *)0xA400004C))
#define SAR3	(*((volatile unsigned long *)0xA4000050))
#define DAR3	(*((volatile unsigned long *)0xA4000054))
#define DMATCR3 (*((volatile unsigned long *)0xA4000058))
#define CHCR3	(*((volatile unsigned long *)0xA400005C))
#define DMAOR	(*((volatile unsigned short *)0xA4000060))
#define CMSTR	(*((volatile unsigned short *)0xA4000070))
#define CMCSR	(*((volatile unsigned short *)0xA4000072))
#define CMCNT	(*((volatile unsigned short *)0xA4000074))
#define CMCOR	(*((volatile unsigned short *)0xA4000076))

#define ADDRAH	(*((volatile unsigned char *)0xA4000080))	/* A/D,D/A */
#define ADDRAL	(*((volatile unsigned char *)0xA4000082))
#define ADDRBH	(*((volatile unsigned char *)0xA4000084))
#define ADDRBL	(*((volatile unsigned char *)0xA4000086))
#define ADDRCH	(*((volatile unsigned char *)0xA4000088))
#define ADDRCL	(*((volatile unsigned char *)0xA400008A))
#define ADDRDH	(*((volatile unsigned char *)0xA400008C))
#define ADDRDL	(*((volatile unsigned char *)0xA400008E))
#define ADCSR	(*((volatile unsigned char *)0xA4000090))
#define ADCR	(*((volatile unsigned char *)0xA4000092))
#define DADR0	(*((volatile unsigned char *)0xA40000A0))
#define DADR1	(*((volatile unsigned char *)0xA40000A2))
#define DACR	(*((volatile unsigned char *)0xA40000A4))
#define DASTCR	(*((volatile unsigned char *)0xA40000A6)) /* weggefallen */

#define CCR2	(*((volatile unsigned long *)0xA40000B0))	/* CACHE */

#define PACR	(*((volatile unsigned short *)0xA4000100))	/* PIN-CTRL */
#define PBCR	(*((volatile unsigned short *)0xA4000102))
#define PCCR	(*((volatile unsigned short *)0xA4000104))
#define PDCR	(*((volatile unsigned short *)0xA4000106))
#define PECR	(*((volatile unsigned short *)0xA4000108))
#define PFCR	(*((volatile unsigned short *)0xA400010A))
#define PGCR	(*((volatile unsigned short *)0xA400010C))
#define PHCR	(*((volatile unsigned short *)0xA400010E))
#define PJCR	(*((volatile unsigned short *)0xA4000110))
#define PKCR	(*((volatile unsigned short *)0xA4000112))
#define PLCR	(*((volatile unsigned short *)0xA4000114))
#define SCPCR	(*((volatile unsigned short *)0xA4000116))
#define PADR	(*((volatile unsigned char *)0xA4000120))
#define PBDR	(*((volatile unsigned char *)0xA4000122))
#define PCDR	(*((volatile unsigned char *)0xA4000124))
#define PDDR	(*((volatile unsigned char *)0xA4000126))
#define PEDR	(*((volatile unsigned char *)0xA4000128))
#define PFDR	(*((volatile unsigned char *)0xA400012A))
#define PGDR	(*((volatile unsigned char *)0xA400012C))
#define PHDR	(*((volatile unsigned char *)0xA400012E))
#define PJDR	(*((volatile unsigned char *)0xA4000130))
#define PKDR	(*((volatile unsigned char *)0xA4000132))
#define PLDR	(*((volatile unsigned char *)0xA4000134))
#define SCPDR	(*((volatile unsigned char *)0xA4000136))

#define SCSMR1	(*((volatile unsigned char *)0xA4000140))	/* SCIF_#1-2 */
#define SCBRR1	(*((volatile unsigned char *)0xA4000142))
#define SCSCR1	(*((volatile unsigned char *)0xA4000144))
#define SCFTDR1 (*((volatile unsigned char *)0xA4000146))
#define SCSSR1	(*((volatile unsigned short *)0xA4000148))
#define SCFRDR1 (*((volatile unsigned char *)0xA400014A))
#define SCFCR1	(*((volatile unsigned char *)0xA400014C))
#define SCFDR1	(*((volatile unsigned short *)0xA400014E))
#define SCSMR2	(*((volatile unsigned char *)0xA4000150))
#define SCBRR2	(*((volatile unsigned char *)0xA4000152))
#define SCSCR2	(*((volatile unsigned char *)0xA4000154))
#define SCFTDR2 (*((volatile unsigned char *)0xA4000156))
#define SCSSR2	(*((volatile unsigned short *)0xA4000158))
#define SCFRDR2 (*((volatile unsigned char *)0xA400015A))
#define SCFCR2	(*((volatile unsigned char *)0xA400015C))
#define SCFDR2	(*((volatile unsigned short *)0xA400015E))

/*------------------*/
/*  CONTROL-MEMORY  */
/*------------------*/

#define INTRAM	((void *)0x7F000000)				/* 4K-SRAM */

#define XRAM	((void *)0xA5007000)				/* 8K-XRAM */
#define YRAM	((void *)0xA5017000)				/* 8K-YRAM */

#define CACHEA	((volatile unsigned long *)0xF0000000)		/* CACHE */
#define CACHED	((volatile unsigned long *)0xF1000000)

#define SDMR2	((volatile unsigned char *)0xFFFFD000)		/* SDRAM-MODE */
#define SDMR3	((volatile unsigned char *)0xFFFFE000)

/*------------------*/
/*  HI-INTERNE I/O  */
/*------------------*/

#define SCSMR	(*((volatile unsigned char *)0xFFFFFE80))	/* SCI */
#define SCBRR	(*((volatile unsigned char *)0xFFFFFE82))
#define SCSCR	(*((volatile unsigned char *)0xFFFFFE84))
#define SCTDR	(*((volatile unsigned char *)0xFFFFFE86))
#define SCSSR	(*((volatile unsigned char *)0xFFFFFE88))
#define SCRDR	(*((volatile unsigned char *)0xFFFFFE8A))
#define SCSCMR	(*((volatile unsigned char *)0xFFFFFE8C))

#define TOCR	(*((volatile unsigned char *)0xFFFFFE90))	/* TMR_#0-2 */
#define TSTR	(*((volatile unsigned char *)0xFFFFFE92))
#define TCOR0	(*((volatile unsigned long *)0xFFFFFE94))
#define TCNT0	(*((volatile unsigned long *)0xFFFFFE98))
#define TCR0	(*((volatile unsigned short *)0xFFFFFE9C))
#define TCOR1	(*((volatile unsigned long *)0xFFFFFEA0))
#define TCNT1	(*((volatile unsigned long *)0xFFFFFEA4))
#define TCR1	(*((volatile unsigned short *)0xFFFFFEA8))
#define TCOR2	(*((volatile unsigned long *)0xFFFFFEAC))
#define TCNT2	(*((volatile unsigned long *)0xFFFFFEB0))
#define TCR2	(*((volatile unsigned short *)0xFFFFFEB4))
#define TCPR2	(*((volatile unsigned long *)0xFFFFFEB8))

#define R64CNT	(*((volatile unsigned char *)0xFFFFFEC0))	/* RTC */
#define RSECCNT (*((volatile unsigned char *)0xFFFFFEC2))
#define RMINCNT (*((volatile unsigned char *)0xFFFFFEC4))
#define RHRCNT	(*((volatile unsigned char *)0xFFFFFEC6))
#define RWKCNT	(*((volatile unsigned char *)0xFFFFFEC8))
#define RDAYCNT (*((volatile unsigned char *)0xFFFFFECA))
#define RMONCNT (*((volatile unsigned char *)0xFFFFFECC))
#define RYRCNT	(*((volatile unsigned char *)0xFFFFFECE))
#define RSECAR	(*((volatile unsigned char *)0xFFFFFED0))
#define RMINAR	(*((volatile unsigned char *)0xFFFFFED2))
#define RHRAR	(*((volatile unsigned char *)0xFFFFFED4))
#define RWKAR	(*((volatile unsigned char *)0xFFFFFED6))
#define RDAYAR	(*((volatile unsigned char *)0xFFFFFED8))
#define RMONAR	(*((volatile unsigned char *)0xFFFFFEDA))
#define RCR1	(*((volatile unsigned char *)0xFFFFFEDC))
#define RCR2	(*((volatile unsigned char *)0xFFFFFEDE))

#define ICR0	(*((volatile unsigned short *)0xFFFFFEE0))	/* INT-CTRL */
#define IPRA	(*((volatile unsigned short *)0xFFFFFEE2))
#define IPRB	(*((volatile unsigned short *)0xFFFFFEE4))

#define MCSCR0	(*((volatile unsigned short *)0xFFFFFF50))	/* ROM-CTRL */
#define MCSCR1	(*((volatile unsigned short *)0xFFFFFF52))
#define MCSCR2	(*((volatile unsigned short *)0xFFFFFF54))
#define MCSCR3	(*((volatile unsigned short *)0xFFFFFF56))
#define MCSCR4	(*((volatile unsigned short *)0xFFFFFF58))
#define MCSCR5	(*((volatile unsigned short *)0xFFFFFF5A))
#define MCSCR6	(*((volatile unsigned short *)0xFFFFFF5C))
#define MCSCR7	(*((volatile unsigned short *)0xFFFFFF5E))

#define BCR1	(*((volatile unsigned short *)0xFFFFFF60))	/* BUS-CTRL */
#define BCR2	(*((volatile unsigned short *)0xFFFFFF62))
#define WCR1	(*((volatile unsigned short *)0xFFFFFF64))
#define WCR2	(*((volatile unsigned short *)0xFFFFFF66))
#define MCR	(*((volatile unsigned short *)0xFFFFFF68))
#define DCR	(*((volatile unsigned short *)0xFFFFFF6A))
#define PCR	(*((volatile unsigned short *)0xFFFFFF6C))
#define RTCSR	(*((volatile unsigned short *)0xFFFFFF6E))
#define RTCNT	(*((volatile unsigned short *)0xFFFFFF70))
#define RTCOR	(*((volatile unsigned short *)0xFFFFFF72))
#define RFCR	(*((volatile unsigned short *)0xFFFFFF74))
#define BCR3	(*((volatile unsigned short *)0xFFFFFF7E))

#define FRQCR	(*((volatile unsigned short *)0xFFFFFF80))	/* CLOCK-CTRL */
#define STBCR	(*((volatile unsigned char *)0xFFFFFF82))
#define WTCNT	(*((volatile unsigned short *)0xFFFFFF84))
#define WTCSR	(*((volatile unsigned short *)0xFFFFFF86))
#define STBCR2	(*((volatile unsigned char *)0xFFFFFF88))

#define BDRB	(*((volatile unsigned long *)0xFFFFFF90))	/* BREAK-CTRL */
#define BDMRB	(*((volatile unsigned long *)0xFFFFFF94))
#define BRCR	(*((volatile unsigned long *)0xFFFFFF98))
#define BETR	(*((volatile unsigned short *)0xFFFFFF9C))
#define BARB	(*((volatile unsigned long *)0xFFFFFFA0))
#define BAMRB	(*((volatile unsigned long *)0xFFFFFFA4))
#define BBRB	(*((volatile unsigned short *)0xFFFFFFA8))
#define BRSR	(*((volatile unsigned long *)0xFFFFFFAC))
#define BARA	(*((volatile unsigned long *)0xFFFFFFB0))
#define BAMRA	(*((volatile unsigned long *)0xFFFFFFB4))
#define BBRA	(*((volatile unsigned short *)0xFFFFFFB8))
#define BRDR	(*((volatile unsigned long *)0xFFFFFFBC))
#define IOBAR	(*((volatile unsigned long *)0xFFFFFFC0))

#define TRA	(*((volatile unsigned long *)0xFFFFFFD0))	/* EVENTS */
#define EXPEVT	(*((volatile unsigned long *)0xFFFFFFD4))
#define INTEVT	(*((volatile unsigned long *)0xFFFFFFD8))
#define IOBDR	(*((volatile unsigned long *)0xFFFFFFDC))

#define MMUCR	(*((volatile unsigned long *)0xFFFFFFE0))	/* MMU+CACHE */
#define BASRA	(*((volatile unsigned long *)0xFFFFFFE4))
#define BASRB	(*((volatile unsigned long *)0xFFFFFFE8))
#define CCR	(*((volatile unsigned long *)0xFFFFFFEC))
#define PTEH	(*((volatile unsigned long *)0xFFFFFFF0))
#define PTEL	(*((volatile unsigned long *)0xFFFFFFF4))
#define TTB	(*((volatile unsigned long *)0xFFFFFFF8))
#define TEA	(*((volatile unsigned long *)0xFFFFFFFC))

/*---------------*/
/*  EXTERNE I/O	 */
/*---------------*/

#define LANDMA	((volatile unsigned short *)0xB4000000)		/* ETHERNET */
#define LANIO	((volatile unsigned short *)0xB8000300)
#define LANRAM	((volatile unsigned short *)0xBA000000)
#define LANROM	((volatile unsigned short *)0xBB000000)

#endif


/*** EOF ***/
