! "hlbports.inc", Version 2.01 vom 29.4.1999, (C) Volker Ernst 1999
!  Simple asm include-file to define the adresses of i/o-ports.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.

!----------------
! LO-INTERNE I/O
!----------------

.set A_INTEVT2, 0xA4000000		! INT-CTRL
.set A_IRR0,	0xA4000004
.set A_IRR1,	0xA4000006
.set A_IRR2,	0xA4000008
.set A_IRR3,	0xA400000A
.set A_IRR4,	0xA400000C
.set A_ICR1,	0xA4000010
.set A_ICR2,	0xA4000012
.set A_PINTER,	0xA4000014
.set A_IPRC,	0xA4000016
.set A_IPRD,	0xA4000018
.set A_IPRE,	0xA400001A

.set A_SAR0,	0xA4000020		! DMA_#0-3
.set A_DAR0,	0xA4000024
.set A_DMATCR0, 0xA4000028
.set A_CHCR0,	0xA400002C
.set A_SAR1,	0xA4000030
.set A_DAR1,	0xA4000034
.set A_DMATCR1, 0xA4000038
.set A_CHCR1,	0xA400003C
.set A_SAR2,	0xA4000040
.set A_DAR2,	0xA4000044
.set A_DMATCR2, 0xA4000048
.set A_CHCR2,	0xA400004C
.set A_SAR3,	0xA4000050
.set A_DAR3,	0xA4000054
.set A_DMATCR3, 0xA4000058
.set A_CHCR3,	0xA400005C
.set A_DMAOR,	0xA4000060
.set A_CMSTR,	0xA4000070
.set A_CMCSR,	0xA4000072
.set A_CMCNT,	0xA4000074
.set A_CMCOR,	0xA4000076

.set A_ADDRAH,	0xA4000080		! A/D,D/A
.set A_ADDRAL,	0xA4000082
.set A_ADDRBH,	0xA4000084
.set A_ADDRBL,	0xA4000086
.set A_ADDRCH,	0xA4000088
.set A_ADDRCL,	0xA400008A
.set A_ADDRDH,	0xA400008C
.set A_ADDRDL,	0xA400008E
.set A_ADCSR,	0xA4000090
.set A_ADCR,	0xA4000092
.set A_DADR0,	0xA40000A0
.set A_DADR1,	0xA40000A2
.set A_DACR,	0xA40000A4
.set A_DASTCR,	0xA40000A6 ! weggefallen

.set A_CCR2,	0xA40000B0		! CACHE

.set A_PACR,	0xA4000100		! PIN-CTRL
.set A_PBCR,	0xA4000102
.set A_PCCR,	0xA4000104
.set A_PDCR,	0xA4000106
.set A_PECR,	0xA4000108
.set A_PFCR,	0xA400010A
.set A_PGCR,	0xA400010C
.set A_PHCR,	0xA400010E
.set A_PJCR,	0xA4000110
.set A_PKCR,	0xA4000112
.set A_PLCR,	0xA4000114
.set A_SCPCR,	0xA4000116
.set A_PADR,	0xA4000120
.set A_PBDR,	0xA4000122
.set A_PCDR,	0xA4000124
.set A_PDDR,	0xA4000126
.set A_PEDR,	0xA4000128
.set A_PFDR,	0xA400012A
.set A_PGDR,	0xA400012C
.set A_PHDR,	0xA400012E
.set A_PJDR,	0xA4000130
.set A_PKDR,	0xA4000132
.set A_PLDR,	0xA4000134
.set A_SCPDR,	0xA4000136

.set A_SCSMR1,	0xA4000140		! SCIF_#1-2
.set A_SCBRR1,	0xA4000142
.set A_SCSCR1,	0xA4000144
.set A_SCFTDR1, 0xA4000146
.set A_SCSSR1,	0xA4000148
.set A_SCFRDR1, 0xA400014A
.set A_SCFCR1,	0xA400014C
.set A_SCFDR1,	0xA400014E
.set A_SCSMR2,	0xA4000150
.set A_SCBRR2,	0xA4000152
.set A_SCSCR2,	0xA4000154
.set A_SCFTDR2, 0xA4000156
.set A_SCSSR2,	0xA4000158
.set A_SCFRDR2, 0xA400015A
.set A_SCFCR2,	0xA400015C
.set A_SCFDR2,	0xA400015E

!----------------
! CONTROL-MEMORY
!----------------

.set A_INTRAM,	0x7F000000		! 4K-SRAM

.set A_XRAM,	0xA5007000		! 8K-XRAM
.set A_YRAM,	0xA5017000		! 8K-YRAM

.set A_CACHEA,	0xF0000000		! CACHE
.set A_CACHED,	0xF1000000

.set A_SDMR2,	0xFFFFD000		! SDRAM-MODE
.set A_SDMR3,	0xFFFFE000

!----------------
! HI-INTERNE I/O
!----------------

.set A_SCSMR,	0xFFFFFE80		! SCI
.set A_SCBRR,	0xFFFFFE82
.set A_SCSCR,	0xFFFFFE84
.set A_SCTDR,	0xFFFFFE86
.set A_SCSSR,	0xFFFFFE88
.set A_SCRDR,	0xFFFFFE8A
.set A_SCSCMR,	0xFFFFFE8C

.set A_TOCR,	0xFFFFFE90		! TMR_#0-2
.set A_TSTR,	0xFFFFFE92
.set A_TCOR0,	0xFFFFFE94
.set A_TCNT0,	0xFFFFFE98
.set A_TCR0,	0xFFFFFE9C
.set A_TCOR1,	0xFFFFFEA0
.set A_TCNT1,	0xFFFFFEA4
.set A_TCR1,	0xFFFFFEA8
.set A_TCOR2,	0xFFFFFEAC
.set A_TCNT2,	0xFFFFFEB0
.set A_TCR2,	0xFFFFFEB4
.set A_TCPR2,	0xFFFFFEB8

.set A_R64CNT,	0xFFFFFEC0		! RTC
.set A_RSECCNT, 0xFFFFFEC2
.set A_RMINCNT, 0xFFFFFEC4
.set A_RHRCNT,	0xFFFFFEC6
.set A_RWKCNT,	0xFFFFFEC8
.set A_RDAYCNT, 0xFFFFFECA
.set A_RMONCNT, 0xFFFFFECC
.set A_RYRCNT,	0xFFFFFECE
.set A_RSECAR,	0xFFFFFED0
.set A_RMINAR,	0xFFFFFED2
.set A_RHRAR,	0xFFFFFED4
.set A_RWKAR,	0xFFFFFED6
.set A_RDAYAR,	0xFFFFFED8
.set A_RMONAR,	0xFFFFFEDA
.set A_RCR1,	0xFFFFFEDC
.set A_RCR2,	0xFFFFFEDE

.set A_ICR0,	0xFFFFFEE0		! INT-CTRL
.set A_IPRA,	0xFFFFFEE2
.set A_IPRB,	0xFFFFFEE4

.set A_MCSCR0,	0xFFFFFF50		! ROM-CTRL
.set A_MCSCR1,	0xFFFFFF52
.set A_MCSCR2,	0xFFFFFF54
.set A_MCSCR3,	0xFFFFFF56
.set A_MCSCR4,	0xFFFFFF58
.set A_MCSCR5,	0xFFFFFF5A
.set A_MCSCR6,	0xFFFFFF5C
.set A_MCSCR7,	0xFFFFFF5E

.set A_BCR1,	0xFFFFFF60		! BUS-CTRL
.set A_BCR2,	0xFFFFFF62
.set A_WCR1,	0xFFFFFF64
.set A_WCR2,	0xFFFFFF66
.set A_MCR,	0xFFFFFF68
.set A_DCR,	0xFFFFFF6A
.set A_PCR,	0xFFFFFF6C
.set A_RTCSR,	0xFFFFFF6E
.set A_RTCNT,	0xFFFFFF70
.set A_RTCOR,	0xFFFFFF72
.set A_RFCR,	0xFFFFFF74
.set A_BCR3,	0xFFFFFF7E

.set A_FRQCR,	0xFFFFFF80		! CLOCK-CTRL
.set A_STBCR,	0xFFFFFF82
.set A_WTCNT,	0xFFFFFF84
.set A_WTCSR,	0xFFFFFF86
.set A_STBCR2,	0xFFFFFF88

.set A_BDRB,	0xFFFFFF90		! BREAK-CTRL
.set A_BDMRB,	0xFFFFFF94
.set A_BRCR,	0xFFFFFF98
.set A_BETR,	0xFFFFFF9C
.set A_BARB,	0xFFFFFFA0
.set A_BAMRB,	0xFFFFFFA4
.set A_BBRB,	0xFFFFFFA8
.set A_BRSR,	0xFFFFFFAC
.set A_BARA,	0xFFFFFFB0
.set A_BAMRA,	0xFFFFFFB4
.set A_BBRA,	0xFFFFFFB8
.set A_BRDR,	0xFFFFFFBC
.set A_IOBAR,	0xFFFFFFC0

.set A_TRA,	0xFFFFFFD0		! EVENTS
.set A_EXPEVT,	0xFFFFFFD4
.set A_INTEVT,	0xFFFFFFD8
.set A_IOBDR,	0xFFFFFFDC

.set A_MMUCR,	0xFFFFFFE0		! MMU+CACHE
.set A_BASRA,	0xFFFFFFE4
.set A_BASRB,	0xFFFFFFE8
.set A_CCR,	0xFFFFFFEC
.set A_PTEH,	0xFFFFFFF0
.set A_PTEL,	0xFFFFFFF4
.set A_TTB,	0xFFFFFFF8
.set A_TEA,	0xFFFFFFFC

!-------------
! EXTERNE I/O
!-------------

.set A_LANDMA,	0xB4000000		! ETHERNET
.set A_LANIO,	0xB8000300
.set A_LANRAM,	0xBA000000
.set A_LANROM,	0xBB000000


!*** EOF ***
