! "sysglue.asm", Version 2.01 vom 18.7.1999, (C) Volker Ernst 1999
!  Simple asm source-file to build the system's startup-code.
!  Part of the source-files for HLB, the harmless little box.
!  Free for non-commercial usage, written by xorrox@gmx.net.


!******************************************************************************!
!                                                                              !
!                   S    Y    S      -      G    L    U    E                   !
!                                                                              !
!******************************************************************************!

!-------------
! ASM-CONTROL
!-------------

.list
.psize 0,132
.title "Harmless little box"
.sbttl "Syscode-Glue"

!----------
! INCLUDES
!----------

.include "hlbports.inc"

!---------
! PUBLICS
!---------

.global _breakpoint, _debugtext

.global _cpu_killme, _cpu_rescold, _cpu_reswarm, _cpu_standby
.global _cpu_getspeed, _cpu_setspeed, _cpu_wdtclr
.global _mmu_translate, _send_signal
.global _sys_crcblock, _sys_crcbyte

.global _sys_setled, _sys_getled

.global _padda_xchg

.global _temic_init, _temic_byteout

.global _flash_erase_chip, _flash_erase_sectors, _flash_program_byte
.global _flash_read_lock, _flash_read_chipid, _flash_read_idmem
.global _flash_read_data

.global _pcon_putch, _pcon_getch, _pcon_kbhit

!*******************************************************************************
!###############################################################################
!*******************************************************************************

.section .text,0

!----------------
! PROGRAM-HEADER
!----------------

                .ascii "HLSYSTEM"        ! Program-/File-Name             [0000]
                .byte  0x00,0x00,0x01    ! Record-Write-Count
                .byte  0x53              ! Record-Infotyp "S"
                .long  0x0001C000        ! Record-Gesamtlnge
                .long  0x19990429        ! Record-Datum
                .long  0x18300000        ! Record-Time
                .long  0xFFFFFFFF        ! <reserviert>
                .long  0xFFFFFFFF        ! <reserviert>
                                         !-
                .long  0x8C010000        ! Programm-Code, Lade-Adresse    [0020]
                .long  _main             ! Programm-Code, 'C'-Startpunkt
                .long  _mdata            ! initialisierte Daten, Lese-Adr
                .long  _data             ! initialisierte Daten, Start-Adr
                .long  _edata            ! initialisierte Daten, Ende-Adr
                .long  _bss              ! genullte Daten, Start-Adr
                .long  _ebss             ! genullte Daten, Ende-Adr
                .long  0x8C400000        ! Stack-Pointer beim Start

!-------------
! ENTRY-POINT
!-------------

                mova 1f,r0               ! **** SYSTEM-ENTRY-POINT ****   [0040]
                add #0xBC,r0             ! hierhin springt der Boot-Loader
             1: mov.l @(0x3C,r0),r15     ! Init R0=*Syscode (typ 0x8C010000)
                mov r0,r7                ! setze Stack-Pointer wie im Header
                mov.l @(0x30,r7),r3      ! Initialisiere Daten-Segment:
                mov.l @(0x2C,r7),r2      ! init R1=*mdata,R2=*data,R3=*edata
                mov.l @(0x28,r7),r1      ! dann Daten als Long-Words kopieren
             2:   cmp/hs r3,r2           ! teste ob data>=edata geworden ist
                  bt 3f                  ! wenn ja sind wir fertig mit Daten
                  mov.l @r1+,r0          ! nchstes Long aus mdata++ lesen
                  mov.l r0,@r2           ! nchstes Long nach data++ schreiben
                  bra 2b                 ! update Pointer mdata/data durch +=4
                  add #0x04,r2           ! weiter mit Test ob fertig mit Daten
             3: mov.l @(0x38,r7),r2      ! Initialisiere Bss-Segment:
                mov.l @(0x34,r7),r1      ! init R0=0x00000000,R1=*bss,R2=*ebss
                xor r0,r0                ! dann Nullen als Long-Words schreiben
             4:   cmp/hs r2,r1           ! teste ob bss>=ebss geworden ist
                  bt 5f                  ! wenn ja sind wir fertig mit Bss
                  mov.l r0,@r1           ! nchstes Long nach bss++ schreiben
                  bra 4b                 ! update Pointer bss in R1 durch +=4
                  add #0x04,r1           ! weiter mit Test ob fertig mit Bss
             5: mov.l @(0x24,r7),r0      ! Starte 'C'-Main-Funktion:
                jmp @r0                  ! lese *main aus Header nach R0
                mov #0x01,r6             ! main-jump,R4/R5=<Args>,R6=1,R7=*code

!------------------
! IO-LIB-INTERFACE
!------------------

_breakpoint:    bra SYS_TRAPSIM          ! 00 - DEBUGGER/MONITOR-AUFRUF:  [0070]
                xor r0,r0                ! void breakpoint (void)
                                         !-
_debugtext:     bra SYS_TRAPSIM          ! 01 - DEBUGGER/INFO-AUSGEBEN:   [0074]
                mov #0x01,r0             ! void debugtext (const u_char *Text)
                                         !=
_cpu_killme:    bra SYS_TRAPCALL         ! 02 - PROGRAMM-ENDE:            [0078]
                mov #0x02,r0             ! void cpu_killme (unsigned long Data)
                                         !-
_cpu_rescold:   bra SYS_TRAPCALL         ! 03 - POWER-ON-RESET:           [007C]
                mov #0x03,r0             ! void cpu_rescold (unsigned long Data)
                                         !-
_cpu_reswarm:   bra SYS_TRAPCALL         ! 04 - MANUAL-RESET:             [0080]
                mov #0x04,r0             ! void cpu_reswarm (unsigned long Data)
                                         !-
_cpu_standby:   bra SYS_TRAPCALL         ! 05 - STANDBY-MODE:             [0084]
                mov #0x05,r0             ! unsigned long cpu_standby (...)
                                         !-
_cpu_getspeed:  bra SYS_TRAPCALL         ! 06 - CPU-SPEED_LESEN:          [0088]
                mov #0x06,r0             ! unsigned long cpu_getspeed (void)
                                         !-
_cpu_setspeed:  bra SYS_TRAPCALL         ! 07 - CPU-SPEED_SETZEN:         [008C]
                mov #0x07,r0             ! unsigned long cpu_setspeed (ulong S)
                                         !-
_cpu_wdtclr:    bra SYS_TRAPCALL         ! 08 - WATCHDOG_BERUHIGEN:       [0090]
                mov #0x08,r0             ! void cpu_wdtclr (void)
                                         !-
_mmu_translate: bra SYS_TRAPCALL         ! 09 - VIRT-ADR_BERSETZEN:      [0094]
                mov #0x09,r0             ! unsigned long mmu_translate (...)
                                         !-
_send_signal:   bra SYS_TRAPCALL         ! 0A - SENDE_SHEDULER-SIGNAL:    [0098]
                mov #0x0A,r0             ! void send_signal (unsigned char Sig)
                                         !-
__trap_0b:      bra SYS_TRAPCALL         ! 0B - <unused>                  [009C]
                mov #0x0B,r0             ! fr Erweiterungen
                                         !-
__trap_0c:      bra SYS_TRAPCALL         ! 0C - <unused>                  [00A0]
                mov #0x0C,r0             ! fr Erweiterungen
                                         !-
__trap_0d:      bra SYS_TRAPCALL         ! 0D - <unused>                  [00A4]
                mov #0x0D,r0             ! fr Erweiterungen
                                         !-
_sys_crcblock:  bra SYS_TRAPCALL         ! 0E - CRC-SUMME_BLOCK-UPDATE:   [00A8]
                mov #0x0E,r0             ! unsigned long sys_crcblock (...)
                                         !-
_sys_crcbyte:   bra SYS_TRAPCALL         ! 0F - CRC-SUMME_BYTE-UPDATE:    [00AC]
                mov #0x0F,r0             ! unsigned long sys_crcbyte (...)
                                         !=
__trap_10:      bra SYS_TRAPCALL         ! 10 - <unused>                  [00B0]
                mov #0x10,r0             ! fr Erweiterungen
                                         !-
__trap_11:      bra SYS_TRAPCALL         ! 11 - <unused>                  [00B4]
                mov #0x11,r0             ! fr Erweiterungen
                                         !-
__trap_12:      bra SYS_TRAPCALL         ! 12 - <unused>                  [00B8]
                mov #0x12,r0             ! fr Erweiterungen
                                         !-
__trap_13:      bra SYS_TRAPCALL         ! 13 - <unused>                  [00BC]
                mov #0x13,r0             ! fr Erweiterungen
                                         !-
__trap_14:      bra SYS_TRAPCALL         ! 14 - <unused>                  [00C0]
                mov #0x14,r0             ! fr Erweiterungen
                                         !-
__trap_15:      bra SYS_TRAPCALL         ! 15 - <unused>                  [00C4]
                mov #0x15,r0             ! fr Erweiterungen
                                         !-
__trap_16:      bra SYS_TRAPCALL         ! 16 - <unused>                  [00C8]
                mov #0x16,r0             ! fr Erweiterungen
                                         !-
__trap_17:      bra SYS_TRAPCALL         ! 17 - <unused>                  [00CC]
                mov #0x17,r0             ! fr Erweiterungen
                                         !-
__trap_18:      bra SYS_TRAPCALL         ! 18 - <unused>                  [00D0]
                mov #0x18,r0             ! fr Erweiterungen
                                         !-
__trap_19:      bra SYS_TRAPCALL         ! 19 - <unused>                  [00D4]
                mov #0x19,r0             ! fr Erweiterungen
                                         !-
__trap_1a:      bra SYS_TRAPCALL         ! 1A - <unused>                  [00D8]
                mov #0x1A,r0             ! fr Erweiterungen
                                         !-
__trap_1b:      bra SYS_TRAPCALL         ! 1B - <unused>                  [00DC]
                mov #0x1B,r0             ! fr Erweiterungen
                                         !-
__trap_1c:      bra SYS_TRAPCALL         ! 1C - <unused>                  [00E0]
                mov #0x1C,r0             ! fr Erweiterungen
                                         !-
__trap_1d:      bra SYS_TRAPCALL         ! 1D - <unused>                  [00E4]
                mov #0x1D,r0             ! fr Erweiterungen
                                         !=
_sys_setled:    bra SYS_TRAPCALL         ! 1E - SETZE_LED-OUTPUT:         [00E8]
                mov #0x1E,r0             ! u_char sys_setled (unsigned char Val)
                                         !-
_sys_getled:    bra SYS_TRAPCALL         ! 1F - LESE_LED-OUTPUT:          [00EC]
                mov #0x1F,r0             ! unsigned char sys_getled (void)
                                         !=
__trap_20:      bra SYS_TRAPCALL         ! 20 - <unused>                  [00F0]
                mov #0x20,r0             ! fr Erweiterungen
                                         !-
__trap_21:      bra SYS_TRAPCALL         ! 21 - <unused>                  [00F4]
                mov #0x21,r0             ! fr Erweiterungen
                                         !-
__trap_22:      bra SYS_TRAPCALL         ! 22 - <unused>                  [00F8]
                mov #0x22,r0             ! fr Erweiterungen
                                         !-
__trap_23:      bra SYS_TRAPCALL         ! 23 - <unused>                  [00FC]
                mov #0x23,r0             ! fr Erweiterungen
                                         !-
__trap_24:      bra SYS_TRAPCALL         ! 24 - <unused>                  [0100]
                mov #0x24,r0             ! fr Erweiterungen
                                         !-
__trap_25:      bra SYS_TRAPCALL         ! 25 - <unused>                  [0104]
                mov #0x25,r0             ! fr Erweiterungen
                                         !-
__trap_26:      bra SYS_TRAPCALL         ! 26 - <unused>                  [0108]
                mov #0x26,r0             ! fr Erweiterungen
                                         !-
__trap_27:      bra SYS_TRAPCALL         ! 27 - <unused>                  [010C]
                mov #0x27,r0             ! fr Erweiterungen
                                         !-
__trap_28:      bra SYS_TRAPCALL         ! 28 - <unused>                  [0110]
                mov #0x28,r0             ! fr Erweiterungen
                                         !-
__trap_29:      bra SYS_TRAPCALL         ! 29 - <unused>                  [0114]
                mov #0x29,r0             ! fr Erweiterungen
                                         !-
__trap_2a:      bra SYS_TRAPCALL         ! 2A - <unused>                  [0118]
                mov #0x2A,r0             ! fr Erweiterungen
                                         !-
__trap_2b:      bra SYS_TRAPCALL         ! 2B - <unused>                  [011C]
                mov #0x2B,r0             ! fr Erweiterungen
                                         !-
__trap_2c:      bra SYS_TRAPCALL         ! 2C - <unused>                  [0120]
                mov #0x2C,r0             ! fr Erweiterungen
                                         !-
__trap_2d:      bra SYS_TRAPCALL         ! 2D - <unused>                  [0124]
                mov #0x2D,r0             ! fr Erweiterungen
                                         !-
__trap_2e:      bra SYS_TRAPCALL         ! 2E - <unused>                  [0128]
                mov #0x2E,r0             ! fr Erweiterungen
                                         !-
__trap_2f:      bra SYS_TRAPCALL         ! 2F - <unused>                  [012C]
                mov #0x2F,r0             ! fr Erweiterungen
                                         !=
__trap_30:      bra SYS_TRAPCALL         ! 30 - <unused>                  [0130]
                mov #0x30,r0             ! fr Erweiterungen
                                         !-
__trap_31:      bra SYS_TRAPCALL         ! 31 - <unused>                  [0134]
                mov #0x31,r0             ! fr Erweiterungen
                                         !-
__trap_32:      bra SYS_TRAPCALL         ! 32 - <unused>                  [0138]
                mov #0x32,r0             ! fr Erweiterungen
                                         !-
__trap_33:      bra SYS_TRAPCALL         ! 33 - <unused>                  [013C]
                mov #0x33,r0             ! fr Erweiterungen
                                         !-
__trap_34:      bra SYS_TRAPCALL         ! 34 - <unused>                  [0140]
                mov #0x34,r0             ! fr Erweiterungen
                                         !-
__trap_35:      bra SYS_TRAPCALL         ! 35 - <unused>                  [0144]
                mov #0x35,r0             ! fr Erweiterungen
                                         !-
__trap_36:      bra SYS_TRAPCALL         ! 36 - <unused>                  [0148]
                mov #0x36,r0             ! fr Erweiterungen
                                         !-
__trap_37:      bra SYS_TRAPCALL         ! 37 - <unused>                  [014C]
                mov #0x37,r0             ! fr Erweiterungen
                                         !-
__trap_38:      bra SYS_TRAPCALL         ! 38 - <unused>                  [0150]
                mov #0x38,r0             ! fr Erweiterungen
                                         !-
__trap_39:      bra SYS_TRAPCALL         ! 39 - <unused>                  [0154]
                mov #0x39,r0             ! fr Erweiterungen
                                         !-
__trap_3a:      bra SYS_TRAPCALL         ! 3A - <unused>                  [0158]
                mov #0x3A,r0             ! fr Erweiterungen
                                         !-
__trap_3b:      bra SYS_TRAPCALL         ! 3B - <unused>                  [015C]
                mov #0x3B,r0             ! fr Erweiterungen
                                         !-
__trap_3c:      bra SYS_TRAPCALL         ! 3C - <unused>                  [0160]
                mov #0x3C,r0             ! fr Erweiterungen
                                         !-
__trap_3d:      bra SYS_TRAPCALL         ! 3D - <unused>                  [0164]
                mov #0x3D,r0             ! fr Erweiterungen
                                         !-
__trap_3e:      bra SYS_TRAPCALL         ! 3E - <unused>                  [0168]
                mov #0x3E,r0             ! fr Erweiterungen
                                         !-
__trap_3f:      bra SYS_TRAPCALL         ! 3F - <unused>                  [016C]
                mov #0x3F,r0             ! fr Erweiterungen
                                         !=
__trap_40:      bra SYS_TRAPCALL         ! 40 - <unused>                  [0170]
                mov #0x40,r0             ! fr Erweiterungen
                                         !-
__trap_41:      bra SYS_TRAPCALL         ! 41 - <unused>                  [0174]
                mov #0x41,r0             ! fr Erweiterungen
                                         !-
__trap_42:      bra SYS_TRAPCALL         ! 42 - <unused>                  [0178]
                mov #0x42,r0             ! fr Erweiterungen
                                         !-
__trap_43:      bra SYS_TRAPCALL         ! 43 - <unused>                  [017C]
                mov #0x43,r0             ! fr Erweiterungen
                                         !-
__trap_44:      bra SYS_TRAPCALL         ! 44 - <unused>                  [0180]
                mov #0x44,r0             ! fr Erweiterungen
                                         !-
__trap_45:      bra SYS_TRAPCALL         ! 45 - <unused>                  [0184]
                mov #0x45,r0             ! fr Erweiterungen
                                         !-
__trap_46:      bra SYS_TRAPCALL         ! 46 - <unused>                  [0188]
                mov #0x46,r0             ! fr Erweiterungen
                                         !-
__trap_47:      bra SYS_TRAPCALL         ! 47 - <unused>                  [018C]
                mov #0x47,r0             ! fr Erweiterungen
                                         !-
__trap_48:      bra SYS_TRAPCALL         ! 48 - <unused>                  [0190]
                mov #0x48,r0             ! fr Erweiterungen
                                         !-
__trap_49:      bra SYS_TRAPCALL         ! 49 - <unused>                  [0194]
                mov #0x49,r0             ! fr Erweiterungen
                                         !-
__trap_4a:      bra SYS_TRAPCALL         ! 4A - <unused>                  [0198]
                mov #0x4A,r0             ! fr Erweiterungen
                                         !-
__trap_4b:      bra SYS_TRAPCALL         ! 4B - <unused>                  [019C]
                mov #0x4B,r0             ! fr Erweiterungen
                                         !-
__trap_4c:      bra SYS_TRAPCALL         ! 4C - <unused>                  [01A0]
                mov #0x4C,r0             ! fr Erweiterungen
                                         !-
__trap_4d:      bra SYS_TRAPCALL         ! 4D - <unused>                  [01A4]
                mov #0x4D,r0             ! fr Erweiterungen
                                         !-
__trap_4e:      bra SYS_TRAPCALL         ! 4E - <unused>                  [01A8]
                mov #0x4E,r0             ! fr Erweiterungen
                                         !-
_padda_xchg:    bra SYS_TRAPCALL         ! 4F - POLLED_AUDIO-EXCHANGE:    [01AC]
                mov #0x4F,r0             ! signed long padda_xchg (...)
                                         !=
__trap_50:      bra SYS_TRAPCALL         ! 50 - <unused>                  [01B0]
                mov #0x50,r0             ! fr Erweiterungen
                                         !-
__trap_51:      bra SYS_TRAPCALL         ! 51 - <unused>                  [01B4]
                mov #0x51,r0             ! fr Erweiterungen
                                         !-
__trap_52:      bra SYS_TRAPCALL         ! 52 - <unused>                  [01B8]
                mov #0x52,r0             ! fr Erweiterungen
                                         !-
__trap_53:      bra SYS_TRAPCALL         ! 53 - <unused>                  [01BC]
                mov #0x53,r0             ! fr Erweiterungen
                                         !-
__trap_54:      bra SYS_TRAPCALL         ! 54 - <unused>                  [01C0]
                mov #0x54,r0             ! fr Erweiterungen
                                         !-
__trap_55:      bra SYS_TRAPCALL         ! 55 - <unused>                  [01C4]
                mov #0x55,r0             ! fr Erweiterungen
                                         !-
__trap_56:      bra SYS_TRAPCALL         ! 56 - <unused>                  [01C8]
                mov #0x56,r0             ! fr Erweiterungen
                                         !-
__trap_57:      bra SYS_TRAPCALL         ! 57 - <unused>                  [01CC]
                mov #0x57,r0             ! fr Erweiterungen
                                         !-
__trap_58:      bra SYS_TRAPCALL         ! 58 - <unused>                  [01D0]
                mov #0x58,r0             ! fr Erweiterungen
                                         !-
__trap_59:      bra SYS_TRAPCALL         ! 59 - <unused>                  [01D4]
                mov #0x59,r0             ! fr Erweiterungen
                                         !-
__trap_5a:      bra SYS_TRAPCALL         ! 5A - <unused>                  [01D8]
                mov #0x5A,r0             ! fr Erweiterungen
                                         !-
__trap_5b:      bra SYS_TRAPCALL         ! 5B - <unused>                  [01DC]
                mov #0x5B,r0             ! fr Erweiterungen
                                         !-
__trap_5c:      bra SYS_TRAPCALL         ! 5C - <unused>                  [01E0]
                mov #0x5C,r0             ! fr Erweiterungen
                                         !=
_temic_init:    bra SYS_TRAPCALL         ! 5D - TEMIC_INITIALISIEREN:     [01E4]
                mov #0x5D,r0             ! signed long temic_init (void)
                                         !-
_temic_byteout: bra SYS_TRAPCALL         ! 5E - CONTROL-BYTE_AN_TEMIC:    [01E8]
                mov #0x5E,r0             ! void temic_byteout (unsigned char N)
                                         !=
__trap_5f:      bra SYS_TRAPCALL         ! 5F - <unused>                  [01EC]
                mov #0x5F,r0             ! fr Erweiterungen
                                         !=
__trap_60:      bra SYS_TRAPCALL         ! 60 - <unused>                  [01F0]
                mov #0x60,r0             ! fr Erweiterungen
                                         !-
__trap_61:      bra SYS_TRAPCALL         ! 61 - <unused>                  [01F4]
                mov #0x61,r0             ! fr Erweiterungen
                                         !-
__trap_62:      bra SYS_TRAPCALL         ! 62 - <unused>                  [01F8]
                mov #0x62,r0             ! fr Erweiterungen
                                         !-
__trap_63:      bra SYS_TRAPCALL         ! 63 - <unused>                  [01FC]
                mov #0x63,r0             ! fr Erweiterungen
                                         !-
__trap_64:      bra SYS_TRAPCALL         ! 64 - <unused>                  [0200]
                mov #0x64,r0             ! fr Erweiterungen
                                         !-
__trap_65:      bra SYS_TRAPCALL         ! 65 - <unused>                  [0204]
                mov #0x65,r0             ! fr Erweiterungen
                                         !-
__trap_66:      bra SYS_TRAPCALL         ! 66 - <unused>                  [0208]
                mov #0x66,r0             ! fr Erweiterungen
                                         !-
__trap_67:      bra SYS_TRAPCALL         ! 67 - <unused>                  [020C]
                mov #0x67,r0             ! fr Erweiterungen
                                         !-
__trap_68:      bra SYS_TRAPCALL         ! 68 - <unused>                  [0210]
                mov #0x68,r0             ! fr Erweiterungen
                                         !-
__trap_69:      bra SYS_TRAPCALL         ! 69 - <unused>                  [0214]
                mov #0x69,r0             ! fr Erweiterungen
                                         !-
__trap_6a:      bra SYS_TRAPCALL         ! 6A - <unused>                  [0218]
                mov #0x6A,r0             ! fr Erweiterungen
                                         !-
__trap_6b:      bra SYS_TRAPCALL         ! 6B - <unused>                  [021C]
                mov #0x6B,r0             ! fr Erweiterungen
                                         !-
__trap_6c:      bra SYS_TRAPCALL         ! 6C - <unused>                  [0220]
                mov #0x6C,r0             ! fr Erweiterungen
                                         !-
__trap_6d:      bra SYS_TRAPCALL         ! 6D - <unused>                  [0224]
                mov #0x6D,r0             ! fr Erweiterungen
                                         !-
__trap_6e:      bra SYS_TRAPCALL         ! 6E - <unused>                  [0228]
                mov #0x6E,r0             ! fr Erweiterungen
                                         !-
__trap_6f:      bra SYS_TRAPCALL         ! 6F - <unused>                  [022C]
                mov #0x6F,r0             ! fr Erweiterungen
                                         !-
__trap_70:      bra SYS_TRAPCALL         ! 70 - <unused>                  [0230]
                mov #0x70,r0             ! fr Erweiterungen
                                         !-
__trap_71:      bra SYS_TRAPCALL         ! 71 - <unused>                  [0234]
                mov #0x71,r0             ! fr Erweiterungen
                                         !-
__trap_72:      bra SYS_TRAPCALL         ! 72 - <unused>                  [0238]
                mov #0x72,r0             ! fr Erweiterungen
                                         !-
__trap_73:      bra SYS_TRAPCALL         ! 73 - <unused>                  [023C]
                mov #0x73,r0             ! fr Erweiterungen
                                         !-
__trap_74:      bra SYS_TRAPCALL         ! 74 - <unused>                  [0240]
                mov #0x74,r0             ! fr Erweiterungen
                                         !-
__trap_75:      bra SYS_TRAPCALL         ! 75 - <unused>                  [0244]
                mov #0x75,r0             ! fr Erweiterungen
                                         !-
__trap_76:      bra SYS_TRAPCALL         ! 76 - <unused>                  [0248]
                mov #0x76,r0             ! fr Erweiterungen
                                         !-
__trap_77:      bra SYS_TRAPCALL         ! 77 - <unused>                  [024C]
                mov #0x77,r0             ! fr Erweiterungen
_flash_erase_chip:                       !=
                bra SYS_TRAPCALL         ! 78 - LSCHE_GESAMTES_FLASH:    [0250]
                mov #0x78,r0             ! signed long flash_erase_chip (...)
_flash_erase_sectors:                    !-
                bra SYS_TRAPCALL         ! 79 - LSCHE_FLASH-SEKTOREN:    [0254]
                mov #0x79,r0             ! signed long flash_erase_sectors (...)
_flash_program_byte:                     !-
                bra SYS_TRAPCALL         ! 7A - PROGRAM_FLASH-BYTE:       [0258]
                mov #0x7A,r0             ! signed long flash_program_byte (...)
_flash_read_lock:                        !-
                bra SYS_TRAPCALL         ! 7B - LESE_SEKTOR-LOCK:         [025C]
                mov #0x7B,r0             ! signed long flash_read_lock (...)
_flash_read_chipid:                      !-
                bra SYS_TRAPCALL         ! 7C - LESE_FLASH-CHIP-ID:       [0260]
                mov #0x7C,r0             ! signed long flash_read_chipid (...)
_flash_read_idmem:                       !-
                bra SYS_TRAPCALL         ! 7D - LESE_FLASH_ID-MEM:        [0264]
                mov #0x7D,r0             ! signed long flash_read_idmem (...)
_flash_read_data:                        !-
                bra SYS_TRAPCALL         ! 7E - LESE_FLASH-DATEN:         [0268]
                mov #0x7E,r0             ! signed long flash_read_data (...)
                                         !=
__trap_7f:      mov #0x7F,r0             ! 7F - <unused>                  [026C]

!----------------
! TRAP-ERZEUGUNG
!----------------

SYS_TRAPCALL:   stc vbr,r1               ! CALL_TRAP-FUNKTION:            [026E]
                mov.w SYS_K0001,r2       ! R0 = Trap-Nr {0x02..0x7F}
                shll r0                  ! Wir callen Bios-Funktion direkt
                mov.w SYS_K0002,r3       ! indem wir Adresse aus Bios-Tbl lesen
                add r1,r2                ! geht schnell, erfordert Std-Umgebung
                mov.w @(r0,r2),r0        ! da kein Stack-Switching, Stack-Frame
                add r1,r3                ! Baue Ptr BiosAdrTable aus Vbr+0x0300
                add r3,r0                ! lese Word-Eintrag Funktions-Offset
                jmp @r0                  ! baue Ptr Funktion Vbr+0x0184+Offset
                nop                      ! weiter mit Bios-Trap-Service-Funktion


SYS_TRAPSIM:    extu.b r0,r0             ! SIMULIERE_TRAP-OPCODE:         [0282]
                mov.l SYS_K0004,r2       ! R0 = Trap-Nr {0x00..0xFF}
                shll2 r0                 ! Wir simulieren Trap#NN-Cpu-Opcode
                stc sr,r1                ! dabei variable Trap-Nummer via R0
                or r1,r2                 ! Set R0=TraVal,R1=UsrSr,R2=Sr(RB=BL=1)
                ldc r2,sr                !_setze RB=BL=1 wie beim Hardware-Trap
                stc r1_bank,r0           ! Lese User-Status-Register nach R0
                ldc r0,ssr               ! save User-Status-Reg in Ssr wie Trap
                sts pr,r0                ! lese User-Return-Adresse nach R0
                mov.w SYS_K0005,r2       ! save User-Return-Adr in Spc wie Trap
                mov #A_TRA,r1            ! setze Expevt=0x0160 fr Trap-Event
                mov.l r2,@(4,r1)         ! wie bei Trap durch Opcode/Hardware
                ldc r0,spc               ! setze Trap-Nummer <<2 in Tra-Register
                mov.w SYS_K0003,r2       ! wie bei Trap durch Opcode/Hardware
                stc r0_bank,r0           ! jetzt mssen wir nur noch jumpen
                mov.l r0,@r1             ! zum Exception-Handler relativ zu Vbr
                stc vbr,r0               ! baue Pointer auf Exception-Handler
                add r2,r0                ! aus Vbr+0x0100 wie bei Trap-Hardware
                jmp @r0                  ! jump zum normalen Exception-Handler
                nop                      ! lediglich R0,R1,R2 sind verndert

!...............

SYS_K0001:      .short 0x0300            ! Vbr-Offset Trap-Function-Table [02AA]
SYS_K0002:      .short 0x0184            ! Vbr-Offset Trap-Table-Referenz
SYS_K0003:      .short 0x0100            ! Vbr-Offset Exception-Handler
SYS_K0004:      .long  0x70000000        ! Sr-Mask fr Md=Rb=Bl=1
SYS_K0005:      .short 0x0160            ! Expevt-Code fr Trap

!----------------
! PROVISORISCHES
!----------------

_pcon_putch:    mov.l SYS_K0102,r3       ! Provisorische Chrout-Routine:  [02B6]
             1:   mov.w @(8,r3),r0       ! void pcon_putch (unsigned char Data)
                  tst #0x20,r0           ! Lade Sio#1 Basis-Adresse nach R3
                  bt 1b                  ! warte bis Sio-Tx wieder bereit ist
                mov r4,r0                ! lese Sio-Status-Reg,teste Tdfe-Bit
                mov.b r0,@(6,r3)         ! lese Daten-Byte aus Parameter/R4
                mov.w SYS_K0101,r0       ! schreibe Daten-Byte in Scsfdr1-Reg
                rts                      ! schreibe Sio-Status-Reg Tend=Tdfe=0
                mov.w r0,@(8,r3)         ! fertig mit Byte-Ausgabe an Sio#1-Tx


_pcon_getch:    mov.l SYS_K0102,r3       ! Provisorische Chrin-Routine:   [02C8]
             1:   mov.w @(14,r3),r0      ! unsigned char pcon_getch (void)
                  tst #0xFF,r0           ! Lade Sio#1 Basis-Adresse nach R3
                  bt 1b                  ! warte bis Sio-Rx Daten empfangen hat
                mov.w @(8,r3),r0         ! lese das Rx-Fifo-Data-Count-Register
                mov.b @(10,r3),r0        ! repeat bis Fifo-Count nicht mehr Null
                mov r0,r1                ! dann Dummy-Read das Status-Register
                mov #0x60,r0             ! damit Rdf- und Dr-Flags lschbar sind
                mov.w r0,@(8,r3)         ! lese Rx-Daten aus Fifo-Daten-Register
                rts                      ! lsche Er,Brk,(Fer),(Per),Rdf,Dr-Flag
                extu.b r1,r0             ! return unsigned Rx-Datenbyte aus Sio


_pcon_kbhit:    mov.l SYS_K0102,r3       ! Provisorische Kbhit-Routine:   [02DE]
                mov.w @(14,r3),r0        ! unsigned char pcon_kbhit (void)
                rts                      ! Lade Sio#1 Basis-Adresse nach R3
                extu.b r0,r0             ! lese Rx-Char-Anzahl aus Scfdr1

!...............

SYS_K0101:      .short 0x009F            ! Ssr-Txput-Value                [02E6]
SYS_K0102:      .long  A_SCSMR1          ! Sio#1-Basisadresse

                .align 4,0xFF


!*** EOF ***
